# CHANGELOG

> Tags
>
> - :boom: [Breaking Change]
> - :rocket: [New Feature]
> - :star2: [Enhancement]
> - :bug: [Bug Fix]
> - :memo: [Documentation]
> - :nail_care: [Styling]

<!-- Start of Current Changelog -->
## v3.40.12 `2023-09-06`
### Components
#### Datepicker
- :bug: Fix anomaly issue [#2004](https://github.com/tokopedia/unify/pull/2004)
#### Lightbox
- :bug: Fix the 'undefined value' error at `videoPlayerRef` [#2011](https://github.com/tokopedia/unify/pull/2011)
#### Loader
- :bug: Fix the loader when the `shimmer` property is set to `false` [#2017](https://github.com/tokopedia/unify/pull/2017)
#### Timer
- :bug: Fix color mapping [#2018](https://github.com/tokopedia/unify/pull/2018)
#### ViewAllCard
- :bug: Fix the mapping settings for both dark mode and color-blind mode [#2003](https://github.com/tokopedia/unify/pull/2003)

Milestone: https://github.com/tokopedia/unify/milestone/214?closed=1
<!-- End of Current Changelog -->

## v3.40.11 `2023-08-09`
### Components
#### Accordion
- :bug: Fix collapsed transition [#1997](https://github.com/tokopedia/unify/pull/1997)
#### ContentSwitcher
- :bug: Fix ripple animation [#1997](https://github.com/tokopedia/unify/pull/1997)
#### QuantityEditor
- :bug: Fix ripple animation [#1997](https://github.com/tokopedia/unify/pull/1997)

Milestone: https://github.com/tokopedia/unify/milestone/212?closed=1

## v3.40.10 `2023-07-20`
### Components
#### Navbar
- :bug: Fix style not rendered [#1995](https://github.com/tokopedia/unify/pull/1995)

Milestone: https://github.com/tokopedia/unify/milestone/210?closed=1

## v3.40.9 `2023-07-10`
### General Changes
- :bug: fix colorblind on several components (`Card`, `Carousel`, `Checkbox`, `Chip`, `Circular`, `FloatingActionButton`, `Footer`, `FooterV2`, `LocalLoad`, `LabelV2`, `LoaderLinear`, `List`, `Megatab`, `Notification`, `Overlay`, `PageControl`, `Pagination`, `ProgressBar`, `TextFieldV2`, `Ticker`, `Timer`, `Toaster`, `Toggle`, `Typography`) [#1973](https://github.com/tokopedia/unify/pull/1973)

Milestone: https://github.com/tokopedia/unify/milestone/209?closed=1

## v3.40.8 `2023-06-28`
### Component Changes
#### Accordion
- :star2: Improve micro-interaction [#1971](https://github.com/tokopedia/unify/pull/1971)
#### ContentSwitcher
- :star2: Improve micro-interaction [#1948](https://github.com/tokopedia/unify/pull/1948)
#### QuantityEditor
- :star2: Improve micro-interaction [#1971](https://github.com/tokopedia/unify/pull/1971)

Milestone: https://github.com/tokopedia/unify/milestone/204?closed=1

## v3.40.7 `2023-06-05`
### Component Changes
#### Accordion
- :star2: Update microinteraction [#1955](https://github.com/tokopedia/unify/pull/1955)
#### DatepickerScroll
- :bug: Fix `maxDate` property not working [#1956](https://github.com/tokopedia/unify/pull/1956)
#### FloatingActionButton
- :star2: Update microinteraction [#1951](https://github.com/tokopedia/unify/pull/1951)
#### Megatab
- :star2: Update microinteraction [#1954](https://github.com/tokopedia/unify/pull/1954)
#### Toggle
- :star2: Update microinteraction [#1957](https://github.com/tokopedia/unify/pull/1957)

Milestone: https://github.com/tokopedia/unify/milestone/200?closed=1

## v3.40.6 `2023-05-23`
### Component Changes
#### Checkbox
- :nail_care: Update border width [#1943](https://github.com/tokopedia/unify/pull/1943)
#### Loader
- :star2: Update microinteraction [#1937](https://github.com/tokopedia/unify/pull/1937)
#### Notification
- :star2: Update microinteraction [#1942](https://github.com/tokopedia/unify/pull/1942)
#### Radio
- :nail_care: Update border width [#1943](https://github.com/tokopedia/unify/pull/1943)
#### Toaster
- :star2: Update microinteraction [#1941](https://github.com/tokopedia/unify/pull/1941)

Milestone: https://github.com/tokopedia/unify/milestone/197?closed=1

## v3.40.5 `2023-05-08`
### Component Changes
#### CoachmarkV2
- :star2: Improve micro-interaction [#1926](https://github.com/tokopedia/unify/pull/1926)
#### SearchBar
- :bug: Fix ui breaking [#1932](https://github.com/tokopedia/unify/pull/1932)
#### Select
- :bug: Fix unclickable icon when withSearch is true [#1929](https://github.com/tokopedia/unify/pull/1929)
#### TextAreaV2
- :star2: Improve micro-interaction [#1927](https://github.com/tokopedia/unify/pull/1927)

Milestone: https://github.com/tokopedia/unify/milestone/195?closed=1

## v3.40.4 `2023-04-18`
### Component Changes
#### Card
- :bug: Remove extra div on card component that cause layout breaking [#1925](https://github.com/tokopedia/unify/pull/1925)

Milestone: https://github.com/tokopedia/unify/milestone/194?closed=1

## v3.40.3 `2023-04-05`
### Component Changes
#### Ticker
- :bug: Fix title color [#1914](https://github.com/tokopedia/unify/pull/1914)

Milestone: https://github.com/tokopedia/unify/milestone/192?closed=1

## v3.40.2 `2023-03-21`
### Component Changes
#### Card
- :rocket: Add microinteraction [#1883](https://github.com/tokopedia/unify/pull/1883)
- :rocket: Add ripple animation [#1898](https://github.com/tokopedia/unify/pull/1898)
- :bug: Fix ripple animation [#1906](https://github.com/tokopedia/unify/pull/1906)
#### Checkbox
- :rocket: Add microinteraction [#1890](https://github.com/tokopedia/unify/pull/1890)
#### Dialog
- :rocket: Add microinteraction [#1878](https://github.com/tokopedia/unify/pull/1878)
- :star2: Update transition duration and timing function [#1897](https://github.com/tokopedia/unify/pull/1897)
#### Radio
- :rocket: Add microinteraction [#1891](https://github.com/tokopedia/unify/pull/1891)
#### SliderV2
- :rocket: Add microinteraction [#1889](https://github.com/tokopedia/unify/pull/1889)
#### Toggle
- :rocket: Add microinteraction [#1881](https://github.com/tokopedia/unify/pull/1881)

Milestone: https://github.com/tokopedia/unify/milestone/188?closed=1

## v3.40.1 `2023-03-02`
### General Changes
- :star2: Audit and fix all component using the right unify-token [#1853](https://github.com/tokopedia/unify/pull/1853)

### Component Changes
#### Button
- :rocket: Add hover style [#1866](https://github.com/tokopedia/unify/pull/1866)
- :rocket: Add ripple style when user click the component [#1866](https://github.com/tokopedia/unify/pull/1866)

#### Chip
- :rocket: Add large variant [#1867](https://github.com/tokopedia/unify/pull/1867)
- :rocket: Add animation when active state = true [#1867](https://github.com/tokopedia/unify/pull/1867)

#### Lightbox
- :bug: Fix swipe behavior [#1858](https://github.com/tokopedia/unify/pull/1858)

#### List
- :rocket: Support custom attributes on action [#1877](https://github.com/tokopedia/unify/pull/1877)

#### Tab
- :rocket: Add hover style [#1866](https://github.com/tokopedia/unify/pull/1866)
- :rocket: Add ripple style when user click the component [#1866](https://github.com/tokopedia/unify/pull/1866)

#### TextField
- :rocket: Add microinteraction [#1879](https://github.com/tokopedia/unify/pull/1879)

#### Ticker
- :rocket: Add microinteraction [#1868](https://github.com/tokopedia/unify/pull/1868)

Milestone: https://github.com/tokopedia/unify/milestone/184?closed=1

## v3.40.0 `2023-02-01`
### Component Changes
#### FooterV2
- :rocket: Add new props `huaweiURL` and `onHuaweiURLClicked` to apply the latest design [#1821](https://github.com/tokopedia/unify/pull/1821)

## v3.39.0 `2023-01-12`
### Component Changes
#### BottomSheetV2
- :bug: Fix missing types definition className and component api not showing in storybook [#1816](https://github.com/tokopedia/unify/pull/1816)

#### CarouselV2
- :bug: Fix carouselV2 centerMode not centered when there is only 1 item [#1806](https://github.com/tokopedia/unify/pull/1806)

## v3.38.1 `2022-12-14`
### Component Changes
#### ViewAllCard
- :star2: Improve the clickable area [#1787](https://github.com/tokopedia/unify/pull/1787)

#### TextFieldV2
- :bug: Fix disabled color issue on ios webview [#1792](https://github.com/tokopedia/unify/pull/1792)

#### Card
- :bug: Fix mising boxshadow on card [#1793](https://github.com/tokopedia/unify/pull/1793)

#### Datepicker
- :bug: Add nullable value to Calendar [#1774](https://github.com/tokopedia/unify/pull/1774)

## v3.38.0 `2022-11-30`
### General Changes
- Update CDN link from ecs7.tokopedia.net to assets.tokopedia.net [#1777](https://github.com/tokopedia/unify/pull/1777)

### Component Changes
#### Card
- :nail-care: Darkmode audit color [#1781](https://github.com/tokopedia/unify/pull/1781)
#### Checkbox
- :nail-care: Darkmode audit color [#1780](https://github.com/tokopedia/unify/pull/1780)
- :start2: Add new prop: inputProps [#1762](https://github.com/tokopedia/unify/pull/1762)
#### DatepickerScroll
- :nail-care: Audit button size [#1778](https://github.com/tokopedia/unify/pull/1778)
#### Label
- :nail-care: Darkmode audit color [#1780](https://github.com/tokopedia/unify/pull/1780)
#### PageControl
- :nail-care: Darkmode audit color [#1760](https://github.com/tokopedia/unify/pull/1760)
#### ProgressBar
- :star2: Add new props full to apply full ProgressBar design [#1760](https://github.com/tokopedia/unify/pull/1760)
- :star2: Add new props info to set the info content like icon, title, and subtitle for the ProgressBar [#1760](https://github.com/tokopedia/unify/pull/1760)
#### SearchBar
- :star2: Add ability to pass dataTest to clear button [#1762](https://github.com/tokopedia/unify/pull/1762)
#### Tab
- :bug: Fix missing property [#1775](https://github.com/tokopedia/unify/pull/1775)
#### TextAreaV2
- :start2: Add new prop: inputProps [#1762](https://github.com/tokopedia/unify/pull/1762)
#### Ticker
- :nail-care: Darkmode audit color [#1780](https://github.com/tokopedia/unify/pull/1780)
#### Timer
- :nail-care: Update fontsize and margin [#1765](https://github.com/tokopedia/unify/pull/1765)
#### Toaster
- :nail-care: Darkmode audit color [#1780](https://github.com/tokopedia/unify/pull/1780)
#### ViewAllCard
- :nail-care: Darkmode audit color [#1781](https://github.com/tokopedia/unify/pull/1781)

## v3.37.5 `2022-11-10`
### Component Changes
#### CoachmarkV2
- :bug: fix positioning issue. [#1730](https://github.com/tokopedia/unify/pull/1730)
#### DatepickerCalendar
- :star2: Adjust style based on design audit. [#1738](https://github.com/tokopedia/unify/pull/1738)
#### Megatab
- :star2: Adjust style based on design audit. [#1747](https://github.com/tokopedia/unify/pull/1747)
#### ViewAllCard
- :star2: Adjust style based on design audit. [#1745](https://github.com/tokopedia/unify/pull/1745)

## v3.37.4 `2022-11-2`
### Component Changes
#### DatepickerScroll
- :star2: Adjust style based on design audit. [#1728](https://github.com/tokopedia/unify/pull/1728)
#### GlobalError
- :star2: Adjust style based on design audit. [#1732](https://github.com/tokopedia/unify/pull/1732)
#### SearchBar
- :star2: Adjust style based on design audit. [#1672](https://github.com/tokopedia/unify/pull/1672)
#### SelectV2
- :star2: Change with search bottom sheet from BottomSheet to BottomSheetV2. [#1735](https://github.com/tokopedia/unify/pull/1735)
#### Ticker
- :star2: Adjust ticker item prop type from string to node. [#1672](https://github.com/tokopedia/unify/pull/1672)
#### TotalAmount
- :star2: Adjust style based on design audit. [#1726](https://github.com/tokopedia/unify/pull/1726)

## v3.37.3 `2022-10-25`
### Component Changes
#### LoaderDecorative
- :rocket: New loader component, `LoaderDecorative`. [#1724](https://github.com/tokopedia/unify/pull/1724)
#### EmptyState
- :star2: Adjust style based on design audit. [#1723](https://github.com/tokopedia/unify/pull/1723)
#### Datepicker
- :bug: Fix incorrect static type. [#1715](https://github.com/tokopedia/unify/pull/1715)

## v3.37.3-beta-1 `2022-10-06`
### General Changes
- :star2: Adjust dark mode token on several components. [#1654](https://github.com/tokopedia/unify/pull/1654)

## v3.37.2 `2022-10-13`
### General Changes
- :star2: Improve static typing of several components. [#1700](https://github.com/tokopedia/unify/pull/1700)
- :star2: Improve static typing of several components. [#1703](https://github.com/tokopedia/unify/pull/1703)

### Component Changes
#### CoachmarkV2
- :bug: Fix close button issue on single line content. [#1704](https://github.com/tokopedia/unify/pull/1704)

## v3.37.1 `2022-10-06`
### Component Changes
#### Datepicker
- :bug: Fix issues where date can't be changed. [#1698](https://github.com/tokopedia/unify/pull/1698)

## v3.37.0 `2022-10-06`
### General Changes
- Update typings on several components

### Component Changes
#### CoachmarkV2
- :nail_care: Adjust style based on design audit. [#1678](https://github.com/tokopedia/unify/pull/1678)

#### Datepicker
- :bug: Fix issue on DatepickerScroll where the seconds displayed as button. [#1694](https://github.com/tokopedia/unify/pull/1694)

#### List
- :nail_care: Adjust style based on design audit. [#1684](https://github.com/tokopedia/unify/pull/1684)
- :bug: Fix visual issue where text are clipped. [#1684](https://github.com/tokopedia/unify/pull/1684)

#### SliderV2
- :nail_care: Adjust style based on design audit. [#1677](https://github.com/tokopedia/unify/pull/1677)

#### TextArea
- :nail_care: Adjust style based on design audit. [#1682](https://github.com/tokopedia/unify/pull/1682)

#### TextFieldV2
- :bug: Fix issue where show/hide password button trigger form submit. [#1670](https://github.com/tokopedia/unify/pull/1670)
- :nail_care: Adjust style based on design audit. [#1682](https://github.com/tokopedia/unify/pull/1682)

#### Ticker
- :nail_care: Adjust style based on design audit. [#1676](https://github.com/tokopedia/unify/pull/1676)

#### Toaster
- :nail_care: Adjust style based on design audit. [#1664](https://github.com/tokopedia/unify/pull/1664)

#### Lightbox
- :star2: Expose video current time. [#1680](https://github.com/tokopedia/unify/pull/1680)

## v3.36.5 `2022-09-26`
### Component Changes
#### LocalLoad
- :bug: Fix wrong import path on utilites used in LocalLoad. [#1660](https://github.com/tokopedia/unify/pull/1660)

## v3.36.4 `2022-09-23`
### Component Changes
#### Lightbox
- :bug: Fix video not playing on the first load [#1660](https://github.com/tokopedia/unify/pull/1660)

#### LocalLoad
- :bug: Fix title font-size, and fix icon wrapper background-color and box-shadow on dark mode [#1657](https://github.com/tokopedia/unify/pull/1657)

## v3.36.3 `2022-09-19`
### Component Changes
#### Lightbox
- :bug: Fix `autoPlay` behavior where video are started to play even when the video is out of focus [#1651](https://github.com/tokopedia/unify/pull/1651)

## v3.36.2 `2022-09-14`
### General Change
- :bug: Fix missing icon asset [#1646](https://github.com/tokopedia/unify/pull/1646)

### Component Changes
#### Coachmark
- :star2: Increase close button tap area [#1648](https://github.com/tokopedia/unify/pull/1648)

## v3.36.1 `2022-09-13`
### Component Changes
#### Accordion
- :star2: Update type of icon to accept node [#1631](https://github.com/tokopedia/unify/pull/1631)
- :bug: Fix audit, update color & icon asset [#1635](https://github.com/tokopedia/unify/pull/1635)
#### Chip
- :bug: Fix audit, update color & icons asset [#1641](https://github.com/tokopedia/unify/pull/1641)
#### ContentSwitcher
- :bug: Fix audit, update height & font size [#1642](https://github.com/tokopedia/unify/pull/1642)

## v3.36.0 `2022-08-31`
### Component Changes
#### PageControl
- :rocket: Add new variant based on component audit [#1614](https://github.com/tokopedia/unify/pull/1614)

#### Toggle
- :nail_care: Update color based on component audit [#1615](https://github.com/tokopedia/unify/pull/1615)

#### FloatingActionButton
- :nail_care: Update background color on dark mode based on audit [#1611](https://github.com/tokopedia/unify/pull/1611)

#### Button
- :nail_care: Update color & font weight based on audit [#1613](https://github.com/tokopedia/unify/pull/1613)

#### Chip
- :nail_care: Update background color based on audit [#1606](https://github.com/tokopedia/unify/pull/1606)

#### Shimmer
- :nail_care: Update background color based on audit [#1606](https://github.com/tokopedia/unify/pull/1606)

#### Loader
- :nail_care: Update background color based on audit [#1606](https://github.com/tokopedia/unify/pull/1606)

#### LabelV2
- :nail_care: Update text color based on audit [#1620](https://github.com/tokopedia/unify/pull/1620)

#### Notification
- :nail_care: Update color & sizing based on audit [#1620](https://github.com/tokopedia/unify/pull/1620)

## v3.35.0 `2022-08-24`
### Component Changes
#### Card
- :nail_care: Update style based on Product Design team audit [#1541](https://github.com/tokopedia/unify/pull/1541)

#### CarouselV2
- :star2: Add new property `adaptiveHeight` [#1593](https://github.com/tokopedia/unify/pull/1593)
- :star2: Add new property `itemAlign` [#1593](https://github.com/tokopedia/unify/pull/1593)

#### Checbox
- :nail_care: Update style based on Product Design team audit [#1590](https://github.com/tokopedia/unify/pull/1590)

#### Chip
- :nail_care: Update border radius value [#1578](https://github.com/tokopedia/unify/pull/1578)

#### Image
- :star2: Hide placeholder image when image isze less than 32px [#1587](https://github.com/tokopedia/unify/pull/1587)

#### Loader
- :star2: Add new property `variant` on Circular, to set variant of the Circular loader  [#1595](https://github.com/tokopedia/unify/pull/1595)
- :star2: Add new property `size` on Circular, to set size of the Circular loader, this property deprecate `width`property  [#1595](https://github.com/tokopedia/unify/pull/1595)
- :star2: Update style based on Product Design team audit [#1595](https://github.com/tokopedia/unify/pull/1595)

#### SearchBar
- :bug: Fix double clear button [#1596](https://github.com/tokopedia/unify/pull/1596)

## v3.34.0 `2022-08-02`
### Component Changes
#### CarouselV2
- :bug: Fix warning when containerRef undefined [#1475](https://github.com/tokopedia/unify/pull/1475)

#### Tab
- :bug: Fix static typing errors [#1476](https://github.com/tokopedia/unify/pull/1476)

#### TextFieldV2
- :rocket: Add inputProps properties so user can add data-testid to input element [#1514](https://github.com/tokopedia/unify/pull/1514)

## v3.33.1 `2022-06-21`
### Component Changes
#### BottomSheetV2
- :bug: Fix spacing on header element (no gap between close button & title) [#1421](https://github.com/tokopedia/unify/pull/1421)
- :bug: Fix some Typescript & linter errors [#1421](https://github.com/tokopedia/unify/pull/1421)
- :bug: Fix drag interaction miss calculation [#1421](https://github.com/tokopedia/unify/pull/1421)

## v3.33.0 `2022-06-06`
### Component Changes
#### CarouselV2
- :bug: Fix issue when resizing window [#1389](https://github.com/tokopedia/unify/pull/1389)
- :bug: Fix adaptive height issue [#1362](https://github.com/tokopedia/unify/pull/1362)
- :bug: Fix layout shifting issue [#1328](https://github.com/tokopedia/unify/pull/1328)

### Lightbox
- :star2: Add custom control for video [#1294](https://github.com/tokopedia/unify/pull/1371)
- :star2: Add new property `dataTest` [#1409](https://github.com/tokopedia/unify/pull/1409)

#### Tips
- :star2: Update with latest Tokopedia Nest requirements [#1395](https://github.com/tokopedia/unify/pull/1395)

## v3.32.0 `2022-03-29`
### General Changes
- :rocket: Enabled accessibility to all components [#1303](https://github.com/tokopedia/unify/pull/1303)

### Component Changes
### Button
- :bug: Fix button with text property [#1294](https://github.com/tokopedia/unify/pull/1294)

#### Dialog
- :bug: Fix actionSecondaryBorder initial value [#1294](https://github.com/tokopedia/unify/pull/1294)

#### Typography
- :star2: Update new font `Open Sauce One` [#1225](https://github.com/tokopedia/unify/pull/1225)

## v3.31.0 `2022-03-14`
### General
- Add new peerDependencies, `react-hls-player`. [1216](https://github.com/tokopedia/unify/pull/1216)

### Component Changes
#### Lightbox
- :star2: Add spread operators on Lightbox. [1216](https://github.com/tokopedia/unify/pull/1216)
- :star2: Add new callback `onSlideChange` to track `activeIndex`. [1216](https://github.com/tokopedia/unify/pull/1216)

## v3.30.1 `2022-03-09`
### Component Changes
#### Ticker
- :bug: fix padding when no close button. [#1268](https://github.com/tokopedia/unify/pull/1268)

## v3.30.0 `2022-03-01`
### Component Changes
#### Chip
- :rocket: Add a new variant `dashed`. [#1235](https://github.com/tokopedia/unify/pull/1235)

#### ProgressBar
- :bug: Fix overflow hidden on container. [#1256](https://github.com/tokopedia/unify/pull/1256)

#### Timer
- :bug: Fix days format in auto so that it will only show day difference without considering time. [#1249](https://github.com/tokopedia/unify/pull/1249)

## v3.29.1 `2022-02-08`
### Component Changes
#### CoachmarkV2
- :bug: Fix close button not shown on iOS webview [#1215](https://github.com/tokopedia/unify/pull/1215)

#### Select
- :bug: Fix `withSearch` error if children has empty array [#1208](https://github.com/tokopedia/unify/pull/1208)

#### SelectV2
- :bug: Fix `withSearch` error if children has empty array [#1208](https://github.com/tokopedia/unify/pull/1208)

## v3.29.0 `2022-01-25`
### Component Changes
#### Lightbox
- :rocket: Add pinch to zoom function [#1191](https://github.com/tokopedia/unify/pull/1191)

#### Typography
- :nail_care: Update style & new font [#1003](https://github.com/tokopedia/unify/pull/1003)
- :rocket: Add a new property `asSpan` [#1003](https://github.com/tokopedia/unify/pull/1003)

#### Chip
- :bug: Fix icon property [#1171](https://github.com/tokopedia/unify/pull/1171)

#### OTPField
- :bug: Fix broken ui on ios device + numberOnly keyboard feature [#1125](https://github.com/tokopedia/unify/pull/1125)

## v3.28.0 `2021-12-21`
### General Changes
- :bug: Fix error color on message in form components [#1122](https://github.com/tokopedia/unify/pull/1122)

### Component Changes
#### Accordion
- :star2: Add new property `text` [#1164](https://github.com/tokopedia/unify/pull/1164)
- :nail_care: Update old color to nest color [#1164](https://github.com/tokopedia/unify/pull/1164)

#### Carousel
- :bug: fix function parameter on onSwipe & onSlideChange property [#1134](https://github.com/tokopedia/unify/pull/1134)

#### ProgressBar
- :star2: Update to nest design [#1154](https://github.com/tokopedia/unify/pull/1154)

#### Pagination
- :bug: Fix onChange triggered on initial render [#1147](https://github.com/tokopedia/unify/pull/1147)

#### DatepickerCalendar
- :star2: Update to nest design [#1151](https://github.com/tokopedia/unify/pull/1151)

#### EmptyState
- :star2: Update to nest design [#1158](https://github.com/tokopedia/unify/pull/1158)

#### SliderV2
- :star2: Update to nest design [#1158](https://github.com/tokopedia/unify/pull/1158)

#### List
- :star2: Update to nest design [#1097](https://github.com/tokopedia/unify/pull/1097)

#### Localload
- :star2: Update to nest design [#1149](https://github.com/tokopedia/unify/pull/1149)

#### CoachmarkV2
- :star2: Update to nest design [#1153](https://github.com/tokopedia/unify/pull/1153)
- :star2: Remove darkmode property [#1153](https://github.com/tokopedia/unify/pull/1153)

#### TotalAmount
- :star2: Update to nest design [#1159](https://github.com/tokopedia/unify/pull/1159)

#### Dialog
- :star2: Update to nest design [#1160](https://github.com/tokopedia/unify/pull/1160)

## v3.27.1 `2021-11-19`
### General Changes
- :bug: Fix styling issues happened after previous version changes.

## v3.27.0 `2021-11-19`
### Component Changes
#### BottomSheetV2 & Dialog
- :bug: Fix overlay stacking issues when BottomSheetV2 and Dialog shown at the same time. [#1073](https://github.com/tokopedia/unify/pull/1073)

#### FloatingActionButton
- :star2: Add new property `enableScrollInteraction`. [#991](https://github.com/tokopedia/unify/pull/991)

#### Select
- :nail_care: Update caret icon using unify-icons [#1091](https://github.com/tokopedia/unify/pull/1091)

#### Slider
- :nail_care: Apply Nest color token. [#1108](https://github.com/tokopedia/unify/pull/1108)

#### TextAreaV2
- :star2: Fix console warning shows when user test the component using react-testing-library. [#1109](https://github.com/tokopedia/unify/pull/1109)

#### Timer
- :star2: Add new time format `MM:SS`, `days`, and `minutes`. [#1098](https://github.com/tokopedia/unify/pull/1098)
- :star2: Add new colorVariant, `informative` and `alternate`. [#1098](https://github.com/tokopedia/unify/pull/1098)
- :star2: Remove text format from timeFormat `auto`. [#1098](https://github.com/tokopedia/unify/pull/1098)

#### Tips
- :star2: Remove maximum text 2 line requirements. [#1099](https://github.com/tokopedia/unify/pull/1099)

#### ViewAllCard
- :bug: Fix glitch issue when there are only one items and doesn't have predefined width and height. [#1062](https://github.com/tokopedia/unify/pull/1062)

## v3.26.1 `2021-10-14`
### Component Changes
#### Timer
- :bug: Fix display format issue. [#1058](https://github.com/tokopedia/unify/pull/1058)

#### Wishlist
- :bug: Fix click event doesn't trigger animation. [#1055](https://github.com/tokopedia/unify/pull/1055)

## v3.26.1 `2021-10-14`
### Component Changes
#### Card
- :bug: Fix issue with `matchMedia` not supported. [#1050](https://github.com/tokopedia/unify/pull/1050)

## v3.26.0 `2021-10-08`
### Component Changes
#### Checkbox
- :star2: Add new property `variant`, to set the color variant of the Checkbox (currently available are `default` and `inverted`). [#1042](https://github.com/tokopedia/unify/pull/1042)

#### Lightbox
- :star2: Add new property `className`, `overlayContent`, `totalItems`, `withCounter`, `onNext`, and `onPrev` see the prop table for details. [#1041](https://github.com/tokopedia/unify/pull/1036)

#### Loader (Circle, Square, Line)
- :star2: Add new property `shimmer`, to turn on/off shimmer animation. [#1043](https://github.com/tokopedia/unify/pull/1043)

#### TextFieldV2
- :star2: Add guard to prevent error on unit testing. [#1037](https://github.com/tokopedia/unify/pull/1036)

## v3.25.0 `2021-10-06`
### Component Changes
#### Card
- :nail_care: Fix wrong color on dark mode. [#1018](https://github.com/tokopedia/unify/pull/1018)

#### ContentSwitcher
- :bug: Fix SSR issue. [#1036](https://github.com/tokopedia/unify/pull/1036)

#### Tips
- :rocket: New component. [#989](https://github.com/tokopedia/unify/pull/989)

#### Ticker
- :star2: Tokopedia Nest Update. [#989](https://github.com/tokopedia/unify/pull/989)

#### Typography
- :star2: Allow `body` property to be used in `link`. [#1013](https://github.com/tokopedia/unify/pull/1013)

#### QuantityEditor
- :star2: Fix issue on smaller size of QuantityEditor, and Tokopedia Nest update. [#1005](https://github.com/tokopedia/unify/pull/1005)

## v3.24.0 `2021-09-24`
### Component Changes
#### CoachmarkV2
- :star2: Add new props `container`. [#1006](https://github.com/tokopedia/unify/pull/1006)

#### ContentSwitcher
- :star2: Add window size/orientation change. [#992](https://github.com/tokopedia/unify/pull/1000)

#### Image
- :bug: Fix console error issue when trigger onClickReload. [#1027](https://github.com/tokopedia/unify/pull/027)
- :bug: Fix cached image not displayed. [#1020](https://github.com/tokopedia/unify/pull/1020)

#### Lightbox
- :rocket: New component. [#845](https://github.com/tokopedia/unify/pull/845)

#### SearchBar
- :bug: Fix console error issue. [#1010](https://github.com/tokopedia/unify/pull/1010)

#### ViewAllCard
- :star2: Improve type definition and background color handler. [#1028](https://github.com/tokopedia/unify/pull/1028)

## v3.23.8 `2021-09-02`
### Component Changes
#### Image
- :bug: Fix issue for image with transparent background. [#998](https://github.com/tokopedia/unify/pull/998)

#### BottomSheet, Dialog, Menu, Tooltip
- :bug: Fix overlay not rendered properly on these components. [#996](https://github.com/tokopedia/unify/pull/996)

#### CoachmarkV2
- :bug: Fix Coachmark arrow color mismatch in dark mode. [#992](https://github.com/tokopedia/unify/pull/999)

#### List
- :bug: Fix issue with icon on list failed to load. [#992](https://github.com/tokopedia/unify/pull/1000)

## v3.23.7 `2021-08-28`
### Component Changes
#### BottomSheetV2
- :bug: Fix overlay doesn't hidden on BottomSheetV2 when `withOverlay` are set to `false`. [#992](https://github.com/tokopedia/unify/pull/992)

## v3.23.6 `2021-08-18`
### Component Changes
#### SearchBar
- :bug: Fix SearchBar style doesn't applied properly. [#985](https://github.com/tokopedia/unify/pull/985)

## v3.23.5 `2021-08-10`
### Component Changes
#### Button
- :bug: Fix children spacing issue since last update. [#976](https://github.com/tokopedia/unify/pull/976)

## v3.23.4 `2021-08-06`
### Component Changes
#### Divider
- :bug: Fix `className` property doesn't applied correctly. [#971](https://github.com/tokopedia/unify/pull/971)
#### SearchBar
- :bug: Fix SearchBar text color issue on dark mode. [#969](https://github.com/tokopedia/unify/pull/969)

## v3.23.3 `2021-07-27`
### Component Changes
#### Chip
- :bug: Removes `console.log` from Chip. [#966](https://github.com/tokopedia/unify/pull/966)

## v3.23.2 `2021-07-23`
### Component Changes
#### SearchBar
- :bug: Fix issue when onClear is triggered whenever `form` onSubmit is triggered. [#961](https://github.com/tokopedia/unify/pull/961)

## v3.23.1 `2021-07-21`
## General Changes
- :star2: Add type definitions file `index.d.ts` for each component. [#808](https://github.com/tokopedia/unify/pull/808)

### Component Changes
#### Chips
- :nail_care: Update color to Nest specifications. [#951](https://github.com/tokopedia/unify/pull/951)

#### Image
- :star2: Add default placeholder image when `src` is empty. [#924](https://github.com/tokopedia/unify/pull/924)
- :star2: Add default error image when there are no connection or image link is broken. [#924](https://github.com/tokopedia/unify/pull/924)
- :star2: Add new props `hasReloadOnError`, to show reload button when there are no connection or image link is broken. [#924](https://github.com/tokopedia/unify/pull/924)
- :star2: Add new props `onClickReload`, callback when reload is clicked if `hasReloadOnError` is `true`. [#924](https://github.com/tokopedia/unify/pull/924)

#### LabelV2
- :nail_care: New component, replace `Label` to follow Nest specifications. [#951](https://github.com/tokopedia/unify/pull/951)

#### SearchBar
- :nail_care: Update color to Nest specifications. [#951](https://github.com/tokopedia/unify/pull/951)

#### SelectV2, TextFieldV2, TextAreaV2
- :nail_care: Update color to Nest specifications. [#957](https://github.com/tokopedia/unify/pull/957)

#### Timer
- :nail_care: Update color to Nest specifications. [#951](https://github.com/tokopedia/unify/pull/951)

## v3.22.0 `2021-06-28`
### Component Changes
#### Accordion
- :bug: Fix issue when `collapsed` is true. [#924](https://github.com/tokopedia/unify/pull/924)

#### Button
- :star2: Allow combination of elements (text, image, icon, etc) to be passed on children, not only for text like before. [#876](https://github.com/tokopedia/unify/pull/876)
- :nail_care: Update color token with the new one. [#876](https://github.com/tokopedia/unify/pull/876)

#### Container
- :star2: Add new predefined color for container, they are `blue`, `green`, `yellow`, `purple`, `red`, and `grey`. [#932](https://github.com/tokopedia/unify/pull/932)
- :star2: Set the default color to `green`. [#932](https://github.com/tokopedia/unify/pull/932)

#### CarouselV2
- :bug: Fix drag & drop positioning issue when autoplay is active. [#937](https:/github.com/tokopedia/unify/pull/937)

#### MegaTab
- :rocket: New component. [#936](https://github.com/tokopedia/unify/pull/936)

#### QuantityEditor
- :star2: Redesign component based on new specification. [#917](https://github.com/tokopedia/unify/pull/917)

#### ViewAllCard
- :rocket: New component. [#938](https://github.com/tokopedia/unify/pull/938)

## v3.21.0 `2021-06-10`
### Component Changes
#### Checkbox
- :rocket: Update color using new nest token color. [#912](https://github.com/tokopedia/unify/pull/912)

#### ContentSwitcher
- :rocket: Update color using new nest token color. [#912](https://github.com/tokopedia/unify/pull/912)

#### FloatingActionButton
- :rocket: New component. [#900](https://github.com/tokopedia/unify/pull/900)

#### Radio
- :rocket: Update color using new nest token color. [#912](https://github.com/tokopedia/unify/pull/912)

#### SelectV2
- :rocket: New component, replacing current `Select`. [#920](https://github.com/tokopedia/unify/pull/920)

#### TextAreaV2
- :rocket: New component, replacing current `TextArea`. [#920](https://github.com/tokopedia/unify/pull/920)

#### TextFieldV2
- :rocket: New component, replacing current `TextField`. [#920](https://github.com/tokopedia/unify/pull/920)

## v3.20.1 `2021-05-17`
### Component Changes
#### TextField, TextArea, Select
- :bug: Fix label font size doesn't resized when focusing or when the field has values. [#892](https://github.com/tokopedia/unify/pull/892)

## v3.20.0 `2021-05-04`
### Component Changes
#### Card
- :rocket: Add new property `touchAnimation`, set the feedback animation when user touch the card. [#824](https://github.com/tokopedia/unify/pull/824)
- :star2: Remove some console warning. [#824](https://github.com/tokopedia/unify/pull/824)
- :nail_care: Update color to Tokopedia Nest colors. [#824](https://github.com/tokopedia/unify/pull/824)

#### Divider
- :nail_care: Update color to Tokopedia Nest colors. [#879](https://github.com/tokopedia/unify/pull/879)

#### Notification
- :nail_care: Update color to Tokopedia Nest colors. [#880](https://github.com/tokopedia/unify/pull/880)

#### Overlay
- :nail_care: Update color to Tokopedia Nest colors. [#881](https://github.com/tokopedia/unify/pull/881). This affects several components that using the Overlay such as:
  - **BottomSheet**
  - **Coachmark**
  - **Datepicker**
  - **Dialog**

#### PageControl
- :nail_care: Update color to Tokopedia Nest colors. [#877](https://github.com/tokopedia/unify/pull/877). This affects several components that using the PageControl such as:
  - **Ticker**

#### Tabs
- :nail_care: Update color to Tokopedia Nest colors. [#879](https://github.com/tokopedia/unify/pull/879)

## v3.19.1 `2021-04-22`
## General Changes
- :star2: Changing several components icon which previously using images as background-image under `<i>` tag, to icon from unify-icons. **This changes probably will fail your UT, please update accordingly.**

### Component Changes
#### BottomSheet
- :nail_care: Update shadow color. [#860](https://github.com/tokopedia/unify/pull/860)

#### Divider
- :bug: Fix error where use cannot pass user defined properties. [#844](https://github.com/tokopedia/unify/pull/844)

#### Button
- :nail_care: Update shadow color on floating button. [#860](https://github.com/tokopedia/unify/pull/860)

#### OTPField
- :nail_care: Update color with new color token. [#862](https://github.com/tokopedia/unify/pull/862)

#### Tab
- :bug:  Fix active tab item highlight not showing [#858](https://github.com/tokopedia/unify/pull/858)

#### Ticker
- :bug: Fix `onClick` event didn't return current item. [#858](https://github.com/tokopedia/unify/pull/858)

## v3.19.0 `2021-04-16`
### General
- Dark mode support for every components. [#806](https://github.com/tokopedia/unify/pull/806)

### Component Changes
#### Tab
- :bug: Fix `parentNode of undefined` issue. [#844](https://github.com/tokopedia/unify/pull/844)

## v3.18.0 `2021-03-26`
### Component Changes
#### CarouselV2
- :star2: Add new property `loop` to set the loop type of the Carousel. [#831](https://github.com/tokopedia/unify/pull/831)

#### CoachmarkV2
- :bug: Fix CoachmarkV2 doesn't update it's position whenever document height is changed. [#825](https://github.com/tokopedia/unify/pull/825)

#### Ticker
- :star2: Add new property `onSwipe`, to add event listener when swiping the Ticker. [#836](https://github.com/tokopedia/unify/pull/836)

## v3.17.8 `2021-03-18`
### Component Changes
#### Timer
- :bug: Fix Timer only showing single 0 in `HH:MM:SS` format. [#827](https://github.com/tokopedia/unify/pull/827)

## v3.17.7 `2021-02-26`
### Component Changes
#### Datepicker
- :bug: Fix Datepicker Calendar not auto-scrolling to currently active month. [#811](https://github.com/tokopedia/unify/pull/811)

#### ProgressBar
- :star2: Add new option for size, `large`. [#813](https://github.com/tokopedia/unify/pull/813)

#### Timer
- :star2: Revert color variant from version `3.17.5` from `fomo` to `general`. [#804](https://github.com/tokopedia/unify/pull/804)
- :star2: New property `showIcon`, to show/hide the Timer icon. [#804](https://github.com/tokopedia/unify/pull/804)
- :star2: New property `timeFormat`, to force change format of the Timer, currently only provide `auto` and `HH:MM:SS` defaulted to `auto`. [#804](https://github.com/tokopedia/unify/pull/804)

## v3.17.6 `2021-02-23`
### Component Changes
#### BottomSheetV2
- :star2: Increase drag threshold to trigger onClose when dragging on BottomSheetV2 that have `withKnobs` property. [#809](https://github.com/tokopedia/unify/pull/809)

## v3.17.5 `2021-02-04`
### Component Changes
#### Subheader
- :bug: Fix Subheader error handling. [#797](https://github.com/tokopedia/unify/pull/797)

#### Timer
- :star2: Add new color variant `fomo`. [#799](https://github.com/tokopedia/unify/pull/799)

## v3.17.4 `2021-01-25`
### Component Changes
#### Timer
- :bug: Add animation to Timer following newest guideline, and several bug fixings. [#778](https://github.com/tokopedia/unify/pull/778)

## v3.17.3 `2021-01-18`
### Component Changes
#### Timer
- :bug: Fix Timer with `single` type container rendered as block-element rather than inline element. [#781](https://github.com/tokopedia/unify/pull/781)

## v3.17.2 `2021-01-18`
### Component Changes
#### Button
- :nail_care: Change the font weight from 800 to 700. [#770](https://github.com/tokopedia/unify/pull/770)
---
#### Carousel/CarouselV2
- :star2: Fix onChange triggered on initial first render. [#776](https://github.com/tokopedia/unify/pull/776)
---
#### PageControl
- :star2: Remove warning `Unknown event handler property ... It will be ignored`. [#768](https://github.com/tokopedia/unify/pull/768)
- :bug: Fix PageControl off-centered when the item is less than 5. [#768](https://github.com/tokopedia/unify/pull/768)
---
#### Tab
- :star2: Remove warning `Unknown event handler property ... It will be ignored`. [#768](https://github.com/tokopedia/unify/pull/768)
---
#### Timer
- :bug: Add position relative on Timer containing element. [#777](https://github.com/tokopedia/unify/pull/777)

## v3.17.1 `2021-01-04`
### Component Changes
#### TextField
- :bug: Fix TextField label doesn't update it's position on initial render when it has default value. [#764](https://github.com/tokopedia/unify/pull/764)

## v3.17.0 `2020-12-21`
### Component Changes
#### CarouselV2
- :star2: Add new callback property, `onSwipe`. [#750](https://github.com/tokopedia/unify/pull/750)
---
#### TextArea
- :star2: Add new property, `placeholder`. [#748](https://github.com/tokopedia/unify/pull/748)
---
#### TextField
- :star2: Add new property, `placeholder`. [#748](https://github.com/tokopedia/unify/pull/748)
---
#### Toaster
- :star2: Add new prop bottomDistance, this property compound the default bottom distance of `24px` with the user defined value. [#760](https://github.com/tokopedia/unify/pull/760)

## v3.16.0 `2020-12-10`
### General Changes
- :star2: Update dependency of uniy-token to version `1.8.0`. [#727](https://github.com/tokopedia/unify/pull/727)
- :star2: Update motion animation on several components using latest token value. [#727](https://github.com/tokopedia/unify/pull/727)
  - Accordion
  - BottomNav
  - BottomSheet
  - BottomSheetV2
  - Carousel
  - CarouselV2
  - Chips
  - Checkbox
  - ContentSwitcher
  - Dialog
  - Overlay
  - ProgressBar
  - Radio
  - SearchBar
  - Tab
  - Toaster
  - Toggle

### Component Changes
#### CoachmarkV2
- :star2: Add new property `showDelay` to set delay before Coachmark appears for CoachmarkSteps wich is part of CoachmarkV2. [#733](https://github.com/tokopedia/unify/pull/733)
---
#### Datepicker
- :bug: Fix datepicked not highlighted by the CSS. [#739](https://github.com/tokopedia/unify/pull/739)
---
#### Dialog
- :star2: Add new props `actionSecondaryBorder` to set Dialog secondary action style without border. [#728](https://github.com/tokopedia/unify/pull/728)
- :nail_care: Update image position on Dialog. [#728](https://github.com/tokopedia/unify/pull/728)
---
#### PageControl
- :star2: New property `variant`, let you choose between specified color scheme. [#737](https://github.com/tokopedia/unify/pull/737)
  - `green` (default)
  - `black`
  - `white`
- :nail_care: Update color to the latest requirements. [#737](https://github.com/tokopedia/unify/pull/737)
---
#### Timer
- :star2: Add new props `stickyProps` to set sticky position when  props `type` `sticky` is selected, accept object. [#741](https://github.com/tokopedia/unify/pull/741)
  - distance, `string` default to `0px`.
  - position, `string` default to `top`.
  - zIndex, `number` default to 10.
- :bug: Fix timer box width constantly changed on Timer with `type` `highlight` is selected. [#741](https://github.com/tokopedia/unify/pull/741)
---
#### TotalAmount
- :rocket: New component `TotalAmount`. [#721](https://github.com/tokopedia/unify/pull/721)
---
#### Toggle
- :nail_care: Update Toggle style to latest requirements. [#734](https://github.com/tokopedia/unify/pull/734)

### v3.15.1 `2020-11-17`

## Component Changes
### BottomSheetV2
- :star2: Add new props `backProps` allow user to add user defined property on back button. [#730](https://github.com/tokopedia/unify/pull/730)

### v3.15.0 `2020-11-17`

## Component Changes
### Timer
- :rocket: New component. [#688](https://github.com/tokopedia/unify/pull/688)

### v3.14.0 `2020-10-19`

## Component Changes
### Accordion
- :rocket: New component. [#672](https://github.com/tokopedia/unify/pull/672)
---
### CarouselV2
- :star2: Add new prop `dataTest` on the Carousel to be passed to the PageControl. [#679](https://github.com/tokopedia/unify/pull/679)
- :bug: Improve transition behaviour. [#679](https://github.com/tokopedia/unify/pull/679)
---
### CoachmarkV2
- :rocket: New component. [#663](https://github.com/tokopedia/unify/pull/663)
---
### List
- :star2: Allow List object props `text` to not only accept string, but also node, to allow label/notification to inside the list.
[#644](https://github.com/tokopedia/unify/pull/644)
---
### Tab
- :star2: Add new prop `onClickToggle`, passing this props will show toggle section on the right side of Tab, to allow other functionalities. [#676](https://github.com/tokopedia/unify/pull/676)

### v3.13.0 `2020-09-23`

## Component Changes
### BottomSheetV2
- :bug: Fix BottomSheetV2 that has `full` and `dynamicContent={false}` props resulting clipped content. [#652](https://github.com/tokopedia/unify/pull/652)
---
### FooterV2
- :rocket: New Component FooterV2 [#630](https://github.com/tokopedia/unify/pull/630)
---
### OTP
- :rocket: New Component OTP. [#651](https://github.com/tokopedia/unify/pull/651)
---
### QuantityEditor
- :star2: Add new props `dataTest`. [#656](https://github.com/tokopedia/unify/pull/656)

### v3.12.4 `2020-09-14`

## Component Changes
### TextField
- :bug: Fix error when user out of focus of the TextField.

### v3.12.3 `2020-09-10`

## Component Changes
### BottomSheetV2
- :nail_care: Update BottomSheet width to accomodate floating button issue. [#648](https://github.com/tokopedia/unify/pull/648)
---
### TextField
- :bug: Fix error when focusing the TextField without a `label` property on it. [#649](https://github.com/tokopedia/unify/pull/649)

### v3.12.2 `2020-09-09`

## Component Changes
### BottomSheetV2
- :bug: Fix BottomSheetV2 issue with dynamic content. [#638](https://github.com/tokopedia/unify/pull/638)
---
### TextField
- :bug: Fix wrong label positioning when there are any prependText/prependObject. [#634](https://github.com/tokopedia/unify/pull/634)

### v3.12.1 `2020-09-02`

## Component Changes
### BottomSheetV2
- :bug: Fix BottomSheet content height not changed if there are any images that finished loading increasing height of the content. [#632](https://github.com/tokopedia/unify/pull/632)

### v3.12.0 `2020-08-31`

## Component Changes
### BottomSheetV2
- :star2: Improve BottomSheet positioning calculation. [#612](https://github.com/tokopedia/unify/pull/612)
- :bug: Fix BottomSheetV2 Input Blur Event Handling in Android OS. [#626](https://github.com/tokopedia/unify/pull/626)
- :bug: Add checker for parentElement existence. [#622](https://github.com/tokopedia/unify/pull/622)
- :nail_care: Open sans font. [#622](https://github.com/tokopedia/unify/pull/622)
- :bug: Fix SSR error. [#619](https://github.com/tokopedia/unify/pull/619)
---
### Carousel
- :star2: Add `PageControl` on the Carousel. [#617](https://github.com/tokopedia/unify/pull/617)
---
### DatePicker
- :rocket: New prop `format`, allow DatePicker to change it's display format. [#613](https://github.com/tokopedia/unify/pull/613)
- :rocket: New sub-prop `textColor` for `price` property, to change text color of the price. [#603](https://github.com/tokopedia/unify/pull/603)
- :bug: Fix panel position and scrollToTop. [#618](https://github.com/tokopedia/unify/pull/618)
---
### PageControl
- :nail_care: Update PageControl design to the newest one. [#617](https://github.com/tokopedia/unify/pull/617)
---
### Pagination
- :star2: Update SEO requirements. [#611](https://github.com/tokopedia/unify/pull/611)

### v3.11.1 `2020-07-27`

## Component Changes
### BottomSheet
- :bug: Fix autoPlay not working. [#594](https://github.com/tokopedia/unify/pull/594)

### v3.11.0 `2020-07-22`

## Component Changes
### BottomNav
- :star2: Add new sub-props on `items`, `color`. [#583](https://github.com/tokopedia/unify/pull/583)
---
### BottomSheetV2
- :star2: Add new event listener `onDrag`, `onDragStart`, `onDragEnd`. [#581](https://github.com/tokopedia/unify/pull/581)
---
### Card
- :star2: Remove unnecessary `console.warn`. [#586](https://github.com/tokopedia/unify/pull/586)
---
### CarouselV2
- :rocket: New component, CarouselV2. Improvement from previous carousel but created as new component since it's breaking changes. [#477](https://github.com/tokopedia/unify/pull/447)
---
### Chip
- :star2: Add new props `ellipsis`. [#570](https://github.com/tokopedia/unify/pull/570)
---
### Coachmark
- :bug: Fix SSR broken because `window/document` not found caused by Coachmark. [#579](https://github.com/tokopedia/unify/pull/579)
---
### Global Error
- :star2: Add secondary actio button. [#544](https://github.com/tokopedia/unify/pull/554)
---
### List
- :nail_care: Update minor style. [#580](https://github.com/tokopedia/unify/pull/580)
---
### Pagination
- :rocket: New component, Pagination. [#557](https://github.com/tokopedia/unify/pull/557)
- :star2: Update HTML element tag for navigation. [#584](https://github.com/tokopedia/unify/pull/584)
---
### SideBar
- :star2: Change static text `TokoPoints` into `Rewards`. [#577](https://github.com/tokopedia/unify/pull/577)
- :star2: Remove Egg icon on previously TokoPoints section to be user configured. [#582](https://github.com/tokopedia/unify/pull/582)

### v3.10.4 `2020-07-08`

## Component Changes
### BottomSheet
- :bug: Fix Toaster shows behind BottomSheet because previous patch behaviour improvements. [#571](https://github.com/tokopedia/unify/pull/571)
---
### Datepicker
- :bug: Fix memory leak when using `minTime` and `maxTime` props. [#573](https://github.com/tokopedia/unify/pull/573)
---
### Tab
- :bug: Fix ellipsis on Tab component. [#555](https://github.com/tokopedia/unify/pull/555)

### v3.10.3 `2020-07-06`

## Component Changes
### BottomNav
- :star2: Change `crossOrigin` property placement to experiment with CORS issue. [#563](https://github.com/tokopedia/unify/pull/563)
---
### BottomSheet
- :bug: Update Behavior & Minor Improvements. [#565](https://github.com/tokopedia/unify/pull/565)
---
### Card
- :bug: Revert layout changes from previous version to fix compability. [#560](https://github.com/tokopedia/unify/pull/560)
---
### Datepicker
- :star2: Add new props, `minTime` and `maxTime`. [#558](https://github.com/tokopedia/unify/pull/558)
- :bug: Fix Datepicker wrong day. [#566](https://github.com/tokopedia/unify/pull/566)

### v3.10.2 `2020-06-09`

## Component Changes
### Coachmark
- :bug: Fix page scrolling disabled after Coachmark close. [#542](https://github.com/tokopedia/unify/pull/542)
---
### Datepicker
- :bug: Fix Datepicker default rendered with time. [#544](https://github.com/tokopedia/unify/pull/544)
- :bug: Fix initial date value. [#551](https://github.com/tokopedia/unify/pull/551)
---
### Navbar
- :bug: Fix Navbar `selectable` margin when `onBack` props exist. [#547](https://github.com/tokopedia/unify/pull/547)
---
### Sidebar
- :nail_care: Adjust Sidebard Card with latest improvement. [#549](https://github.com/tokopedia/unify/pull/549)
---
### TextField
- :bug: Fix `this.info` is `null` error on some occasions. [#546](https://github.com/tokopedia/unify/pull/546)

### v3.10.1 `2020-06-03`

## Component Changes
### Chip
- :bug: Fix `keyframe_shimmer` is not defined.

### v3.10.0 `2020-05-27`

## Component Changes
### Button
- :star2: Add new props `padding` to override default Button padding. [#521](https://github.com/tokopedia/unify/pull/521)
- :nail_care: Update Button border color. [#523](https://github.com/tokopedia/unify/pull/523)
- :nail_care: Update Button `disabled` style. [#527](https://github.com/tokopedia/unify/pull/527)
---
### Coachmark
- :star2: Rework on how Coachmark highlighting the element to prevent future use case (highlighting fixed elements, inside parent with position other than static, etc). [#529](https://github.com/tokopedia/unify/pull/529)
---
### ContentSwitcher
- :star2: Add new props `heading` to override default heading tag level (H1-H6). [#488](https://github.com/tokopedia/unify/pull/488)
- :star2: Minor improvement on micro-interaction. [#488](https://github.com/tokopedia/unify/pull/488)
- :nail_care: Update the design to follow guideline. [#488](https://github.com/tokopedia/unify/pull/488)
---
### Datepicker
- :rocket: Add new variant, Datepicker with Time. [#492](https://github.com/tokopedia/unify/pull/492)
---
### Dialog
- :star2: Add new props `titleProps`, to add user defined props on Dialog title. [#530](https://github.com/tokopedia/unify/pull/530)
- :star2: Add new props `descriptionProps`, to add user defined props on Dialog description. [#530](https://github.com/tokopedia/unify/pull/530)
---
### LocalLoad
- :nail_care: Update assets. [#522](https://github.com/tokopedia/unify/pull/522)
- :nail_care: Fix load icon position. [#522](https://github.com/tokopedia/unify/pull/522)
---
### Navbar
- :star2: Add new props `onClick`, adding click event listener to the whole Navbar (exclude back button). [#528](https://github.com/tokopedia/unify/pull/528)

## Component Changes

### v3.9.0 `2020-04-21`

## General Changes
- :star2: Update prebuild script. [#472](https://github.com/tokopedia/unify/pull/472)

## Component Changes
### BottomSheet (V2)
- :bug: Fix rolling body lock on stacked BottomSheet. [#507](https://github.com/tokopedia/unify/pull/507)
- :star2: Add new prop `closeProps` to set the close button user defined properties. [#514](https://github.com/tokopedia/unify/pull/514)
---
### Card
- :bug: Fix wrong asset path that leads to error. [#504](https://github.com/tokopedia/unify/pull/472)
- :star2: Add new prop `active` to set the card into active state. [#447](https://github.com/tokopedia/unify/pull/447)
---
### Chip
- :star2: Add new prop `shrink` property to shrink the Chip. [#439](https://github.com/tokopedia/unify/pull/439)
---
### Datepicker
**Calendar**
- :bug: Fix indicator focus. [#479](https://github.com/tokopedia/unify/pull/479)
- :star: Add new prop `enabledDate` to do what `disabledDate` do but reversed, set only selected date available to the user and set other date to be disabled. [#500](https://github.com/tokopedia/unify/pull/500)

**Scroll**
- :star2: Allow custom className from the user. [#478](https://github.com/tokopedia/unify/pull/478)
---
### Dialog
- :star2: Add new prop `actionPrimaryProps` to set the primary action button user defined properties. [#514](https://github.com/tokopedia/unify/pull/514)
- :star2: Add new prop `actionSecondaryProps` to set the secondary action button user defined properties. [#514](https://github.com/tokopedia/unify/pull/514)
---
### Footer
- :star2: Add new prop `tokopediaCareURL` and `tokopediaCareURLClicked`. [#478](https://github.com/tokopedia/unify/pull/478)
---
### Loader
- :star2: Add shimmering effect on Circle and Square Loader. [#506](https://github.com/tokopedia/unify/pull/506)
- :bug: Fix `borderRadius` props not working on Loader Line. [#490](https://github.com/tokopedia/unify/pull/490)
---
### Navbar
- :star2: Add new prop `heading` to dynamically change tag level for the title. [#454](https://github.com/tokopedia/unify/pull/454)
---
### QuantityEditor
- :star2: Add new prop `readonly` to only let the value changed from the button. [#495](https://github.com/tokopedia/unify/pull/495)
- :star2: Add new prop `onClickPlus` and `onClickMin` to set callback when clicking the buttons. [#495](https://github.com/tokopedia/unify/pull/495)
---
### Select
- :bug: Fix `onBlur` event not working on Select with `withSearch` property. [#464](https://github.com/tokopedia/unify/pull/464)
---
### Sidebar
- :star2: Update icon and wording from `Pusat Bantuan` to `Tokopedia Care`. [#474](https://github.com/tokopedia/unify/pull/474)
---
### Tab
- :bug: Fix spacing between `Tab` and `TabItem` when prop `flat` set to `true`. [#456](https://github.com/tokopedia/unify/pull/456)
- :nail_care: Add ellipsis on Tab text. [#508](https://github.com/tokopedia/unify/pull/508)
---
### TextField
- :star2: Change propTypes for `appendObject` and `prependObject` to `node`. [#468](https://github.com/tokopedia/unify/pull/468)
- :bug: Fix eslint error `import-resolver`. [#468](https://github.com/tokopedia/unify/pull/468)
---
### Toaster
- :bug: Fix error log shows el is `null`. [#512](https://github.com/tokopedia/unify/pull/512)
---

### v3.8.2 `2020-04-02`

### TextField
- :star2: Allow label to transition to the top when TextField has appended/prepended text or object. [#487](https://github.com/tokopedia/unify/pull/487) [#491](https://github.com/tokopedia/unify/pull/487)
---
### Ticker
- :bug: Fix `error` object sub prop doesn't change Ticker type. [#482](https://github.com/tokopedia/unify/pull/482)
---
### Typography
- :bug: Fix `color` prop not working. [#480](https://github.com/tokopedia/unify/pull/480)
---
### GlobalError
- :bug: Fix GlobalError wrong path on StoryBook. [#482](https://github.com/tokopedia/unify/pull/482)

### v3.8.1 `2020-03-19`

### GlobalError
- :bug: Fix wrong import path.

### v3.8.0 `2020-03-06`

### General
- :star2: Reduce bundle size [#425](https://github.com/tokopedia/unify/pull/425)
- :star2: Prevent duplicate code on build file [#425](https://github.com/tokopedia/unify/pull/425)
---
### BottomSheetV2
- :star2: Cleanup & transform static styled-component into static css emotion ([#442](https://github.com/tokopedia/unify/pull/442))
- :bug: Fix body scroll lock on conditional rendered BottomSheetV2 ([#442](https://github.com/tokopedia/unify/pull/442))
- :bug: Fix scroll lock on iOS [#450](https://github.com/tokopedia/unify/pull/450)
---
### BottomNav
- :star2: Use conditional rendering for img ([#434](https://github.com/tokopedia/unify/pull/434))
---
### Carousel
- :star2: Add static class for carousel footer ([#436](https://github.com/tokopedia/unify/pull/436))
- :bug: Fix css animations cause flicker on safari ios ([#436](https://github.com/tokopedia/unify/pull/436))
- :bug: Fix Swipe Behavior ([#436](https://github.com/tokopedia/unify/pull/436))
---
### Datepicker
#### Calendar
- :bug: Fix for second Date does not appear if you enter the same date ([#433](https://github.com/tokopedia/unify/pull/433))
- :bug: Fix display incorrect index for day name ( panelRange ) ([#433](https://github.com/tokopedia/unify/pull/433))

#### Scroll
- :star2: Added value index as second argument to `onChangeValue` [#437](https://github.com/tokopedia/unify/pull/437)
---
### EmptyState
- :nail_care: Update font-size from 12px to 14px ([#449](https://github.com/tokopedia/unify/pull/449))
- :nail_care: Update margin-bottom from 8px to 16px ([#449](https://github.com/tokopedia/unify/pull/449))
---
### Label
- :nail_care: Update time (icon) and style ([#444](https://github.com/tokopedia/unify/pull/444))
---
### Loader Line
- :star2: Add new props `borderRadius` to set border-radius ([#445](https://github.com/tokopedia/unify/pull/445))
---
### NavBar
- :star2: Improve props `transparent` to apply transparent NavBar design. So now props `transparent` can receive boolean and object. If you pass it as object, you can set `offset` and `persist`. ([#440](https://github.com/tokopedia/unify/pull/440))
- :star2: Add new props `onTransparentChange` to pass callback when NavBar is changed from transparent into non-transparent. ([#440](https://github.com/tokopedia/unify/pull/440))
---
### Sliders
- :star2: Fix warning error messages for Sliders ([#441](https://github.com/tokopedia/unify/pull/441))
---
### Typography
- :star2: Introducing new props: `heading`. To make peace with SEO, we make you a new props to set HTML heading tag different than it's size appearance. Set it along with `tag` props and say goodbye to SEO issues. ([#430](https://github.com/tokopedia/unify/pull/430))
- :memo: Update documentation ([#430](https://github.com/tokopedia/unify/pull/430))
---

## 3.7.1

`2020-02-03`

### Select
- :bug: Rebuild to fix super expression error.

---

## 3.7.0

`2020-02-03`

### BottomSheetV2

- :bug: Fix close button error with non-inline svg approach

**Pull Request(s)**
[#418](https://github.com/tokopedia/unify/pull/418)

---

### Datepicker (Calendar)

- :bug: make monday be a first day of week
- :bug: fix background in endDate selected

**Pull Request(s)**
[#417](https://github.com/tokopedia/unify/pull/417)

---

### Datepicker (Scroll)

- :star2: Improve clarity to year section by adding disabled values between min and max years
- :bug: Fix date and month scroll behaviour not updated after updating year due to bug in event handlers
- :bug: Fix minYear and maxYearnot working as intended because of superseding issue in code
- :bug: Fix crashing bug that occurs by rapidly clicking while changing values

**Pull Request(s)**
[#409](https://github.com/tokopedia/unify/pull/409)

---

### Dialog
- :star2: Add new `loadingPrimary` and `loadingSecondary` props for toggle loading props on primary and secondary action button.

**Pull Request(s)**
[#406](https://github.com/tokopedia/unify/pull/406)

---

### Carousel, NavBar, SearchBar, Tab, Toaster

- :star2: Add new props to provide `data-testid`
- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#400](https://github.com/tokopedia/unify/pull/400)
[#398](https://github.com/tokopedia/unify/pull/398)

---

### Sliders

- :rocket: Implement SliderV2
- :memo: Add Deprecation Error Messages for RangeSlider and Slider
- :memo: Add Documentations for All Sliders

**Pull Request(s)**
[#389](https://github.com/tokopedia/unify/pull/389)

---

## 3.6.0-beta-1

`2020-1-8`

### Carousel

- :star2: Add `useContainerWidth` props to use container's width for Carousel's width.
- :star2: Fix `autoPlay` not updating behavior when changed.

**Pull Request(s)**
[#392](https://github.com/tokopedia/unify/pull/392)

---

## BottomSheetV2

- :bug: Fix body scroll on BottomSheet with close button [#382]
- :bug: Fix BottomSheetV2 stack with Dialog/overlay components [#382]
- Enable stackability in Dialog component [#382]
- :bug: Fix tracking error caused by inline svg icon [#390]

**Pull Request(s)**
[#382](https://github.com/tokopedia/unify/pull/382)
[#390](https://github.com/tokopedia/unify/pull/390)

---

## Coachmark

- :star2: Wrap Coachmark in overlay HOC to properly disable scrolling when active [#383]
- fix Coachmark position issue that is caused by calculation with height of null containerRef in useEffect [#387]
- remove onChange action when 'done' button of Coachmark is clicked to prevent unwanted scrolling [#387]
- onChange when currentPage changes doesn't change horizontal scroll position [#387]

## Coachmark, BottomSheet, Dialog, Menu, Tooltip

- :star2: Set body's overflow property to hidden when element inside overlay HOC's display is true on load. [#383]

**Pull Request(s)**
[#383](https://github.com/tokopedia/unify/pull/383)
[#387](https://github.com/tokopedia/unify/pull/387)

---

## TextArea

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#381](https://github.com/tokopedia/unify/pull/381)

---

## BottomNav, Dialog, Label, Navbar, Tab, EmptyState, Typography

- 🌟 rework styled component

**Pull Request(s)**
[#380](https://github.com/tokopedia/unify/pull/380)

---

## Loaders

- :memo: Add notes for Loaders.

## Datepicker

- :star2: Enable Datepicker scrolling on Desktop

##

- :star2: Add 4px padding between banner and footer sections for Carousel.

**Pull Request(s)**
[#375](https://github.com/tokopedia/unify/pull/375)

---

## SearchBar

- :star2: Adding onBlur and onFocus event

**Pull Request(s)**
[#369](https://github.com/tokopedia/unify/pull/369)

---

### BottomSheet (V2)

- :star2: Set `dynamicContent` props by default to `true`, this is for fixing BottomSheet doesn't updated it's height if content is dynamic. [#372](https://github.com/tokopedia/unify/pull/372)

---

### Select

- :star2: Improve style on disabled state. [#374](https://github.com/tokopedia/unify/pull/374)
- :star2: Style minor adjustment with design kit. [#374](https://github.com/tokopedia/unify/pull/374)

---

### TextArea

- :star2: Improve style on disabled state. [#374](https://github.com/tokopedia/unify/pull/374)
- :star2: Style minor adjustment with design kit. [#374](https://github.com/tokopedia/unify/pull/374)

---

### TextField

- :star2: Improve style on disabled state. [#374](https://github.com/tokopedia/unify/pull/374)
- :star2: Style minor adjustment with design kit. [#374](https://github.com/tokopedia/unify/pull/374)

---

### General

- Disabling Terser minification because it's add several issue on client
- Reducing several component size

---

### Image

- Fix `loading` props show gradient background, not the actual image

---

## 3.5.5-beta-4

`2019-12-04`

## Ticker

- :bug: remove min-height to fix one line content issue

**Pull Request(s)**
[#365](https://github.com/tokopedia/unify/pull/365)

---

## BottomSheetV2

- :star2: Support dynamic viewport
- :bug: Fix dynamicContent props not working on share sheet (with loadable children)
- :bug: Fix onScroll event props not working
- :bug: Fix onClose console error
- :star2: Migrate to unify-color token v2

**Pull Request(s)**
[#366](https://github.com/tokopedia/unify/pull/366)

---

## 3.5.5-beta-3

`2019-12-04`

## Tab

- :bug: revert 3.5.5-beta-2 change
- :bug: fix uninentional removal of `value` props

**Pull Request(s)**
[#367](https://github.com/tokopedia/unify/pull/367)

---

## 3.5.5-beta-2

`2019-12-03`

## Tab

- :bug: fix unintentinoal change

**Pull Request(s)**
[#364](https://github.com/tokopedia/unify/pull/364)

---

## 3.5.5-beta-1

`2019-11-29`

## DatepickerScroll

- :bug: fix bug when min and max dates have the same month/year values

**Pull Request(s)**
[#360](https://github.com/tokopedia/unify/pull/360)

---

## Button, Carousel, Loaders, PageControl, QuantityEditor, SearchBar, Sliders, Tabs, Dialog, List, NavigationBar

- :star2: rework styled component

## Button

- :star2: pass parameter e to onClick

**Pull Request(s)**
[#358](https://github.com/tokopedia/unify/pull/358)

---

## Ticker, Tooltip

- :star2: Refactor styled component implementation

**Pull Request(s)**
[#359](https://github.com/tokopedia/unify/pull/359)

---

## Image, BottomNavigation, Card, Container, Divider, Footer, Label, Menu, Notification, Toaster, Wishlist, LocalLoad

- :star2: Refactor styled component implementation

**Pull Request(s)**
[#354](https://github.com/tokopedia/unify/pull/354)

---

## BottomSheet, ContentSwitcher, Datepicker, Checkbox, Radio, Select, Toggle, TextArea, TextField, EmptyState

- :star2: Refactor styled component implementation

**Pull Request(s)**
[#356](https://github.com/tokopedia/unify/pull/356)

---

## Refactor Chip, Coachmark, Overlay & PageControl

- :star2: Refactor styled component implementation

**Pull Request(s)**
[#350](https://github.com/tokopedia/unify/pull/350)

---

## Tips, Tooltips, Toaster, Ticker, Subheader, SearchBar, QuantityEditor, Link, Tips, Typography, PageControl, EmptyState, Notification, Menu, NavBar, Datepicker, Footer, Floating, ContentSwitcher, Carousel, List, Checkbox, Radio, Select, TextArea, TextField, Toggle, Toolbar

- :star2: Implement unify-token v2 (typographies and spacings)

**Pull Request(s)**
[#337](https://github.com/tokopedia/unify/pull/337)

---

## Button, Card, Chip, Container, Label, Loaders

- :star2: Implement unify-token v2 (typographies and spacings)

**Pull Request(s)**
[#336](https://github.com/tokopedia/unify/pull/336)

---

## 3.5.4

`2019-11-18`

## Coachmark

- :star2: disable scrolling when coachmark is active
- :star2: increase top padding of coachmark to 60px to prevent it from overlapping Navbar
- :star2: change opacity of to 0.96

## DatepickerScroll

- :star2: add property touch-action:none to prevent pull-to-refresh on Chrome when scrolling down datepicker scroll

## Toaster

- :star2: set font-weight:normal to description, font-weight:bold to CTA

## Tips

- :star2: fix infinite looping issue on Firefox in handleMultiline() due to scrollHeight is greater than offsetHeight for font-size: 14px

**Pull Request(s)**
[#311](https://github.com/tokopedia/unify/pull/311)

---

## DatepickerScroll

- :star2: add momentum scroll

**Pull Request(s)**
[#334](https://github.com/tokopedia/unify/pull/334)

---

## Subheader, Loader, Slider, QuantityEditor, Tooltip, Toaster, Ticker, PageControl, Link, Tab, Overlay, Organism, Notification, NavBar, Menu, Label, Footer, Container, Chip, Carousel, BottomSheet, BottomNav

- :star2: Implement unify-token v2 (color)

**Pull Request(s)**
[#322](https://github.com/tokopedia/unify/pull/322)

---

## BottomNav, SearchBar, Typography, List, Link, Dialog

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#339](https://github.com/tokopedia/unify/pull/339)
[#288](https://github.com/tokopedia/unify/pull/288)

## BottomSheetV2

- :bug: Fix breaking SSR
- :bug: Fix unexpected full props change behavior on withKnob bottom sheet
- :boom: Remove noPadding props (as now default padding is 0)
- :memo: Update documentation
- :star2: Add new props: dynamicContent, enable dynamic height adjustment on withClose bottom sheet

**Pull Request(s)**
[#285](https://github.com/tokopedia/unify/pull/285)

---

## ContentSwitcher, Checkbox, Radio, Select, Toggle, Image, Wishlist, EmptyState

- :memo: Update documentation (notes, story and knobs)

## Button, Card, ContentSwitcher, Divider, Checkbox, Radio, Select, Toggle, Image, List, TextField. TextArea, Wishlist, EmptyState, SearchBar, LocalLoad, Typography

- :star2: Implement unify-token v2 (color)

**Pull Request(s)**
[#310](https://github.com/tokopedia/unify/pull/310)

---

## Datepicker

- :memo: Update documentation (notes, story and knobs)
- :star2: Implement unify-token color v2 (Calendar & scrollMode)
- :star2: Back one year, **_only 1 year from the current year_** (Calendar)
- :star2: Independent props `minDate` (Calendar)
- :star2: Independent props `maxDate` (Calendar)
- :star2: Independent props `disabledDate` (Calendar)
- :star2: Independent props `alternateDate` (Calendar)
- :star2: Independent props `infoDate` (Calendar)
- :star2: `disabledDate`, `alternateDate`, `infoDate` can repeatedly or only once (Calendar)
- :star2: shorten lines of code and delete unnecessary code (Calendar)
- :bug: stories Datepicker ( related to PR [#314](https://github.com/tokopedia/unify/pull/314) )

**Pull Request(s)**
[#300](https://github.com/tokopedia/unify/pull/300), [#314](https://github.com/tokopedia/unify/pull/314)

---

## QuantityEditor

- :memo: Update documentation (notes, story and knobs)

## Tooltip

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#301](https://github.com/tokopedia/unify/pull/301)

## Image

- :star2: :bug: render image as `<img />` tag.
- :star2: :bug: prop `alt` will be rendered as attribute on `<img />`
- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#248](https://github.com/tokopedia/unify/pull/248)

---

## Coachmark

- :bug: Fix wrong coachmark position calculation when document.body is scrolled
- :bug: Fix wrong coachmark position calculation because of incorrect offsetTop for target element
- :bug: Fix target elements with position:static not appearing on top of overlay
- :bug: Fix wrong position of coachmark when document.body height is less than window height
- :star2: Now handles absolute positioning
- :star2: ripple effect on button now positioned correctly (fixed by adding box-sizing: border)
- :memo: Update documentation (notes, story, Knobs and Actions)

**Pull Request(s)**
[#274](https://github.com/tokopedia/unify/pull/274)

---

## Datepicker, Footer, RangeSlider, Carousel

- :memo: Update documentation (notes, story, knobs)

## DatepickerScroll

- :star2: minDate/maxDate for DatepickerScroll now can be set dynamically (not only on first props setting)

**Pull Request(s)**
[#276](https://github.com/tokopedia/unify/pull/276)

---

## GlobalError

- :memo: Update documentation (notes, story and knobs)

## Label

- :memo: Update documentation (notes, story and knobs)

## Menu

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#275](https://github.com/tokopedia/unify/pull/275)

---

## EmptyState

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#225](https://github.com/tokopedia/unify/pull/225)

---

## NavBar

- :bug: Fix back icon color if transparent active

**Pull Request(s)**
[#272](https://github.com/tokopedia/unify/pull/272)

---

## ContentSwitcher

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#270](https://github.com/tokopedia/unify/pull/270)

---

## Toggle

- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#264](https://github.com/tokopedia/unify/pull/264)

---

## Notification

- :memo: Update documentation (notes, story and knobs).

## Tab

- :star2: Add props `lang` to specify language of New Notification Component

**Pull Request(s)**
[#263](https://github.com/tokopedia/unify/pull/263)

---

## Divider

- :star2: Delete unused code
- :memo: Add README.md.
- :memo: Update Storybook with Notes

**Pull Request(s)**
[#259](https://github.com/tokopedia/unify/pull/259)

---

## Container

- :memo: Update documentation (notes, story and knobs).

**Pull Request(s)**
[#257](https://github.com/tokopedia/unify/pull/257)

---

## Wishlist

- :memo: Add README.md.
- :memo: Update Storybook with Knobs.

**Pull Request(s)**
[#256](https://github.com/tokopedia/unify/pull/256)

---

## Select

- :memo: Add README.md.
- :memo: Update Storybook with Knobs.

**Pull Request(s)**
[#238](https://github.com/tokopedia/unify/pull/238)

---

## Radio

- :memo: Add README.md.
- :memo: Update Storybook with Knobs.

**Pull Request(s)**
[#235](https://github.com/tokopedia/unify/pull/235)

---

## Button

- :star2: Adding background on ghost button
- :memo: Update documentation (notes, story and knobs)

**Pull Request(s)**
[#232](https://github.com/tokopedia/unify/pull/232)

---

## TextField

- :memo: Add README.md.
- :memo: Update Storybook with Knobs.

**Pull Request(s)**
[#230](https://github.com/tokopedia/unify/pull/230)

---

## Chip

- :memo: Update component documentation
- :memo: Update Storybooks Knobs

**Pull Request(s)**
[#281](https://github.com/tokopedia/unify/pull/281)

## 3.5.3

`2019-10-14`

### BottomSheetV2

- :star2: Refined draggable (`withKnob`) BottomSheetV2 interaction.
- :boom: `withClose` variant is now default (previously `withKnob`).
- :rocket: Introducing new event props `onMaximize` & `onMinimize` (require `withKnob`).
- :bug: Height problems should now fixed and more consistent.
- :memo: Improved documentation with Storybook Knobs.

**Pull Request(s)**
[#224](https://github.com/tokopedia/unify/pull/224)

---

### Select, TextArea, TextField

- :star2: Improvement space on wrapper info/message.
- :star2: deprecated props `withInfo`

**Pull Request(s)**
[#239](https://github.com/tokopedia/unify/pull/239)

---

### Ticker

- :memo: improve documentation
- :star2: setting `indexActive` outside range no longer causes crash
- remove restriction that causes actionText to not appear when props `additional` is passed
- :bug: fix bug that causes close icon to appear even when `onClose` not set, produced in `3.5.2`

### PageControl

- :memo: improve documentation
- :bug: fix unexpected jerk animation at beginning

### Toaster

- :memo: improve documentation

### Tab

- :memo: improve documentation
- Deprecate `primary` and `secondary` props

### RangeSlider

- :bug: fix bug component not re-rendering when value is updated

**Pull Request(s)**
[#249](https://github.com/tokopedia/unify/pull/249)

### Global error

- :star2: Update illustrations for all global error.
- :star2: Update copywriting.
- :star2: Add button.
  **New Props**
  - `onActionClick`, To pass callback when button is clicked.
  - `buttonFull`, To adjust the button's full width, use it if you place this component inside a BottomSheet.

### Empty States

- :star2: Update button from 200px into 220px.

### Notification

:star:

- Update padding of New Notification
- Add new props `lang` to specify language of New Notification

---

### Carousel

:boom: Possibly breaks design.

- :star2: Refactor to a functional component
- :star2: Removes old design where page control is on top of banner image container. `padding` no longer adds margin below banner image container
- :bug: Fix padding bugs when parent element has padding

**Pull Request**
[#221](https://github.com/tokopedia/unify/pull/221)

---

### Datepicker

- :rocket: :boom: change `maxYear` and `minYear` to `maxDate` and `minDate` for DatepickerScroll, now type is Date object instead of number.

**Pull Request**
[#241](https://github.com/tokopedia/unify/pull/241)

---

### Checkbox

- :memo: Add `README.md`.
- :memo: Update Storybook with Knobs.

**Pull Request**
[#234](https://github.com/tokopedia/unify/pull/234)

---

### LocalLoad

- :memo: Add `README.md`.
- :memo: Update Storybook with Knobs.

**Pull Request**
[#233](https://github.com/tokopedia/unify/pull/233)

---

### Tips

- :memo: Add `README.md`.
- :memo: Update Storybook with Knobs.

**Pull Request**
[#228](https://github.com/tokopedia/unify/pull/228)

---

###Card

- :memo: Update Storybook documentation (notes and knobs).

**Pull Request**
[#237](https://github.com/tokopedia/unify/pull/237)

## 3.5.2

`2019-09-23`

### Ticker

- :star2: `info` is no longer props at parent component level. Instead `info` may be used per individual ticker item by having the property `info: true` in the select item element inside array `items`.
- :star2: onClick and onClose callbacks are now called with `indexActive` and `e` as arguments.
- :star2: Refactor to a functional component (Hooks).

**Pull Request**
[#192](https://github.com/tokopedia/unify/pull/192)
[#215](https://github.com/tokopedia/unify/pull/215)

---

### Button

- :star2: Update text color for ghost alternate variant.

### Dialogs

- :star2: Update title color.

### Tips

- :star2: Refactor to a functional component (Hooks).

**Pull Request**
[#181](https://github.com/tokopedia/unify/pull/181)
[#202](https://github.com/tokopedia/unify/pull/202)

---

### Coachmark

- :bug: Fix bug where z-index of previously active items remains 60/set to 0 even when coachmark is inactive.
- :star2: Refactor to a functional component (Hooks).

**Pull Request**
[#192](https://github.com/tokopedia/unify/pull/192)

---

### Tab

- :star2: Refactor to a functional component.

**New Props**

- `icon` to provide icon url.
- `iconSize` to provide icon size, strictly either 16, 24 or 32.
- `newNotification` to provide new variant of notification in tab item.

**Pull Request**
[#201](https://github.com/tokopedia/unify/pull/201)
[#202](https://github.com/tokopedia/unify/pull/202)

---

### Datepicker

**New Props**

- `lang`, new prop to specify language of Datepicker.

**Pull Request**
[#204](https://github.com/tokopedia/unify/pull/204)

---

### PageControl

- :star2: Refactor to a functional component (Hooks). Might affect `Coachmark` and `Ticker`.

### DragAndDropList

- :star2: Refactor to a functional component (Hooks).

### Link

- :star2: Refactor to a functional component (Hooks). Might affect `Navbar` and `Typography`.

**Pull Request**
[#202](https://github.com/tokopedia/unify/pull/202)

## 3.5.1

`2019-09-17`

- :bug: Rebuild for trying to resolve issue in several users.

## 3.5.0

`2019-09-16`

### Datepicker :boom:

This update is a `breaking change` since there are redesign, behavior change, and new type of Datepicker, `scroll`. The changes are:

- :star2: Refactor Datepicker to functional components (Hooks).

**New Props**

- `scrollMode`, turn Datepicker into Datepicker scroll mode **(default is Calendar)**.

**Removed Props**

- `full`
- `reverse`

> If you got a problem with Datepicker, please contact Unify team for assistance

**Pull Request**
[#196](https://github.com/tokopedia/unify/pull/196)
[#189](https://github.com/tokopedia/unify/pull/189)
[#183](https://github.com/tokopedia/unify/pull/183)

---

### Tab

- :star2: you can pass `items.key` props with either `string` or `number`.

**Pull Request**
[#187](https://github.com/tokopedia/unify/pull/187)

---

## BottomNav

- :star2: you can pass `items.count` props with either `string` or `number`.

**Pull Request**
[#187](https://github.com/tokopedia/unify/pull/187)

---

### Toaster

- :star2: Refactor into functional components (Hooks).

**Pull Request**
[#186](https://github.com/tokopedia/unify/pull/186)

---

### Tooltip

- :star2: Refactor into functional components (Hooks).

**Pull Request**
[#186](https://github.com/tokopedia/unify/pull/186)

---

### Loader Linear

- :star2: Change linear height from `8px` to `3px`.

**Pull Request**
[#190](https://github.com/tokopedia/unify/pull/190)

---

### Coachmark

- :bug: Fix coachmark crash on Android v7.0.0 Webview.

**Pull Request**
[#195](https://github.com/tokopedia/unify/pull/195)

---

### EmptyState

- :star2: Set image to 4:3 ratio
- :star2: Add secondary CTA
- :star2: Update storybook

**New Props**

- `actionSecondaryText`, set secondary CTA text.
- `onActionSecondaryClick`, set secondary CTA function.
- `loadingSecondary`, set secondary CTA loading state.

**Pull Request**
[#199](https://github.com/tokopedia/unify/pull/199)
[#188](https://github.com/tokopedia/unify/pull/188)

---

### Chip

- :star2: Add Dropdown indicator.
- :star2: Add ability to Chips to have prepended element.

**New props**

- `dropdown`, this props to show caret down icon to indicate `Chips` that have `Dropdown`.
- `prependObject`, this props allow user to pass `HTMLElement` or `Node` to be placed on the left side of the `Chips`.

**Pull Request**
[#191](https://github.com/tokopedia/unify/pull/191)

---

### Footer

- :star2: Refactor into functional components (Hooks).

**Pull Request**
[#180](https://github.com/tokopedia/unify/pull/180)

---

### Menu

- :star2: Refactor into functional components (Hooks).

**Pull Request**
[#180](https://github.com/tokopedia/unify/pull/180)

---

### Quantity Editor

- :star2: Refactor into functional components (Hooks).

**Pull Request**
[#180](https://github.com/tokopedia/unify/pull/180)

---

### Card

- :star2: Set the default margin to `16px`

**Pull Request**
[#180](https://github.com/tokopedia/unify/pull/180)

---

### BottomSheet

- :bug: Revert changes from [146](https://github.com/tokopedia/unify/pull/146)

## 3.4.3

`2019-08-15`

### List

- :star2: Refactor mobile/List component using react hooks
- :star2: Refactor mobile/List unit test to fix circleCI test issue

### Loader Jumper

- :bug: Removing gooey animation to fix bug on android webview

### BottomSheetV2

- :bug: fix `BottomSheetV2` calculation when there is added children

## 3.4.2

`2019-07-15`

- :star2: Adding `crossOrigin` attribute to img html element
- :star2: Fix several missing attribute for img
- :star2: Remove Tab animations for better performance

`2019-07-03`

### Label

- :bug: Fix progress label when there is background color behind it

`2019-07-02`

### Circular

- :bug: Fix loader with indeterminate props animations

### Typography

- :bug: Add security fix on link

`2019-06-20`

- :bug: Revert emotion@10 to react-emotion
- :star2:
  - Add import resolver
  - Update webpack version
- :memo: Update `unify-react-mobile` readme

### BottomSheet

- :bug:

  - fix `full` props when `withClose` is used
  - fix behavior `onMount` when `display` props is true

- :star2:
  - add `onScroll` props to trigger `onScroll` on it's child element
  - improve calculation for padding and height for `ContentWrapper`

### Dialog

- :bug: Bug fix dialog illustration and icon design

### Ticker

- :bug: Fix page controller position bug

### Toaster

- :bug: Fix styles

### Typography

- :star2: Refactor code rendering on link props

## 3.4.1

- :star2:
  - bundle size optimization 1.32mb -> 1.13 :fire:
  - TextField
    - Enable hide info
  - BottomNav
    - Design sync
  - PageControl
    - `timed` page control now fill entire block
- :bug:
  - fix main entrypoint for this package
  - SearchBar
    - fix camera props jank animation transition
  - Tab
    - Fix animation bug when tab is opened in phone that have width greater than 320
  - TextArea
    - Fix placeholder issue get stacked with label, and deprecate placeholder props
  - List
    - Fix onClick not passed to listItem when template is used

## 3.3.1

`2019-05-17`

### Dialog

- :star2: Sync with design kit 1.6.0

## 3.3.0

`2019-05-17`

- :rocket: New Components
  - LoaderLinear - New progress loader
  - Props:
    - indeterminate - looping loader animation
    - loading - pause state for loader
    - progress - loader progress percentage

### BottomSheetV2

- :star2: New props
  - `actionText` display text on right side of BottomSheet header
  - `onActionClick` callback function on text

### Chip

- :bug: Fix ellipsis calculation
- :star2: New props:
  - add `iconSize` props, oneOf [16,24,32] on number type.
  - change `icon` propsType from boolean to string.

### Coachmark

- :star2: Make `title` and `description` props to accept array of strings

### Carousel

- :bug: Fix image `width` bug

### Dialog

- :bug: Fix `className` returns false when there's no `longAction` props given

### Footer

- :star2: Enhance `Footer` assets ( reducing size )

### NavBar

- :star2: New Props:
  - `selectable` props to trigger header with select style. Provides `value` as displayed text and `onClick` callback function

### SearchBar

- :bug: Fix `camera` props condition

### Slider

- :star2: New design applied

### TextArea

- :star2: Increase performance by refactoring several props that calling the same function repeatedly
- :star2: Provide new Textarea for fullscreen Textarea with BottomSheet

## 3.2.1-beta-10

- :star2:
  - BottomSheet
    - add `full` props.
    - add `initialHeight` props.
    - now `maxHeight` for BottomSheet animation is 95%.
    - With Knob:
      - Initial State -> Height following content, Max 50% -> Swipe up.
      - Full State -> Max height 520px -> Swipe down.
      - Back to Initial State -> Swipe down.
      - Back to zero.
      - max `initialHeight` is 50% of screen.
    - Static / With Close:
      - Initial State -> Height following content, No max height.
  - Button
    - Loading button animate transform 0% to up 100% from bottom to up.
  - Content Switcher
    - design sync.
  - Carousel
    - Bug width.
  - Dialog
    - Overlay change into black ( inverted props ).
  - EmptyState
    - add props `horizontal`, `vertical`, `padding`.
    - fix some styles.
  - LoaderList
    - Need image in left side.
  - LocalLoad
    - Change into new background.
  - Notification
    - When numbers reach above 99 will be 99+.
  - Tab
    - Animation indicator slides when changing index.
    - Remove margin right.
  - Ticker
    - Height without `PageControl` should differ with `PageControl`.
    - Full and loose props ( boolean ). Full: no border radius and no margin.
  - Wishlist
    - Add animation heartbeat on click.
  - Textfield
    - Type `password` update assets.

## 3.2.1-beta-9

- :bug:
  - Fix Ticker `min-height` when `title` is not available.

## 3.2.1-beta-8

- :bug:
  - Fix TextField `prepend` and `append` label state.

## 3.2.1-beta-7

- :bug:
  - Fix NavBar camera toggle warning.
  - remove TextArea placeholder.
  - Fix Select label.

## 3.2.1-beta-6

- :bug:
  - Fix coachmark position when index increment
  - Fix get undefined label on Textfield, TextArea and Select
  - ContentSwitcher fail to mount.
  - When overlay umount, revert overflow state.
  - Fix label style is not applied.

## 3.2.1-beta-5

- :bug: Fix bugs on bottomnav

## 3.2.1-beta-4

- :bug: Fix bugs on bottomnav
- :bug: Fix undefined variable in textfield

## 3.2.1-beta-3

- :bug: Fix remove classNames leftover in `Textfield`

## 3.2.1-beta-2

- :bug: Fix memory leak on `withOverlay` HoC

### Chip

- :bugs:
  - Fix ellipsis bug.

### CoachMark

- :bug: Fix wrong scroll calculation on container

### Dialog

- :bug: Fix box-shadow bug on Dialog box

### NavBar

- :bugs:
  - Fix NavBar stepper subtitle bug when there is no onBack props.

### Ticker

- :star2:
  - fix nested <p> warning.
  - auto slide ticker items.
  - multiple ticker type.
  - remove `Carousel` from `Ticker` component to reduce bundle size and optimizing `Ticker`.
  - sync to latest design.

## 3.2.1-beta-1

### NavBar

- :star2:
  - Update burger icon in `NavBar`.

### BottomNav

- :star2:
  - Change BottomNav display to `flex`

### BottomSheetV2

- :rocket:
  - Adding New props to `BottomSheetV2`
    - withKnob={false} to use plain `BottomSheetV2`
    - scrollable `BottomSheetV2` if content is overflowing the bottomsheet itself.
    - now `BottomSheetV2` height is dynamic. depending on
- :star2:
  - Disabling onClose when `BottomSheetV2` is in full state.
    - now `BottomSheetV2` height is dynamic. depending on
- :star2:
  - Disabling onClose when `BottomSheetV2` is in full state.

### TextField

- :star2: Update new design

### Toaster

- :star2: Update new design

### Label

- :star2: New props:
  - progress: number - to indicate # percentage

### ContentSwitcher

- :star2: Update color values

## 3.2.0

`2019-03-25`

- :memo: Update changelog

## 3.2.0-beta-20

`2019-03-21`

- :bug: Fix Carousel footer to be align center

## 3.2.0-beta-19

`2019-03-19`

- Fix build

## 3.2.0-beta-18

`2019-03-18`

### Carousel

- :star2: removing border-radius from image

## 3.2.0-beta-17

`2019-03-18`

### BottomSheetV2

- :star2: Fix title style

### Carousel

- :star2: Add border radius to image

### Ticker

- :star2: Add new props onClick on item for tracking (pass onClick on Ticker for single item, pass onClick on items for multiple item)

## 3.2.0-beta-16

`2019-03-18`

### BottomSheetV2

- :star2: New Props:
  - withClose: boolean (to apply bottomSheet with close button)

### Carousel

- :star2: Update style
  - Change font-size on `Lihat Semua` to 10px

### Divider

- :star2: Update style
  - Change background color

### Ticker

- :star2: New Props:
  - onClick: func

## 3.2.0-beta-15

`2019-03-15`

### Carousel

- :bug: Bugfixing on initial item image load

### Ticker

- :bug: Bugfixing on `setInnerHTML` props

### Tab

- :bug: Bugfixing on tab design

## 3.2.0-beta-14

`2019-03-14`

### Ticker

- :star2: New key on props item (setInnerHTML: boolean)
- :star2: New key on props item (title: string)

## 3.2.0-beta-13

`2019-03-14`

- :rocket: Add New Component:
  - ContentSwitcher

### Carousel

- :star2: New design applied
- New props:
  - :star2: padding: number ( for applying new design )
  - :star2: inverted: bool ( for applying white color on indicator and link in coloured background )
- :bug: [#395](https://github.com/tokopedia/unify-react-mobile/pull/395) Rework carousel reset index if children changed

### Tab

- :star2: New design Applied
- New props:
  - :star2: items['notification']: boolean

### Ticker

- :boom::star2: New design applied, might have breaking changes
- New props:
  - :star2: additional: arrayOf(string)
  - :star2: error: boolean

### Select

- :star2: Accept onClear props when using withSearch props

## 3.2.0-beta-12

`2019-03-13`

### BottomSheet

- :bug: Fix Typography body text font family to follow system font.

## 3.2.0-beta-11

`2019-03-12`

### BottomSheet

- :bug: Remove history support to avoid unneccesarry onClose.

## 3.2.0-beta-10

`2019-03-11`

### Typography

- :bug: Fix default font family

## 3.2.0-beta-9

`2019-03-10`

### BottomSheetV2

- :star2: Update design

### BottomNav

- :star2: Update design

## 3.2.0-beta-8

`2019-03-08`

- :rocket: Add New Component:

  - LoaderShimmer with mask
  - BottomSheetV2 motion

- :star2:
  - Optimize global svg with svgomg
  - disable scrolling when `withOverlay` is triggered
  - reduce package publish size and install size (remove bloat file from pc)

### Label

- :star2: New design applied

### NavBar

- :star2: New design applied
- :star2: `main` NavBar redesign

### SearchBar

- :star2: New design applied

### Wishlist

- :star2: Optimize component

- :bug:
  - Fix Chip styles

## 3.2.0-beta-7

`2019-03-01`

- :rocket: Add New Component:
  - Divider
  - Image ( area, product, userr )
- :star2: Add back history support for mobile devices

### Chips

- :star2: New design applied

### Dialog

- :star2: New design applied

### SearchBar

- :star2: Change SearchBar icon to latest and fix styles.

## 3.2.0-beta-6

`2019-02-22`

- :bug: Fix emotion version compatibility issue
- :bug: Fix coachmark not working with fixed positioning
- :bug: Fix pagecontrol still showing active style when totalPage only one

## 3.2.0-beta-5

`2019-02-21`

- :rocket: Add New Component:

  - LocalLoad
  - QuantityEditor

- Revert emotion 10 to 9 due to compatibility issue.

### EmptyState

- :star2: New design applied

## 3.2.0-beta-4

`2019-02-15`

### BottomNav

- :star2: Add `notification` key to item props
- :star2: Update style for `count` props

### BottomSheet

- :star2: Add new design ( for now please use BottomSheetV2, we will replace the old one in near future )

### Button

- :star2: Add `micro` props for new size variant
- :star2: Update color using design tokens

### Coachmark

- :bug: Fixing bug on animation motion
- :star2: Enhance coachmark performance

### Container

- :star2: Update linear-gradient opacity value

### Selection Control

- :star2: Update styles with new design
- :star2: Remove old png pictures with svg

### Typography

- :star2: Update typography style
- :star2: Add `link` props for component `Link` ( The current Link component will be replaced )

## 3,2.0-beta-5

### TextArea

- :star2:
  - fix `onInput` not called.
  - fix `placeholder` not added.

## 3,2.0-beta-3

`2019-02-07`

### Selection Control

- :star2: Update `Checkbox`, `Radio`, `Toggle` design style.
- :star2: Add `indeterminate` props to checkbox.

### BottomNav

- :star2: Add `notification` props for showing green indicators on top left of icon

## 3,2.0-beta-2

`2019-01-31`

- :rocket: Add New Component:
  - Page Control
  - Coachmark
  - Container (now separated from Card)
- :star2: Update new card design
- :rocket: Add new helper hexToRgbaa

### Datepicker

- :star2: Add `reverse` props for reversing years

## 3.2.0-beta-1

`2019-01-28`

- :rocket: Add New Components:
  - `Wishlist`
  - `Typography`

### Button

- :star2: Add new props to sync with design kit

## 3.1.9

`2019-01-02`

### BottomNav

- :star2: Add lifecycle CDU to update indexActive state.

### Footer

- :star2: Compress Footer svg files ( android and ios )

## 3.1.9-beta-11

`2018-12-27`

### LoaderJumper

- :star2: Add z-index for loader

### Ticker

- :star2: actionLink now accepts both string and function

- :rocket: Add checkString helper function

## 3.1.9-beta-10

### :rocket: Enhancement

- Fix warnings ( props naming convention )
- Update accessibility

## 3.1.9-beta-9

- fix `renderStepper` bug `NavBar`
- fix `withPadding` in `NavBar`
- add customProps in `NavBar`

## 3.1.9-beta-8

### :rocket: Enhancment

- `Carousel` link props now accept either string or function
- Add secondaryTransaction(boolean) props for `Button` ( Design sync )
- Add autoClose(boolean) and autoCloseDuration(number) props for `Toaster`

## 3.1.9-beta-7

### :rocket: Enhancement

- Add custom props to `BottomNav`

## 3.1.9-beta-6

### :rocket: Enhancement

- custom socialLogin button in `Sidebar` children.

## 3.1.9-beta-5

### :rocket: Enhancement

- Tidy `Sidebar` code.
- Allow custom social login to be implemented.

## 3.1.9-beta-4

### :rocket: New Feature

- Add hotlist and official store link on footer
- Props:
  - hotlistURL for hotlist link
  - officialStoreURL for official store link
  - onHotlistURLClicked for hotlist click function
  - onOfficialStoreURLClicked for official store click function

## 3.1.9-beta-3

### :rocket: New Feature

- [#368](https://github.com/tokopedia/unify-react-mobile/pull/368) selection control use label fix

  - :bug:
    - fix `onClick` triggered twice in `SelectionControls` components.

- [#365](https://github.com/tokopedia/unify-react-mobile/pull/365) Enhance lib size
  - :rocket:
    - Enhance library size ( taking out unused packages )
    - Enhance loader jumper animation with gooey effect

## 3.1.9-beta-2

### :bug: Bug Fix

- Fix subnavbar positioning

### :rocket: Enhance

- Remove RichTextEditor and SelectwithSearch component
- Remove sanitize-html, react-transition-group.
- Move glob to devDependencies
- Fix toaster warning
- Add conditional render on navbar back button

## 3.1.9-beta-1

### :bug: Bug Fix

- Fix subnavbar list item props
- Fix subnavbar style image

## 3.1.8

### :rocket: New Feature

- [350](https://github.com/tokopedia/unify-react-mobile/pull/350) New Component SubNavBar
  - Add new component subnavbar
  - Fix Tokopoints to TokoPoints
  - Fix Tab onClick props
  - Improve accessibility on Footer, NavBar, and Searchbar

## 3.1.8-beta-4

### :rocket: New Feature

- [311](https://github.com/tokopedia/unify-react-mobile/pull/311) Rework Slider
  - Add new component named RangeSlider ( old Slider still in library )
  - Refactor Slider code structure and flow
  - Different props usage on RangeSlider ( better and more simple ).
  - custom props for `TabItem`

### :bug: Bug Fix

- [#325](https://github.com/tokopedia/unify-react-mobile/pull/325) Components Test

  - `Button` tx feedback
  - `Button` disable on loading
  - `Footer` inline image
  - `TabContent` children props type
  - Add Components Test

- Bugfix className overwrite problem on several components

## 3.1.7

#### :bug: Bug Fix

- [#321](https://github.com/tokopedia/unify-react-mobile/pull/321) action fix
  - padding on `NavBar` `content` when `title` is not used
- [#326](https://github.com/tokopedia/unify-react-mobile/pull/326) Enhance searchBar accesibilites score in lighthouse
  - Make a label element to wrap searchbar input
  - Fill empty button tag
  - Fix a little style for unf-searchbar--nav
- [#327](https://github.com/tokopedia/unify-react-mobile/pull/327) Hotfix Polyfill
  - Fix polyfill not working for safari and IE (window is not defined)
- [#330](https://github.com/tokopedia/unify-react-mobile/pull/330) Components Fix
  - change `SearchBar` placeholder to 0.38
  - change `Sidebar` anim time from 0.24 to 0.16, remove outline in fold line
  - change `List` HTML structure to `ul`, `li` for better accesibility
  - enable custom props per item in `List`
  - enhance animation in `SideBar`
  - fix `BottomNav` collision with iphone X bottom edge
- [#337](https://github.com/tokopedia/unify-react-mobile/pull/337) add custom props to image banner
  - add fallback styles for `List`
  - add custom props to `SideBar` promo banner image
  - fix `NavBar` stepper issue, and rework stepper animation etc. [#284](https://github.com/tokopedia/unify-react-mobile/issues/284)
- [#339](https://github.com/tokopedia/unify-react-mobile/pull/339) Sidebar bugs
  - add lost margin in `SideBar` link
- [#315](https://github.com/tokopedia/unify-react-mobile/pull/315) Fix Tab
  - Fixes tab content not rendering #314
- [#312](https://github.com/tokopedia/unify-react-mobile/pull/312) SideBar enhance
  - Split SideBar and NavBar export to respective file.
  - Change `display` prop name to `show` in `SearchBar` close button to erase warning.
  - Fix `main` `NavBar` with `title` not showing.
  - Fix `SearchBar` close button style in `main` `NavBar`.
  - Fix `List` toggle styles.
- [#316](https://github.com/tokopedia/unify-react-mobile/pull/316) Enhance Component
  - Fix Bottomnav text spacing
  - Enhance TextArea toggleClear and make withoutAnimation prop to affects message as well
- Remove BottomNav animation to avoid intermittent animation
- [#324](https://github.com/tokopedia/unify-react-mobile/pull/324) Hotfix Toaster
  - Fix floating button classname for toaster to show ontop of floating button

#### :rocket: New Feature

- Implement lazyload on footer image
- Enhance NavBar styles
- [#342](https://github.com/tokopedia/unify-react-mobile/pull/342) Enhance Toaster
  - Enhance animation on toaster with transform
  - Enhance toaster lifecycle for initial display props set to true

## 3.1.6

- Fix Animation Scroll
- Hide Referral Card in Storybook
- Add Loading State
- Add Scroll Animation and Promo Slider to Sidebar.
- Reduce Bundle Size 23% ~ ⚡️, optimize svg filesize from (1.630.657 bytes) to (1.342.145 bytes).
- Base64 image file after optimize, to support Desktop more (1.388.805 bytes).
- Fix native <img /> tag usage :bugfix:
- Change all background-image url data using double quotes.
- Focus actived tab to be at center of tab horizontal scroll box
- Fix Toaster unknown onSwipeDown error
- Fix Ticker link text spacing with single child item
- Fix TextField withoutAnimation props to handle message as well
- Fix label icon not appeared
- Fix Select trigger multiple onChange
- Enhance Tab focus active index
- Add onClear for SearchBar
- Sidebar:
  - Enhance component
  - Add noAnimation props
- NavBar:
  - Add props onSearchChange, onSearchClick, searchValue, placeholder
  - Add noAnimation props
- Add Link Component
- Add organism storybook:
  - Button
  - Card
  - NavBar
  - SearchBar

## 3.1.5

- Revert classnames props and default classname to each component
- Change Toolbar suggestions design
- Enable customprops for all components
- Add label to navbar
- Fix animation on toolbar textfield
- Fix toolbar width animation when displaySuggestions is true
- Fix toolbar and textarea onClear

## 3.1.4

- Add classname to Bottomsheet, Button, Overlay, and BottomNav for Toaster bottom style

## 3.1.3

- Auto complete on text input component
- JEST & Enzyme basic setup
- Tips atom component
- EmptyState organism component
- Chip's children props type using oneOfType for string, object and node
- Change Picker to Datepicker and give major enhancement
- Add function when link clicked on Footer based on this [issue 180](https://github.com/tokopedia/unify-react-mobile/issues/180)
- Add disabled props to Chips based on this [issue 160](https://github.com/tokopedia/unify-react-mobile/issues/160)
- Multiline ellipsis List description based on this [issue 174](https://github.com/tokopedia/unify-react-mobile/issues/174)
- Enhance Select with bottomsheet + list + searchBar [issue 199](https://github.com/tokopedia/unify-react-mobile/issues/199)
- Fix canUseDOM on PortalWrapper
- Fix Carousel max width to 100%
- Fix Calculation range on Slider
- Fix TextArea autogrow based on this [issue 156](https://github.com/tokopedia/unify-react-mobile/issues/156)
- Fix Card removing static padding top
- Fix autoComplete behaviour and onSelect function
- Enhance Drawer, pass items and state via props, link and func wrapper for Drawer
- Change form components to styled component
- Add new props withSearch for Select component
- Fix validation on textarea clear field button
- User can export Sidebar from NavBar
- Remove onClear defaultProps
- Revert handling navbar children
- Add withoutAnimation props on TextArea and fix onClear validation
- Datepicker fix selection date
- Fix passing error props on Toaster

## 3.1.2

- Unmount Loading SVG when button's state false
- Fix Carousel on Ticker

## 3.1.1

- Starting stable version with better release management
- Synchronized version with Design Kit

## 0.3.5

- Give stopPropagation on Toggle component

## 0.3.4

- Remove className passing props on Button image

## 0.3.3

- Set ellipsis on button.
- Remove BottomSheet subtitle & action DOM on header when no related props specified.
- Fix info date on Picker

## 0.3.2

- Enhance Carousel to be SSR friendly
- Fix Picker when choosing date on Double Date format

## 0.3.1

- Enhance Datepicker
- Fixing z-index for Toaster & Floating Button
- Give stopPropagation on Checkbox and Radio component based on this [issue](https://github.com/tokopedia/unify-react-mobile/issues/145)

## 0.3.0

- Props border for BottomSheet
- Props secondaryGreen for Button
- Fix BottomSheet title positioning when no subTitle specified
- Fix Button with image style

## 0.2.9

- Add subTitle props on BottomSheet

## 0.2.8

- Fixing List action bug

## 0.2.7

- New Label component
- New iconSize (sizing style) & textIndent (text spacing) props on List's items props.

## 0.2.6

- Template props on List & its items for custom rendering
- Fix & enhance List
- Add autoCapitalize & autoComplete props on SearchBar

## 0.2.5

- Fix subheader default margin for Card & Container
- Subheader (Atomic) & SearchBar component
- shadow props for Navbar

## 0.2.4

- Fix TextArea on mount mechanism for null or empty value
- Add noBorder props on List item to hide its bottom border

## 0.2.3

- Fix TextArea showing only one line when value has 2 or more lines
- Fix Picker date grid duplicate width
- Fix List Component styles
- Fix Stepper styles

## 0.2.2

- Add shadow on Container
- Fix Action Style inside Card & Container
- Fix button with image text-indent

## 0.2.1

- Add padding props (string & can be filled like CSS) to BottomSheet. noPadding props will be removed.
- Enable 2 lines List Description
- Enhance emotion CSS in JS by removing calc
- Bug fix for List, BottomSheet, Radio

## 0.2.0

- Portal Enhancement
- Slider enhancement for near max & min value
- Menu enhancement (no border bottom for last item in non-action menu)

## 0.1.10

- Add width props for Carosel component
- Make multi-item Ticker slideable
- Several code enhancement

## 0.1.9

- Add action on BottomSheet header
- Smooth LoaderJumper animation
- Base Style (Global) on emotion CSS in JS
- Remove unnecessary code (CSS, unused import, etc)

## 0.1.8

- Fixing webpack config for error build - continued

## 0.1.7

- Fixing webpack config for error build

## 0.1.6

- Fixing build conflict for Tokopedia Lite client

## 0.1.5

- Add loading props to Chip
- Fix Footer on IPhone 5 device width
- Tooltip title style fixing

## 0.1.4

- Fix TabContent for displaying only selected content.

## 0.1.3

- Revert webpack configuration

## 0.1.2

- LoaderJumper component
- Card enhancement for LoaderJumper component
- fix Ripple animation on emotion

## 0.1.1

- Yarn build for code splitting

## 0.1.0

- Code Splitting Implementation for component import

## 0.0.88

- Add RequestAnimationFrame to Carousel SetState

## 0.0.87

- Remove duplicate Navbar folder

## 0.0.86

- Fix Carousel bugs on SSR & Navbar.

## 0.0.85

- Fix Carousel for better support on SSR.

## 0.0.84

- Set defaultProps for every function on `TextField`, and `TextArea`.

## 0.0.83

- Fix error on TextField, and TextArea, when user do not provide `onFocus`, and `onBlur` property.

## 0.0.82

- Changes on event handling for TextArea and TextField. For this version, change your parameter handler from `e` to `e.target`.

## 0.0.81

- Bug fixing for emotion CSS in JS. If you have emotion installed on your code, please use the same version with this library.
