import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["collapsed", "icon", "id", "subTitle", "title", "titleTag", "type", "onClick"];
import React, { useEffect, useState, useRef } from 'react';
import { GN500, NN950, NN600, NN50 } from 'unify-token/colors';
import { ChevronDown } from 'unify-icons/system';
import Typography from "../../build/Typography";
import Image from "../../build/Image";
import Ripple from "../../build/Providers/common/components/Ripple";
import { Header, cssIconHeader, TextHeader, ImageHeader } from "./style";

var AccordionHeader = function AccordionHeader(_ref) {
  var _ref$collapsed = _ref.collapsed,
      collapsed = _ref$collapsed === void 0 ? false : _ref$collapsed,
      icon = _ref.icon,
      id = _ref.id,
      subTitle = _ref.subTitle,
      title = _ref.title,
      _ref$titleTag = _ref.titleTag,
      titleTag = _ref$titleTag === void 0 ? 6 : _ref$titleTag,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'default' : _ref$type,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? function () {} : _ref$onClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isCollapsed = _useState2[0],
      setIsCollapsed = _useState2[1];

  var titleToId = typeof title === 'string' ? title.split(' ').join('-') : '';
  var accordionId = id ? id : titleToId;

  var handleClick = function handleClick(e) {
    onClick(e);
    setIsCollapsed(function (prevOpen) {
      return !prevOpen;
    });
  };

  useEffect(function () {
    return setIsCollapsed(collapsed);
  }, [collapsed]);
  var rippleRef = useRef(null);

  var handleMouseDown = function handleMouseDown(e) {
    if (rippleRef.current) {
      rippleRef.current.trigger(e);
    }
  };

  return React.createElement(Header, _extends({
    "aria-controls": "content-".concat(accordionId),
    role: "button",
    className: "unf-accordion__header",
    "data-unify": "Accordion",
    type: type,
    hasSubtitle: Boolean(subTitle),
    onClick: handleClick,
    onMouseDown: handleMouseDown,
    "aria-expanded": !isCollapsed
  }, otherProps), React.createElement(Ripple, {
    ref: rippleRef,
    color: NN50
  }), icon && type !== 'text' && React.createElement(ImageHeader, {
    className: "unf-accordion__header__icon"
  }, typeof icon === 'string' ? React.createElement(Image, {
    src: icon,
    ratio: "1:1"
  }) : icon), React.createElement(TextHeader, {
    className: "unf-accordion__header__text"
  }, type === 'text' ? React.createElement(Typography, {
    id: "header-".concat(accordionId),
    margin: "0",
    bold: true,
    heading: titleTag,
    color: GN500,
    tag: 6
  }, title) : React.createElement(Typography, {
    id: "header-".concat(accordionId),
    margin: "0",
    heading: titleTag,
    tag: 4,
    bold: true,
    color: NN950
  }, title), subTitle && type !== 'text' && React.createElement(Typography, {
    margin: "0",
    body: "paragraph-2",
    color: NN600
  }, subTitle)), React.createElement("div", {
    className: cssIconHeader
  }, React.createElement(ChevronDown, {
    size: 24,
    color: type === 'text' ? GN500 : NN950,
    style: {
      transform: isCollapsed ? 'rotate(0deg)' : 'rotate(-180deg)'
    }
  })));
};

export default AccordionHeader;