import styled, { css, keyframes } from 'react-emotion';
import { colorShadow } from 'unify-token/build/v2/colors';
import { NN50, NN0 } from 'unify-token/colors';
import { spacingLv1, spacingLv3, spacingLv4 } from 'unify-token/build/v2/spacings';
import { durationT3, easeOut, easeInOut } from 'unify-token/build/v2/motions';
export var ContentChildren = css("label:unf-accordion__content--children;position:relative;");
export var Container = styled('div', {
  target: "e10zmi580"
})("label:unf-accordion;display:flex;justify-content:space-between;flex-direction:column;align-items:flex-start;position:relative;overflow:hidden;");

var handleMinHeight = function handleMinHeight(type, hasSubtitle) {
  if (type === 'text') {
    return 'auto';
  } else if (hasSubtitle) {
    return "67px";
  } else {
    return "57px";
  }
};

export var Header = styled('div', {
  target: "e10zmi581"
})("label:unf-accordion__header;position:relative;overflow:hidden;display:flex;justify-content:space-between;flex-direction:row;align-items:center;width:", function (_ref) {
  var type = _ref.type;
  return type === 'text' ? 'auto' : "100%";
}, ";min-height:", function (_ref2) {
  var type = _ref2.type,
      hasSubtitle = _ref2.hasSubtitle;
  return handleMinHeight(type, hasSubtitle);
}, ";", function (_ref3) {
  var type = _ref3.type;
  return type !== 'text' && "padding: 12px ".concat(spacingLv4, ";");
});
export var Content = styled('div', {
  target: "e10zmi582"
})("label:unf-accordion__content;width:100%;transform-origin:top;overflow:hidden;height:", function (_ref4) {
  var contentHeight = _ref4.contentHeight;
  return "".concat(contentHeight, "px");
}, ";transition-property:height,transform;transition-duration:", durationT3, ";transition-timing-function:", easeOut, ";");
export var ImageHeader = styled('div', {
  target: "e10zmi583"
})("label:unf-accordion__header__icon;width:32px;height:32px;margin-right:", spacingLv3, ";position:relative;");
export var TextHeader = styled('div', {
  target: "e10zmi584"
})("label:unf-accordion__header__text;display:flex;flex:1;flex-direction:column;overflow:hidden;margin-right:", spacingLv3, ";");
export var cssIconHeader = css("label:unf-accordion__header__chevron;width:32px;height:32px;border-radius:8px;background-position:center;position:relative;overflow:hidden;& > svg{position:absolute;top:0;bottom:0;right:0;left:0;margin:auto;transition:transform ", easeInOut, " ", durationT3, ";}");
export var Divider = styled('div', {
  target: "e10zmi585"
})("label:unf-accordion__divider;display:block;width:100%;height:1px;background-color:", NN50, ";");
export var StickySection = styled('div', {
  target: "e10zmi586"
})("label:unf-accordion__sticky-section;width:100%;box-shadow:0 1px 6px 0 ", colorShadow, ";background-color:", NN0, ";max-width:", function (_ref5) {
  var maxWidth = _ref5.maxWidth;
  return maxWidth;
}, ";", function (_ref6) {
  var switchPosition = _ref6.switchPosition,
      position = _ref6.position,
      zIndex = _ref6.zIndex;
  return switchPosition ? "\n    position: absolute;\n    bottom: ".concat(spacingLv1, ";\n  ") : "\n    position: fixed;\n    z-index: ".concat(zIndex ? zIndex : 1, ";\n    top: ").concat(position, "px;\n  ");
});
export var fadeInOut = keyframes("from{opacity:0;}to{opacity:1;}");