import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "indexActive", "items", "noWrapper"];
import React, { useState, useEffect } from 'react';
import { cx } from 'emotion';
import Notification from "../../build/Notification";
import Typography from "../../build/Typography";
import { Container, Item, ImageContainer, Image, ImageDiv, unf_bottomnav_count, unf_bottomnav_indicator } from "./style";

var BottomNav = function BottomNav(_ref) {
  var _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$indexActive = _ref.indexActive,
      indexActive = _ref$indexActive === void 0 ? 0 : _ref$indexActive,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      _ref$noWrapper = _ref.noWrapper,
      noWrapper = _ref$noWrapper === void 0 ? false : _ref$noWrapper,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(indexActive),
      _useState2 = _slicedToArray(_useState, 2),
      index = _useState2[0],
      setIndex = _useState2[1];

  var customClasses = cx('unf-bottomnav', className);
  useEffect(function () {
    setIndex(indexActive);
  }, [indexActive]);

  var changeTab = function changeTab(idx, pressEvent) {
    setIndex(idx);
    pressEvent();
  };

  var renderItem = function renderItem() {
    return items === null || items === void 0 ? void 0 : items.map(function (item, i) {
      var isIndexActive = index === i;
      return React.createElement(Item, _extends({
        className: cx('unf-bottomnav__item', {
          'unf-bottomnav__item--active': isIndexActive
        }),
        key: i,
        index: i,
        noWrapper: noWrapper,
        active: isIndexActive,
        style: {
          width: "".concat(100 / items.length, "%")
        },
        onClick: function onClick() {
          return changeTab(i, item.onClick);
        }
      }, item.props), item.count && !item.notification && React.createElement(Notification, {
        className: unf_bottomnav_count
      }, item.count), item.notification && React.createElement(Notification, {
        className: unf_bottomnav_indicator,
        secondary: true
      }), React.createElement(ImageContainer, {
        className: "unf-bottomnav__item-image",
        active: isIndexActive
      }, typeof item.icon !== 'string' ? React.createElement(React.Fragment, null, React.createElement(ImageDiv, null, !isIndexActive ? item.icon : item.iconActive), item.count && React.createElement(Notification, {
        className: unf_bottomnav_count
      }, item.count)) : React.createElement(React.Fragment, null, React.createElement(Image, {
        alt: item.text,
        crossOrigin: "anonymous",
        src: !isIndexActive ? item.icon : item.iconActive
      }))), React.createElement(Typography, {
        micro: true,
        margin: "0",
        color: item.color
      }, item.text));
    });
  };

  return noWrapper ? renderItem() : React.createElement(Container, _extends({
    className: customClasses,
    "data-unify": "BottomNav",
    role: "navigation"
  }, otherProps), renderItem());
};

export default BottomNav;