import React from 'react';
export interface BottomNavProps extends Omit<React.ComponentPropsWithoutRef<'div'>, 'css' | 'ref'> {
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To indicate currently active item
     */
    indexActive?: number;
    /**
     * To specify content of BottomNav
     */
    items?: Array<{
        count?: string | number;
        color?: string;
        icon?: string;
        iconActive?: string;
        key?: number;
        notification?: boolean;
        props?: Record<string, unknown>;
        text?: string;
        onClick?: (e: React.MouseEvent<HTMLDivElement>) => void;
    }>;
    /**
     * Used only when using coachMark
     */
    noWrapper?: boolean;
    /**
     * To pass custom props to Component
     */
    props?: Record<string, unknown>;
}
export declare type ImageContainerProps = {
    active?: boolean;
};
export declare type ImageProps = {
    hide?: boolean;
};
export interface ItemProps extends BottomNavProps {
    active?: boolean;
    highlight?: boolean;
    index?: number;
}
