import _extends from "@babel/runtime/helpers/extends";
import React, { useRef } from 'react';
import { Close } from 'unify-icons/system';
import wrapper from "../../build/Providers/common/HOC/withMobileOverlay";
import Typography from "../../build/Typography";
import { canUseDOM, cx } from "../../build/Providers/common/functions";
import { Container, Header, Content, actionStyle, closeButton } from "./style";
var closeLabel = {
  id: 'Tutup tampilan ini',
  en: 'Close current display'
};

var BottomSheet = function BottomSheet(_ref) {
  var _ref$actionText = _ref.actionText,
      actionText = _ref$actionText === void 0 ? '' : _ref$actionText,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? true : _ref$border,
      children = _ref.children,
      className = _ref.className,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? false : _ref$display,
      _ref$full = _ref.full,
      full = _ref$full === void 0 ? false : _ref$full,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      _ref$noPadding = _ref.noPadding,
      noPadding = _ref$noPadding === void 0 ? false : _ref$noPadding,
      padding = _ref.padding,
      _ref$subTitle = _ref.subTitle,
      subTitle = _ref$subTitle === void 0 ? '' : _ref$subTitle,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      onActionClick = _ref.onActionClick,
      onClose = _ref.onClose;
  var sheetRef = useRef(null);

  var fullProps = function fullProps() {
    if (sheetRef.current) {
      var minDeviceHeight = 568;
      var pageHeight = canUseDOM ? Math.min(document.documentElement.clientHeight, window.innerHeight) : minDeviceHeight;
      var sheetHeight = Math.abs(sheetRef.current.offsetHeight / pageHeight * 100);
      return {
        full: full ? full : sheetHeight >= 75 || false
      };
    }

    return {
      full: false
    };
  };

  return React.createElement(Container, _extends({
    mod: {
      display: display
    },
    className: className,
    innerRef: sheetRef,
    role: "dialog",
    "aria-modal": "true",
    "data-unify": "BottomSheet"
  }, fullProps()), React.createElement(Header, {
    className: "unf-bottomsheet__title",
    subTitle: subTitle,
    border: border
  }, React.createElement("button", {
    "aria-label": closeLabel[String(lang)],
    className: cx(closeButton, 'unf-bottomsheet__title-close'),
    onClick: onClose
  }, React.createElement(Close, {
    size: 18
  })), React.createElement("div", {
    className: "unf-bottomsheet__text-wrapper"
  }, React.createElement(Typography, {
    tag: 4,
    heading: 2,
    main: true,
    margin: "0",
    className: "unf-bottomsheet__title-text"
  }, title), subTitle && React.createElement(Typography, {
    caption: true,
    margin: "0",
    className: "unf-bottomsheet__subtitle"
  }, subTitle)), actionText && (typeof onActionClick === 'string' ? React.createElement("a", {
    href: onActionClick,
    className: cx(actionStyle, 'unf-bottomsheet__action')
  }, actionText) : React.createElement("button", {
    onClick: onActionClick,
    className: cx(actionStyle, 'unf-bottomsheet__action')
  }, actionText))), React.createElement(Content, {
    className: "unf-bottomsheet__content",
    noPadding: noPadding,
    padding: padding
  }, children));
};

var wrapperElement = wrapper(BottomSheet, 'bottomsheet');
export default wrapperElement;