import React from 'react';
declare type BottomSheetAttributes = React.ComponentProps<'div'>;
export interface BottomSheetBaseProps {
    /**
     * To set text on top right action
     * @default ''
     */
    actionText?: string;
    /**
     * To display border under header section of component
     * @default true
     */
    border?: boolean;
    /**
     * To specify content on BottomSheet
     */
    children?: React.ReactNode;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To toggle visibility of BottomSheet
     * @default false
     */
    display?: boolean;
    /**
     * To determine BottomSheet height in full mode
     * @default false
     */
    full?: boolean;
    /**
     * To set accessible label language
     * @default 'id'
     */
    lang?: 'en' | 'id';
    /**
     * To specify 0 padding on BottomSheet
     * @default false
     */
    noPadding?: boolean;
    /**
     * To specify custom padding on BottomSheet
     */
    padding?: string;
    /**
     * To specify text under title
     * @default ''
     */
    subTitle?: string;
    /**
     * To specify string in header section
     * @default ''
     */
    title?: string;
    /**
     * To pass callback function on top right action text
     */
    onActionClick?: string | ((e: React.MouseEvent<HTMLButtonElement>) => void);
    /**
     * To pass callback when closed icon is clicked
     */
    onClose?: (e: React.MouseEvent<HTMLButtonElement>) => void;
}
export declare type BottomSheetProps = BottomSheetBaseProps & Omit<BottomSheetAttributes, keyof BottomSheetBaseProps>;
export {};
