import React from 'react';
/**
 * Get tap position based on input, wether mouse or touch
 * @param {object} event Native mouse and touch event object
 */
export declare function getTapPosition(event: React.TouchEvent<HTMLElement> | React.MouseEvent<HTMLElement>): {
    clientX: any;
    clientY: any;
};
/**
 * Set number within range of minimum and maximum
 * @param {number} number Number to be clamped
 * @param {number} min Minimum bound number
 * @param {number} max Maximum bound number
 */
export declare function clamp(number: number, min: number, max: number): number;
/**
 * Check for device user agent from a name string
 * @param {string} deviceString User agent name to identify
 */
export declare function getUserAgent(deviceString: string): boolean;
export declare const isAndroid: boolean;
/**
 * Get input type that has keyboard interaction
 * @param {string} inputType type of input to check
 */
export declare function getEditableInputType(inputType: string): boolean;
/**
 * Identify if it's editable element
 * @param {object} target Target element from DOM event
 */
export declare function isEditableElement(target: HTMLElement): boolean;
