import { canUseDOM } from "../../build/Providers/common/functions";
export function getTapPosition(event) {
  if (event) {
    var isTouchEvent = event.type.toString().search('touch') !== -1;
    var eventPosition = isTouchEvent ? event.touches[0] : event;
    var clientX = eventPosition.clientX,
        clientY = eventPosition.clientY;
    return {
      clientX: clientX,
      clientY: clientY
    };
  }

  return {
    clientX: 0,
    clientY: 0
  };
}
export function clamp(number, min, max) {
  if (number < min) {
    return min;
  } else if (number > max) {
    return max;
  }

  return number;
}
export function getUserAgent(deviceString) {
  if (canUseDOM) {
    var userAgent = window.navigator.userAgent.toLowerCase() || '';
    return userAgent.indexOf(String(deviceString)) !== -1;
  }

  return false;
}
export var isAndroid = getUserAgent('android');
export function getEditableInputType(inputType) {
  switch (inputType) {
    case 'number':
    case 'password':
    case 'email':
    case 'search':
    case 'url':
    case 'tel':
    case 'text':
      return true;
  }

  return false;
}
export function isEditableElement(target) {
  var isInput = target.nodeName === 'INPUT';
  var isTextarea = target.nodeName === 'TEXTAREA';
  var inputType = target.getAttribute('type');
  var isEditableInput = isInput && getEditableInputType(inputType);
  return isTextarea || isEditableInput;
}