import styled, { css } from 'react-emotion';
import { colorShadow } from 'unify-token/build/v2/colors';
import { NN0, NN200, NN950 } from 'unify-token/colors';
import { fontSizeLv3 } from 'unify-token/build/v2/typographies';
import { easeOut, easeInOut, durationT4 } from 'unify-token/build/v2/motions';
import { focusStyle } from "../../build/Providers/common/style";
export var Wrapper = styled("div", {
  target: "e16lj5u60"
})("label:unf-bottomsheet-container;display:flex;justify-content:center;position:fixed;top:0;left:0;width:100%;height:100%;pointer-events:none;transform:translate3d(0,", function (_ref) {
  var isDisplay = _ref.isDisplay;
  return isDisplay ? 0 : '100%';
}, ",0);transition-property:transform;transition-duration:", durationT4, ";transition-timing-function:", function (_ref2) {
  var isDisplay = _ref2.isDisplay;
  return isDisplay ? easeOut : easeInOut;
}, ";");
export var Sheet = styled("article", {
  target: "e16lj5u61"
})("label:unf-bottomsheet;position:absolute;font-family:inherit;border-radius:10px 10px 0 0;box-shadow:0px -1px 6px ", colorShadow, ";background-color:", NN0, ";pointer-events:all;transition-property:transform;transition-timing-function:", easeOut, ";overscroll-behavior-y:contain;overflow:", function (_ref3) {
  var withKnob = _ref3.withKnob;
  return !withKnob ? 'auto' : 'hidden';
}, ";max-height:95%;width:100%;", function (_ref4) {
  var withKnob = _ref4.withKnob,
      full = _ref4.full;
  return (withKnob || full) && 'height: 95%';
}, ";", function (_ref5) {
  var withKnob = _ref5.withKnob;
  return withKnob && 'top: 5%';
}, ";", function (_ref6) {
  var withKnob = _ref6.withKnob,
      initialPos = _ref6.initialPos;
  return !withKnob && initialPos && "height: ".concat(initialPos, "px");
}, ";", function (_ref7) {
  var withKnob = _ref7.withKnob;
  return !withKnob && 'bottom: 0';
}, ";-webkit-overflow-scrolling:touch;");
export var InnerWrapper = styled("div", {
  target: "e16lj5u62"
})("display:flex;flex-direction:column;max-height:100%;");
export var Header = styled("header", {
  target: "e16lj5u63"
})("label:unf-bottomsheet__header;display:flex;gap:8px;align-items:center;justify-content:space-between;padding:16px;background-color:", NN0, ";z-index:1;flex-wrap:", function (_ref8) {
  var withKnob = _ref8.withKnob;
  return withKnob ? 'wrap' : 'nowrap';
}, ";", function (_ref9) {
  var withClose = _ref9.withClose,
      withKnob = _ref9.withKnob;
  return withClose && !withKnob && 'position: sticky; top: 0;';
}, ";& .unf-sheet__title{flex:1 1 auto;color:", NN950, ";}& .unf-sheet__action-text{flex:0 0 auto;font-weight:bold;font-size:", fontSizeLv3, ";cursor:pointer;}& .unf-sheet__close-btn{border:none;background-color:transparent;padding:0;-webkit-appearance:none;", focusStyle, "}");
export var DragHandler = styled("div", {
  target: "e16lj5u64"
})("label:unf-bottomsheet__drag-handler;position:relative;display:flex;justify-content:center;position:relative;margin-top:-4px;margin-bottom:4px;width:100%;&:last-child{margin-bottom:0;}&::before{content:'';width:48px;height:4px;border-radius:2px;background-color:", NN200, ";}");
export var Content = styled("div", {
  target: "e16lj5u65"
})("label:unf-bottomsheet__content;position:relative;flex:1 1 auto;padding:", function (_ref10) {
  var padding = _ref10.padding;
  return padding;
}, ";overflow-y:", function (_ref11) {
  var withKnob = _ref11.withKnob,
      isMaximized = _ref11.isMaximized;
  return withKnob && !isMaximized ? 'hidden' : 'auto';
}, ";-webkit-overflow-scrolling:touch;");
export var scrollLock = css("overflow:hidden;");
export var scrollLock_iOS = css("width:100%;overscroll-behavior-y:none;");