import React from 'react';
declare type BottomSheetV2Attribute = React.ComponentPropsWithoutRef<'div'>;
interface BottomSheetV2BaseProps {
    /**
     * To set text on top right action
     */
    actionText?: string;
    /**
     * To specify content on BottomSheetV2
     */
    children?: React.ReactNode;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To pass additional props to close button
     */
    closeProps?: object;
    /**
     * To toggle visibility of BottomSheet
     */
    display?: boolean;
    /**
     * To enable dynamic content height adjustment
     */
    dynamicContent?: boolean;
    /**
     * To determine BottomSheet height in full mode
     */
    full?: boolean;
    /**
     * To insert custom header
     */
    header?: () => void;
    /**
     * To specify initial position of BottomSheet
     */
    initialPos?: number;
    /**
     * To determine overlay background color
     */
    inverted?: boolean;
    /**
     * Specify UI labels language
     */
    lang?: string;
    /**
     * To specify custom padding on BottomSheet content
     */
    padding?: string;
    /**
     * To specify string in header section
     */
    title?: string | object;
    /**
     * To pass additional props to title
     */
    titleProps?: object;
    /**
     * To apply BottomSheet with close button design
     */
    withClose?: boolean;
    /**
     * To enable floating Button in BottomSheet
     */
    withFloatingButton?: boolean;
    /**
     * To apply BottomSheet with knob design
     */
    withKnob?: boolean;
    /**
     * To pass callback function on top right action text
     */
    onActionClick?: () => void;
    /**
     * To pass callback when closed icon is clicked
     */
    onClose?: () => void;
    /**
     * To pass callback when dragging occur
     */
    onDrag?: () => void;
    /**
     * To pass callback when dragging ended
     */
    onDragEnd?: () => void;
    /**
     * To pass callback when dragging started
     */
    onDragStart?: () => void;
    /**
     * To pass callback when the sheet is on maximized state
     */
    onMaximize?: () => void;
    /**
     * To pass callback when the sheet is on minimized state
     */
    onMinimize?: () => void;
    /**
     * To pass callback when user scrolled the child inside
     */
    onScroll?: () => void;
}
export declare type BottomSheetV2Props = BottomSheetV2BaseProps & Omit<BottomSheetV2Attribute, keyof BottomSheetV2BaseProps | 'css'>;
export interface BottomSheetV2State extends BottomSheetV2Props {
    isMaximized?: boolean;
    isDisplay?: boolean;
}
export interface BottomSheetTitleProps {
    children?: React.ReactNode;
    className?: string;
}
export {};
