import React from 'react';
import { UnifyCarouselIndicator } from "./style";

var CarouselIndicator = function CarouselIndicator(props) {
  var active = props.active,
      className = props.className,
      dataTest = props.dataTest,
      index = props.index,
      inverted = props.inverted,
      padding = props.padding,
      onClick = props.onClick;

  var handleClick = function handleClick() {
    onClick(index);
  };

  return React.createElement(UnifyCarouselIndicator, {
    active: active,
    className: className,
    inverted: inverted,
    padding: padding,
    onClick: handleClick,
    "data-testid": dataTest
  });
};

CarouselIndicator.defaultProps = {
  active: false,
  className: '',
  index: 0,
  inverted: false,
  onClick: function onClick() {}
};
export default CarouselIndicator;