import React from 'react';
export interface CarouselProps {
    /**
     * To specify Carousel autoslide motion to next index
     */
    autoPlay?: boolean;
    /**
     * To specify content on Carousel
     */
    children?: React.ReactNode | React.ReactNode[];
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To pass data-testid on Carousel
     */
    dataTest?: object;
    /**
     * To specify rendering of indicator
     */
    indicator?: boolean;
    /**
     * To determine carousel looping when reaching last index
     */
    infinite?: boolean;
    /**
     * To apply inverted design
     */
    inverted?: boolean;
    /**
     * To specify actions when link is clicked
     */
    link?: React.MouseEventHandler<HTMLDivElement> | string;
    /**
     * To specify text in link
     */
    linkText?: string;
    /**
     * To specify custom padding between banner images on Carousel
     */
    padding?: string;
    /**
     * To set width to parent's width
     */
    useContainerWidth?: boolean;
    /**
     * To specify custom padding on Carousel
     * To specify custom width on Carousel
     */
    width?: number;
    /**
     * To pass callback when changing index
     */
    onChange?: (val: number) => void;
}
declare const Carousel: {
    (props: CarouselProps): JSX.Element;
    propTypes: {
        autoPlay: import("prop-types").Requireable<boolean>;
        children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        className: import("prop-types").Requireable<string>;
        dataTest: import("prop-types").Requireable<object>;
        indicator: import("prop-types").Requireable<boolean>;
        infinite: import("prop-types").Requireable<boolean>;
        inverted: import("prop-types").Requireable<boolean>;
        link: import("prop-types").Requireable<string | ((...args: any[]) => any)>;
        linkText: import("prop-types").Requireable<string>;
        padding: import("prop-types").Requireable<string>;
        useContainerWidth: import("prop-types").Requireable<boolean>;
        width: import("prop-types").Requireable<number>;
        onChange: import("prop-types").Requireable<(...args: any[]) => any>;
    };
    defaultProps: {
        autoPlay: boolean;
        children: any;
        className: string;
        dataTest: {};
        indicator: boolean;
        infinite: boolean;
        inverted: boolean;
        link: string;
        linkText: string;
        padding: string;
        useContainerWidth: boolean;
        width: number;
        onChange: () => void;
    };
};
export default Carousel;
