import styled from 'react-emotion';
import { NN0L, GN500, NN0, NN50 } from 'unify-token/colors';
import { fontSizeLv1, fontWeightBold } from 'unify-token/build/v2/typographies';
import hexToRgba from "../../build/Providers/common/functions/hexToRgba";

var handleIndicatorColor = function handleIndicatorColor(_ref) {
  var active = _ref.active,
      inverted = _ref.inverted;

  switch (true) {
    case active && inverted:
      return NN0;

    case active && !inverted:
      return GN500;

    case !active && inverted:
      return hexToRgba(NN0L, 0.32);

    default:
      return NN50;
  }
};

var handleLinkColor = function handleLinkColor(_ref2) {
  var inverted = _ref2.inverted;

  switch (true) {
    case inverted:
      return NN0;

    case !inverted:
      return GN500;

    default:
      return NN0;
  }
};

export var UnifyCarousel = styled('div', {
  target: "e1wojynj0"
})("label:unf-carousel;position:relative;width:100%;margin:auto;padding:0;overflow:hidden;");
export var UnifyCarouselTrack = styled('div', {
  target: "e1wojynj1"
})("display:block;left:0;margin:0 auto;position:relative;top:0;transition:transform 240ms linear;backface-visibility:hidden;transform:translate3d(0,0,0);will-change:transform;white-space:nowrap;&:after{clear:both;}");
export var UnifyCarouselItem = styled('div', {
  target: "e1wojynj2"
})("font-size:0;vertical-align:top;width:100%;display:inline-block;", function (_ref3) {
  var padding = _ref3.padding;
  return "padding: 0 ".concat(padding);
}, ";& img{width:100%;}");
export var UnifyCarouselIndicator = styled('div', {
  target: "e1wojynj3"
})("background-color:", function (_ref4) {
  var active = _ref4.active,
      inverted = _ref4.inverted;
  return handleIndicatorColor({
    active: active,
    inverted: inverted
  });
}, ";border-radius:50%;display:inline-block;height:8px;margin-right:4px;width:8px;");
export var UnifyCarouselLink = styled('a', {
  target: "e1wojynj4"
})("text-decoration:none;font-size:", fontSizeLv1, ";color:", function (_ref5) {
  var inverted = _ref5.inverted;
  return handleLinkColor({
    inverted: inverted
  });
}, ";");
export var UnifyCarouselDiv = styled('div', {
  target: "e1wojynj5"
})("font-weight:", fontWeightBold, ";text-decoration:none;font-size:", fontSizeLv1, ";color:", function (_ref6) {
  var inverted = _ref6.inverted;
  return handleLinkColor({
    inverted: inverted
  });
}, ";");
export var UnifyCarouselFooter = styled('div', {
  target: "e1wojynj6"
})("display:flex;justify-content:space-between;align-items:center;width:100%;", function (_ref7) {
  var padding = _ref7.padding;
  return "padding: 0 ".concat(padding);
}, ";");