import styled from 'react-emotion';

var handleCarouselItemWidth = function handleCarouselItemWidth(_ref) {
  var useContentWidth = _ref.useContentWidth,
      centerMode = _ref.centerMode,
      sneakPeekWidth = _ref.sneakPeekWidth,
      slideToShow = _ref.slideToShow;
  var sneakpk = sneakPeekWidth;

  if (Number.isInteger(sneakPeekWidth) || sneakPeekWidth && !isNaN(parseInt(sneakPeekWidth.slice(-1)))) {
    sneakpk += '%';
  }

  switch (true) {
    case !useContentWidth && centerMode:
      return "calc((100% - ".concat(sneakpk, " - ").concat(sneakpk, ") /").concat(slideToShow, ")");

    case !useContentWidth:
      return "calc(100%/".concat(slideToShow, ")");

    default:
      return '';
  }
};

export var CarouselContainer = styled('section', {
  target: "e26128c0"
})("width:100%;position:relative;margin:0 auto;overflow:hidden;white-space:nowrap;");
export var CarouselContentContainer = styled('div', {
  target: "e26128c1"
})("position:relative;");

var handleItemAlign = function handleItemAlign(_ref2) {
  var itemAlign = _ref2.itemAlign;

  switch (true) {
    case itemAlign === 'top':
      return 'flex-start';

    case itemAlign === 'middle':
      return 'center';

    case itemAlign === 'bottom':
      return 'flex-end';

    default:
      return 'auto';
  }
};

export var CarouselItem = styled("div", {
  target: "e26128c2"
})("width:", handleCarouselItemWidth, ";display:inline-block;align-self:", handleItemAlign, ";position:relative;flex-shrink:0;img{width:", function (_ref3) {
  var useContentWidth = _ref3.useContentWidth;
  return useContentWidth ? '' : '100%';
}, ";}");