import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["id", "inputProps", "className", "name", "value", "useLabel", "checked", "disabled", "indeterminate", "onChange", "onClick"];
import React from 'react';
import { cx } from 'emotion';
import Check from 'unify-icons/system/Check';
import { NN0L } from 'unify-token/colors';
import { noop } from "../../build/Providers/common/functions/noop";
import { Checkbox as ContainerLabel, CheckboxDiv as ContainerDiv, IconContainer, cssIndeterminate } from "./style";

var Checkbox = function Checkbox(_ref) {
  var _ref$id = _ref.id,
      id = _ref$id === void 0 ? '' : _ref$id,
      _ref$inputProps = _ref.inputProps,
      inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '' : _ref$name,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value,
      _ref$useLabel = _ref.useLabel,
      useLabel = _ref$useLabel === void 0 ? true : _ref$useLabel,
      _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$indeterminate = _ref.indeterminate,
      indeterminate = _ref$indeterminate === void 0 ? false : _ref$indeterminate,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? noop : _ref$onChange,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var containerClass = cx('unf_checkbox', {
    isDisabled: disabled
  }, className);

  var inputCheckboxProps = _objectSpread({
    id: id,
    name: name,
    value: value,
    checked: checked,
    disabled: disabled,
    onClick: onClick,
    onChange: onChange
  }, inputProps);

  var Container = useLabel ? ContainerLabel : ContainerDiv;
  return React.createElement(Container, _extends({
    disabled: disabled,
    className: containerClass
  }, otherProps), React.createElement("input", _extends({
    "aria-checked": checked,
    autoComplete: "off",
    "data-unify": "Checkbox",
    type: "checkbox"
  }, inputCheckboxProps)), React.createElement("div", {
    className: "unf-checkbox__area checkbox-area"
  }, React.createElement(IconContainer, {
    checked: checked
  }, indeterminate ? React.createElement("div", {
    className: cssIndeterminate
  }) : React.createElement("div", null, React.createElement(Check, {
    size: 24,
    color: NN0L
  })))));
};

export default Checkbox;