import styled, { css } from 'react-emotion';
import { NN0, NN0L, NN300, NN900, GN500, PN500L } from 'unify-token/colors';
import { durationT2, durationT3, easeOut, easeInOut } from 'unify-token/build/v2/motions';

var handleBorderColor = function handleBorderColor(_ref) {
  var disabled = _ref.disabled,
      variant = _ref.variant;

  switch (true) {
    case disabled:
      return NN300;

    case variant === 'inverted':
      return NN0;

    default:
      return NN900;
  }
};

export var Checkbox = styled('label', {
  target: "e1co7v4u0"
})("label:unf-checkbox;display:inline-block;line-height:1;.checkbox-area{width:24px;height:24px;vertical-align:middle;border:1.5px solid ", function (_ref2) {
  var disabled = _ref2.disabled,
      variant = _ref2.variant;
  return handleBorderColor({
    disabled: disabled,
    variant: variant
  });
}, ";border-radius:4px;position:relative;display:inline-block;display:flex;justify-content:center;align-items:center;&::before{content:'';border-radius:4px;position:absolute;top:-1.5px;left:-1.5px;width:24px;height:24px;background:", function (props) {
  return props.disabled ? NN300 : GN500;
}, ";opacity:0;scale:0.2;transition-property:opacity,scale;transition-duration:", durationT2, ";transition-timing-function:", easeInOut, ";}}input[type='checkbox']{width:0;height:0;opacity:0;position:absolute;appearance:none;margin:0;padding:0;}input[type='checkbox']:checked + .checkbox-area{&::before{opacity:1;scale:1;transition-property:opacity,scale;transition-duration:", durationT3, ";transition-timing-function:", easeOut, ";}}input[type='checkbox']:focus-visible + .checkbox-area{outline:2px dotted ", PN500L, ";outline-offset:3px;}");
export var CheckboxDiv = Checkbox.withComponent('div', {
  target: "e1co7v4u1"
});
export var IconContainer = styled("div", {
  target: "e1co7v4u2"
})("> div{width:", function (_ref3) {
  var checked = _ref3.checked;
  return checked ? '100%' : '0%';
}, ";overflow:hidden;transition:", function (_ref4) {
  var checked = _ref4.checked;
  return checked ? "width ".concat(durationT2, " ").concat(easeOut, " ").concat(durationT2) : "width ".concat(durationT3, " ").concat(easeOut);
}, ";position:relative;}");
export var cssIndeterminate = css("width:10px !important;height:2px;background-color:", NN0L, ";border-radius:1px;");