import styled, { keyframes } from 'react-emotion';
import { NN300, GN50, GN400, GN500, NN50, NN400, NN0, NN100, NN600 } from 'unify-token/colors';
import { fontSizeLv3, lineHeightLv3 } from 'unify-token/build/v2/typographies';
import { durationT2, easeInOut, durationT3 } from 'unify-token/build/v2/motions';
import { ShimmerRules } from "../../build/Providers/styles/Loader/_SharedLoaderStyle";
import { focusStyle } from "../../build/Providers/common/style";
var rippleAnimation = keyframes("to{transform:scale(2.5);}");
var fadeOutAnimation = keyframes("from{transform:scale(2.5);opacity:1;}to{transform:scale(2.5);opacity:0;}");

var handleBackgroundHover = function handleBackgroundHover(_ref) {
  var active = _ref.active;

  switch (true) {
    case active:
      return GN50;

    default:
      return NN50;
  }
};

var handleBackgroundColorActive = function handleBackgroundColorActive(_ref2) {
  var disabled = _ref2.disabled,
      active = _ref2.active;

  switch (true) {
    case disabled:
      return 'none';

    case active:
      return GN50;

    default:
      return NN50;
  }
};

var handleBackgroundColor = function handleBackgroundColor(_ref3) {
  var active = _ref3.active,
      disabled = _ref3.disabled,
      loading = _ref3.loading;

  switch (true) {
    case active:
      return GN50;

    case loading:
      return NN100;

    case disabled:
      return NN50;

    default:
      return NN0;
  }
};

var handleBorderColor = function handleBorderColor(_ref4) {
  var active = _ref4.active,
      alternate = _ref4.alternate,
      disabled = _ref4.disabled,
      loading = _ref4.loading,
      primary = _ref4.primary;

  switch (true) {
    case loading || disabled:
      return 'transparent';

    case active || alternate:
      return GN400;

    case primary || alternate:
      return GN400;

    default:
      return NN300;
  }
};

var handleColor = function handleColor(_ref5) {
  var active = _ref5.active,
      alternate = _ref5.alternate,
      disabled = _ref5.disabled,
      loading = _ref5.loading,
      primary = _ref5.primary;

  switch (true) {
    case active:
      return GN500;

    case disabled:
      return NN400;

    case loading:
      return 'transparent';

    case primary || alternate:
      return GN500;

    default:
      return NN600;
  }
};

var handleHeight = function handleHeight(_ref6) {
  var small = _ref6.small,
      large = _ref6.large;

  switch (true) {
    case small:
      return 32;

    case large:
      return 48;

    default:
      return 40;
  }
};

var handlePaddingContainer = function handlePaddingContainer(_ref7) {
  var large = _ref7.large,
      image = _ref7.image,
      shrink = _ref7.shrink;

  switch (true) {
    case large && Boolean(image) && shrink:
      return '0 4px';

    case large && Boolean(image):
      return '0 12px 0 4px';

    default:
      return '0 12px';
  }
};

var CHIPS_MAX_WIDTH = 184;
var CHIPS_MEDIA_MAX_WIDTH = 232;
export var AddonIcon = styled('i', {
  target: "edxvmbf0"
})("z-index:1;background-position:center;background-repeat:no-repeat;flex-shrink:0;transition:margin-right 280ms ease;width:", function (_ref8) {
  var iconSize = _ref8.iconSize;
  return iconSize ? iconSize : 24;
}, "px;height:", function (_ref9) {
  var iconSize = _ref9.iconSize;
  return iconSize ? iconSize : 24;
}, "px;background-image:url('", function (props) {
  return props.icon;
}, "');background-size:", function (_ref10) {
  var iconSize = _ref10.iconSize;
  return iconSize ? iconSize : 24;
}, "px;border-radius:", function (_ref11) {
  var borderRadius = _ref11.borderRadius;
  return "".concat(borderRadius, "px");
}, ";flex-basis:", function (_ref12) {
  var iconSize = _ref12.iconSize;
  return iconSize ? iconSize : 24;
}, "px;margin-right:", function (_ref13) {
  var marginRight = _ref13.marginRight,
      shrink = _ref13.shrink;
  return shrink ? undefined : "".concat(marginRight, "px");
}, ";margin-left:", function (_ref14) {
  var marginLeft = _ref14.marginLeft;
  return "".concat(marginLeft, "px");
}, ";");
export var Addon = styled('div', {
  target: "edxvmbf1"
})("line-height:", lineHeightLv3, ";margin-right:", function (_ref15) {
  var shrink = _ref15.shrink;
  return shrink ? undefined : '4px';
}, ";z-index:1;transition:margin-right 280ms ease,margin-left 280ms ease;", AddonIcon, " + &{", function (_ref16) {
  var shrink = _ref16.shrink;
  return shrink && "margin-left: 4px";
}, ";}");
export var Container = styled('button', {
  target: "edxvmbf2"
})("label:unf-chip;max-width:", function (_ref17) {
  var ellipsis = _ref17.ellipsis;
  return ellipsis ? "".concat(CHIPS_MAX_WIDTH, "px") : 'unset';
}, ";color:", handleColor, ";font-size:", fontSizeLv3, ";line-height:", lineHeightLv3, ";border:1px solid ", handleBorderColor, ";border-radius:", function (_ref18) {
  var large = _ref18.large;
  return large ? '8px' : '12px';
}, ";border-style:", function (_ref19) {
  var dashed = _ref19.dashed;
  return dashed ? 'dashed' : 'solid';
}, ";display:inline-flex;align-items:center;padding:", handlePaddingContainer, ";margin-right:8px;margin-bottom:8px;background-color:", handleBackgroundColor, ";transition-property:color,background-color,border-color,background;transition-duration:", durationT2, ";transition-timing-function:", easeInOut, ";transition:color ", durationT3, " ", easeInOut, ",background-color ", durationT3, " ", easeInOut, ",border-color ", durationT3, " ", easeInOut, ",background ", durationT3, " ", easeInOut, ";min-width:", function (_ref20) {
  var loading = _ref20.loading;
  return loading && '120px';
}, ";height:", handleHeight, "px;", function (_ref21) {
  var loading = _ref21.loading;
  return loading && ShimmerRules;
}, " ", focusStyle, " @media screen and (min-width:768px){max-width:", CHIPS_MEDIA_MAX_WIDTH, "px;}i,img{opacity:", function (_ref22) {
  var disabled = _ref22.disabled;
  return disabled && 0.23;
}, ";}position:relative;overflow:hidden;.unf-chip-ripple{animation:", rippleAnimation, " ", durationT3, " ", easeInOut, ",", fadeOutAnimation, " ", durationT3, " ", durationT3, " ", easeInOut, ";background-color:", handleBackgroundColorActive, ";border-radius:50%;left:0;position:absolute;transform:scale(0);top:0;}:hover{background-color:", handleBackgroundHover, ";}");

var getShrinkableMaxWidth = function getShrinkableMaxWidth(ellipsis, shrink) {
  if (shrink && ellipsis || shrink) {
    return 0;
  } else {
    return '100%';
  }
};

export var Shrinkable = styled('div', {
  target: "edxvmbf3"
})("display:flex;align-items:center;overflow:hidden;transition:max-width 280ms ease;will-change:max-width;max-width:", function (_ref23) {
  var ellipsis = _ref23.ellipsis,
      shrink = _ref23.shrink;
  return getShrinkableMaxWidth(ellipsis, shrink);
}, ";");
export var Content = styled('span', {
  target: "edxvmbf4"
})("min-width:0%;line-height:", lineHeightLv3, ";text-overflow:ellipsis;z-index:1;overflow:hidden;", function (_ref24) {
  var large = _ref24.large;
  return large ? "\n      text-align: left;\n      display: -webkit-box;\n      -webkit-line-clamp: 2; /* number of lines to show */\n      -webkit-box-orient: vertical;\n  " : "\n      white-space: nowrap;\n  ";
});
export var Image = styled('img', {
  target: "edxvmbf5"
})("z-index:1;margin-right:", function (_ref25) {
  var shrink = _ref25.shrink;
  return shrink ? '0' : '8px';
}, ";border-radius:", function (_ref26) {
  var large = _ref26.large;
  return large ? '8px' : '4px';
}, ";width:", function (_ref27) {
  var large = _ref27.large;
  return large ? '40px' : '24px';
}, ";height:", function (_ref28) {
  var large = _ref28.large;
  return large ? '40px' : '24px';
}, ";");