import styled, { keyframes } from 'react-emotion';
import { durationDefault, easeDefault } from 'unify-token/build/v2/motions';

var sizeResolver = function sizeResolver(size) {
  switch (size) {
    case 'large':
      return typeof size === 'number' ? 24 : '24px';

    case 'small':
      return typeof size === 'number' ? 16 : '16px';

    default:
      return typeof size === 'number' ? size : "".concat(size, "px");
  }
};

var indeterminateAnimation = keyframes("0%{stroke-dasharray:1,200;stroke-dashoffset:0;}100%{stroke-dasharray:200,200;stroke-dashoffset:-125px;}");
var _ref = "0%{stroke-dashoffset:";
var _ref2 = ";}";

var determinateAnimation = function determinateAnimation(circumference) {
  return keyframes(_ref, circumference, _ref2);
};

export var DeterminateContainer = styled("div", {
  target: "eomga6v0"
})("width:", function (_ref3) {
  var domSize = _ref3.domSize,
      width = _ref3.width;
  return domSize ? sizeResolver(domSize) : "".concat(width, "px");
}, ";height:", function (_ref4) {
  var domSize = _ref4.domSize,
      width = _ref4.width;
  return domSize ? sizeResolver(domSize) : "".concat(width, "px");
}, ";svg{transform:rotate(280deg);transform-origin:center center;}circle{stroke-linecap:round;transition:all ", durationDefault, " ", easeDefault, ";&.unf-loader-circular__progress{opacity:0;}&.unf-loader-circular__play{opacity:1;animation:", function (_ref5) {
  var circumference = _ref5.circumference;
  return determinateAnimation(circumference);
}, " 1500ms ease-in-out;}}");
export var IndeterminateContainer = styled("div", {
  target: "eomga6v1"
})("width:", function (_ref6) {
  var domSize = _ref6.domSize,
      width = _ref6.width;
  return domSize ? sizeResolver(domSize) : "".concat(width, "px");
}, ";height:", function (_ref7) {
  var domSize = _ref7.domSize,
      width = _ref7.width;
  return domSize ? sizeResolver(domSize) : "".concat(width, "px");
}, ";position:relative;svg{position:absolute;transform-origin:center center;&:last-child{transform:rotate(180deg);}}circle{stroke-dashoffset:0;stroke-linecap:round;animation:", indeterminateAnimation, " 1300ms ", easeDefault, " infinite;&.unf-loader-circular__reverse{animation-direction:reverse;}}");