import React from 'react';
declare type CircularAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface CircularProps extends Omit<CircularAttributes, 'css'> {
    /**
     * Set the Circular loader type to indeterminate type
     * @default false
     */
    indeterminate?: boolean;
    /**
     * Set the the state of Circular loader to loading and show loading animation, applicable if
     * `indeterminate` are set to **false**
     * @default false
     */
    loading?: boolean;
    /**
     * Set the progress of Circular loader in percentage, applicable if
     * `indeterminate` are set to **false**
     */
    progress?: number;
    /**
     * Set the size of the Circular loader, available value are `large`, and `small`,
     * But it also accept custom string and number.
     * @default 'large'
     */
    size?: 'large' | 'small' | string | number;
    /**
     * Set the color variant, available value are `color`, and `inverted`
     * @default 'color'
     */
    variant?: 'color' | 'inverted';
    /**
     * **Deprecated** use `size` instead, To set the type of label
     */
    width?: number;
}
export {};
