import * as React from 'react';
import styled, { css } from 'react-emotion';
import { NN900L } from 'unify-token/colors';
import getDocumentHeight from "../../build/Providers/common/functions/getDocumentHeight";
export var overlayDefaultProps = {
  top: 0,
  left: 0,
  right: 0,
  bottom: 0,
  height: 0,
  width: 0,
  spotlightPadding: 8
};

var _overlayBase = css("position:absolute;background-color:var(--NN0,", NN900L, ");opacity:0.7;box-sizing:border-box;z-index:50;");

var _overlayCorner = css("content:'';position:absolute;height:8px;width:8px;");

var OverlayTop = styled('div', {
  target: "e1bk4yg90"
})(_overlayBase, " top:0;left:", function (_ref) {
  var y = _ref.y,
      highlightPadding = _ref.highlightPadding;
  return y - highlightPadding;
}, "px;height:", function (_ref2) {
  var x = _ref2.x,
      highlightPadding = _ref2.highlightPadding;
  return x - highlightPadding;
}, "px;width:", function (_ref3) {
  var width = _ref3.width,
      highlightPadding = _ref3.highlightPadding;
  return width + 2 * highlightPadding;
}, "px;&:before{", _overlayCorner, " background:radial-gradient(circle at 100% 100%,rgba(0,0,0,0) 8px,var(--NN0,", NN900L, ") 8px);bottom:-8px;}&:after{", _overlayCorner, " background:radial-gradient(circle at 0 100%,rgba(0,0,0,0) 8px,var(--NN0,", NN900L, ") 8px);bottom:-8px;right:0;}");
var OverlayBottom = styled('div', {
  target: "e1bk4yg91"
})(_overlayBase, " width:", function (_ref4) {
  var width = _ref4.width,
      highlightPadding = _ref4.highlightPadding;
  return width + 2 * highlightPadding;
}, "px;top:", function (_ref5) {
  var x = _ref5.x,
      height = _ref5.height,
      highlightPadding = _ref5.highlightPadding;
  return x + height + highlightPadding;
}, "px;left:", function (_ref6) {
  var y = _ref6.y,
      highlightPadding = _ref6.highlightPadding;
  return y - highlightPadding;
}, "px;height:", function (_ref7) {
  var x = _ref7.x,
      height = _ref7.height,
      highlightPadding = _ref7.highlightPadding,
      documentHeight = _ref7.documentHeight;
  return documentHeight - (x + height + highlightPadding);
}, "px;&:before{", _overlayCorner, " background:radial-gradient(circle at 100% 0,rgba(0,0,0,0) 8px,var(--NN0,", NN900L, ") 8px);top:-8px;}&:after{", _overlayCorner, " background:radial-gradient(circle at 0 0,rgba(0,0,0,0) 8px,var(--NN0,", NN900L, ") 8px);top:-8px;right:0;}");
var OverlayRight = styled('div', {
  target: "e1bk4yg92"
})(_overlayBase, " top:0;left:", function (_ref8) {
  var y = _ref8.y,
      width = _ref8.width,
      highlightPadding = _ref8.highlightPadding;
  return y + width + highlightPadding;
}, "px;width:calc(100vw - ", function (_ref9) {
  var y = _ref9.y,
      width = _ref9.width,
      highlightPadding = _ref9.highlightPadding;
  return y + width + highlightPadding;
}, "px);height:", function (_ref10) {
  var documentHeight = _ref10.documentHeight;
  return documentHeight;
}, "px;");
var OverlayLeft = styled('div', {
  target: "e1bk4yg93"
})(_overlayBase, " left:0;top:0;height:", function (_ref11) {
  var documentHeight = _ref11.documentHeight;
  return documentHeight;
}, "px;width:", function (_ref12) {
  var y = _ref12.y,
      highlightPadding = _ref12.highlightPadding;
  return y - highlightPadding;
}, "px;");
var Cover = styled('div', {
  target: "e1bk4yg94"
})("position:absolute;box-sizing:border-box;z-index:50;top:", function (_ref13) {
  var top = _ref13.top;
  return top;
}, "px;left:", function (_ref14) {
  var left = _ref14.left;
  return left;
}, "px;width:", function (_ref15) {
  var width = _ref15.width;
  return width;
}, "px;height:", function (_ref16) {
  var height = _ref16.height;
  return height;
}, "px;");
var HIGHLIGHT_PADDING = 8;

var CoachmarkOverlay = function CoachmarkOverlay(_ref17) {
  var top = _ref17.top,
      left = _ref17.left,
      height = _ref17.height,
      width = _ref17.width,
      highlightOptions = _ref17.highlightOptions,
      ariaLabel = _ref17.ariaLabel,
      onClick = _ref17.onClick;
  var documentHeight = getDocumentHeight();
  var highlightPadding = highlightOptions && typeof highlightOptions.padding !== 'undefined' ? highlightOptions.padding : HIGHLIGHT_PADDING;
  return React.createElement(React.Fragment, null, React.createElement(OverlayTop, {
    x: top,
    y: left,
    width: width,
    highlightPadding: highlightPadding,
    onClick: onClick,
    role: "button",
    "aria-label": ariaLabel
  }), React.createElement(OverlayBottom, {
    x: top,
    y: left,
    highlightPadding: highlightPadding,
    height: height,
    width: width,
    documentHeight: documentHeight,
    onClick: onClick,
    role: "button",
    "aria-label": ariaLabel
  }), React.createElement(OverlayRight, {
    y: left,
    width: width,
    highlightPadding: highlightPadding,
    documentHeight: documentHeight,
    onClick: onClick,
    role: "button",
    "aria-label": ariaLabel
  }), React.createElement(OverlayLeft, {
    y: left,
    highlightPadding: highlightPadding,
    documentHeight: documentHeight,
    onClick: onClick,
    role: "button",
    "aria-label": ariaLabel
  }), React.createElement(Cover, {
    top: top,
    left: left,
    width: width,
    height: height
  }));
};

export default CoachmarkOverlay;