import styled, { css, keyframes } from 'react-emotion';
import { NN700, GN500, GN300, NN0 } from 'unify-token/colors';
import { focusStyle } from "../../build/Providers/common/style";
import ic_caret_disabled from "../../build/Providers/assets/ic_caret_disabled.svg";
import ic_caret from "../../build/Providers/assets/ic_caret.svg";
import ic_checkmark from "../../build/Providers/assets/ic_checkmark.svg";
import hexToRgba from "../../build/Providers/common/functions/hexToRgba";

var handleImage = function handleImage(_ref) {
  var previous = _ref.previous;

  switch (true) {
    case previous:
      return 'rotate(0deg)';

    default:
      return 'rotate(0deg)';
  }
};

var handleBackground = function handleBackground(_ref2) {
  var previous = _ref2.previous,
      last = _ref2.last;

  switch (true) {
    case last:
      return ic_checkmark;

    case previous:
      return ic_caret_disabled;

    default:
      return ic_caret;
  }
};

var ping = keyframes("0%{transform:scale(1.1);opacity:1;}100%{transform:scale(1.5);opacity:0;}");
export var Container = styled("div", {
  target: "eehn2rg0"
})("label:unf-coachmark;position:absolute;top:0;left:0;width:100%;max-height:166px;z-index:", function (_ref3) {
  var isDisplay = _ref3.isDisplay;
  return isDisplay ? '60' : '-1';
}, ";opacity:", function (_ref4) {
  var isDisplay = _ref4.isDisplay;
  return isDisplay ? '1' : '0';
}, ";transform:", function (_ref5) {
  var isDisplay = _ref5.isDisplay,
      yPos = _ref5.yPos;
  return isDisplay && yPos ? "translateY(".concat(yPos, "px)") : 'translateY(0)';
}, ";transition:all 0.3s ease-in-out;outline:none;&:after{content:'';position:absolute;", function (_ref6) {
  var reverse = _ref6.reverse;
  return reverse ? 'bottom' : 'top';
}, ":0;transform:", function (_ref7) {
  var xPos = _ref7.xPos,
      reverse = _ref7.reverse;
  return "translate(".concat(xPos, "px, ").concat(reverse ? 8 : -8, "px) rotate(").concat(reverse ? 180 : 0, "deg)");
}, ";width:0;height:0;border-left:8px solid transparent;border-right:8px solid transparent;border-bottom:8px solid ", NN0, ";}");
export var Footer = styled("div", {
  target: "eehn2rg1"
})("display:flex;flex:1;justify-content:space-between;align-items:center;");
export var ActionWrapper = styled("div", {
  target: "eehn2rg2"
})("display:flex;flex-direction:row;");
var _ref8 = "&:after{content:'';position:absolute;top:0;left:0;right:0;bottom:0;width:32px;height:32px;border-radius:50%;border:3px solid ";
var _ref9 = ";box-sizing:border-box;animation:";
var _ref10 = " 2s infinite;}";

var lastActionStyle = function lastActionStyle() {
  return css(_ref8, GN300, _ref9, ping, _ref10);
};

export var ActionButton = styled("button", {
  target: "eehn2rg3"
})("width:32px;height:32px;border:none;border-radius:16px;background-color:", function (_ref11) {
  var previous = _ref11.previous;
  return previous ? 'transparent' : GN500;
}, ";background-image:url(", function (_ref12) {
  var previous = _ref12.previous,
      last = _ref12.last;
  return handleBackground({
    previous: previous,
    last: last
  });
}, ");background-repeat:no-repeat;background-position:center center;background-size:auto;", function (_ref13) {
  var previous = _ref13.previous;
  return previous ? "border: 1px solid ".concat(GN500) : '';
}, ";transform:", function (_ref14) {
  var previous = _ref14.previous;
  return handleImage({
    previous: previous
  });
}, ";margin-right:", function (_ref15) {
  var previous = _ref15.previous;
  return previous ? 8 : 0;
}, "px;position:relative;", function (_ref16) {
  var last = _ref16.last;
  return last ? lastActionStyle() : '';
}, ";", focusStyle, ";");
export var ActionText = styled("button", {
  target: "eehn2rg4"
})("background-color:transparent;border:none;color:", GN500, ";cursor:pointer;font-size:14px;font-weight:bold;line-height:32px;margin:0 12px;padding:0;", focusStyle);
export var Highlight = styled("div", {
  target: "eehn2rg5"
})("background-color:", hexToRgba(NN700, 0.68), ";height:", function (_ref17) {
  var height = _ref17.height;
  return height;
}, "px;left:", function (_ref18) {
  var left = _ref18.left;
  return left;
}, "px;position:absolute;top:", function (_ref19) {
  var top = _ref19.top;
  return top;
}, "px;width:", function (_ref20) {
  var width = _ref20.width;
  return width;
}, "px;z-index:60;");