/// <reference types="react" />
declare type CoachmarkBaseProps = React.ComponentPropsWithoutRef<'div'>;
interface UnifyCoachmarkProps {
    /**
     * To indicate currently active item
     */
    currentPage: number;
    /**
     * To specify description text on item
     */
    description?: string | string[];
    /**
     * To toggle visibility of coachmark
     */
    display: boolean;
    /**
     * To show skip button
     */
    hasSkip?: boolean;
    /**
     * To specify highlight options
     */
    highlightOptions?: HighlightOptionProps;
    /**
     * To specify content language
     */
    lang?: string;
    /**
     * To specify which item to be highlighted when coachmark is active
     */
    numberOfPage?: string[];
    /**
     * To specify overlay options
     */
    overlayOptions?: OverlayProps;
    /**
     * To specify title text on item
     */
    title?: string | string[];
    /**
     * To pass callback when changing index | params: `nextCurrentIndex`
     */
    onChange?: (val: number) => void;
    /**
     * To pass callback when coachmark is skipped
     */
    onClickSkip?: () => void;
    /**
     * To pass callback when coachmark is closed
     */
    onClose?: () => void;
}
export declare type CoachmarkProps = UnifyCoachmarkProps & Omit<CoachmarkBaseProps, keyof UnifyCoachmarkProps>;
export interface overlayOptions {
    clickToClose: boolean;
    show: boolean;
}
export interface HighlightOptionProps {
    padding?: number;
}
export interface CoachmarkOverlayProps {
    top: number;
    left: number;
    height: number;
    width: number;
    highlightOptions?: HighlightOptionProps;
    ariaLabel?: string;
    onClick?: React.MouseEventHandler<HTMLDivElement>;
}
export interface OverlayProps {
    x: number;
    y: number;
    highlightPadding: number;
    width: number;
    height: number;
    documentHeight: number;
}
export interface CoverProps {
    top: number;
    left: number;
    width: number;
    height: number;
}
export interface ActionButtonProps {
    previous?: boolean;
    last?: boolean;
    next?: boolean;
}
export interface HighlightProps {
    height?: number;
    width?: number;
    left?: number;
    top?: number;
}
export interface ContainerProps {
    isDisplay?: boolean;
    reverse?: boolean;
    xPos?: number;
    yPos?: number;
}
export {};
