import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children"];
import React, { useRef, forwardRef } from 'react';
import { NN100 } from 'unify-token/colors';
import { easeInOut } from 'unify-token/build/v2/motions';
import Ripple from "../../build/Providers/common/components/Ripple";
import { Item } from "./style";
var ItemSwitcher = forwardRef(function (props, ref) {
  var children = props.children,
      rest = _objectWithoutProperties(props, _excluded);

  var rippleRef = useRef(null);

  var handleMouseDown = function handleMouseDown(e) {
    if (rippleRef.current) {
      rippleRef.current.trigger(e);
    }
  };

  return React.createElement(Item, _extends({}, rest, {
    innerRef: ref,
    onMouseDown: handleMouseDown
  }), React.createElement(Ripple, {
    ref: rippleRef,
    color: NN100,
    duration: 200,
    easing: easeInOut
  }), children);
});
ItemSwitcher.displayName = 'ItemSwitcher';
export default ItemSwitcher;