import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["heading", "indexActive", "selections", "onItemClick"];
import React, { useState, useEffect, useRef, useCallback } from 'react';
import Typography from "../../build/Typography";
import { canUseDOM } from "../../build/Providers/common/functions";
import getViewport from "../../build/Providers/common/functions/getViewport";
import { Container, ItemContainer, ItemHighlight } from "./style";
import ItemSwitcher from "./ItemSwitcher";

var ContentSwitcher = function ContentSwitcher(_ref) {
  var _ref$heading = _ref.heading,
      heading = _ref$heading === void 0 ? 5 : _ref$heading,
      _ref$indexActive = _ref.indexActive,
      indexActive = _ref$indexActive === void 0 ? 0 : _ref$indexActive,
      _ref$selections = _ref.selections,
      selections = _ref$selections === void 0 ? ['Indonesia', 'English'] : _ref$selections,
      _ref$onItemClick = _ref.onItemClick,
      onItemClick = _ref$onItemClick === void 0 ? function () {} : _ref$onItemClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var itemEl = useRef(null);

  var _useState = useState({
    x: 4,
    y: 4
  }),
      _useState2 = _slicedToArray(_useState, 2),
      position = _useState2[0],
      setPosition = _useState2[1];

  var _useState3 = useState({
    width: 0,
    height: 0
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      dimension = _useState4[0],
      setDimension = _useState4[1];

  var x = position.x,
      y = position.y;
  var width = dimension.width,
      height = dimension.height;

  var getWindowDimension = function getWindowDimension() {
    return canUseDOM ? getViewport() : {
      height: 0,
      width: 0
    };
  };

  var _useState5 = useState(getWindowDimension()),
      _useState6 = _slicedToArray(_useState5, 2),
      windowDimension = _useState6[0],
      setWindowDimension = _useState6[1];

  var handleWindowDimension = useCallback(function () {
    setWindowDimension(getWindowDimension());
  }, []);
  useEffect(function () {
    window.addEventListener('resize', handleWindowDimension);
    return function cleanup() {
      window.removeEventListener('resize', handleWindowDimension);
    };
  }, [handleWindowDimension]);
  useEffect(function () {
    if (itemEl && typeof itemEl.current !== 'undefined') {
      var itemDOM = itemEl.current;
      var itemRect = (itemDOM === null || itemDOM === void 0 ? void 0 : itemDOM.getBoundingClientRect()) || 0;
      var itemWidth = itemRect && itemRect.width;
      var itemHeight = itemRect && itemRect.height;
      var itemClientLeft = (itemDOM === null || itemDOM === void 0 ? void 0 : itemDOM.offsetLeft) || 0;
      var itemClientTop = (itemDOM === null || itemDOM === void 0 ? void 0 : itemDOM.offsetTop) || 0;
      setPosition({
        x: itemClientLeft,
        y: itemClientTop
      });
      setDimension({
        width: itemWidth,
        height: itemHeight
      });
    }
  }, [indexActive, selections, windowDimension.height, windowDimension.width]);

  var renderSelections = function renderSelections() {
    return selections === null || selections === void 0 ? void 0 : selections.map(function (selection, index) {
      var isActive = indexActive === index;
      return React.createElement(ItemSwitcher, {
        active: isActive,
        "aria-selected": isActive,
        ref: isActive ? itemEl : undefined,
        key: "".concat(selection, "-").concat(index),
        role: "tab",
        type: "button",
        onClick: function onClick(e) {
          return onItemClick(selection, index, e);
        }
      }, React.createElement(Typography, {
        tag: 6,
        heading: heading,
        margin: "0"
      }, selection));
    });
  };

  return React.createElement("div", _extends({
    className: Container,
    "data-unify": "ContentSwitcher"
  }, otherProps), React.createElement(ItemHighlight, {
    width: width,
    height: height,
    xPos: x,
    yPos: y
  }), React.createElement("div", {
    className: ItemContainer,
    role: "tablist"
  }, renderSelections()));
};

export default ContentSwitcher;