import { colorTextHigh, colorShadow, colorPageBackground, colorTextLow } from 'unify-token/build/v2/colors';
import { GN100, GN500, RN200, RN500, NN300, NN400, NN600, NN950, NN0 } from 'unify-token/colors';
import { fontSizeLv1, fontSizeLv2, fontWeightBold } from 'unify-token/build/v2/typographies';
import styled, { css } from 'react-emotion';
import { colorWhiteAlways } from "../../../build/Providers/common/style";
var DateChildElem = css("text-align:center;line-height:1.2;display:block;");
var datepicker = css("label:datepicker;display:flex;flex-direction:column;height:100%;-webkit-overflow-scrolling:touch;&-date{position:relative;}");
var Day = styled('div', {
  target: "e196e5ir0"
})("label:datepicker-day;.datepicker-day__items{width:calc(100% / 7);height:40px;color:", NN600, ";font-size:", fontSizeLv2, ";line-height:2;vertical-align:top;display:inline-block;position:relative;margin-bottom:0;&--holiday{color:", RN500, ";}span{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);}}");
var DateSection = styled('div', {
  target: "e196e5ir1"
})("label:date;width:calc(100% / 7);height:40px;vertical-align:top;display:inline-block;position:relative;margin:2px 0;border:none;&.selected{background-color:", GN100, ";}&.disabled{pointer-events:none;}&.disabled .date__number,&.disabled.active .date__number{color:", NN400, ";}&.disabled.holiday .date__number{color:", RN200, ";}&.holiday .date__number{color:", RN500, ";}&.active .date__number,&.active .date__text,&.active.holiday .date__number,&.active.holiday .date__text{color:", colorWhiteAlways, ";}&.active:not(.startDate):not(.endDate)::before,&.today:not(.active)::before,&.alternate:not(.active)::before,&.startDate::before,&.endDate::after{content:'';width:40px;height:40px;border-radius:12px;position:absolute;top:50%;left:50%;z-index:4;transform:translate(-50%,-50%);}&.today:not(.active)::before{border:1px solid ", NN300, ";}&.alternate:not(.active)::before{border:1px solid ", RN500, ";}&.active:not(.startDate):not(.endDate)::before,&.startDate::before,&.endDate::after{background-color:", GN500, ";}&.active:not(.startDate):not(.endDate)::before{box-shadow:none;}&.active:not(.startDate):not(.endDate)::after{right:0;background-color:", colorPageBackground, ";}&.active:not(.startDate):not(.endDate)::after,&.startDate::after,&.endDate::before{content:'';width:50%;height:40px;position:absolute;top:0;z-index:3;}&.startDate::after{right:0;background-color:", GN100, ";}&.endDate:not(.sameDate)::before{left:0;background-color:", GN100, ";}");
var DateSectionWrapper = styled('div', {
  target: "e196e5ir2"
})("z-index:5;position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);");
var DateSectionNumber = styled('span', {
  target: "e196e5ir3"
})("label:date__number;", DateChildElem, " color:", NN950, ";font-size:", fontSizeLv2, ";");
var DateSectionText = styled('span', {
  target: "e196e5ir4"
})("label:date__text;", DateChildElem, " color:", function (_ref) {
  var hasColor = _ref.hasColor;
  return hasColor !== null && hasColor !== void 0 ? hasColor : NN600;
}, ";font-size:", fontSizeLv1, ";max-width:40px;text-overflow:ellipsis;overflow:hidden;");
var DatepickerInfoWrapper = styled('div', {
  target: "e196e5ir5"
})("label:unf-datepicker-info;margin-bottom:16px;padding:8px 16px 0;dl{margin-top:0;margin-bottom:8px;dt{width:50px;color:", RN500, ";font-size:", fontSizeLv2, ";float:left;}dd{color:", NN600, ";font-size:", fontSizeLv2, ";margin-left:50px;}&:last-child{margin-bottom:0;}}");
var DatepickerPriceWrapper = styled('div', {
  target: "e196e5ir6"
})("label:unf-price-toggle;height:45px;color:", colorTextHigh, ";font-size:", fontSizeLv2, ";background-color:", NN0, ";display:block;position:sticky;bottom:0;width:100%;z-index:6;padding:8px 16px;box-shadow:0 1px 6px 0 ", colorShadow, ";label:not(.datepicker-price-toggle){line-height:29px;}.datepicker-price-toggle{position:absolute;top:50%;right:16px;transform:translateY(-50%);}");
var DatepickerMonthWrapper = styled('div', {
  target: "e196e5ir7"
})("label:unf-month-wrapper;.unf-month__title{font-size:", fontSizeLv2, ";color:", NN950, ";font-weight:", fontWeightBold, ";text-align:center;margin:16px 0 8px;}");
var DatepickerPanelWrapper = styled('div', {
  target: "e196e5ir8"
})("label:unf-panel;width:100%;position:sticky;z-index:6;top:0;background-color:", colorPageBackground, ";border-bottom:1px solid ", NN300, ";");
var DatepickerPanelInfoWrapper = styled('div', {
  target: "e196e5ir9"
})("label:unf-panel__info;padding:0 16px 8px;display:flex;flex-direction:column;color:", colorTextLow, ";.unf-info__content{max-height:45px;margin-bottom:12px;font-size:", fontSizeLv2, ";overflow:hidden;text-overflow:ellipsis;display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;}.unf-info__legend{display:flex;.unf-legend__items{display:inline-flex;margin-right:16px;font-size:", fontSizeLv1, ";.unf-legend__logo{border-radius:2px;margin-right:4px;width:12px;height:12px;border:1px solid;&.today{border-color:", NN300, ";}&.alternate{border-color:", RN500, ";}}}}");
var DatepickerPanelRangeWrapper = styled('div', {
  target: "e196e5ir10"
})("label:unf-panel__range;padding:0 16px;display:flex;justify-content:space-between;.unf-input__panel-wrapper{width:145px;}");
export { datepicker, Day, DateSection, DateSectionWrapper, DateSectionNumber, DateSectionText, DatepickerInfoWrapper, DatepickerPriceWrapper, DatepickerMonthWrapper, DatepickerPanelRangeWrapper, DatepickerPanelInfoWrapper, DatepickerPanelWrapper };