import React from 'react';
import { DatepickerInfoWrapper } from "./_DatepickerCalendarStyle";

var DatepickerInfo = function DatepickerInfo(_ref) {
  var infoDate = _ref.infoDate,
      monthsLabel = _ref.monthsLabel,
      currentMonth = _ref.currentMonth,
      currentYear = _ref.currentYear;

  var pushContent = function pushContent(data, key, dateLabel, infoText) {
    if (Array.isArray(data)) {
      return data.push(React.createElement("dl", {
        key: key
      }, React.createElement("dt", null, dateLabel), React.createElement("dd", null, infoText)));
    } else return {};
  };

  var infoList = [];
  if (!infoDate || !monthsLabel) return;

  for (var x = 0; x < infoDate.length; x++) {
    var day = infoDate[parseInt(x)].date.getDate();
    var month = infoDate[parseInt(x)].date.getMonth();
    var year = infoDate[parseInt(x)].date.getFullYear();
    var specialDate = infoDate[parseInt(x)].specialDate;
    var infoText = infoDate[parseInt(x)].text;
    var monthLabel = monthsLabel[parseInt(currentMonth)].slice(0, 3);
    var dateLabel = "".concat(day, " ").concat(monthLabel);
    var newDate = new Date(currentYear, currentMonth, day);

    if (specialDate) {
      if (day === newDate.getDate() && month === newDate.getMonth() && year === newDate.getFullYear()) {
        pushContent(infoList, x, dateLabel, infoText);
      }
    } else {
      if (day === newDate.getDate()) {
        pushContent(infoList, x, dateLabel, infoText);
      }
    }
  }

  return infoList.length > 0 && React.createElement(DatepickerInfoWrapper, null, infoList);
};

export default DatepickerInfo;