import React, { useEffect, useCallback } from 'react';
import { canUseDOM } from "../../../build/Providers/common/functions";
import { noop } from "../../../build/Providers/common/functions/noop";
import { emptyArray } from "./constant";
import DatepickerWeekDate from "./_DatepickerWeek_Date";
import DatepickerInfo from "./_DatepickerInfo";
import { DatepickerMonthWrapper } from "./_DatepickerCalendarStyle";

var DatepickerMonth = function DatepickerMonth(_ref) {
  var _ref$alternateDate = _ref.alternateDate,
      alternateDate = _ref$alternateDate === void 0 ? emptyArray : _ref$alternateDate,
      currentMonth = _ref.currentMonth,
      currentYear = _ref.currentYear,
      _ref$disabledDate = _ref.disabledDate,
      disabledDate = _ref$disabledDate === void 0 ? emptyArray : _ref$disabledDate,
      _ref$enabledDate = _ref.enabledDate,
      enabledDate = _ref$enabledDate === void 0 ? emptyArray : _ref$enabledDate,
      firstDate = _ref.firstDate,
      _ref$infoDate = _ref.infoDate,
      infoDate = _ref$infoDate === void 0 ? emptyArray : _ref$infoDate,
      maxDate = _ref.maxDate,
      minDate = _ref.minDate,
      _ref$monthsLabel = _ref.monthsLabel,
      monthsLabel = _ref$monthsLabel === void 0 ? emptyArray : _ref$monthsLabel,
      _ref$price = _ref.price,
      price = _ref$price === void 0 ? emptyArray : _ref$price,
      secondDate = _ref.secondDate,
      _ref$showPrice = _ref.showPrice,
      showPrice = _ref$showPrice === void 0 ? false : _ref$showPrice,
      _ref$yearLabel = _ref.yearLabel,
      yearLabel = _ref$yearLabel === void 0 ? emptyArray : _ref$yearLabel,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick;

  var getClsName = function getClsName(cls, idx) {
    var get = canUseDOM && document.getElementsByClassName(cls)[parseInt(idx)];
    return get;
  };

  var handleScrollMonth = useCallback(function () {
    var sheetWrapperContent = getClsName('unf-picker__calendar', 0);
    var scrollArea = sheetWrapperContent.closest('.unf-sheet__content');
    var panel = getClsName('unf-panel', 0);
    var activeMonth = getClsName('unf--current-month', 0);
    var panelHeight = canUseDOM && panel.getBoundingClientRect().height;
    var space = panelHeight;

    if (!activeMonth) {
      return null;
    } else {
      scrollArea.scrollTop = (activeMonth === null || activeMonth === void 0 ? void 0 : activeMonth.offsetTop) - space;
    }

    return null;
  }, []);
  useEffect(function () {
    var timerId = null;
    timerId = setTimeout(function () {
      handleScrollMonth();
    }, 1);
    return function () {
      return clearTimeout(timerId);
    };
  }, [handleScrollMonth]);

  var renderMonth = function renderMonth() {
    return yearLabel.map(function (year, yearIndex) {
      return monthsLabel.map(function (month, monthIndex) {
        return React.createElement(DatepickerMonthWrapper, {
          key: "month-".concat(monthIndex, "-").concat(yearIndex),
          className: monthIndex === currentMonth && year === currentYear ? 'unf--current-month' : ''
        }, React.createElement("div", {
          className: "unf-month__title"
        }, month, " ", year), React.createElement(DatepickerWeekDate, {
          infoDate: infoDate,
          minDate: minDate,
          maxDate: maxDate,
          disabledDate: disabledDate,
          enabledDate: enabledDate,
          alternateDate: alternateDate,
          firstDate: firstDate,
          secondDate: secondDate,
          currentMonth: monthIndex,
          currentYear: year,
          price: price,
          showPrice: showPrice,
          onClick: onClick
        }), React.createElement(DatepickerInfo, {
          infoDate: infoDate,
          monthsLabel: monthsLabel,
          currentMonth: monthIndex,
          currentYear: year
        }));
      });
    });
  };

  return renderMonth();
};

export default DatepickerMonth;