import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useState, useEffect, useCallback } from 'react';
import TextFieldV2 from "../../../build/TextFieldV2";
import { DatepickerPanelRangeWrapper } from "./_DatepickerCalendarStyle";

var DatepickerPanelRange = function DatepickerPanelRange(_ref) {
  var dayLabel = _ref.dayLabel,
      display = _ref.display,
      firstDate = _ref.firstDate,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      monthLabel = _ref.monthLabel,
      secondDate = _ref.secondDate,
      _ref$titleFirstDate = _ref.titleFirstDate,
      titleFirstDate = _ref$titleFirstDate === void 0 ? 'First Date' : _ref$titleFirstDate,
      _ref$titleSecondDate = _ref.titleSecondDate,
      titleSecondDate = _ref$titleSecondDate === void 0 ? 'Second Date' : _ref$titleSecondDate;
  var emptyVal = lang === 'id' ? 'Pilih tanggal' : 'Select date';
  var newDateFirst = new Date(firstDate);
  var newDateSecond = new Date(secondDate);
  var dateFirstVal = newDateFirst.getDate();
  var dateSecondVal = newDateSecond.getDate();
  var dayFirstVal = dayLabel[newDateFirst.getDay()];
  var daySecondVal = dayLabel[newDateSecond.getDay()];
  var monthFirstVal = monthLabel[newDateFirst.getMonth()];
  var monthSecondVal = monthLabel[newDateSecond.getMonth()];
  var yearFirstVal = newDateFirst.getFullYear();
  var yearSecondVal = newDateSecond.getFullYear();
  var comparisonFirstDate = newDateFirst.getTime();
  var comparisonSecondDate = newDateSecond.getTime();

  var _useState = useState(emptyVal),
      _useState2 = _slicedToArray(_useState, 2),
      firstDateVal = _useState2[0],
      setFirstDateVal = _useState2[1];

  var _useState3 = useState(emptyVal),
      _useState4 = _slicedToArray(_useState3, 2),
      secondDateVal = _useState4[0],
      setSecondDateVal = _useState4[1];

  var initialValidate = function initialValidate() {
    if (dateFirstVal === dateSecondVal) {
      setFirstDateVal(emptyVal);
      setSecondDateVal(emptyVal);
    } else if (comparisonFirstDate > comparisonSecondDate) {
      setFirstDateVal("".concat(dateFirstVal, " ").concat(monthFirstVal, " ").concat(yearFirstVal));
      setSecondDateVal(emptyVal);
    } else {
      setFirstDateVal("".concat(dateFirstVal, " ").concat(monthFirstVal, " ").concat(yearFirstVal));
      setSecondDateVal("".concat(dateSecondVal, " ").concat(monthSecondVal, " ").concat(yearSecondVal));
    }
  };

  var updateValidate = useCallback(function () {
    if (comparisonSecondDate === 0 && display) {
      setFirstDateVal("".concat(dateFirstVal, " ").concat(monthFirstVal, " ").concat(yearFirstVal));
      setSecondDateVal(emptyVal);
    } else if (comparisonFirstDate > comparisonSecondDate) {
      setFirstDateVal("".concat(dateFirstVal, " ").concat(monthFirstVal, " ").concat(yearFirstVal));
      setSecondDateVal(emptyVal);
    } else {
      setFirstDateVal("".concat(dateFirstVal, " ").concat(monthFirstVal, " ").concat(yearFirstVal));
      setSecondDateVal("".concat(dateSecondVal, " ").concat(monthSecondVal, " ").concat(yearSecondVal));
    }
  }, [display, emptyVal, comparisonFirstDate, comparisonSecondDate, dayFirstVal, daySecondVal, dateFirstVal, monthFirstVal, dateSecondVal, monthSecondVal]);
  useEffect(function () {
    initialValidate();
    updateValidate();
  });
  return React.createElement(DatepickerPanelRangeWrapper, null, React.createElement("div", {
    className: "unf-input__panel-wrapper"
  }, React.createElement(TextFieldV2, {
    readOnly: true,
    label: titleFirstDate,
    value: firstDateVal,
    focus: !secondDate
  })), React.createElement("div", {
    className: "unf-input__panel-wrapper"
  }, React.createElement(TextFieldV2, {
    readOnly: true,
    label: titleSecondDate,
    value: secondDateVal,
    focus: Boolean(secondDate)
  })));
};

export default DatepickerPanelRange;