import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["alternateDate", "alternateTitle", "className", "disabledDate", "display", "enabledDate", "firstDate", "infoDate", "lang", "maxDate", "messageInfo", "minDate", "panelInfo", "panelRange", "price", "secondDate", "showPrice", "showPriceToggle", "titleFirstDate", "titlePriceToggle", "titleSecondDate", "onClick", "onClickDouble"];
import React, { useState } from 'react';
import { cx } from 'emotion';
import Toggle from "../../../build/Toggle";
import { noop } from "../../../build/Providers/common/functions/noop";
import DatepickerWeekDay from "./_DatepickerWeek_Day";
import DatepickerPanelRange from "./_DatepickerPanelRange";
import DatepickerPanelInfo from "./_DatepickerPanelInfo";
import DatepickerMonth from "./_DatepickerMonth";
import { datepicker, DatepickerPriceWrapper, DatepickerPanelWrapper } from "./_DatepickerCalendarStyle";

var Calendar = function Calendar(_ref) {
  var _firstDate$getFullYea, _firstDate$getMonth;

  var alternateDate = _ref.alternateDate,
      alternateTitle = _ref.alternateTitle,
      className = _ref.className,
      disabledDate = _ref.disabledDate,
      display = _ref.display,
      enabledDate = _ref.enabledDate,
      _ref$firstDate = _ref.firstDate,
      firstDate = _ref$firstDate === void 0 ? new Date() : _ref$firstDate,
      infoDate = _ref.infoDate,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      maxDate = _ref.maxDate,
      messageInfo = _ref.messageInfo,
      minDate = _ref.minDate,
      panelInfo = _ref.panelInfo,
      panelRange = _ref.panelRange,
      price = _ref.price,
      secondDate = _ref.secondDate,
      showPrice = _ref.showPrice,
      showPriceToggle = _ref.showPriceToggle,
      titleFirstDate = _ref.titleFirstDate,
      titlePriceToggle = _ref.titlePriceToggle,
      titleSecondDate = _ref.titleSecondDate,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      _ref$onClickDouble = _ref.onClickDouble,
      onClickDouble = _ref$onClickDouble === void 0 ? noop : _ref$onClickDouble,
      datePickerProps = _objectWithoutProperties(_ref, _excluded);

  var daysLabel = {
    id: ['Min', 'Sen', 'Sel', 'Rab', 'Kam', 'Jum', 'Sab'],
    en: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
  };
  var monthsLabel = {
    id: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
    en: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
  };

  var _useState = useState(showPrice),
      _useState2 = _slicedToArray(_useState, 2),
      isShowPrice = _useState2[0],
      setIsShowPrice = _useState2[1];

  var generateYears = function generateYears(cy) {
    var _maxDate$getFullYear;

    var years = [];
    var startYear = {};
    var endYear = (_maxDate$getFullYear = maxDate === null || maxDate === void 0 ? void 0 : maxDate.getFullYear()) !== null && _maxDate$getFullYear !== void 0 ? _maxDate$getFullYear : cy + 1;

    if (minDate) {
      if (minDate.getFullYear() < cy - 1) {
        startYear = cy - 1;
      } else {
        startYear = minDate.getFullYear();
      }
    } else {
      startYear = cy;
    }

    while (startYear <= endYear) {
      years.push(startYear++);
    }

    return years;
  };

  var dayLabel = lang === 'id' ? daysLabel.id : daysLabel.en;
  var monthLabel = lang === 'id' ? monthsLabel.id : monthsLabel.en;
  var currentYear = (_firstDate$getFullYea = firstDate === null || firstDate === void 0 ? void 0 : firstDate.getFullYear()) !== null && _firstDate$getFullYea !== void 0 ? _firstDate$getFullYea : new Date().getFullYear();
  var currentMonth = (_firstDate$getMonth = firstDate === null || firstDate === void 0 ? void 0 : firstDate.getMonth()) !== null && _firstDate$getMonth !== void 0 ? _firstDate$getMonth : new Date().getMonth();
  var yearLabel = generateYears(currentYear);

  var handlePickDate = function handlePickDate(date) {
    if (firstDate === null) {
      onClick(date);
    }

    if (secondDate === undefined) {
      onClick(date);
    } else if (firstDate && secondDate) {
      onClick(date);
      onClickDouble(null);
    } else if (onClickDouble && (firstDate === null || firstDate === void 0 ? void 0 : firstDate.getTime()) === date.getTime()) {
      onClick(date);
      onClickDouble(firstDate);
    } else if (!onClickDouble || (firstDate === null || firstDate === void 0 ? void 0 : firstDate.getTime()) === date.getTime()) {
      onClick(date);
    } else if (date < firstDate) {
      onClick(date);
      onClickDouble(firstDate);
    } else {
      onClickDouble(date);
    }
  };

  var handleShowPrice = function handleShowPrice() {
    setIsShowPrice(!isShowPrice);
  };

  var renderPriceToggle = function renderPriceToggle() {
    return React.createElement(DatepickerPriceWrapper, null, React.createElement("label", null, titlePriceToggle), showPriceToggle && React.createElement(Toggle, {
      onClick: handleShowPrice,
      checked: isShowPrice,
      className: "datepicker-price-toggle"
    }));
  };

  var renderPanel = function renderPanel(day, month) {
    if (panelRange) {
      return React.createElement(DatepickerPanelRange, {
        display: display,
        dayLabel: day,
        lang: lang,
        monthLabel: month,
        firstDate: firstDate,
        secondDate: secondDate,
        titleFirstDate: titleFirstDate,
        titleSecondDate: titleSecondDate
      });
    } else if (panelInfo) {
      return React.createElement(DatepickerPanelInfo, {
        messageInfo: messageInfo,
        alternateTitle: alternateTitle,
        lang: lang
      });
    } else {
      return false;
    }
  };

  return React.createElement("div", _extends({
    className: cx('unf-picker__calendar', datepicker, className)
  }, datePickerProps), React.createElement(DatepickerPanelWrapper, {
    className: "unf-panel"
  }, renderPanel(dayLabel, monthLabel), React.createElement(DatepickerWeekDay, {
    dayLabel: dayLabel
  })), React.createElement(DatepickerMonth, {
    yearLabel: yearLabel,
    alternateDate: alternateDate,
    infoDate: infoDate,
    minDate: minDate,
    maxDate: maxDate,
    disabledDate: disabledDate,
    enabledDate: enabledDate,
    firstDate: firstDate,
    secondDate: secondDate,
    currentYear: currentYear,
    currentMonth: currentMonth,
    price: price,
    showPrice: isShowPrice,
    onClick: handlePickDate,
    monthsLabel: monthLabel
  }), showPrice && renderPriceToggle());
};

export default Calendar;