import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "content", "description", "lang", "type", "onClick", "initialDate"];
import React, { useRef, useEffect, useState } from 'react';
import Button from "../../../build/Button";
import { noop } from "../../../build/Providers/common/functions/noop";
import DatepickerScrollDefault from "./_DatepickerScrollDefault";
import DatepickerScrollTime from "./_DatepickerScrollTime";
import { datepicker_scroll, datepicker_sheet_description, datepicker_scroll_container, datepicker_scroll_selected, datepicker_scroll_content } from "./_DatepickerScrollStyle";
import { defaultInitialDate } from "./utility";

var DatepickerScroll = function DatepickerScroll(_ref) {
  var className = _ref.className,
      content = _ref.content,
      _ref$description = _ref.description,
      description = _ref$description === void 0 ? '' : _ref$description,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'date' : _ref$type,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      _ref$initialDate = _ref.initialDate,
      initialDate = _ref$initialDate === void 0 ? defaultInitialDate : _ref$initialDate,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(initialDate),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var ariaLiveRef = useRef(null);

  var onButtonClick = function onButtonClick(e) {
    onClick(value, e);
  };

  var getLocaleString = function getLocaleString() {
    var toReturn = '';

    if (type === 'datetime') {
      toReturn = (value === null || value === void 0 ? void 0 : value.toLocaleDateString('en-US', {
        weekday: 'long',
        year: 'numeric',
        month: 'long',
        day: 'numeric',
        hour: 'numeric',
        minute: 'numeric'
      })) || '';
    } else if (type === 'time') {
      toReturn = (value === null || value === void 0 ? void 0 : value.toLocaleTimeString('en-US', {
        hour: 'numeric',
        minute: 'numeric'
      })) || '';
    } else {
      toReturn = (value === null || value === void 0 ? void 0 : value.toLocaleDateString('en-US', {
        weekday: 'long',
        year: 'numeric',
        month: 'long',
        day: 'numeric'
      })) || '';
    }

    return toReturn;
  };

  useEffect(function () {
    setValue(initialDate);
  }, [initialDate]);
  var customClass = className ? " ".concat(className) : '';
  var tempType;

  if (content) {
    tempType = content;
    console.warn('Props content will be deprecated. Use props type instead.');
  } else {
    tempType = type;
  }

  tempType = type;
  return React.createElement("div", {
    "data-unify": "Datepicker"
  }, description && React.createElement("div", {
    className: datepicker_sheet_description
  }, description), React.createElement("div", {
    className: "".concat(datepicker_scroll).concat(customClass)
  }, React.createElement("div", {
    className: datepicker_scroll_container
  }, React.createElement("div", {
    className: datepicker_scroll_content,
    role: "group"
  }, tempType !== 'date' ? React.createElement(DatepickerScrollTime, _extends({
    type: tempType,
    lang: lang,
    initialDate: initialDate,
    setValue: setValue
  }, otherProps)) : React.createElement(DatepickerScrollDefault, _extends({
    lang: lang,
    setValue: setValue,
    initialDate: initialDate
  }, otherProps))), React.createElement("div", {
    className: datepicker_scroll_selected
  })), React.createElement(Button, {
    filled: true,
    main: true,
    block: true,
    onClick: onButtonClick,
    "aria-label": getLocaleString()
  }, lang === 'id' ? 'Pilih' : 'Set')), React.createElement("div", {
    id: "datepickerScroll2Aria",
    "aria-live": "polite",
    ref: ariaLiveRef,
    style: {
      width: '0',
      height: '0',
      overflow: 'hidden',
      position: 'absolute'
    }
  }, getLocaleString()));
};

export default DatepickerScroll;