import _createForOfIteratorHelper from "@babel/runtime/helpers/createForOfIteratorHelper";
export var ROW_HEIGHT = 30;
export var CONTAINER_HEIGHT = 125;
export var ACCELERATION_COEFF = 3;
export var FRICTION_COEFF = 0.8;
export var MIN_ABS_VELOCITY = 100;
export var RENDER_INTERVAL = 1000 / 60;
export var LIST_SIZE_CONSTANT = 4;
export var Y_ORIGIN = (CONTAINER_HEIGHT - ROW_HEIGHT) / 2;
export var DISABLED_PAD_AMOUNT = 30;
export var MS_TO_DAY_DIVIDER = 1000 * 60 * 60 * 24;
export var monthList = {
  id: ['Jan', 'Feb', 'Mar', 'Apr', 'Mei', 'Jun', 'Jul', 'Agu', 'Sep', 'Okt', 'Nov', 'Des'],
  en: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
};
export var dayList = {
  id: ['Min', 'Sen', 'Sel', 'Rab', 'Kam', 'Jum', 'Sab'],
  en: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
};
export var fullMonthList = {
  id: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
  en: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
};
export var disableArrayValues = function disableArrayValues(array, minIndex, maxIndex) {
  if (minIndex !== 0 || maxIndex !== array.length - 1) {
    var _iterator = _createForOfIteratorHelper(array),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var i = _step.value;
        var index = Number(i);

        if (index < minIndex) {
          array[Number(index)].disabled = true;
        } else if (index > maxIndex) {
          array[Number(index)].disabled = true;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
};
export var disableArrayValuesByIndex = function disableArrayValuesByIndex(array, minIndex, maxIndex) {
  if (minIndex !== 0 || maxIndex !== array.length - 1) {
    var _iterator2 = _createForOfIteratorHelper(array),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var i = _step2.value;
        var index = Number(i);

        if (index < minIndex) {
          array[Number(index)].disabled = true;
        } else if (index > maxIndex) {
          array[Number(index)].disabled = true;
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
};
export var generateYears = function generateYears() {
  var minYear = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1900;
  var maxYear = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Date().getFullYear();
  var years = [];
  var startYear = minYear;
  var endYear = maxYear;

  for (var i = startYear - DISABLED_PAD_AMOUNT; i < startYear; ++i) {
    years.push({
      text: "".concat(i),
      value: i,
      disabled: true
    });
  }

  while (startYear <= endYear) {
    years.push({
      text: "".concat(startYear),
      value: startYear
    });
    startYear++;
  }

  for (var _i = endYear + 1; _i <= endYear + DISABLED_PAD_AMOUNT; ++_i) {
    years.push({
      text: "".concat(_i),
      value: _i,
      disabled: true
    });
  }

  return years;
};
export var formatDate = function formatDate(format) {
  var arr = format.split('-');
  var newFormat = {
    date: 'd',
    month: 'MMMM',
    year: 'yyyy'
  };
  var order = [];
  arr.map(function (i) {
    if (i.toLowerCase().charAt(0) === 'd') {
      newFormat.date = i.toLowerCase();
      order.push('d');
    } else if (i.toUpperCase().charAt(0) === 'M') {
      newFormat.month = i.toUpperCase();
      order.push('M');
    } else if (i.toLowerCase().charAt(0) === 'y') {
      newFormat.year = i.toLowerCase();
      order.push('y');
    }
  });
  return {
    dateFormat: newFormat,
    order: order
  };
};
export var defaultInitialDate = new Date();
export var defaultMaxDate = new Date(new Date().getFullYear(), 11, 31);
export var defaultMinDate = new Date(1900, 1, 1);