import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["scrollMode", "onClose", "title", "display"];
import React from 'react';
import BottomSheetV2 from "../../build/BottomSheetV2";
import Calendar from "./DatepickerCalendar";
import DatepickerScroll from "./DatepickerScroll";

var Datepicker = function Datepicker(_ref) {
  var scrollMode = _ref.scrollMode,
      onClose = _ref.onClose,
      title = _ref.title,
      display = _ref.display,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  return React.createElement(BottomSheetV2, {
    className: "unf-picker__bottomsheet",
    title: title,
    full: !scrollMode,
    padding: "0",
    withClose: true,
    onClose: onClose,
    display: display
  }, scrollMode ? React.createElement(DatepickerScroll, otherProps) : React.createElement(Calendar, _extends({
    display: display,
    "data-unify": "Datepicker"
  }, otherProps)));
};

export default Datepicker;