import { ComponentPropsWithoutRef } from 'react';
import { CalendarProps } from './DatepickerCalendar/type';
declare type DatepickerAttributes = ComponentPropsWithoutRef<'div'>;
export interface DatepickerProps extends Omit<DatepickerAttributes, 'css' | 'onClick'>, Pick<CalendarProps, 'secondDate' | 'maxDate' | 'minDate' | 'infoDate' | 'firstDate' | 'enabledDate' | 'disabledDate' | 'className' | 'price' | 'showPrice' | 'showPriceToggle' | 'titlePriceToggle' | 'alternateTitle' | 'alternateDate' | 'messageInfo' | 'panelRange' | 'panelInfo' | 'titleFirstDate' | 'titleSecondDate' | 'lang' | 'onClick' | 'onClickDouble'> {
    /**
     * To toggle visibility of Datepicker
     */
    display?: boolean;
    /**
     * To switch between Calendar and Scroll modes
     */
    scrollMode?: boolean;
    /**
     * To specify string in header section
     */
    title?: string;
    /**
     * To pass callback when closing datepicker
     */
    onClose?: () => void;
}
export {};
