import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["actionPrimaryProps", "actionPrimaryText", "actionSecondaryBorder", "actionSecondaryProps", "actionSecondaryText", "children", "className", "descriptionProps", "display", "icon", "illustration", "loadingPrimary", "loadingSecondary", "longAction", "title", "titleProps", "onActionPrimaryClick", "onActionSecondaryClick"];
import React from 'react';
import Button from "../../build/Button";
import Card from "../../build/Card";
import Typography from "../../build/Typography";
import wrapper from "../../build/Providers/common/HOC/withMobileOverlay";
import { Action, Container, Image, card, primaryAction, secondaryAction, Title, Description } from "./style";

var Dialog = function Dialog(_ref) {
  var actionPrimaryProps = _ref.actionPrimaryProps,
      _ref$actionPrimaryTex = _ref.actionPrimaryText,
      actionPrimaryText = _ref$actionPrimaryTex === void 0 ? '' : _ref$actionPrimaryTex,
      _ref$actionSecondaryB = _ref.actionSecondaryBorder,
      actionSecondaryBorder = _ref$actionSecondaryB === void 0 ? false : _ref$actionSecondaryB,
      actionSecondaryProps = _ref.actionSecondaryProps,
      _ref$actionSecondaryT = _ref.actionSecondaryText,
      actionSecondaryText = _ref$actionSecondaryT === void 0 ? '' : _ref$actionSecondaryT,
      children = _ref.children,
      className = _ref.className,
      descriptionProps = _ref.descriptionProps,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? false : _ref$display,
      icon = _ref.icon,
      illustration = _ref.illustration,
      loadingPrimary = _ref.loadingPrimary,
      loadingSecondary = _ref.loadingSecondary,
      longAction = _ref.longAction,
      title = _ref.title,
      titleProps = _ref.titleProps,
      onActionPrimaryClick = _ref.onActionPrimaryClick,
      onActionSecondaryClick = _ref.onActionSecondaryClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var renderImage = function renderImage() {
    if (illustration) {
      return React.createElement(Image, {
        alt: "illustration image",
        src: illustration,
        crossOrigin: "anonymous"
      });
    }

    if (icon) {
      return React.createElement(Image, {
        alt: "icon image",
        icon: icon,
        src: icon,
        crossOrigin: "anonymous"
      });
    }

    return null;
  };

  return React.createElement(Container, _extends({
    "aria-label": title,
    "aria-modal": display,
    mod: {
      display: display
    }
  }, otherProps, {
    className: className,
    "data-unify": "Dialog"
  }), React.createElement(Card, {
    className: card({
      icon: icon,
      illustration: illustration
    })
  }, renderImage(), title && React.createElement(Typography, _extends({
    main: true,
    tag: 2,
    className: Title({
      illustration: illustration,
      icon: icon
    })
  }, titleProps), title), React.createElement(Typography, _extends({
    className: Description
  }, descriptionProps), children), React.createElement(Action, {
    longAction: longAction
  }, React.createElement(Button, _extends({
    block: true,
    className: longAction ? primaryAction : '',
    filled: true,
    loading: loadingPrimary,
    main: true,
    onClick: onActionPrimaryClick
  }, actionPrimaryProps), actionPrimaryText), Boolean(actionSecondaryText) && React.createElement(Button, _extends({
    block: true,
    text: true,
    className: secondaryAction({
      actionSecondaryBorder: actionSecondaryBorder,
      longAction: longAction
    }),
    loading: loadingSecondary,
    secondaryGreen: !longAction,
    onClick: onActionSecondaryClick
  }, actionSecondaryProps), actionSecondaryText))));
};

var wrapperElement = wrapper(Dialog, 'dialog', {
  inverted: true,
  stacked: true,
  childrenType: 'dialog'
});
export default wrapperElement;