import React from 'react';
import { arrayMove } from "../../build/Providers/common/components/Archive/DragAndDrop";
import DragAndDropListContainer from "./_DragAndDropListContainer";

var DragAndDropList = function DragAndDropList(props) {
  var items = props.items,
      onItemClick = props.onItemClick,
      onDragAndDropEnd = props.onDragAndDropEnd;

  var handleDragAndDropEnd = function handleDragAndDropEnd(_ref) {
    var oldIndex = _ref.oldIndex,
        newIndex = _ref.newIndex;
    onDragAndDropEnd && onDragAndDropEnd(arrayMove(items, oldIndex, newIndex));
  };

  return React.createElement(DragAndDropListContainer, {
    pressDelay: 40,
    items: items,
    onSortEnd: handleDragAndDropEnd,
    onItemClick: onItemClick,
    "data-unify": "DragAndDropList"
  });
};

export default DragAndDropList;