import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["actionSecondaryText", "actionSecondaryTransparentBorder", "actionText", "buttonFull", "children", "className", "horizontal", "image", "imageAlt", "loading", "loadingSecondary", "padding", "title", "onActionClick", "onActionSecondaryClick"];
import React from 'react';
import { cx } from 'emotion';
import { NN600, NN950 } from 'unify-token/colors';
import Typography from "../../build/Typography";
import Button from "../../build/Button";
import { noop } from "../../build/Providers/common/functions/noop";
import { Container, horizontalBtnContainerStyle } from "./style";

var EmptyState = function EmptyState(_ref) {
  var actionSecondaryText = _ref.actionSecondaryText,
      actionSecondaryTransparentBorder = _ref.actionSecondaryTransparentBorder,
      actionText = _ref.actionText,
      buttonFull = _ref.buttonFull,
      children = _ref.children,
      className = _ref.className,
      _ref$horizontal = _ref.horizontal,
      horizontal = _ref$horizontal === void 0 ? false : _ref$horizontal,
      image = _ref.image,
      _ref$imageAlt = _ref.imageAlt,
      imageAlt = _ref$imageAlt === void 0 ? 'empty-state-image' : _ref$imageAlt,
      loading = _ref.loading,
      loadingSecondary = _ref.loadingSecondary,
      _ref$padding = _ref.padding,
      padding = _ref$padding === void 0 ? '16px' : _ref$padding,
      title = _ref.title,
      _ref$onActionClick = _ref.onActionClick,
      onActionClick = _ref$onActionClick === void 0 ? noop : _ref$onActionClick,
      _ref$onActionSecondar = _ref.onActionSecondaryClick,
      onActionSecondaryClick = _ref$onActionSecondar === void 0 ? noop : _ref$onActionSecondar,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  return React.createElement(Container, _extends({
    className: className,
    buttonFull: buttonFull,
    horizontal: horizontal,
    padding: padding,
    "data-unify": "EmptyState"
  }, otherProps), React.createElement("div", {
    className: "unf-emptystate__content-wrap"
  }, React.createElement("img", {
    className: "unf-emptystate__image",
    alt: imageAlt,
    src: image,
    crossOrigin: "anonymous"
  }), React.createElement("div", {
    className: "unf-emptystate__text-wrap"
  }, React.createElement(Typography, {
    className: "unf-emptystate__title",
    color: NN950,
    tag: 2,
    margin: horizontal ? '0 0 4px 0' : '0 0 8px 0'
  }, title), React.createElement(Typography, {
    caption: horizontal,
    color: NN600,
    margin: horizontal ? '4px 0 0px 0' : '8px 0 0px 0'
  }, children))), React.createElement("div", {
    className: cx('unf-emptystate-Action', horizontal && horizontalBtnContainerStyle)
  }, React.createElement("div", {
    className: "unf-emptystate-Action__button"
  }, actionText && onActionClick && React.createElement(Button, {
    main: true,
    filled: true,
    block: horizontal || buttonFull,
    small: horizontal,
    loading: loading,
    onClick: onActionClick
  }, actionText)), actionText && onActionClick && actionSecondaryText && onActionSecondaryClick && React.createElement("div", {
    className: "unf-emptystate-Action__button"
  }, React.createElement(Button, {
    main: true,
    ghost: actionSecondaryTransparentBorder ? false : true,
    block: horizontal || buttonFull,
    small: horizontal,
    loading: loadingSecondary,
    onClick: onActionSecondaryClick
  }, actionSecondaryText))));
};

export default EmptyState;