import React from 'react';
declare type EmptyStateAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface EmptyStateProps extends Omit<EmptyStateAttributes, 'css'> {
    /**
     * To specify text in button secondary inside empty state
     */
    actionSecondaryText?: string;
    /**
     * To apply transparent border style to the secondary button
     */
    actionSecondaryTransparentBorder?: boolean;
    /**
     * To specify text in button inside empty state
     */
    actionText?: string;
    /**
     * To set the Button width to 100% of container
     */
    buttonFull?: boolean;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To flexing component's content
     */
    flex?: boolean;
    /**
     * To apply custom height on empty state
     */
    height?: string;
    /**
     * To apply horizontal design
     */
    horizontal?: boolean;
    /**
     * To provide image url
     */
    image?: string;
    /**
     * To provide alt attribute on image
     */
    imageAlt?: string;
    /**
     * To determine empty state loading state
     */
    loading?: boolean;
    /**
     * To determine empty state loading secondary state
     */
    loadingSecondary?: boolean;
    /**
     * To apply custom padding on empty state
     */
    padding?: string;
    /**
     * To specify title text on empty state
     */
    title?: string;
    /**
     * To pass callback when button is clicked
     */
    onActionClick?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when button secondary is clicked
     */
    onActionSecondaryClick?: (e: React.MouseEvent<HTMLButtonElement>) => void;
}
export {};
