import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["icon", "text", "color", "size", "onClick"];
import React from 'react';
import Overlay from "../../build/Overlay";
import ActionButton from "./ActionButton";
import { menuButton } from "./style";

var ButtonMenu = function ButtonMenu(_ref) {
  var _ref$display = _ref.display,
      display = _ref$display === void 0 ? false : _ref$display,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      onClickOverlay = _ref.onClickOverlay;
  return display ? React.createElement(React.Fragment, null, React.createElement(Overlay, {
    display: true,
    inverted: true,
    onClick: onClickOverlay
  }), Boolean(items) && items.map(function (item, id) {
    var icon = item.icon,
        text = item.text,
        color = item.color,
        size = item.size,
        onClick = item.onClick,
        otherProps = _objectWithoutProperties(item, _excluded);

    return React.createElement("div", {
      className: menuButton,
      key: id
    }, React.createElement(ActionButton, _extends({
      color: color,
      size: size,
      onClick: onClick
    }, otherProps), icon), text && React.createElement("span", null, text));
  })) : null;
};

export default ButtonMenu;