import _extends from "@babel/runtime/helpers/extends";
import _typeof from "@babel/runtime/helpers/typeof";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "offset", "position", "zIndex"];
import React, { useCallback } from 'react';
import PortalWrapper from "../../build/Providers/common/components/PortalWrapper";
import { container } from "./style";
import { getAdditonalGap } from "./_utils";

var FloatingContainer = function FloatingContainer(_ref) {
  var children = _ref.children,
      offset = _ref.offset,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'bottom-right' : _ref$position,
      zIndex = _ref.zIndex,
      etc = _objectWithoutProperties(_ref, _excluded);

  var containerRef = useCallback(function (node) {
    if (!node || !offset) {
      return;
    }

    var isNumberOffset = typeof offset === 'number';
    var isElementOffset = _typeof(offset) === 'object' && (offset === null || offset === void 0 ? void 0 : offset.current) instanceof Element;
    var viewportHeight = Math.max(document.documentElement.clientHeight || 0, window.innerHeight || 0);
    var atTop = (position === null || position === void 0 ? void 0 : position.indexOf('top')) !== -1;
    var styleOffsetPosition = atTop ? 'top' : 'bottom';

    if (isNumberOffset) {
      node.style[String(styleOffsetPosition)] = "".concat(offset, "px");
    } else if (isElementOffset) {
      var offsetElement = _typeof(offset) === 'object' ? offset.current : null;
      var additonalGap = getAdditonalGap(offsetElement);
      var boundingRect = offsetElement === null || offsetElement === void 0 ? void 0 : offsetElement.getBoundingClientRect();
      var top = (boundingRect === null || boundingRect === void 0 ? void 0 : boundingRect.top) || 0;
      var height = (boundingRect === null || boundingRect === void 0 ? void 0 : boundingRect.height) || 0;
      var topOffset = top + height + additonalGap;
      var bottomOffset = viewportHeight - top + additonalGap;
      var theOffset = atTop ? topOffset : bottomOffset;
      node.style[String(styleOffsetPosition)] = "".concat(theOffset, "px");
    }
  }, [offset, position]);
  return React.createElement(PortalWrapper, null, React.createElement("div", _extends({
    ref: containerRef,
    className: container,
    "data-unify": "FAB-Container",
    "data-position": position,
    style: {
      zIndex: zIndex
    }
  }, etc), children));
};

FloatingContainer.displayName = 'FloatingContainer';
export default FloatingContainer;