export function smoothScrollTo(x, y) {
  try {
    window.scrollTo({
      top: y,
      left: x,
      behavior: 'smooth'
    });
  } catch (err) {
    window.scrollTo(x, y);
  }
}
export function getElementYPosition(elementRef) {
  var _window, _elementRef$current;

  var currentScrollPosition = ((_window = window) === null || _window === void 0 ? void 0 : _window.scrollY) || 0;
  var elementRect = ((_elementRef$current = elementRef.current) === null || _elementRef$current === void 0 ? void 0 : _elementRef$current.getBoundingClientRect()) || {
    top: 0
  };
  var elementTopPosition = elementRect.top;
  return currentScrollPosition + elementTopPosition;
}
export function isInViewport(elementRef) {
  var _elementRef$current2;

  var viewportHeight = window.innerHeight || document.documentElement.clientHeight;
  var elementRect = ((_elementRef$current2 = elementRef.current) === null || _elementRef$current2 === void 0 ? void 0 : _elementRef$current2.getBoundingClientRect()) || {
    top: 0,
    bottom: 0
  };
  var top = elementRect.top,
      bottom = elementRect.bottom;

  if (top < viewportHeight && bottom >= 0) {
    return true;
  }

  return false;
}
export function getAdditonalGap(element) {
  if (element !== null) {
    var _element$dataset;

    var isFABNode = ((_element$dataset = element.dataset) === null || _element$dataset === void 0 ? void 0 : _element$dataset.unify) === 'FAB-Button';
    return isFABNode ? 8 : 16;
  }

  return 16;
}