import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["anchor", "color", "children", "entryPoint", "expanded", "items", "offset", "position", "size", "enableScrollInteraction", "zIndex", "onClick", "onClickOverlay"];
import React, { forwardRef } from 'react';
import FloatingContainer from "./FloatingContainer";
import ActionButton from "./ActionButton";
import ButtonMenu from "./ButtonMenu";
var FloatingActionButton = forwardRef(function (_ref, ref) {
  var anchor = _ref.anchor,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'white' : _ref$color,
      children = _ref.children,
      entryPoint = _ref.entryPoint,
      expanded = _ref.expanded,
      items = _ref.items,
      offset = _ref.offset,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'bottom-right' : _ref$position,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'small' : _ref$size,
      _ref$enableScrollInte = _ref.enableScrollInteraction,
      enableScrollInteraction = _ref$enableScrollInte === void 0 ? true : _ref$enableScrollInte,
      zIndex = _ref.zIndex,
      onClick = _ref.onClick,
      onClickOverlay = _ref.onClickOverlay,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var hasItems = items && items.length > 1;
  return React.createElement(FloatingContainer, {
    offset: offset,
    position: position,
    zIndex: zIndex
  }, React.createElement(ActionButton, _extends({
    ref: ref,
    anchor: anchor,
    color: color,
    entryPoint: entryPoint,
    expandable: hasItems,
    size: size,
    enableScrollInteraction: enableScrollInteraction,
    onClick: onClick
  }, otherProps), children), hasItems ? React.createElement(ButtonMenu, {
    display: expanded,
    items: items,
    onClickOverlay: onClickOverlay
  }) : null);
});
FloatingActionButton.displayName = 'FloatingActionButton';
export default FloatingActionButton;