import styled, { css, keyframes } from 'react-emotion';
import { fontSizeLv2, lineHeightLv2 } from 'unify-token/build/v2/typographies';
import { NN0, NN100, NN500RGB, NN900, GN500, GN700 } from 'unify-token/colors';
import { durationT2, durationT3, durationT4, easeOut, easeInOut, easeOvershoot } from 'unify-token/build/v2/motions';
import { colorWhiteAlways, cssRipple, focusStyle } from "../../build/Providers/common/style";
var transition = keyframes("0%{opacity:0;transform:scale(0);}100%{opacity:1;transform:scale(1);}");
var smallStyle = css("min-width:40px;min-height:40px;border-radius:20px;");
var mediumStyle = css("min-width:48px;min-height:48px;border-radius:24px;");
var bgColors = {
  white: NN0,
  green: GN500,
  anchor: 'transparent'
};
var textColors = {
  white: GN500,
  green: colorWhiteAlways,
  anchor: colorWhiteAlways
};
var rippleColors = {
  white: NN100,
  green: GN700
};
var _ref8 = "transform:scale(0);opacity:0;visibility:hidden;";
var _ref12 = "&:active{transform:scale(0.95);transition:transform ";
var _ref13 = " ";
var _ref14 = ";}";
var _ref16 = "transition:transform ";
var _ref17 = " ";
var _ref18 = ";&:active{transform:scale(0.75);transition:transform ";
var _ref19 = " ";
var _ref20 = ";}&:active > svg{transform:scale(0.85);transition:transform ";
var _ref21 = " ";
var _ref22 = ";}& > svg{transform:scale(1);transition:transform ";
var _ref23 = " ";
var _ref24 = ";}";
var _ref26 = "svg{fill:currentColor;}";
export var ActionButton = styled("button", {
  target: "e1ayqs3d0"
})("-webkit-appearance:none;align-items:center;background-color:", function (_ref) {
  var _bgColors$String;

  var color = _ref.color;
  return (_bgColors$String = bgColors[String(color)]) !== null && _bgColors$String !== void 0 ? _bgColors$String : color;
}, ";border:none;box-shadow:0px 1px 4px rgba(var(--NN0RGB,", NN500RGB, "),0.4);color:", function (_ref2) {
  var _textColors$String;

  var color = _ref2.color;
  return (_textColors$String = textColors[String(color)]) !== null && _textColors$String !== void 0 ? _textColors$String : NN0;
}, ";cursor:pointer;display:flex;gap:4px;justify-content:center;margin:0;max-width:100%;opacity:1;padding:0 8px;position:relative;text-decoration:none;transform:scale(1);transition-duration:", function (_ref3) {
  var isHidden = _ref3.isHidden;
  return isHidden ? durationT3 : durationT4;
}, ";transition-property:transform,opacity,visibility;transition-timing-function:", function (_ref4) {
  var isHidden = _ref4.isHidden;
  return isHidden ? easeOut : easeOvershoot;
}, ";visibility:visible;z-index:70;", focusStyle, ";", function (_ref5) {
  var size = _ref5.size;
  return size === 'medium' ? mediumStyle : smallStyle;
}, ";", function (_ref6) {
  var animateOnEnter = _ref6.animateOnEnter;
  return animateOnEnter && "animation: ".concat(transition, " ").concat(durationT3, " ").concat(easeOvershoot);
}, ";", function (_ref7) {
  var isHidden = _ref7.isHidden;
  return isHidden && css(_ref8);
}, " *:first-child:not(:last-child){margin-left:4px;}&:before,&:after{content:'';position:absolute;left:0;top:0;width:100%;pointer-events:none;", function (_ref9) {
  var size = _ref9.size;
  return size === 'medium' ? mediumStyle : smallStyle;
}, ";}&:before{opacity:0.4;z-index:-2;}&:after{opacity:0.7;z-index:-1;", function (_ref10) {
  var color = _ref10.color;
  return color === 'anchor' && "background-color: ".concat(NN900);
}, ";}", function (_ref11) {
  var color = _ref11.color;
  return color !== 'anchor' && css(_ref12, durationT2, _ref13, easeInOut, _ref14, cssRipple(rippleColors[String(color)]));
}, " ", function (_ref15) {
  var expandable = _ref15.expandable;
  return expandable && css(_ref16, durationT3, _ref17, easeOvershoot, _ref18, durationT2, _ref19, easeInOut, _ref20, durationT2, _ref21, easeInOut, _ref22, durationT3, _ref23, easeOvershoot, _ref24);
}, " h1,h2,h3,h4,h5,h6,p,span,label{margin-top:0;margin-bottom:0;font-size:", fontSizeLv2, ";font-weight:800;line-height:", lineHeightLv2, ";color:inherit;white-space:nowrap;&:last-child:not(:first-child){margin-right:8px;}&:first-child:not(:last-child){margin-left:8px;}}", function (_ref25) {
  var color = _ref25.color;
  return bgColors[String(color)] && css(_ref26);
}, ";svg{flex:0 0 auto;}@supports not (gap:4px){* + *{margin-left:4px;}}");
export var ActionLink = ActionButton.withComponent('a', {
  target: "e1ayqs3d1"
});
export var menuButton = css("display:flex;align-items:center;flex-direction:row;z-index:70;gap:8px;@supports not (gap:8px){", ActionButton, "{margin-top:8px;margin-bottom:8px;}}span{color:", colorWhiteAlways, ";}");
export var container = css("position:fixed;display:flex;gap:8px;max-width:calc(100% - 32px);@supports not (gap:8px){", ActionButton, "{margin-top:8px;margin-bottom:8px;}}&[data-position*='top']{top:16px;flex-direction:column;}&[data-position*='bottom']{bottom:16px;flex-direction:column-reverse;}&[data-position*='left']{left:16px;align-items:flex-start;}&[data-position*='right']{right:16px;align-items:flex-end;.", menuButton, "{flex-direction:row-reverse;}}&[data-position*='center']{left:50%;transform:translate(-50%,0);align-items:center;}");