import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["androidURL", "categoryURL", "className", "contactUsURL", "desktopURL", "hotlistURL", "iosURL", "lang", "officialStoreURL", "privacyURL", "termConditionsURL", "tokopediaCareURL", "onAndroidURLClicked", "onCategoryURLClicked", "onContactUsURLClicked", "onDesktopURLClicked", "onHotlistURLClicked", "onIosURLClicked", "onLanguageChange", "onOfficialStoreURLClicked", "onPrivacyURLClicked", "onTermConditionsURLClicked", "onTokopediaCareURLClicked"];
import React, { useEffect } from 'react';
import { cx } from 'emotion';
import Card from "../../build/Card";
import { canUseDOM } from "../../build/Providers/common/functions";
import { noop } from "../../build/Providers/common/functions/noop";
import { unf_footer } from "./style";

var Footer = function Footer(_ref) {
  var _ref$androidURL = _ref.androidURL,
      androidURL = _ref$androidURL === void 0 ? '#' : _ref$androidURL,
      _ref$categoryURL = _ref.categoryURL,
      categoryURL = _ref$categoryURL === void 0 ? '#' : _ref$categoryURL,
      className = _ref.className,
      _ref$contactUsURL = _ref.contactUsURL,
      contactUsURL = _ref$contactUsURL === void 0 ? '#' : _ref$contactUsURL,
      _ref$desktopURL = _ref.desktopURL,
      desktopURL = _ref$desktopURL === void 0 ? '#' : _ref$desktopURL,
      _ref$hotlistURL = _ref.hotlistURL,
      hotlistURL = _ref$hotlistURL === void 0 ? '#' : _ref$hotlistURL,
      _ref$iosURL = _ref.iosURL,
      iosURL = _ref$iosURL === void 0 ? '#' : _ref$iosURL,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      _ref$officialStoreURL = _ref.officialStoreURL,
      officialStoreURL = _ref$officialStoreURL === void 0 ? '#' : _ref$officialStoreURL,
      _ref$privacyURL = _ref.privacyURL,
      privacyURL = _ref$privacyURL === void 0 ? '#' : _ref$privacyURL,
      _ref$termConditionsUR = _ref.termConditionsURL,
      termConditionsURL = _ref$termConditionsUR === void 0 ? '#' : _ref$termConditionsUR,
      _ref$tokopediaCareURL = _ref.tokopediaCareURL,
      tokopediaCareURL = _ref$tokopediaCareURL === void 0 ? '#' : _ref$tokopediaCareURL,
      _ref$onAndroidURLClic = _ref.onAndroidURLClicked,
      onAndroidURLClicked = _ref$onAndroidURLClic === void 0 ? noop : _ref$onAndroidURLClic,
      _ref$onCategoryURLCli = _ref.onCategoryURLClicked,
      onCategoryURLClicked = _ref$onCategoryURLCli === void 0 ? noop : _ref$onCategoryURLCli,
      _ref$onContactUsURLCl = _ref.onContactUsURLClicked,
      onContactUsURLClicked = _ref$onContactUsURLCl === void 0 ? noop : _ref$onContactUsURLCl,
      _ref$onDesktopURLClic = _ref.onDesktopURLClicked,
      onDesktopURLClicked = _ref$onDesktopURLClic === void 0 ? noop : _ref$onDesktopURLClic,
      _ref$onHotlistURLClic = _ref.onHotlistURLClicked,
      onHotlistURLClicked = _ref$onHotlistURLClic === void 0 ? noop : _ref$onHotlistURLClic,
      _ref$onIosURLClicked = _ref.onIosURLClicked,
      onIosURLClicked = _ref$onIosURLClicked === void 0 ? noop : _ref$onIosURLClicked,
      _ref$onLanguageChange = _ref.onLanguageChange,
      onLanguageChange = _ref$onLanguageChange === void 0 ? noop : _ref$onLanguageChange,
      _ref$onOfficialStoreU = _ref.onOfficialStoreURLClicked,
      onOfficialStoreURLClicked = _ref$onOfficialStoreU === void 0 ? noop : _ref$onOfficialStoreU,
      _ref$onPrivacyURLClic = _ref.onPrivacyURLClicked,
      onPrivacyURLClicked = _ref$onPrivacyURLClic === void 0 ? noop : _ref$onPrivacyURLClic,
      _ref$onTermConditions = _ref.onTermConditionsURLClicked,
      onTermConditionsURLClicked = _ref$onTermConditions === void 0 ? noop : _ref$onTermConditions,
      _ref$onTokopediaCareU = _ref.onTokopediaCareURLClicked,
      onTokopediaCareURLClicked = _ref$onTokopediaCareU === void 0 ? noop : _ref$onTokopediaCareU,
      footerProps = _objectWithoutProperties(_ref, _excluded);

  var classes = cx(unf_footer, className, 'unf-footer');
  useEffect(function () {
    initObserver();
    console.warn('Props contactUsURL and onContactUsURLClicked is going to be deprecated. For next, please use props tokopediaCareURL and onTokopediaCareURLClicked. Please contact unify-dev if you have any concerns.');
  }, []);

  var getCurrentYear = function getCurrentYear() {
    return new Date().getFullYear().toString();
  };

  var initObserver = function initObserver() {
    if (canUseDOM) {
      var lazyImages = [].slice.call(document.querySelectorAll('.unf-lazyload'));
      var UnifyObserver = new IntersectionObserver(function (entries) {
        entries.forEach(function (entry) {
          if (entry.isIntersecting) {
            entry.target.classList.add('visible');
            UnifyObserver.unobserve(entry.target);
          }
        });
      });
      lazyImages.forEach(function (lazyImage) {
        UnifyObserver.observe(lazyImage);
      });
    }
  };

  return React.createElement("div", _extends({
    className: classes,
    "data-unify": "Footer"
  }, footerProps), React.createElement(Card, {
    container: true,
    className: "unf-footer__apps"
  }, React.createElement("div", {
    className: "unf-footer__apps-text"
  }, lang !== 'id' ? 'Download Tokopedia Mobile App' : 'Dapatkan Aplikasi Mobile Tokopedia'), React.createElement("div", {
    className: "unf-footer__apps-icon"
  }, React.createElement("a", {
    href: androidURL,
    onClick: onAndroidURLClicked,
    "aria-label": "footer-android"
  }, React.createElement("div", {
    className: "unf-lazyload unf-footer__apps-icon--android",
    "aria-label": "footer-android-icon"
  })), React.createElement("a", {
    href: iosURL,
    onClick: onIosURLClicked,
    "aria-label": "footer-ios"
  }, React.createElement("div", {
    className: "unf-lazyload unf-footer__apps-icon--ios",
    "aria-label": "footer-ios-icon"
  })))), React.createElement("div", {
    className: "unf-footer__content"
  }, React.createElement("div", {
    className: "unf-footer__content--flex"
  }, React.createElement("a", {
    href: hotlistURL,
    onClick: onHotlistURLClicked
  }, "Hotlist"), React.createElement("a", {
    href: officialStoreURL,
    onClick: onOfficialStoreURLClicked
  }, "Official Store")), React.createElement("div", {
    className: "unf-footer__content--flex"
  }, React.createElement("a", {
    href: contactUsURL || tokopediaCareURL,
    onClick: onContactUsURLClicked || onTokopediaCareURLClicked
  }, "Tokopedia Care"), React.createElement("a", {
    href: categoryURL,
    onClick: onCategoryURLClicked
  }, lang !== 'id' ? 'Category' : 'Kategori'), React.createElement("a", {
    href: desktopURL,
    onClick: onDesktopURLClicked
  }, lang !== 'id' ? 'Desktop Site' : 'Situs Desktop')), React.createElement("div", {
    className: "unf-footer__content--flex"
  }, React.createElement("a", {
    href: termConditionsURL,
    onClick: onTermConditionsURLClicked
  }, lang !== 'id' ? 'Term & Conditions' : 'Syarat & Ketentuan'), React.createElement("a", {
    href: privacyURL,
    onClick: onPrivacyURLClicked
  }, lang !== 'id' ? 'Privacy Policy' : 'Kebijakan Privasi')), React.createElement("div", null, lang !== 'id' ? 'Choose Language' : 'Pilih Bahasa', React.createElement("select", {
    "aria-label": "unf-footer-language",
    onChange: onLanguageChange,
    value: lang,
    style: {
      width: lang !== 'id' ? '72px' : '88px'
    }
  }, React.createElement("option", {
    value: "id"
  }, "Indonesia"), React.createElement("option", {
    value: "en"
  }, "English")))), React.createElement("div", {
    className: "unf-footer__copyright"
  }, "Copyright 2009-", getCurrentYear(), ", PT Tokopedia"));
};

export default Footer;