import React from 'react';
declare type FooterAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface FooterProps extends Omit<FooterAttributes, 'css'> {
    /**
     * To specify android link
     * @default '#'
     */
    androidURL?: string;
    /**
     * To specify category link
     * @default '#'
     */
    categoryURL?: string;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To specify contact us link.
     * Is going to be deprecated. For next, please use props tokopediaCareURL and onTokopediaCareURLClicked. Please contact nest-dev if you have any concerns.
     * @default '#'
     * @deprecated
     */
    contactUsURL?: string;
    /**
     * To specify desktop link
     * @default '#'
     */
    desktopURL?: string;
    /**
     * To specify hotlist link
     * @default '#'
     */
    hotlistURL?: string;
    /**
     * To specify iOS link
     * @default '#'
     */
    iosURL?: string;
    /**
     * To specify languange on footer
     * @default 'id'
     */
    lang?: 'id' | 'en' | string;
    /**
     * To specify official store link
     * @default '#'
     */
    officialStoreURL?: string;
    /**
     * To specify privacy link
     * @default '#'
     */
    privacyURL?: string;
    /**
     * To specify terms and conditional link
     * @default '#'
     */
    termConditionsURL?: string;
    /**
     * To specify tokopedia care link
     * @default '#'
     */
    tokopediaCareURL?: string;
    /**
     * To pass callback when android link is clicked
     */
    onAndroidURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when category link is clicked
     */
    onCategoryURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when contact us is clicked.
     * Is going to be deprecated. For next, please use props tokopediaCareURL and onTokopediaCareURLClicked. Please contact nest-dev if you have any concerns.*
     * @deprecated
     */
    onContactUsURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when desktop link is clicked
     */
    onDesktopURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when hotlist link is clicked
     */
    onHotlistURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when iOS link is clicked
     */
    onIosURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when language has changed
     */
    onLanguageChange?: (e: React.ChangeEvent<HTMLSelectElement>) => void;
    /**
     * To pass callback when official store link is clicked
     */
    onOfficialStoreURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when privacy link is clicked
     */
    onPrivacyURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when terms and condition link is clicked
     */
    onTermConditionsURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when tokopedia care link is clicked
     */
    onTokopediaCareURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
}
export {};
