import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["androidURL", "className", "huaweiURL", "iosURL", "lang", "langSwitcherHeading", "privacyURL", "termConditionsURL", "tokopediaCareURL", "withLangSwitcher", "onAndroidURLClicked", "onHuaweiURLClicked", "onIosURLClicked", "onLangSwitcherChange", "onPrivacyURLClicked", "onTermConditionsURLClicked", "onTokopediaCareURLClicked"];
import React, { useEffect } from 'react';
import { cx } from 'emotion';
import ContentSwitcher from "../../build/ContentSwitcher";
import { canUseDOM } from "../../build/Providers/common/functions";
import { noop } from "../../build/Providers/common/functions/noop";
import { unf_footer } from "./style";

var FooterV2 = function FooterV2(_ref) {
  var _ref$androidURL = _ref.androidURL,
      androidURL = _ref$androidURL === void 0 ? '#' : _ref$androidURL,
      className = _ref.className,
      _ref$huaweiURL = _ref.huaweiURL,
      huaweiURL = _ref$huaweiURL === void 0 ? '#' : _ref$huaweiURL,
      _ref$iosURL = _ref.iosURL,
      iosURL = _ref$iosURL === void 0 ? '#' : _ref$iosURL,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      _ref$langSwitcherHead = _ref.langSwitcherHeading,
      langSwitcherHeading = _ref$langSwitcherHead === void 0 ? 5 : _ref$langSwitcherHead,
      _ref$privacyURL = _ref.privacyURL,
      privacyURL = _ref$privacyURL === void 0 ? '#' : _ref$privacyURL,
      _ref$termConditionsUR = _ref.termConditionsURL,
      termConditionsURL = _ref$termConditionsUR === void 0 ? '#' : _ref$termConditionsUR,
      _ref$tokopediaCareURL = _ref.tokopediaCareURL,
      tokopediaCareURL = _ref$tokopediaCareURL === void 0 ? '#' : _ref$tokopediaCareURL,
      _ref$withLangSwitcher = _ref.withLangSwitcher,
      withLangSwitcher = _ref$withLangSwitcher === void 0 ? false : _ref$withLangSwitcher,
      _ref$onAndroidURLClic = _ref.onAndroidURLClicked,
      onAndroidURLClicked = _ref$onAndroidURLClic === void 0 ? noop : _ref$onAndroidURLClic,
      _ref$onHuaweiURLClick = _ref.onHuaweiURLClicked,
      onHuaweiURLClicked = _ref$onHuaweiURLClick === void 0 ? noop : _ref$onHuaweiURLClick,
      _ref$onIosURLClicked = _ref.onIosURLClicked,
      onIosURLClicked = _ref$onIosURLClicked === void 0 ? noop : _ref$onIosURLClicked,
      _ref$onLangSwitcherCh = _ref.onLangSwitcherChange,
      onLangSwitcherChange = _ref$onLangSwitcherCh === void 0 ? noop : _ref$onLangSwitcherCh,
      _ref$onPrivacyURLClic = _ref.onPrivacyURLClicked,
      onPrivacyURLClicked = _ref$onPrivacyURLClic === void 0 ? noop : _ref$onPrivacyURLClic,
      _ref$onTermConditions = _ref.onTermConditionsURLClicked,
      onTermConditionsURLClicked = _ref$onTermConditions === void 0 ? noop : _ref$onTermConditions,
      _ref$onTokopediaCareU = _ref.onTokopediaCareURLClicked,
      onTokopediaCareURLClicked = _ref$onTokopediaCareU === void 0 ? noop : _ref$onTokopediaCareU,
      footerV2Props = _objectWithoutProperties(_ref, _excluded);

  var classes = cx(unf_footer, className, 'unf-footer');
  var ariaLabels = {
    id: {
      androidLink: 'Unduh aplikasi Tokopedia di Google Play',
      huaweiLink: 'Unduh aplikasi Tokopedia di Huawei App Gallery',
      iosLink: 'Unduh aplikasi Tokopedia di App Store'
    },
    en: {
      androidLink: 'Download Tokopedia app on Google Play',
      huaweiLink: 'Download Tokopedia app on Huawei App Gallery',
      iosLink: 'Download Tokopedia app on App Store'
    }
  };
  useEffect(function () {
    initObserver();
  }, []);

  var getCurrentYear = function getCurrentYear() {
    return new Date().getFullYear().toString();
  };

  var initObserver = function initObserver() {
    if (canUseDOM) {
      var lazyImages = [].slice.call(document.querySelectorAll('.unf-lazyload'));
      var UnifyObserver = new IntersectionObserver(function (entries) {
        entries.forEach(function (entry) {
          if (entry.isIntersecting) {
            entry.target.classList.add('visible');
            UnifyObserver.unobserve(entry.target);
          }
        });
      });
      lazyImages.forEach(function (lazyImage) {
        UnifyObserver.observe(lazyImage);
      });
    }
  };

  return React.createElement("div", _extends({
    className: classes,
    "data-unify": "FooterV2",
    role: "contentinfo"
  }, footerV2Props), React.createElement("div", {
    className: "unf-footer__content"
  }, React.createElement("a", {
    href: tokopediaCareURL,
    onClick: onTokopediaCareURLClicked
  }, "Tokopedia Care"), React.createElement("a", {
    href: termConditionsURL,
    onClick: onTermConditionsURLClicked
  }, lang !== 'id' ? 'Term & Conditions' : 'Syarat & Ketentuan'), React.createElement("a", {
    href: privacyURL,
    onClick: onPrivacyURLClicked
  }, lang !== 'id' ? 'Privacy Policy' : 'Kebijakan Privasi')), React.createElement("div", {
    className: "unf-footer__apps"
  }, React.createElement("span", {
    className: "unf-footer__apps-text"
  }, lang !== 'id' ? 'Enjoy Tokopedia App' : 'Gunakan Aplikasi Tokopedia'), React.createElement("div", {
    className: "unf-footer__apps-icon"
  }, React.createElement("a", {
    href: androidURL,
    onClick: onAndroidURLClicked,
    "aria-label": ariaLabels[String(lang)].androidLink
  }, React.createElement("div", {
    className: "unf-lazyload unf-footer__apps-icon--android"
  })), React.createElement("a", {
    href: iosURL,
    onClick: onIosURLClicked,
    "aria-label": ariaLabels[String(lang)].iosLink
  }, React.createElement("div", {
    className: "unf-lazyload unf-footer__apps-icon--ios"
  }))), React.createElement("div", {
    className: "unf-footer__apps-icon"
  }, React.createElement("a", {
    href: huaweiURL,
    onClick: onHuaweiURLClicked,
    "aria-label": ariaLabels[String(lang)].huaweiLink
  }, React.createElement("div", {
    className: "unf-lazyload unf-footer__apps-icon--huawei"
  })))), withLangSwitcher && React.createElement("div", {
    className: "unf-footer__language"
  }, React.createElement(ContentSwitcher, {
    heading: langSwitcherHeading,
    indexActive: lang !== 'id' ? 1 : 0,
    selections: ['Indonesia', 'English'],
    onItemClick: onLangSwitcherChange
  })), React.createElement("div", {
    className: "unf-footer__copyright"
  }, "\xA9 2009 - ", getCurrentYear(), ", PT Tokopedia"));
};

export default FooterV2;