import React from 'react';
declare type FooterV2Attributes = React.ComponentPropsWithoutRef<'div'>;
export interface FooterV2Props extends Omit<FooterV2Attributes, 'css'> {
    /**
     * To specify android link
     * @default '#'
     */
    androidURL?: string;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To specify huawei link
     * @default '#'
     */
    huaweiURL?: string;
    /**
     * To specify iOS link
     * @default '#'
     */
    iosURL?: string;
    /**
     * To specify languange on footer
     * @default 'id'
     */
    lang?: 'id' | 'en' | string;
    /**
     * To specify heading tag level of ContentSwitcher
     */
    langSwitcherHeading?: number;
    /**
     * To specify privacy link
     * @default '#'
     */
    privacyURL?: string;
    /**
     * To specify terms and conditional link
     * @default '#'
     */
    termConditionsURL?: string;
    /**
     * To specify tokopedia care link
     * @default '#'
     */
    tokopediaCareURL?: string;
    /**
     * To apply Footer with language switcher design
     * @default false
     */
    withLangSwitcher?: boolean;
    /**
     * To pass callback when android link is clicked
     */
    onAndroidURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when huawei link is clicked
     */
    onHuaweiURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when iOS link is clicked
     */
    onIosURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when ContentSwitcher is clicked
     */
    onLangSwitcherChange?: (val: string, index: number, e: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when privacy link is clicked
     */
    onPrivacyURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when terms and conditions link is clicked
     */
    onTermConditionsURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
    /**
     * To pass callback when tokopedia care link is clicked
     */
    onTokopediaCareURLClicked?: (e: React.MouseEvent<HTMLAnchorElement>) => void;
}
export {};
