import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["buttonFull", "lang", "onActionClick"];
import React from 'react';
import EmptyState from "../../build/EmptyState";
import i18n from "../../build/Providers/common/i18n";
import { il_error_full_visitor, il_error_maintenance, il_error_no_connection, il_error_not_found, il_error_server_error } from "../../build/Providers/assets/CDN";

var GlobalError = function GlobalError(_ref) {
  var buttonFull = _ref.buttonFull,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      onActionClick = _ref.onActionClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var responseCopy = i18n[String(lang)];
  var response_no_connection = responseCopy.response_no_connection,
      response_not_found = responseCopy.response_not_found,
      response_down = responseCopy.response_down,
      response_full = responseCopy.response_full,
      response_maintenance = responseCopy.response_maintenance;

  var handleContent = function handleContent(_ref2) {
    var _ref2$full = _ref2.full,
        full = _ref2$full === void 0 ? false : _ref2$full,
        _ref2$maintenance = _ref2.maintenance,
        maintenance = _ref2$maintenance === void 0 ? false : _ref2$maintenance,
        _ref2$noConnection = _ref2.noConnection,
        noConnection = _ref2$noConnection === void 0 ? false : _ref2$noConnection,
        _ref2$server = _ref2.server,
        server = _ref2$server === void 0 ? false : _ref2$server;

    switch (true) {
      case maintenance:
        return {
          img: il_error_maintenance,
          title: response_maintenance.title,
          description: response_maintenance.description,
          actionText: response_maintenance.mobile_action_text
        };

      case server:
        return {
          img: il_error_server_error,
          title: response_down.title,
          description: response_down.description,
          actionText: response_down.mobile_action_text
        };

      case full:
        return {
          img: il_error_full_visitor,
          title: response_full.title,
          description: response_full.description,
          actionText: response_full.mobile_action_text
        };

      case noConnection:
        return {
          img: il_error_no_connection,
          title: response_no_connection.title,
          description: response_no_connection.description,
          actionText: response_no_connection.mobile_action_text
        };

      default:
        return {
          img: il_error_not_found,
          title: response_not_found.title,
          description: response_not_found.description,
          actionText: response_not_found.mobile_action_text
        };
    }
  };

  var _handleContent = handleContent(otherProps),
      img = _handleContent.img,
      title = _handleContent.title,
      description = _handleContent.description,
      actionText = _handleContent.actionText;

  return React.createElement(EmptyState, _extends({
    "data-unify": "GlobalError",
    actionText: actionText,
    buttonFull: buttonFull,
    image: img,
    imageAlt: title,
    title: title,
    onActionClick: onActionClick
  }, otherProps), description);
};

export default GlobalError;