import React from 'react';
import { EmptyStateProps } from '../../build/EmptyState/type';
declare type GlobalErrorAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface GlobalErrorProps extends Omit<GlobalErrorAttributes, 'css'>, Pick<EmptyStateProps, 'onActionClick'> {
    /**
     * To adjust the button's full width, use it if this component inside on BottomSheet=
     */
    buttonFull?: boolean;
    /**
     * Display `Server overload` variant
     */
    full?: boolean;
    /**
     * Determine format language for the messages
     */
    lang?: 'en' | 'id';
    /**
     * Display `maintenance` variant
     */
    maintenance?: boolean;
    /**
     * Display `no connection` variant
     */
    noConnection?: boolean;
    /**
     * Display `server error` variant
     */
    server?: boolean;
}
export {};
