import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["alt", "borderRadius", "hasReloadOnError", "product", "ratio", "shimmerLoading", "size", "src", "user", "onError", "onClickReload"];
import React, { useRef, useState, useEffect } from 'react';
import { noop } from "../../build/Providers/common/functions/noop";
import { Container, Wrapper, reloadIconStyle, placeholderStyle, imageStyle } from "./style";

var Image = function Image(_ref) {
  var alt = _ref.alt,
      _ref$borderRadius = _ref.borderRadius,
      borderRadius = _ref$borderRadius === void 0 ? '8px' : _ref$borderRadius,
      _ref$hasReloadOnError = _ref.hasReloadOnError,
      hasReloadOnError = _ref$hasReloadOnError === void 0 ? false : _ref$hasReloadOnError,
      _ref$product = _ref.product,
      product = _ref$product === void 0 ? false : _ref$product,
      _ref$ratio = _ref.ratio,
      ratio = _ref$ratio === void 0 ? '1:1' : _ref$ratio,
      _ref$shimmerLoading = _ref.shimmerLoading,
      shimmerLoading = _ref$shimmerLoading === void 0 ? true : _ref$shimmerLoading,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? '' : _ref$size,
      _ref$src = _ref.src,
      src = _ref$src === void 0 ? '' : _ref$src,
      _ref$user = _ref.user,
      user = _ref$user === void 0 ? false : _ref$user,
      _ref$onError = _ref.onError,
      onError = _ref$onError === void 0 ? noop : _ref$onError,
      _ref$onClickReload = _ref.onClickReload,
      onClickReload = _ref$onClickReload === void 0 ? noop : _ref$onClickReload,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var imgRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isError = _useState2[0],
      setIsError = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      isLoading = _useState4[0],
      setIsLoading = _useState4[1];

  var isTooSmall = size === 'small' || size === 'micro' || size.indexOf('px') >= 0 && parseInt(size) <= 32 ? true : false;

  var onImgLoad = function onImgLoad() {
    var img = imgRef.current;

    if (img) {
      img.style.display = 'block';
      img.style.animation = '';
      img.style.transition = '';
      setIsLoading(false);
    }
  };

  var onImgError = function onImgError(e) {
    setIsError(true);
    onError(e);
  };

  var handleReloadClick = function handleReloadClick(e) {
    e.stopPropagation();
    e.preventDefault();

    if (imgRef.current) {
      var oldUrl = new URL(imgRef.current.src);
      imgRef.current.src = "".concat(oldUrl.origin + oldUrl.pathname, "?t=").concat(new Date().getTime());
      setIsError(false);
    }

    onClickReload(e);
  };

  useEffect(function () {
    var _imgRef$current;

    var img = imgRef.current;

    if (img && imgRef !== null && imgRef !== void 0 && (_imgRef$current = imgRef.current) !== null && _imgRef$current !== void 0 && _imgRef$current.complete) {
      img.style.display = 'block';
      img.style.animation = '';
      img.style.transition = '';
      setIsLoading(false);
    }
  }, []);

  var PlaceholderContent = function PlaceholderContent() {
    if (!isTooSmall) {
      return React.createElement("svg", {
        className: placeholderStyle,
        viewBox: "0 0 256 256",
        fill: "none",
        xmlns: "http://www.w3.org/2000/svg"
      }, React.createElement("path", {
        d: "M45.1 133.8c-6.8 2.1-8.4 8.2-7.7 13.4-6 3-8.5 8.1-6.7 13.8a11.4 11.4 0 002.6 4c2 2 5.2 3.9 11 3.2 3.7 6.8 9.6 7.8 14 6.5 2.2-.7 9-3.5 7.7-13 7.1-3.8 8.2-9.6 6.8-13.6l-.1-.5c-3-7.3-9.8-7.5-13.6-7l-1-1.4a3 3 0 00-.6-.9 11.1 11.1 0 00-12.4-4.4z",
        fill: "#fff"
      }), React.createElement("path", {
        d: "M59.8 146.4l-2.7.3a2.6 2.6 0 01-2.1-1l-1.2-2.3-1-1.7A15.3 15.3 0 0142 160c-1.5.4-3 .6-4.5.7.9 1.3 2.7 2.1 6.3 1.7l2.6-.4a2.7 2.7 0 012 1.1l1.3 2.3c2.2 4.4 5.2 4.1 6.8 3.6 1.6-.4 4.1-1.8 3.5-6.8l-.3-2.5a2.5 2.5 0 011.1-2l2.4-1.2c4.5-2.3 4.4-5 3.9-6.6-.5-1.6-2-4.2-7.3-3.4z",
        fill: "#DBDEE2"
      }), React.createElement("path", {
        d: "M52.8 141.7a5 5 0 00-5.9-2c-1.6.4-4.1 1.8-3.3 7l.4 2.5a2.5 2.5 0 01-1.1 2l-2.4 1.3c-4.5 2.3-4.2 5-3.7 6.7.2.6.6 1 1 1.5a15.6 15.6 0 0015-19z",
        fill: "#E5E7E9"
      }), React.createElement("path", {
        d: "M210 99.6c-6.2-1.2-10 3-11.6 7.3-6 0-10.2 3-11.2 8.1a9.9 9.9 0 00.3 4.2c.7 2.2 2.5 5 7.3 6.9 0 6.8 4.2 10 8.1 10.6 2 .4 8.6 1 11.7-7 7.1 0 10.4-4.2 11-7.9l.2-.4c.7-7-4.4-9.8-7.7-11V109c0-.3 0-.6-.2-1a9.5 9.5 0 00-7.8-8.5z",
        fill: "#fff"
      }), React.createElement("path", {
        d: "M216.2 115.3l-2.3-.8a2.3 2.3 0 01-1.2-1.7v-2.3-1.7a14 14 0 01-16.2 9.9c-1.3-.3-2.6-.7-3.9-1.3.2 1.5 1.3 2.8 4.2 3.9l2.2.8a2.3 2.3 0 011.2 1.6v2.3c-.1 4.4 2.3 5.3 3.7 5.6 1.5.2 4.1.2 5.7-4l.8-2a2.4 2.4 0 011.8-1.2h2.3c4.5 0 5.7-2.2 5.9-3.6.2-1.4.2-4-4.2-5.5z",
        fill: "#DBDEE2"
      }), React.createElement("path", {
        d: "M212.7 108.8a4.3 4.3 0 00-3.6-4c-1.5-.2-4.1-.2-5.6 4.2l-.9 2.1a2.3 2.3 0 01-1.7 1.2h-2.3c-4.5 0-5.5 2.2-5.8 3.7l.1 1.6a14.2 14.2 0 0019.8-8.8z",
        fill: "#E5E7E9"
      }), React.createElement("path", {
        d: "M71.3 64.3a8.3 8.3 0 00-9.5 4 8.2 8.2 0 00-8.4 5.9c-.2.6-.3 1.2-.3 1.9v1.3a8.7 8.7 0 004.3 5.7 8 8 0 006 8.2 8.4 8.4 0 009.6-4.1 8.1 8.1 0 008.1-5.5 7.5 7.5 0 00-3.9-9.5v-.8a8 8 0 00-6-7.2l.1.1z",
        fill: "#fff"
      }), React.createElement("path", {
        d: "M74.2 76.6l-1.6-.7a2 2 0 01-.7-1.2l.2-1.6L72 72a9.3 9.3 0 01-11.2 5.5c-.8-.2-1.7-.6-2.5-1a4 4 0 002.5 2.7l1.4.6c.4.3.6.8.7 1.3l-.1 1.5c-.5 2.8 1.2 3.7 2 4 1 .2 2.7.3 4-2.4l.6-1.4a2 2 0 011.3-.7h1.4c3 .4 3.9-1.1 4.1-1.8.2-.8.8-2.6-2-3.7z",
        fill: "#DBDEE2"
      }), React.createElement("path", {
        d: "M72.1 72A2.8 2.8 0 0070 69c-1-.2-2.6-.3-3.9 2.4l-.6 1.3a2 2 0 01-1.3.7h-1.6c-3-.3-3.8 1.2-4 2-.2.4-.2.8 0 1.1.7.5 1.6.8 2.5 1A9.3 9.3 0 0072 72z",
        fill: "#E5E7E9"
      }), React.createElement("path", {
        d: "M186.1 84c-.8-7.4-10.2-7.7-15.7-10A193 193 0 0097 66.6C81.5 72.2 76.5 157 78 173.7c.4 6 7.2 7.2 11.8 8.8a188.2 188.2 0 0077 8.7c15.7-5.2 20.8-90.7 19.4-107.2z",
        fill: "#fff"
      }), React.createElement("path", {
        d: "M94 177c12.5 4.6 68.4 16 74.7 3.3 9-29.7 13-60.7 12-91.8 1.9-11.3-78.8-23.9-78.8-11.7-4 15.4-20.3 93-8 100.2z",
        fill: "#DBDEE2"
      }), React.createElement("path", {
        d: "M87.5 174.8c11.8 5 69 18.8 74.5 6.1A358 358 0 00174 86.2c2.1-11.6-78.2-20.6-78.9-9-5 16.2-20.4 88.5-7.7 97.6z",
        fill: "#E5E7E9"
      }), React.createElement("path", {
        d: "M95 170.2c9.4 2.4 59.2 15.2 61.1 3.6 6-27 9.4-54.6 10.5-82.3a6.1 6.1 0 00-4.4-5.9c-9.7-2.1-58.7-13-61.2-1.7-2.7 12.6-18 82.7-6 86.3z",
        fill: "#FAFCFE"
      }), React.createElement("path", {
        d: "M97.8 166.4c8 1.6 53.6 12.8 55 4 5-25.2 8.3-50.8 9.7-76.5a4.3 4.3 0 00-3.1-4.3c-8-1.4-53.4-11.2-55.2-2.5-2 11.2-15.5 76-6.4 79.3z",
        fill: "#F3F4F5"
      }), React.createElement("path", {
        d: "M147 173.7c-16-.7-31.9-3-47.4-6.9a6.8 6.8 0 01-5-6.5c.5-10.3 1.3-20.7 2.5-31 11-6 19.7 10.2 19.7 10.3 15.9-14.5 31.8-13.3 41.6-2.6-1.5 10.6-3.2 21.1-5.2 31.6a6.4 6.4 0 01-6.2 5.1zM115.8 109c-1 7.7 10.6 8.7 11.6 1.3.9-7.9-10.5-8.7-11.6-1.3z",
        fill: "#DBDEE2"
      }));
    }

    return null;
  };

  var ErrorContent = function ErrorContent() {
    if (!isTooSmall) {
      if (hasReloadOnError) {
        return React.createElement("button", {
          className: reloadIconStyle,
          "aria-label": "Reload Image"
        }, React.createElement("svg", {
          role: "button",
          viewBox: "0 0 32 32",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, React.createElement("path", {
          opacity: ".44",
          d: "M16 32a16 16 0 100-32 16 16 0 000 32z",
          fill: "#31353B"
        }), React.createElement("path", {
          d: "M24.98 16.09c0-.53-.36-.89-.9-.89-.52 0-.88.36-.88.89 0 3.91-3.2 7.11-7.11 7.11a7.28 7.28 0 01-3.38-.8c-.09-.09-.18-.18-.27-.18-.08-.09-.17-.09-.26-.18a7.14 7.14 0 01-1.07-10.93 7.14 7.14 0 0110.05 0l.44.45h-1.16c-.53 0-.88.35-.88.88 0 .54.35.9.88.9H24.36c.08 0 .08-.1.08-.1.1 0 .1-.08.18-.08 0 0 0-.1.1-.1 0-.08.08-.08.08-.17v-4c0-.53-.36-.89-.89-.89s-.89.36-.89.89v1.6l-.7-.62A8.73 8.73 0 0016 7.29a8.78 8.78 0 00-8.89 8.8 8.7 8.7 0 004 7.38c.09.09.27.17.36.17.09.1.26.18.35.18.18.1.45.27.71.36h.1c1.15.44 2.3.7 3.46.7a9.1 9.1 0 006.31-2.57c.09-.09.18-.18.18-.27a8.4 8.4 0 002.4-5.95z",
          fill: "#fff"
        })));
      } else {
        return React.createElement("svg", {
          className: placeholderStyle,
          viewBox: "0 0 256 256",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, React.createElement("path", {
          d: "M182.1 83.2c-.8-7.4-10.2-7.8-15.7-10A193 193 0 0093 65.7C77.5 71.4 72.5 156.2 74 172.9c.4 6 7.3 7.1 11.9 8.7a188.2 188.2 0 0077 8.7c15.6-5.1 20.7-90.6 19.3-107.1z",
          fill: "#fff"
        }), React.createElement("path", {
          d: "M90 176.2c12.5 4.6 68.4 16 74.8 3.3 8.9-29.7 13-60.7 11.9-91.8C178.7 76.3 98 63.8 98 76c-4.1 15.4-20.3 93-8 100.2z",
          fill: "#DBDEE2"
        }), React.createElement("path", {
          d: "M83.5 174c11.9 5 69.1 18.8 74.5 6.1 8.3-30.9 12.3-62.8 12.1-94.8 2.1-11.5-78.2-20.6-78.8-9-5.1 16.3-20.5 88.7-7.8 97.7z",
          fill: "#E5E7E9"
        }), React.createElement("path", {
          d: "M91 169.4c9.4 2.4 59.3 15.2 61.1 3.6 6-27 9.4-54.6 10.5-82.3a6.1 6.1 0 00-4.3-6c-9.7-2-58.7-13-61.3-1.6-2.6 12.5-18 82.7-6 86.3z",
          fill: "#FAFCFE"
        }), React.createElement("path", {
          d: "M93.9 165.5c7.8 1.7 53.5 12.8 55 4.1a560 560 0 009.7-76.5 4.3 4.3 0 00-3.2-4.3c-8-1.4-53.4-11.2-55.1-2.5-2 11.2-15.6 75.9-6.4 79.2z",
          fill: "#F3F4F5"
        }), React.createElement("path", {
          d: "M143 172.9c-16-.7-31.9-3-47.4-7a6.8 6.8 0 01-4.9-6.4c.4-10.3 1.2-20.7 2.5-31 11-6 19.6 10.2 19.6 10.3 16-14.5 31.8-13.4 41.6-2.6-1.5 10.6-3.2 21.1-5.2 31.6a6.3 6.3 0 01-6.2 5zM111.8 108.2c-1 7.7 10.7 8.7 11.6 1.2 1-7.8-10.5-8.6-11.6-1.2z",
          fill: "#DBDEE2"
        }), React.createElement("path", {
          d: "M146.8 80.2l-7 3.1 4 10.4-18.2 19.7-10.2 15.8-9.6 1.6 10 1-2.9 10.5 5.3-8.6 8-16.4V128l3.4-13.4 17.6-18V85l8.7-2.8-1.7-6.2c-2.7-.7-5.7-1.4-8.8-1.9l1.4 6z",
          fill: "#B5BBC5"
        }), React.createElement("path", {
          d: "M99.6 169.2l6.3-5.4 1.4-17.4 4-7.4-9.6 5.6.1 10.5-12.3-15.7 8.8 17.2-7.5 5.7-9.5 9c.5 1 1.3 2 2.2 2.7a127 127 0 0015.3 4.7l.8-9.5z",
          fill: "#B5BBC5"
        }));
      }
    }

    return null;
  };

  return React.createElement(Container, _extends({
    size: size
  }, otherProps), React.createElement(Wrapper, {
    borderRadius: borderRadius,
    shimmerLoading: shimmerLoading,
    ratio: ratio,
    user: user,
    product: product,
    isError: isError,
    src: src,
    isLoading: isLoading,
    onClick: isError && hasReloadOnError ? handleReloadClick : function () {}
  }, src ? React.createElement("img", {
    ref: imgRef,
    alt: alt,
    className: imageStyle,
    src: src,
    onLoad: onImgLoad,
    onError: onImgError
  }) : React.createElement(PlaceholderContent, null), isError && React.createElement(ErrorContent, null)));
};

export default Image;