import styled, { css } from 'react-emotion';
import { N75 } from 'unify-token/build/v2/colors';
import { NN100L } from 'unify-token/colors';
import { KeyframeShimmer } from "../../build/Providers/styles/Loader/_SharedLoaderStyle";

var handleSize = function handleSize(_ref) {
  var size = _ref.size;

  switch (size) {
    case 'micro':
      return "24px";

    case 'small':
      return "32px";

    case 'medium':
      return "48px";

    case 'large':
      return "56px";

    case 'extra large':
      return "64px";

    case '':
      return "100%";

    default:
      return size;
  }
};

var borderResolver = function borderResolver(_ref2) {
  var product = _ref2.product,
      isLoading = _ref2.isLoading,
      user = _ref2.user,
      borderRadius = _ref2.borderRadius;

  switch (true) {
    case user || user && isLoading:
      return '50%';

    case product || product && isLoading:
      return borderRadius;

    default:
      return '0';
  }
};

var handleRatioSize = function handleRatioSize(_ref3) {
  var ratio = _ref3.ratio;

  switch (true) {
    case ratio === '1:1':
      return '100%';

    case ratio === '3:2':
      return '66.66%';

    case ratio === '2:1':
      return '50%';

    case ratio === '3:1':
      return '33.33%';

    case ratio === '4:1':
      return '25%';

    default:
      return '100%';
  }
};

var handleBackgroundColor = function handleBackgroundColor(_ref4) {
  var src = _ref4.src,
      isError = _ref4.isError,
      isLoading = _ref4.isLoading;

  switch (true) {
    case src && !isLoading && !isError:
      return '';

    default:
      return "".concat(NN100L);
  }
};

export var Container = styled("div", {
  target: "epodq6i0"
})("label:unf-img;width:", handleSize, ";");
export var reloadIconStyle = css("border:0;width:100%;height:100%;top:0;right:0;position:absolute;background:transparent;svg{display:block;object-fit:contain;max-width:32px;max-height:32px;width:100%;height:100% auto;top:50%;left:50%;transform:translate(-50%,-50%);position:absolute;}");
export var placeholderStyle = css("display:block;object-fit:contain;max-width:256px;max-height:256px;width:100%;height:100%;top:50%;left:50%;transform:translate(-50%,-50%);position:absolute;");
export var imageStyle = css("object-fit:cover;top:0;right:0;bottom:0;left:0;display:none;");
export var Wrapper = styled("div", {
  target: "epodq6i1"
})("border-radius:", borderResolver, ";padding-top:", handleRatioSize, ";position:relative;background-color:", handleBackgroundColor, ";background-size:99% 100%;background-repeat:no-repeat;background-image:", function (_ref5) {
  var isLoading = _ref5.isLoading,
      isError = _ref5.isError,
      shimmerLoading = _ref5.shimmerLoading,
      src = _ref5.src;
  return isLoading && shimmerLoading && src && !isError ? "linear-gradient(89deg,var(--N75,#E5E7E9),var(--N50,#F3F4F5))" : N75;
}, ";animation:", function (props) {
  return !props.shimmerLoading ? '' : "".concat(KeyframeShimmer, " 1300ms linear 1ms infinite backwards");
}, ";img{width:100%;height:100%;border-radius:", borderResolver, ";position:absolute;}");