import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["backgroundColor", "cashback", "children", "color", "large", "medium", "progress", "textColor", "time"];
import React from 'react';
import Typography from "../../build/Typography";
import { Container, Icon } from "./style";

var Label = function Label(_ref) {
  var _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? '' : _ref$backgroundColor,
      _ref$cashback = _ref.cashback,
      cashback = _ref$cashback === void 0 ? false : _ref$cashback,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? '' : _ref$color,
      _ref$large = _ref.large,
      large = _ref$large === void 0 ? false : _ref$large,
      _ref$medium = _ref.medium,
      medium = _ref$medium === void 0 ? false : _ref$medium,
      _ref$progress = _ref.progress,
      progress = _ref$progress === void 0 ? '' : _ref$progress,
      _ref$textColor = _ref.textColor,
      textColor = _ref$textColor === void 0 ? '' : _ref$textColor,
      _ref$time = _ref.time,
      time = _ref$time === void 0 ? false : _ref$time,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var containerProps = {
    medium: medium,
    large: large,
    backgroundColor: backgroundColor,
    textColor: textColor,
    progress: progress
  };
  var iconProps = {
    cashback: cashback,
    time: time
  };
  var typographyProps = {
    bold: true,
    caption: medium,
    margin: '0',
    micro: !(large || medium),
    style: {
      color: color || textColor
    }
  };
  return React.createElement(Container, _extends({
    "data-unify": "Label"
  }, containerProps, otherProps), (time || cashback) && React.createElement(Icon, iconProps), React.createElement(Typography, typographyProps, children));
};

Label.displayName = 'Label';
export default Label;