import styled, { css } from 'react-emotion';
import { GN200L, GN500L, NN50L } from 'unify-token/colors';
import { spacingLv1, spacingLv2 } from 'unify-token/build/v2/spacings';
import icon_time from "./assets/icon-time.svg";
import icon_saldo from "./assets/icon-saldo.svg";

var handleHeight = function handleHeight(_ref) {
  var large = _ref.large;

  switch (true) {
    case large:
      return '28px';

    default:
      return '20px';
  }
};

var handleBackgroundImage = function handleBackgroundImage(_ref2) {
  var cashback = _ref2.cashback,
      time = _ref2.time;

  switch (true) {
    case cashback:
      return icon_saldo;

    case time:
      return icon_time;

    default:
      return 'none';
  }
};

var _ref4 = "background-color:";
var _ref5 = ";&:before{content:'';width:100%;height:100%;background:linear-gradient(to bottom,";
var _ref6 = " 0%,";
var _ref7 = " 100%) no-repeat;position:absolute;top:0;left:0;transition:transform 0.2s ease-out;transform:scaleX(";
var _ref8 = ");transform-origin:left;}";

var styleProgress = function styleProgress(_ref3) {
  var backgroundColor = _ref3.backgroundColor,
      progress = _ref3.progress;
  return css(_ref4, NN50L, _ref5, backgroundColor, _ref6, backgroundColor, _ref7, Math.abs(progress / 100), _ref8);
};

export var Container = styled('div', {
  target: "eej3d450"
})("label:unf-label;display:inline-flex;align-items:center;justify-content:space-between;border-radius:3px;position:relative;overflow:hidden;padding:", spacingLv1, " ", spacingLv2, ";height:", function (_ref9) {
  var small = _ref9.small,
      large = _ref9.large;
  return handleHeight({
    small: small,
    large: large
  });
}, ";background:", function (_ref10) {
  var backgroundColor = _ref10.backgroundColor;
  return backgroundColor ? "".concat(backgroundColor) : "".concat(GN200L);
}, ";color:", function (_ref11) {
  var textColor = _ref11.textColor;
  return textColor ? "".concat(textColor) : "".concat(GN500L);
}, ";", function (_ref12) {
  var backgroundColor = _ref12.backgroundColor,
      progress = _ref12.progress;
  return progress && styleProgress({
    backgroundColor: backgroundColor,
    progress: progress
  });
}, ";");
export var Icon = styled('i', {
  target: "eej3d451"
})("label:unf-label__icon;display:inline-flex;width:16px;height:16px;background-image:url('", handleBackgroundImage, "');background-position:center;background-repeat:no-repeat;margin-right:2px;");