import React from 'react';
declare type LabelAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface LabelProps extends Omit<LabelAttributes, 'onClick' | 'css'> {
    /**
     * To specify background color of Label
     */
    backgroundColor?: string;
    /**
     * To apply cashback Label design
     */
    cashback?: boolean;
    /**
     * To specify text color of Label
     */
    color?: string;
    /**
     * To apply large Label size design
     */
    large?: boolean;
    /**
     * To apply medium Label size design
     */
    medium?: boolean;
    /**
     * To apply progress Label design
     */
    progress?: number | string;
    /**
     * To apply small Label size design
     */
    small?: boolean;
    /**
     * To specify text color of Label ( DEPRECATED SOON )
     */
    textColor?: string;
    /**
     * To apply time Label design
     */
    time?: boolean;
}
export {};
