import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "color", "type"];
import React from 'react';
import Typography from "../../build/Typography";
import { Container, handleTextColor } from "./style";

var LabelV2 = function LabelV2(_ref) {
  var children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'green' : _ref$color,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'highlight' : _ref$type,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var containerProps = {
    color: color,
    type: type
  };
  var typographyProps = {
    bold: true,
    caption: false,
    margin: '0',
    micro: true,
    color: handleTextColor({
      color: color,
      type: type
    })
  };
  return React.createElement(Container, _extends({}, containerProps, {
    "data-unify": "Label"
  }, otherProps), React.createElement(Typography, typographyProps, children));
};

LabelV2.displayName = 'LabelV2';
export default LabelV2;