import styled from 'react-emotion';
import { YN100, YN500, RN100, RN500, BN100, BN500, GN100, GN500, TN100, TN500, NN600, NN900RGB, NN100L } from 'unify-token/colors';
import { spacingLv1, spacingLv2 } from 'unify-token/build/v2/spacings';
import { colorWhiteAlways } from "../../build/Providers/common/style";
export var handleTextColor = function handleTextColor(_ref) {
  var color = _ref.color,
      type = _ref.type;

  switch (true) {
    case type === 'highlight' || type === 'highlightImage':
      return colorWhiteAlways;

    case type === 'highlightAlternate' && color === 'orange':
      return YN500;

    case type === 'highlightAlternate' && color === 'red':
      return RN500;

    case type === 'highlightAlternate' && color === 'blue':
      return BN500;

    case type === 'highlightAlternate' && color === 'green':
      return GN500;

    case type === 'highlightAlternate' && color === 'teal':
      return TN500;

    case type === 'highlightAlternate' && color === 'grey':
      return NN600;

    default:
      return colorWhiteAlways;
  }
};

var handleBackgroundColor = function handleBackgroundColor(_ref2) {
  var color = _ref2.color,
      type = _ref2.type;
  var bgColorArr = [{
    test: type === 'highlight' && color === 'orange',
    value: YN500
  }, {
    test: type === 'highlight' && color === 'red',
    value: RN500
  }, {
    test: type === 'highlight' && color === 'blue',
    value: BN500
  }, {
    test: type === 'highlight' && color === 'teal',
    value: TN500
  }, {
    test: type === 'highlight' && color === 'grey',
    value: NN600
  }, {
    test: type === 'highlight' && color === 'orange',
    value: YN100
  }, {
    test: type === 'highlightImage',
    value: "rgba(var(--NN100RGB, ".concat(NN900RGB, "), 0.7)")
  }, {
    test: type === 'highlightAlternate' && color === 'orange',
    value: YN100
  }, {
    test: type === 'highlightAlternate' && color === 'red',
    value: RN100
  }, {
    test: type === 'highlightAlternate' && color === 'blue',
    value: BN100
  }, {
    test: type === 'highlightAlternate' && color === 'green',
    value: GN100
  }, {
    test: type === 'highlightAlternate' && color === 'teal',
    value: TN100
  }, {
    test: type === 'highlightAlternate' && color === 'grey',
    value: "var(--NN100, ".concat(NN100L, ")")
  }, {
    test: type === 'general',
    value: 'transparent'
  }, {
    test: true,
    value: GN500
  }];
  return bgColorArr.find(function (s) {
    return s.test;
  }).value;
};

export var Container = styled('div', {
  target: "e1ieqkgf0"
})("label:unf-label;display:inline-flex;align-items:center;justify-content:space-between;border-radius:3px;position:relative;overflow:hidden;padding:", spacingLv1, " ", spacingLv2, ";height:20px;background-color:", handleBackgroundColor, ";");