import React from 'react';
export interface LightboxHeaderProps {
    /**
     * Specify data-testid in back button
     */
    dataTest?: string;
    /**
     * To apply Lightbox Header design with action icon on the right side
     */
    headerActions?: React.ReactNode;
    /**
     * To specify content of Lightbox Header
     */
    headerContent?: React.ReactNode;
    /**
     * To set subtitle text for Lightbox Header
     */
    subTitle?: string;
    /**
     * To set title text for Lightbox Header
     */
    title?: string;
    /**
     * To set a callback function if user click back icon
     */
    onClickBack?: string | ((e: React.MouseEvent<HTMLButtonElement>) => void);
}
declare const LightboxHeader: {
    (props: LightboxHeaderProps): JSX.Element;
    propTypes: {
        dataTest: import("prop-types").Requireable<string>;
        headerActions: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        headerContent: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        subTitle: import("prop-types").Requireable<string>;
        title: import("prop-types").Requireable<string>;
        onClickBack: import("prop-types").Requireable<string | ((...args: any[]) => any)>;
    };
};
export default LightboxHeader;
