import React from 'react';
export interface LightboxSliderProps {
    /**
     * To pass active index for this LightboxSlider
     */
    activeIndex?: number;
    /**
     * To pass items of LightboxSlider
     */
    children?: React.ReactNode[];
    /**
     * To pass callback that triggers when index changed
     */
    onNext?: (activeIndex: number) => void;
    /**
     * To pass callback that triggers when index changed
     */
    onPrev?: (activeIndex: number) => void;
    /**
     * To pass callback that triggers when index changed
     */
    onSlideChange?: (activeIndex: number) => void;
    /**
     * To pass callback that triggers whenever active slide is changed through swipes
     */
    onSwipe?: () => void;
}
declare const LightboxSlider: {
    (props: LightboxSliderProps): JSX.Element;
    propTypes: {
        activeIndex: import("prop-types").Requireable<number>;
        children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        onNext: import("prop-types").Requireable<(...args: any[]) => any>;
        onPrev: import("prop-types").Requireable<(...args: any[]) => any>;
        onSlideChange: import("prop-types").Requireable<(...args: any[]) => any>;
        onSwipe: import("prop-types").Requireable<(...args: any[]) => any>;
    };
    defaultProps: {
        onNext: () => void;
        onPrev: () => void;
        onSlideChange: () => void;
        onSwipe: () => void;
    };
};
export default LightboxSlider;
