import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["activeIndex", "className", "dataTest", "display", "headerActions", "headerContent", "items", "loading", "noImage", "noVideo", "overlayContent", "subTitle", "title", "totalItems", "withCounter", "withThumbnail", "onClickBack", "onClickThumbnail", "onNext", "onPrev", "onSlideChange"],
    _excluded2 = ["alt", "autoPlay", "url", "onPlay"];
import React, { useState, useEffect, useRef, useCallback, createRef } from 'react';
import ReactHlsPlayer from 'react-hls-player';
import { cx } from 'emotion';
import { NN0 } from 'unify-token/colors';
import { ImageBroken, Pause, Play, ScreenFull, VideoBroken, VolumeMute, VolumeUp } from 'unify-icons/system';
import { usePrev } from "../../build/Providers/common/hooks";
import LoadingCircle from "../../build/Providers/common/components/LoadingCircle";
import PortalWrapper from "../../build/Providers/common/components/PortalWrapper";
import Typography from "../../build/Typography";
import { canUseDOM } from "../../build/Providers/common/functions";
import LightboxHeader from "./LightboxHeader";
import LightboxSlider from "./LightboxSlider";
import { Container, ContentContainer, ContentWrapper, Counter, EdgeStateWrapper, PreviewContainer, ThumbnailsWrapper, VideoControlsWrapper } from "./style";

var Lightbox = function Lightbox(props) {
  var activeIndexProp = props.activeIndex,
      className = props.className,
      dataTest = props.dataTest,
      display = props.display,
      headerActions = props.headerActions,
      headerContent = props.headerContent,
      items = props.items,
      loading = props.loading,
      noImage = props.noImage,
      noVideo = props.noVideo,
      overlayContent = props.overlayContent,
      subTitle = props.subTitle,
      title = props.title,
      totalItems = props.totalItems,
      withCounter = props.withCounter,
      withThumbnail = props.withThumbnail,
      onClickBack = props.onClickBack,
      onClickThumbnail = props.onClickThumbnail,
      onNext = props.onNext,
      onPrev = props.onPrev,
      onSlideChange = props.onSlideChange,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState(activeIndexProp),
      _useState2 = _slicedToArray(_useState, 2),
      activeIndex = _useState2[0],
      setActiveIndex = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      toggleContent = _useState4[0],
      setToggleContent = _useState4[1];

  var _useState5 = useState(null),
      _useState6 = _slicedToArray(_useState5, 2),
      deltaX = _useState6[0],
      setDeltaX = _useState6[1];

  var _useState7 = useState(null),
      _useState8 = _slicedToArray(_useState7, 2),
      deltaY = _useState8[0],
      setDeltaY = _useState8[1];

  var _useState9 = useState(false),
      _useState10 = _slicedToArray(_useState9, 2),
      isScaled = _useState10[0],
      setIsScaled = _useState10[1];

  var _useState11 = useState(1),
      _useState12 = _slicedToArray(_useState11, 2),
      scaleValue = _useState12[0],
      setScaleValue = _useState12[1];

  var _useState13 = useState({
    x: 0,
    y: 0,
    distance: 0
  }),
      _useState14 = _slicedToArray(_useState13, 2),
      startPos = _useState14[0],
      setStartPos = _useState14[1];

  var totalItemsAuto = items === null || items === void 0 ? void 0 : items.length;
  var prevActiveIndex = usePrev(activeIndex);
  var initialItems = activeIndex + 1;

  var handleActiveIndexChange = function handleActiveIndexChange(activeIndex) {
    var _videoPlayerRef$curre, _videoPlayerRef$curre2, _videoPlayerRef$curre3;

    setActiveIndex(activeIndex);
    onSlideChange && onSlideChange(activeIndex);
    videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre = videoPlayerRef.current) === null || _videoPlayerRef$curre === void 0 ? void 0 : (_videoPlayerRef$curre2 = _videoPlayerRef$curre[prevActiveIndex]) === null || _videoPlayerRef$curre2 === void 0 ? void 0 : (_videoPlayerRef$curre3 = _videoPlayerRef$curre2.current) === null || _videoPlayerRef$curre3 === void 0 ? void 0 : _videoPlayerRef$curre3.pause();
    items === null || items === void 0 ? void 0 : items.map(function (item, index) {
      if (item.autoPlay && activeIndex === index) {
        var _videoPlayerRef$curre4, _videoPlayerRef$curre5, _videoPlayerRef$curre6;

        setVideoMuted(true);
        videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre4 = videoPlayerRef.current) === null || _videoPlayerRef$curre4 === void 0 ? void 0 : (_videoPlayerRef$curre5 = _videoPlayerRef$curre4[index]) === null || _videoPlayerRef$curre5 === void 0 ? void 0 : (_videoPlayerRef$curre6 = _videoPlayerRef$curre5.current) === null || _videoPlayerRef$curre6 === void 0 ? void 0 : _videoPlayerRef$curre6.play();
      }
    });
  };

  var handleToggleContent = function handleToggleContent() {
    setToggleContent(!toggleContent);
  };

  var renderEdgeStateInfo = function renderEdgeStateInfo(type) {
    return React.createElement(Typography, {
      body: 3,
      color: NN0,
      margin: "16px 0 0"
    }, "The ", type, " has not found");
  };

  var handleEdgeState = function handleEdgeState() {
    if (loading) {
      return React.createElement(LoadingCircle, {
        display: true
      });
    } else if (noImage) {
      return React.createElement(React.Fragment, null, React.createElement(ImageBroken, {
        color: NN0,
        size: 40
      }), renderEdgeStateInfo('image'));
    } else if (noVideo) {
      return React.createElement(React.Fragment, null, React.createElement(VideoBroken, {
        color: NN0,
        size: 40
      }), renderEdgeStateInfo('video'));
    }
  };

  var videosRef = items === null || items === void 0 ? void 0 : items.map(function (item) {
    return item.type === 'video' && createRef();
  });
  var videoPlayerRef = useRef(videosRef);

  var _useState15 = useState(false),
      _useState16 = _slicedToArray(_useState15, 2),
      videoMuted = _useState16[0],
      setVideoMuted = _useState16[1];

  var _useState17 = useState(false),
      _useState18 = _slicedToArray(_useState17, 2),
      videoPlaying = _useState18[0],
      setVideoPlaying = _useState18[1];

  var _useState19 = useState(0),
      _useState20 = _slicedToArray(_useState19, 2),
      videoProgress = _useState20[0],
      setVideoProgress = _useState20[1];

  var _useState21 = useState(0),
      _useState22 = _slicedToArray(_useState21, 2),
      videoCurrentTime = _useState22[0],
      setVideoCurrentTime = _useState22[1];

  var _useState23 = useState(0),
      _useState24 = _slicedToArray(_useState23, 2),
      videoTime = _useState24[0],
      setVideoTime = _useState24[1];

  var videoHandler = function videoHandler(control, index) {
    var _videoPlayerRef$curre7, _videoPlayerRef$curre8, _videoPlayerRef$curre9, _videoPlayerRef$curre10, _videoPlayerRef$curre11, _videoPlayerRef$curre12, _videoPlayerRef$curre13, _videoPlayerRef$curre14;

    switch (control) {
      case 'play':
        setVideoPlaying(true);
        setVideoTime(videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre7 = videoPlayerRef.current) === null || _videoPlayerRef$curre7 === void 0 ? void 0 : (_videoPlayerRef$curre8 = _videoPlayerRef$curre7[index]) === null || _videoPlayerRef$curre8 === void 0 ? void 0 : (_videoPlayerRef$curre9 = _videoPlayerRef$curre8.current) === null || _videoPlayerRef$curre9 === void 0 ? void 0 : _videoPlayerRef$curre9.duration);
        videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre10 = videoPlayerRef.current) === null || _videoPlayerRef$curre10 === void 0 ? void 0 : (_videoPlayerRef$curre11 = _videoPlayerRef$curre10[index].current) === null || _videoPlayerRef$curre11 === void 0 ? void 0 : _videoPlayerRef$curre11.play();
        break;

      case 'pause':
        setVideoPlaying(false);
        videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre12 = videoPlayerRef.current) === null || _videoPlayerRef$curre12 === void 0 ? void 0 : (_videoPlayerRef$curre13 = _videoPlayerRef$curre12[index]) === null || _videoPlayerRef$curre13 === void 0 ? void 0 : (_videoPlayerRef$curre14 = _videoPlayerRef$curre13.current) === null || _videoPlayerRef$curre14 === void 0 ? void 0 : _videoPlayerRef$curre14.pause();
        break;

      case 'mute':
        setVideoMuted(true);
        break;

      case 'unmute':
        setVideoMuted(false);
        break;

      case 'fullscreen':
        handleVideoFullscreen();
        break;
    }
  };

  var handleVideoFullscreen = function handleVideoFullscreen() {
    var _videoPlayerRef$curre15, _videoPlayerRef$curre16, _videoPlayerRef$curre17, _videoPlayerRef$curre21, _videoPlayerRef$curre22, _videoPlayerRef$curre23, _videoPlayerRef$curre27, _videoPlayerRef$curre28, _videoPlayerRef$curre29, _videoPlayerRef$curre33, _videoPlayerRef$curre34, _videoPlayerRef$curre35, _videoPlayerRef$curre39, _videoPlayerRef$curre40, _videoPlayerRef$curre41;

    if (videoPlayerRef !== null && videoPlayerRef !== void 0 && (_videoPlayerRef$curre15 = videoPlayerRef.current) !== null && _videoPlayerRef$curre15 !== void 0 && (_videoPlayerRef$curre16 = _videoPlayerRef$curre15[activeIndex]) !== null && _videoPlayerRef$curre16 !== void 0 && (_videoPlayerRef$curre17 = _videoPlayerRef$curre16.current) !== null && _videoPlayerRef$curre17 !== void 0 && _videoPlayerRef$curre17.requestFullscreen) {
      var _videoPlayerRef$curre18, _videoPlayerRef$curre19, _videoPlayerRef$curre20;

      videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre18 = videoPlayerRef.current) === null || _videoPlayerRef$curre18 === void 0 ? void 0 : (_videoPlayerRef$curre19 = _videoPlayerRef$curre18[activeIndex]) === null || _videoPlayerRef$curre19 === void 0 ? void 0 : (_videoPlayerRef$curre20 = _videoPlayerRef$curre19.current) === null || _videoPlayerRef$curre20 === void 0 ? void 0 : _videoPlayerRef$curre20.requestFullscreen();
    } else if (videoPlayerRef !== null && videoPlayerRef !== void 0 && (_videoPlayerRef$curre21 = videoPlayerRef.current) !== null && _videoPlayerRef$curre21 !== void 0 && (_videoPlayerRef$curre22 = _videoPlayerRef$curre21[activeIndex]) !== null && _videoPlayerRef$curre22 !== void 0 && (_videoPlayerRef$curre23 = _videoPlayerRef$curre22.current) !== null && _videoPlayerRef$curre23 !== void 0 && _videoPlayerRef$curre23.mozRequestFullscreen) {
      var _videoPlayerRef$curre24, _videoPlayerRef$curre25, _videoPlayerRef$curre26;

      videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre24 = videoPlayerRef.current) === null || _videoPlayerRef$curre24 === void 0 ? void 0 : (_videoPlayerRef$curre25 = _videoPlayerRef$curre24[activeIndex]) === null || _videoPlayerRef$curre25 === void 0 ? void 0 : (_videoPlayerRef$curre26 = _videoPlayerRef$curre25.current) === null || _videoPlayerRef$curre26 === void 0 ? void 0 : _videoPlayerRef$curre26.mozRequestFullscreen();
    } else if (videoPlayerRef !== null && videoPlayerRef !== void 0 && (_videoPlayerRef$curre27 = videoPlayerRef.current) !== null && _videoPlayerRef$curre27 !== void 0 && (_videoPlayerRef$curre28 = _videoPlayerRef$curre27[activeIndex]) !== null && _videoPlayerRef$curre28 !== void 0 && (_videoPlayerRef$curre29 = _videoPlayerRef$curre28.current) !== null && _videoPlayerRef$curre29 !== void 0 && _videoPlayerRef$curre29.webkitRequestFullscreen) {
      var _videoPlayerRef$curre30, _videoPlayerRef$curre31, _videoPlayerRef$curre32;

      videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre30 = videoPlayerRef.current) === null || _videoPlayerRef$curre30 === void 0 ? void 0 : (_videoPlayerRef$curre31 = _videoPlayerRef$curre30[activeIndex]) === null || _videoPlayerRef$curre31 === void 0 ? void 0 : (_videoPlayerRef$curre32 = _videoPlayerRef$curre31.current) === null || _videoPlayerRef$curre32 === void 0 ? void 0 : _videoPlayerRef$curre32.webkitRequestFullscreen();
    } else if (videoPlayerRef !== null && videoPlayerRef !== void 0 && (_videoPlayerRef$curre33 = videoPlayerRef.current) !== null && _videoPlayerRef$curre33 !== void 0 && (_videoPlayerRef$curre34 = _videoPlayerRef$curre33[activeIndex]) !== null && _videoPlayerRef$curre34 !== void 0 && (_videoPlayerRef$curre35 = _videoPlayerRef$curre34.current) !== null && _videoPlayerRef$curre35 !== void 0 && _videoPlayerRef$curre35.msRequestFullscreen) {
      var _videoPlayerRef$curre36, _videoPlayerRef$curre37, _videoPlayerRef$curre38;

      videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre36 = videoPlayerRef.current) === null || _videoPlayerRef$curre36 === void 0 ? void 0 : (_videoPlayerRef$curre37 = _videoPlayerRef$curre36[activeIndex]) === null || _videoPlayerRef$curre37 === void 0 ? void 0 : (_videoPlayerRef$curre38 = _videoPlayerRef$curre37.current) === null || _videoPlayerRef$curre38 === void 0 ? void 0 : _videoPlayerRef$curre38.msRequestFullscreen();
    } else if (videoPlayerRef !== null && videoPlayerRef !== void 0 && (_videoPlayerRef$curre39 = videoPlayerRef.current) !== null && _videoPlayerRef$curre39 !== void 0 && (_videoPlayerRef$curre40 = _videoPlayerRef$curre39[activeIndex]) !== null && _videoPlayerRef$curre40 !== void 0 && (_videoPlayerRef$curre41 = _videoPlayerRef$curre40.current) !== null && _videoPlayerRef$curre41 !== void 0 && _videoPlayerRef$curre41.webkitEnterFullscreen) {
      var _videoPlayerRef$curre42, _videoPlayerRef$curre43, _videoPlayerRef$curre44;

      videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre42 = videoPlayerRef.current) === null || _videoPlayerRef$curre42 === void 0 ? void 0 : (_videoPlayerRef$curre43 = _videoPlayerRef$curre42[activeIndex]) === null || _videoPlayerRef$curre43 === void 0 ? void 0 : (_videoPlayerRef$curre44 = _videoPlayerRef$curre43.current) === null || _videoPlayerRef$curre44 === void 0 ? void 0 : _videoPlayerRef$curre44.webkitEnterFullscreen();
    }
  };

  var handleVideoEnded = function handleVideoEnded() {
    setVideoCurrentTime(0);
    setVideoPlaying(false);
    setVideoProgress(0);
  };

  var handleVideoPause = function handleVideoPause() {
    setVideoPlaying(false);
  };

  var handleVideoPlaying = function handleVideoPlaying() {
    setVideoPlaying(true);
  };

  var handleVideoTimeUpdate = function handleVideoTimeUpdate() {
    var _videoPlayerRef$curre45, _videoPlayerRef$curre46, _videoPlayerRef$curre47, _videoPlayerRef$curre48, _videoPlayerRef$curre49, _videoPlayerRef$curre50, _videoPlayerRef$curre51, _videoPlayerRef$curre52, _videoPlayerRef$curre53;

    var progress = (videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre45 = videoPlayerRef.current) === null || _videoPlayerRef$curre45 === void 0 ? void 0 : (_videoPlayerRef$curre46 = _videoPlayerRef$curre45[activeIndex]) === null || _videoPlayerRef$curre46 === void 0 ? void 0 : (_videoPlayerRef$curre47 = _videoPlayerRef$curre46.current) === null || _videoPlayerRef$curre47 === void 0 ? void 0 : _videoPlayerRef$curre47.currentTime) / (videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre48 = videoPlayerRef.current) === null || _videoPlayerRef$curre48 === void 0 ? void 0 : (_videoPlayerRef$curre49 = _videoPlayerRef$curre48[activeIndex]) === null || _videoPlayerRef$curre49 === void 0 ? void 0 : (_videoPlayerRef$curre50 = _videoPlayerRef$curre49.current) === null || _videoPlayerRef$curre50 === void 0 ? void 0 : _videoPlayerRef$curre50.duration) * 100;
    setVideoProgress(progress);
    setVideoCurrentTime(videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre51 = videoPlayerRef.current) === null || _videoPlayerRef$curre51 === void 0 ? void 0 : (_videoPlayerRef$curre52 = _videoPlayerRef$curre51[activeIndex]) === null || _videoPlayerRef$curre52 === void 0 ? void 0 : (_videoPlayerRef$curre53 = _videoPlayerRef$curre52.current) === null || _videoPlayerRef$curre53 === void 0 ? void 0 : _videoPlayerRef$curre53.currentTime);
  };

  var handleVideoProgress = function handleVideoProgress(e) {
    var _videoPlayerRef$curre54, _videoPlayerRef$curre55, _videoPlayerRef$curre56;

    var manualChange = Number(e.target.value);
    videoPlayerRef.current[activeIndex].current.currentTime = (videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre54 = videoPlayerRef.current) === null || _videoPlayerRef$curre54 === void 0 ? void 0 : (_videoPlayerRef$curre55 = _videoPlayerRef$curre54[activeIndex]) === null || _videoPlayerRef$curre55 === void 0 ? void 0 : (_videoPlayerRef$curre56 = _videoPlayerRef$curre55.current) === null || _videoPlayerRef$curre56 === void 0 ? void 0 : _videoPlayerRef$curre56.duration) / 100 * manualChange;
    setVideoProgress(manualChange);
  };

  var renderCustomControlsVideo = function renderCustomControlsVideo() {
    return React.createElement(React.Fragment, null, items.map(function (item, index) {
      if (item.type === 'video' && activeIndex === index) {
        var _videoPlayerRef$curre57, _videoPlayerRef$curre58, _videoPlayerRef$curre59, _videoPlayerRef$curre60, _videoPlayerRef$curre61, _videoPlayerRef$curre62, _videoPlayerRef$curre63, _videoPlayerRef$curre64, _videoPlayerRef$curre65, _videoPlayerRef$curre66, _videoPlayerRef$curre67, _videoPlayerRef$curre68;

        return React.createElement("div", {
          key: index,
          className: VideoControlsWrapper
        }, React.createElement("div", {
          className: "unf-lightbox__video-controls--play"
        }, videoPlaying ? React.createElement(Pause, {
          color: NN0,
          size: 24,
          onClick: function onClick() {
            return videoHandler('pause', activeIndex);
          }
        }) : React.createElement(Play, {
          color: NN0,
          size: 24,
          onClick: function onClick() {
            return videoHandler('play', activeIndex);
          }
        })), React.createElement("input", {
          className: "unf-lightbox__video-controls--timeline",
          type: "range",
          value: videoProgress,
          onChange: function onChange(e) {
            return handleVideoProgress(e);
          }
        }), React.createElement("div", {
          className: "unf-lightbox__video-controls--group"
        }, React.createElement("span", {
          className: "unf-lightbox__video-controls--time"
        }, (videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre57 = videoPlayerRef.current) === null || _videoPlayerRef$curre57 === void 0 ? void 0 : (_videoPlayerRef$curre58 = _videoPlayerRef$curre57[index]) === null || _videoPlayerRef$curre58 === void 0 ? void 0 : (_videoPlayerRef$curre59 = _videoPlayerRef$curre58.current) === null || _videoPlayerRef$curre59 === void 0 ? void 0 : _videoPlayerRef$curre59.currentTime) === undefined ? '0:00' : "".concat(Math.floor(videoCurrentTime / 60), ":").concat("0".concat(Math.floor(videoCurrentTime % 60)).slice(-2)), "/", (videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre60 = videoPlayerRef.current) === null || _videoPlayerRef$curre60 === void 0 ? void 0 : (_videoPlayerRef$curre61 = _videoPlayerRef$curre60[index]) === null || _videoPlayerRef$curre61 === void 0 ? void 0 : (_videoPlayerRef$curre62 = _videoPlayerRef$curre61.current) === null || _videoPlayerRef$curre62 === void 0 ? void 0 : _videoPlayerRef$curre62.duration) === undefined ? '0:00' : "".concat(Math.floor((videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre63 = videoPlayerRef.current) === null || _videoPlayerRef$curre63 === void 0 ? void 0 : (_videoPlayerRef$curre64 = _videoPlayerRef$curre63[index]) === null || _videoPlayerRef$curre64 === void 0 ? void 0 : (_videoPlayerRef$curre65 = _videoPlayerRef$curre64.current) === null || _videoPlayerRef$curre65 === void 0 ? void 0 : _videoPlayerRef$curre65.duration) / 60), ":").concat("0".concat(Math.floor((videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre66 = videoPlayerRef.current) === null || _videoPlayerRef$curre66 === void 0 ? void 0 : (_videoPlayerRef$curre67 = _videoPlayerRef$curre66[index]) === null || _videoPlayerRef$curre67 === void 0 ? void 0 : (_videoPlayerRef$curre68 = _videoPlayerRef$curre67.current) === null || _videoPlayerRef$curre68 === void 0 ? void 0 : _videoPlayerRef$curre68.duration) % 60)).slice(-2))), React.createElement("div", {
          className: "unf-lightbox__video-controls--volume"
        }, videoMuted || item.muted ? React.createElement(VolumeMute, {
          color: NN0,
          size: 24,
          onClick: function onClick() {
            return videoHandler('unmute', activeIndex);
          }
        }) : React.createElement(VolumeUp, {
          color: NN0,
          size: 24,
          onClick: function onClick() {
            return videoHandler('mute', activeIndex);
          }
        })), React.createElement("div", {
          className: "unf-lightbox__video-controls--screen"
        }, React.createElement(ScreenFull, {
          color: NN0,
          size: 24,
          onClick: function onClick() {
            return videoHandler('fullscreen', activeIndex);
          }
        }))));
      } else {
        return null;
      }
    }));
  };

  var renderThumbnails = function renderThumbnails() {
    return React.createElement("div", {
      className: ThumbnailsWrapper,
      ref: containerRef
    }, items.map(function (item, index) {
      if (item.type === 'image') {
        return React.createElement("img", _extends({
          key: index,
          className: activeIndex === index ? 'unf-lightbox__thumbnail active' : 'unf-lightbox__thumbnail',
          src: item.url,
          alt: item.alt,
          loading: "lazy"
        }, dataTest !== null && dataTest !== void 0 && dataTest.imageThumbnail ? {
          'data-testid': (dataTest === null || dataTest === void 0 ? void 0 : dataTest.imageThumbnail) + index
        } : {}, {
          onClick: function onClick() {
            return handleClickThumbnail(index);
          }
        }));
      } else if (item.type === 'video') {
        return React.createElement("div", {
          key: index,
          className: activeIndex === index ? 'unf-lightbox__video-wrapper active' : 'unf-lightbox__video-wrapper',
          onClick: function onClick() {
            return handleClickThumbnail(index);
          },
          onKeyDown: function onKeyDown() {
            return handleClickThumbnail(index);
          }
        }, React.createElement("img", _extends({
          className: activeIndex === index ? 'unf-lightbox__thumbnail active' : 'unf-lightbox__thumbnail',
          src: item.videoPoster,
          alt: item.alt,
          loading: "lazy"
        }, dataTest !== null && dataTest !== void 0 && dataTest.imageThumbnail ? {
          'data-testid': (dataTest === null || dataTest === void 0 ? void 0 : dataTest.imageThumbnail) + index
        } : {})), React.createElement("div", {
          className: "unf-lightbox__video--icon"
        }, React.createElement(Play, {
          color: NN0,
          size: 14
        })));
      }
    }));
  };

  var handleClickThumbnail = function handleClickThumbnail(activeIndex) {
    handleActiveIndexChange(activeIndex);
    onClickThumbnail && onClickThumbnail(activeIndex);
  };

  var renderCustomContent = function renderCustomContent() {
    return React.createElement("div", {
      className: ContentWrapper,
      ref: containerRef
    }, items.map(function (item, index) {
      return React.createElement("div", {
        key: index,
        className: activeIndex === index ? 'active' : 'hidden'
      }, item.content);
    }));
  };

  var containerRef = useRef(null);
  var focusActiveThumbnail = useCallback(function () {
    var _containerRef$current;

    var item = (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 ? void 0 : _containerRef$current.querySelector('.active');
    var thumbnail = item.parentNode;

    if (thumbnail) {
      var itemCenter = item.offsetLeft + item.offsetWidth / 2;
      var thumbnailCenter = thumbnail.offsetWidth / 2;
      var newScrollPosition = itemCenter - thumbnailCenter;

      if (newScrollPosition >= 0) {
        if (items.length - 1 === activeIndex && thumbnail.scrollLeft > 0) {
          newScrollPosition = thumbnail.scrollWidth - thumbnail.offsetWidth;
        }

        thumbnail.scrollLeft = newScrollPosition;
      } else {
        newScrollPosition = 0;
        thumbnail.scrollLeft = 0;
      }
    }
  }, [activeIndex, items.length]);

  var distance = function distance(e) {
    return Math.hypot(e.touches[0].pageX - e.touches[1].pageX, e.touches[0].pageY - e.touches[1].pageY);
  };

  var handleTouchStart = function handleTouchStart(e) {
    var _e$touches;

    if (((_e$touches = e.touches) === null || _e$touches === void 0 ? void 0 : _e$touches.length) === 2) {
      e.preventDefault();
      var startX = (e.touches[0].pageX + e.touches[1].pageX) / 2;
      var startY = (e.touches[0].pageY + e.touches[1].pageY) / 2;
      var startDistance = distance(e);
      setStartPos({
        x: startX,
        y: startY,
        distance: startDistance
      });
    }
  };

  var handleTouchMove = function handleTouchMove(e) {
    var _e$touches2;

    if (((_e$touches2 = e.touches) === null || _e$touches2 === void 0 ? void 0 : _e$touches2.length) === 2) {
      e.preventDefault();
      setIsScaled(true);
      var scale;

      if (e.scale) {
        scale = e.scale;
      } else {
        var deltaDistance = distance(e);
        scale = deltaDistance / startPos.distance;
      }

      var imageElementScale = Math.min(Math.max(1, scale), 4);
      setScaleValue(imageElementScale);
      var dX = ((e.touches[0].pageX + e.touches[1].pageX) / 2 - startPos.x) * 2;
      var dY = ((e.touches[0].pageY + e.touches[1].pageY) / 2 - startPos.y) * 2;
      setDeltaX(dX);
      setDeltaY(dY);
    }
  };

  var handleTouchEnd = function handleTouchEnd(e) {
    var _e$touches3;

    if (((_e$touches3 = e.touches) === null || _e$touches3 === void 0 ? void 0 : _e$touches3.length) === 2) {
      e.preventDefault();
    }

    setIsScaled(false);
  };

  useEffect(function () {
    prevActiveIndex === undefined ? prevActiveIndex = activeIndex : prevActiveIndex;
    containerRef.current && focusActiveThumbnail();
  }, [focusActiveThumbnail, activeIndex]);
  useEffect(function () {
    if (canUseDOM && containerRef.current) {
      window.addEventListener('resize', focusActiveThumbnail);
    }

    return function () {
      window.removeEventListener('resize', focusActiveThumbnail);
    };
  }, [focusActiveThumbnail]);
  var handleVideoAutoPlay = useCallback(function () {
    items === null || items === void 0 ? void 0 : items.map(function (item, index) {
      if (item.autoPlay && activeIndex === index) {
        var _videoPlayerRef$curre69, _videoPlayerRef$curre70, _videoPlayerRef$curre71, _videoPlayerRef$curre72, _videoPlayerRef$curre73, _videoPlayerRef$curre74;

        setVideoMuted(true);
        setVideoTime(videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre69 = videoPlayerRef.current) === null || _videoPlayerRef$curre69 === void 0 ? void 0 : (_videoPlayerRef$curre70 = _videoPlayerRef$curre69[index]) === null || _videoPlayerRef$curre70 === void 0 ? void 0 : (_videoPlayerRef$curre71 = _videoPlayerRef$curre70.current) === null || _videoPlayerRef$curre71 === void 0 ? void 0 : _videoPlayerRef$curre71.duration);
        videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre72 = videoPlayerRef.current) === null || _videoPlayerRef$curre72 === void 0 ? void 0 : (_videoPlayerRef$curre73 = _videoPlayerRef$curre72[index]) === null || _videoPlayerRef$curre73 === void 0 ? void 0 : (_videoPlayerRef$curre74 = _videoPlayerRef$curre73.current) === null || _videoPlayerRef$curre74 === void 0 ? void 0 : _videoPlayerRef$curre74.play();
      } else {
        var _videoPlayerRef$curre75, _videoPlayerRef$curre76, _videoPlayerRef$curre77, _videoPlayerRef$curre78;

        setVideoCurrentTime(0);
        setVideoPlaying(false);
        setVideoProgress(0);
        videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre75 = videoPlayerRef.current) === null || _videoPlayerRef$curre75 === void 0 ? void 0 : (_videoPlayerRef$curre76 = _videoPlayerRef$curre75[prevActiveIndex]) === null || _videoPlayerRef$curre76 === void 0 ? void 0 : (_videoPlayerRef$curre77 = _videoPlayerRef$curre76.current) === null || _videoPlayerRef$curre77 === void 0 ? void 0 : _videoPlayerRef$curre77.pause();

        if (((_videoPlayerRef$curre78 = videoPlayerRef.current[prevActiveIndex].current) === null || _videoPlayerRef$curre78 === void 0 ? void 0 : _videoPlayerRef$curre78.currentTime) > 0) {
          videoPlayerRef.current[prevActiveIndex].current.currentTime = 0;
        }
      }
    });
  }, [activeIndex]);
  useEffect(function () {
    handleVideoAutoPlay();
  }, [handleVideoAutoPlay]);

  var handleClickBack = function handleClickBack() {
    typeof onClickBack === 'function' && onClickBack(videoCurrentTime);
  };

  var handleVideoPlay = function handleVideoPlay(e) {
    items === null || items === void 0 ? void 0 : items.map(function (item, index) {
      if (item.onPlay && activeIndex === index) {
        item.onPlay && item.onPlay(e.currentTarget.currentTime);
      }
    });
  };

  return React.createElement(React.Fragment, null, display && React.createElement(PortalWrapper, null, React.createElement("div", _extends({
    className: cx(Container, className)
  }, otherProps), React.createElement(LightboxHeader, {
    className: !toggleContent ? 'unf-navbar--hidden' : null,
    dataTest: dataTest === null || dataTest === void 0 ? void 0 : dataTest.iconBack,
    headerContent: headerContent,
    title: title,
    subTitle: subTitle,
    headerActions: headerActions,
    onClickBack: handleClickBack
  }), React.createElement("div", {
    className: PreviewContainer,
    onClick: handleToggleContent
  }, (loading || noImage || noVideo) && React.createElement("div", {
    className: EdgeStateWrapper
  }, handleEdgeState()), React.createElement(LightboxSlider, {
    activeIndex: activeIndex,
    onNext: onNext,
    onPrev: onPrev,
    onSlideChange: handleActiveIndexChange
  }, items.map(function (item, index) {
    var alt = item.alt,
        autoPlay = item.autoPlay,
        url = item.url,
        onPlay = item.onPlay,
        otherProps = _objectWithoutProperties(item, _excluded2);

    if (item.type === 'image') {
      return React.createElement("img", _extends({
        key: index,
        src: url,
        alt: alt,
        loading: "lazy"
      }, dataTest !== null && dataTest !== void 0 && dataTest.itemSlider ? {
        'data-testid': (dataTest === null || dataTest === void 0 ? void 0 : dataTest.itemSlider) + index
      } : {}, {
        onTouchStart: handleTouchStart,
        onTouchMove: handleTouchMove,
        onTouchEnd: handleTouchEnd,
        style: {
          transform: activeIndex === index && isScaled ? "translate3d(".concat(deltaX, "px, ").concat(deltaY, "px, 0) scale(").concat(scaleValue, ")") : null
        }
      }));
    } else if (item.type === 'video') {
      var _videoPlayerRef$curre79, _videoPlayerRef$curre80;

      return item.url.includes('.m3u8') ? React.createElement(ReactHlsPlayer, _extends({
        key: index,
        muted: videoMuted || item.muted,
        playerRef: videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre79 = videoPlayerRef.current) === null || _videoPlayerRef$curre79 === void 0 ? void 0 : _videoPlayerRef$curre79[index],
        playsInline: true,
        src: url,
        onEnded: handleVideoEnded || item.onEnded,
        onPause: handleVideoPause || item.onPause,
        onPlay: handleVideoPlay,
        onPlaying: handleVideoPlaying,
        onTimeUpdate: handleVideoTimeUpdate
      }, dataTest !== null && dataTest !== void 0 && dataTest.itemSlider ? {
        'data-testid': (dataTest === null || dataTest === void 0 ? void 0 : dataTest.itemSlider) + index
      } : {}, otherProps)) : React.createElement("video", _extends({
        key: index,
        muted: videoMuted || item.muted,
        playsInline: true,
        ref: videoPlayerRef === null || videoPlayerRef === void 0 ? void 0 : (_videoPlayerRef$curre80 = videoPlayerRef.current) === null || _videoPlayerRef$curre80 === void 0 ? void 0 : _videoPlayerRef$curre80[index],
        src: url,
        onEnded: handleVideoEnded || item.onEnded,
        onPause: handleVideoPause || item.onPause,
        onPlay: handleVideoPlay,
        onPlaying: handleVideoPlaying,
        onTimeUpdate: handleVideoTimeUpdate
      }, dataTest !== null && dataTest !== void 0 && dataTest.itemSlider ? {
        'data-testid': (dataTest === null || dataTest === void 0 ? void 0 : dataTest.itemSlider) + index
      } : {}, otherProps));
    }
  })), overlayContent && overlayContent), React.createElement("div", {
    className: "".concat(ContentContainer, " ").concat(!toggleContent ? 'unf-lightbox__content--hidden' : null)
  }, withCounter && React.createElement("div", {
    className: Counter,
    "data-testid": dataTest === null || dataTest === void 0 ? void 0 : dataTest.textCounter
  }, initialItems, "/", totalItems ? totalItems : totalItemsAuto), renderCustomControlsVideo(), withThumbnail ? renderThumbnails() : renderCustomContent()))));
};

Lightbox.defaultProps = {
  activeIndex: 0,
  dataTest: {},
  display: false,
  items: [],
  loading: false,
  noImage: false,
  noVideo: false
};
export default Lightbox;