import { css } from 'react-emotion';
import { NN0, NN600, GN300, NN1000 } from 'unify-token/colors';
import { durationT3, easeInOut } from 'unify-token/build/v2/motions';
import { spacingLv2, spacingLv4 } from 'unify-token/build/v2/spacings';
import { fontSizeLv2 } from 'unify-token/build/v2/typographies';
export var EdgeStateWrapper = css("label:unf-lightbox__edge-state-wrapper;height:100vh;width:100%;background-color:", NN600, ";display:flex;flex-direction:column;align-items:center;justify-content:center;position:absolute;z-index:1;");
export var PreviewContainer = css("label:unf-lightbox__preview-container;display:flex;align-items:center;height:100vh;");
export var ContentContainer = css("label:unf-lightbox__content-container;position:fixed;right:0;bottom:0;left:0;z-index:2;transition:transform ", durationT3, " ", easeInOut, ";&.unf-lightbox__content--hidden{transform:translateY(100%);}");
export var Counter = css("label:unf-lightbox__counter;display:flex;align-items:center;justify-content:center;height:35px;width:55px;background-color:rgba(0,0,0,0.8);border-radius:0 4px 0 0;color:", NN0, ";font-size:", fontSizeLv2, ";");
export var VideoControlsWrapper = css("label:unf-lightbox__video-controls-wrapper;padding:", spacingLv4, " 12px 0;background-color:rgba(0,0,0,0.8);display:flex;justify-content:space-between;align-items:center;.unf-lightbox__video-controls--timeline{-webkit-appearance:none;border-radius:999px;flex-grow:1;height:2px;margin:0 16px;width:100%;&::-webkit-slider-thumb{-webkit-appearance:none;background-color:", NN0, ";border-radius:999px;height:14px;width:14px;}}.unf-lightbox__video-controls--group{display:flex;align-items:center;}.unf-lightbox__video-controls--time{min-width:75px;text-align:center;}.unf-lightbox__video-controls--volume{margin:0 16px;}");
export var ThumbnailsWrapper = css("label:unf-lightbox__thumbnails-wrapper;padding:", spacingLv4, " 12px;background-color:rgba(0,0,0,0.8);display:flex;overflow-x:auto;& .unf-lightbox__thumbnail{height:60px;width:60px;margin:0 ", spacingLv2, ";border:2px solid transparent;border-radius:4px;object-fit:cover;transition:border ", durationT3, " ", easeInOut, ";flex:0 0 60px;&.active{border:2px solid ", GN300, ";}}& .unf-lightbox__video{&-wrapper{position:relative;}&--icon{display:flex;align-items:center;justify-content:center;height:24px;width:24px;background-color:rgba(0,0,0,0.8);border-radius:999px;position:absolute;top:50%;left:50%;transform:translate(-50%,-50%);}}");
export var ContentWrapper = css("label:unf-lightbox__content-wrapper;padding:12px ", spacingLv4, " ", spacingLv4, ";background-color:rgba(0,0,0,0.8);max-height:200px;overflow:auto;.active{display:block;}.hidden{display:none;}");
export var Container = css("label:unf-lightbox__container;position:fixed;top:0;left:0;height:100vh;width:100%;background-color:", NN1000, ";display:flex;flex-direction:column;justify-content:center;overflow:hidden;color:white;z-index:10;.unf-navbar-container{position:absolute;top:0;right:0;left:0;.unf-navbar{background-color:rgba(0,0,0,0.8);transition:transform ", durationT3, " ", easeInOut, ";&--hidden{transform:translateY(-100%);}}}");