import React from 'react';
export interface LinkProps {
    /**
     * To set content
     */
    children?: React.ReactNode;
    /**
     * To pass custom className
     */
    className?: string;
    /**
     * To set font size
     */
    fontSize?: number;
    /**
     * To apply 'large' design
     */
    large?: boolean;
    /**
     * To set custom ref on Link
     */
    setRef?: React.MutableRefObject<HTMLAnchorElement> | React.Ref<any>;
    /**
     * To apply 'small' design
     */
    small?: boolean;
    /**
     * To pass callback when Link is clicked
     */
    onClick?: string | ((e: React.MouseEvent<HTMLAnchorElement>) => void);
}
declare const Link: {
    (props: LinkProps): JSX.Element;
    propTypes: {
        children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        className: import("prop-types").Requireable<string>;
        fontSize: import("prop-types").Requireable<number>;
        large: import("prop-types").Requireable<boolean>;
        setRef: import("prop-types").Requireable<(...args: any[]) => any>;
        small: import("prop-types").Requireable<boolean>;
        onClick: import("prop-types").Requireable<string | ((...args: any[]) => any)>;
    };
    defaultProps: {
        fontSize: number;
    };
};
export default Link;
