import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "items", "noMargin", "subheader", "template"];
import React, { useEffect } from 'react';
import { cx } from 'emotion';
import { ChevronRight, CheckBig } from 'unify-icons/system';
import { NN300, NN400, NN600, NN950, GN200, GN500, NN900 } from 'unify-token/colors';
import Typography from "../../build/Typography";
import Checkbox from "../../build/Checkbox";
import Toggle from "../../build/Toggle";
import Radio from "../../build/Radio";
import { unf_list } from "./style";

var List = function List(_ref) {
  var _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      _ref$noMargin = _ref.noMargin,
      noMargin = _ref$noMargin === void 0 ? false : _ref$noMargin,
      subheader = _ref.subheader,
      _ref$template = _ref.template,
      Template = _ref$template === void 0 ? undefined : _ref$template,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var ListDescription = [];
  var classes = cx(unf_list, {
    'unf-list--no-margin': noMargin
  }, className);

  var handleMultiline = function handleMultiline() {
    var el = ListDescription;

    for (var x = 0; x < el.length; x++) {
      if (el[Number(x)] !== undefined && el[Number(x)] !== null) {
        var wordArray = el[Number(x)].innerHTML.split(' ');

        while (el[Number(x)].scrollHeight > 44 || wordArray.length === 0) {
          wordArray.pop();
          el[Number(x)].innerHTML = "".concat(wordArray.join(' '), "...");
        }
      }
    }
  };

  useEffect(function () {
    handleMultiline();
  });

  var handleClick = function handleClick(e, item) {
    e.preventDefault();
    item.onClick && item.onClick(e, item);
  };

  var handleActionPlacement = function handleActionPlacement(actionPlacement, indexList) {
    if (!actionPlacement || actionPlacement === 'left' || 'right') {
      return items.map(function (item, index) {
        return React.createElement(React.Fragment, null, item.actionType === 'checkbox' && indexList === index ? React.createElement(Checkbox, _extends({
          checked: item.checked,
          disabled: item.disabled
        }, item.actionProps)) : item.actionType === 'radio' && indexList === index ? React.createElement(Radio, _extends({
          checked: item.checked,
          disabled: item.disabled
        }, item.actionProps)) : item.actionType === 'toggle' && indexList === index ? React.createElement(Toggle, _extends({
          checked: item.checked,
          disabled: item.disabled
        }, item.actionProps)) : !item.checked && indexList === index && item.actionText);
      });
    }

    return null;
  };

  return React.createElement("ul", _extends({
    className: classes,
    "data-unify": "List"
  }, otherProps), subheader && React.createElement("li", {
    className: "unf-list__subheader"
  }, subheader), items.map(function (item, index) {
    var TemplateItem = item.template;
    var TemplateTemp = Template;
    var itemClasses = cx('unf-list__item', {
      'unf-list__item--image': !Template && !TemplateItem && item.icon,
      'unf-list__item--image-large': !Template && !TemplateItem && item.largeIcon,
      'unf-list__item--no-border': item.noBorder
    });
    return TemplateItem ? React.createElement("li", _extends({
      className: itemClasses,
      key: item.key || index
    }, item), React.createElement(TemplateItem, item)) : Template ? React.createElement("li", _extends({
      className: itemClasses,
      key: item.key || index
    }, item), React.createElement(TemplateTemp, item)) : React.createElement("li", _extends({
      className: itemClasses,
      key: item.key || index
    }, item, {
      style: {
        backgroundImage: item.icon && "url(\"".concat(item.icon, "\")"),
        backgroundSize: item.iconSize
      },
      onClick: function onClick(e) {
        return handleClick(e, item);
      },
      onKeyDown: function onKeyDown(e) {
        return handleClick(e, item);
      }
    }), item.actionType && item.actionPlacement === 'left' && React.createElement("div", {
      className: "unf-list__item-action",
      style: {
        color: item.disabled && NN400,
        cursor: item.disabled && 'not-allowed'
      }
    }, handleActionPlacement(item.actionPlacement, index)), React.createElement("div", {
      className: "unf-list__item-container",
      style: {
        paddingLeft: item.textIndent ? item.textIndent : item.largeIcon ? '64px' : item.icon ? '40px' : item.actionPlacement === 'left' ? '8px' : '0',
        paddingRight: item.actionText || item.arrow ? '8px' : item.actionPlacement === 'left' ? '0' : '8px'
      }
    }, item.text && React.createElement(Typography, {
      className: "unf-list__item-text",
      body: "display-2",
      bold: true,
      color: item.disabled ? NN400 : NN950,
      margin: item.description ? '0' : '8px 0'
    }, item.text), item.description && React.createElement(Typography, {
      setRef: function setRef(node) {
        return ListDescription[index] = node;
      },
      className: "unf-list__item-description",
      body: "paragraph-3",
      color: item.disabled ? NN400 : NN600,
      margin: "2px 0 0 0"
    }, item.description)), (item.actionText || item.arrow || (item.actionType || item.checked) && (!item.actionPlacement || item.actionPlacement === 'right')) && React.createElement("div", _extends({
      className: "unf-list__item-action",
      style: {
        color: item.disabled && NN400,
        cursor: item.disabled && 'not-allowed'
      }
    }, item.actionProps), item.actionPlacement !== 'left' && handleActionPlacement(item.actionPlacement, index), !item.actionType && !item.actionText && item.checked && React.createElement(CheckBig, {
      color: item.disabled ? GN200 : GN500
    }), item.arrow && React.createElement(ChevronRight, {
      color: item.disabled ? NN300 : NN900
    })));
  }));
};

export default List;