import React from 'react';
export interface ListProps extends React.ComponentProps<'ul'> {
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To determine List item
     */
    items?: ListItemsProps[];
    /**
     * To apply zero margin on List
     */
    noMargin?: boolean;
    /**
     * To specify text on List
     */
    subheader?: React.ReactNode;
    /**
     * To apply custom template for all items in list
     */
    template?: (() => void) | React.ReactNode;
}
export interface ItemsProps {
    actionPlacement?: string;
    actionText?: string;
    actionType?: string;
    actionProps?: Record<string, any>;
    arrow?: boolean;
    checked?: boolean;
    description?: string;
    disabled?: boolean;
    icon?: string;
    iconSize?: number;
    key?: number;
    largeIcon?: string;
    noBorder?: boolean;
    template?: (() => void) | React.ReactNode;
    text?: React.ReactNode;
    textIndent?: string;
}
export interface ListItemsProps extends ItemsProps {
    onClick?: (e: React.MouseEvent<HTMLLIElement> | React.KeyboardEvent<HTMLLIElement>, item: ItemsProps) => void;
}
