import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "title", "loading", "onClick"];
import React from 'react';
import { NN600, NN900, NN950, YN200 } from 'unify-token/colors';
import Reload from 'unify-icons/system/Reload';
import Typography from "../../build/Typography";
import Card from "../../build/Card";
import LoadingCircle from "../../build/Providers/common/components/LoadingCircle";
import il_wave from "../../build/Providers/assets/il_section_waves.svg";
import { useDarkMode } from "../../build/Card/_utils";
import { noop } from "../../build/Providers/common/functions/noop";
import Background from "./assets/Background";
import { Wrapper, IconWrapper, BackgroundStyle } from "./style";

var LocalLoad = function LocalLoad(_ref) {
  var _ref$children = _ref.children,
      children = _ref$children === void 0 ? '' : _ref$children,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var isDarkMode = useDarkMode();
  var customStyle = {
    backgroundImage: "url(".concat(il_wave, ")"),
    backgroundPosition: 'right top',
    backgroundRepeat: 'no-repeat',
    backgroundSize: 'auto',
    border: '0',
    padding: '12px 16px'
  };

  var handleClick = function handleClick(e) {
    onClick && onClick(e);
  };

  return React.createElement(Card, _extends({
    style: customStyle,
    "data-unify": "LocalLoad"
  }, otherProps), React.createElement(Background, {
    className: BackgroundStyle,
    color: YN200
  }), React.createElement(Wrapper, null, React.createElement("div", null, React.createElement(Typography, {
    body: "paragraph-2",
    bold: true,
    color: NN950,
    main: true,
    margin: "0 0 4px 0"
  }, title), React.createElement(Typography, {
    caption: true,
    color: NN600,
    margin: "0"
  }, children)), React.createElement(IconWrapper, {
    "aria-label": loading ? 'Loading' : 'Reload',
    isDarkMode: isDarkMode,
    loading: loading,
    type: "button",
    onClick: handleClick
  }, React.createElement(Reload, {
    color: NN900,
    size: 24
  }), React.createElement(LoadingCircle, {
    color: NN900,
    display: loading
  }))));
};

export default LocalLoad;