import React from 'react';
declare type LocalLoadAttributes = React.ComponentPropsWithoutRef<'section'>;
export interface LocalLoadProps extends Omit<LocalLoadAttributes, 'onClick' | 'css'> {
    /**
     * To determine loading state of LocalLoad
     * @default false
     */
    loading?: boolean;
    /**
     * To specify title text
     * @default ""
     */
    title?: string;
    /**
     * To pass callback when icon reload is clicked
     * @default () => {}
     */
    onClick?: (e: React.MouseEvent<HTMLButtonElement>) => void;
}
export {};
