import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["title", "activeTheme", "defaultTheme", "eventKey", "isShrinked", "className", "onClick", "isActive"];
import React, { useRef } from 'react';
import { cx } from 'react-emotion';
import { NN100 } from 'unify-token/colors';
import { easeOut } from 'unify-token/build/v2/motions';
import Typography from "../../build/Typography";
import Ripple from "../../build/Providers/common/components/Ripple";
import { _tabPaneItem } from "./styles";

var TabPaneItem = function TabPaneItem(props) {
  var title = props.title,
      _props$activeTheme = props.activeTheme,
      activeTheme = _props$activeTheme === void 0 ? 'green' : _props$activeTheme,
      defaultTheme = props.defaultTheme,
      eventKey = props.eventKey,
      _props$isShrinked = props.isShrinked,
      isShrinked = _props$isShrinked === void 0 ? false : _props$isShrinked,
      className = props.className,
      onClick = props.onClick,
      _props$isActive = props.isActive,
      isActive = _props$isActive === void 0 ? false : _props$isActive,
      otherProps = _objectWithoutProperties(props, _excluded);

  var itemRef = useRef(null);
  var rippleRef = useRef(null);

  var handleClick = function handleClick(e) {
    onClick && onClick(e, eventKey);
  };

  var handleRippleClick = function handleRippleClick(e) {
    rippleRef.current && rippleRef.current.trigger(e);
  };

  return React.createElement("button", _extends({}, otherProps, {
    "aria-selected": isActive ? true : false,
    role: "tab",
    tabIndex: isActive ? 1 : -1,
    "data-key": "megaTab__pane__item-".concat(eventKey),
    ref: itemRef,
    onClick: handleClick,
    onMouseDown: handleRippleClick,
    className: cx('megaTab__pane__item', _tabPaneItem(defaultTheme, activeTheme, isShrinked), isActive ? 'megaTab__pane__item--active' : '', className)
  }), React.createElement(Ripple, {
    ref: rippleRef,
    color: NN100,
    duration: 120,
    easing: easeOut
  }), React.createElement(Typography, {
    body: "paragraph-3",
    bold: true,
    className: "megaTab__pane__item__title"
  }, title));
};

export default TabPaneItem;