/// <reference types="react" />
export interface MegaTabThemeObject {
    backgroundImage?: string;
    fontColor?: string;
    backgroundColor?: Array<string>;
}
export interface MegaTabProps {
    /**
     * Specify which TabItem is active
     */
    activeIndex?: number;
    /**
     * To set TabContent inside MegaTab
     */
    children?: React.ReactNode | React.ReactNode[];
    /**
     * Specify custom MegaTab className
     */
    className?: string;
    /**
     * Specify MegaTab items
     */
    items?: [];
    /**
     * Specify Top position of MegaTab
     */
    top?: number;
    /**
     * Specify zIndex value
     */
    zIndex?: number;
    /**
     * callback when the TabItem is clicked
     */
    onChange?: (e: React.MouseEvent<HTMLButtonElement>, index: number) => void;
}
export interface TabPaneItemProps {
    /**
     * Specify background when this TabItem is active
     */
    activeTheme?: string | MegaTabThemeObject;
    /**
     * Specify custom className of TabItem
     */
    className?: string;
    /**
     * Specify default background of TabItem
     */
    defaultTheme?: MegaTabThemeObject;
    /**
     * Specify unique identifier of TabItem to make it distinguishable from others TabItems
     */
    eventKey?: number;
    isActive?: boolean;
    isShrinked?: boolean;
    /**
     * Specify a Title of the TabItem
     */
    title?: string;
    /**
     * Callback when TabItem is clicked
     */
    onClick?: (e: React.MouseEvent<HTMLButtonElement>, eventKey?: number) => void;
}
