import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["actionText", "children", "className", "items", "onAction"];
import React from 'react';
import List from "../../build/List";
import wrapper from "../../build/Providers/common/HOC/withMobileOverlay";
import Container from "./style";

var Menu = function Menu(_ref) {
  var _ref$actionText = _ref.actionText,
      actionText = _ref$actionText === void 0 ? '' : _ref$actionText,
      children = _ref.children,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      onAction = _ref.onAction,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  return React.createElement(Container, _extends({
    actionText: actionText,
    role: "dialog",
    "aria-modal": "true",
    className: className,
    "data-unify": "Menu"
  }, otherProps), children, React.createElement(List, {
    noMargin: true,
    items: items
  }), typeof onAction === 'function' && React.createElement("button", {
    className: "unf-menu__action",
    onClick: onAction
  }, actionText));
};

var wrapperElement = wrapper(Menu, 'menu');
export default wrapperElement;