import React from 'react';
declare type BaseAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface MenuProps extends Omit<BaseAttributes, 'css'> {
    /**
     * To apply call to action text on Menu
     */
    actionText?: string;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To toggle visibility of Menu
     */
    display?: boolean;
    /**
     * To determine Menu item
     */
    items?: Array<React.ReactNode> | ItemsProps[];
    /**
     * To pass callback function on call to action text
     */
    onAction?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when Menu is closed
     */
    onClose?: (e: React.MouseEvent<HTMLDivElement>) => void;
}
export interface ItemsProps {
    checked?: boolean;
    icon?: string;
    key?: number;
    text?: string;
    onClick?: (e: React.MouseEvent<HTMLLIElement> | React.KeyboardEvent<HTMLLIElement>, item: object) => void;
}
export {};
