import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React from 'react';
import PortalWrapper from "../../build/Providers/common/components/PortalWrapper";
import Delayed from "../../build/Providers/common/components/Delayed";
import Overlay from "../../build/Overlay";
import { Container, Title, MenuButton, MenuContainer, CloseButton, MenuList, MenuItem } from "./style";

var MicroHeader = function (_React$PureComponent) {
  _inherits(MicroHeader, _React$PureComponent);

  var _super = _createSuper(MicroHeader);

  function MicroHeader() {
    var _this;

    _classCallCheck(this, MicroHeader);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isMenuOpen: false
    });

    _defineProperty(_assertThisInitialized(_this), "menuButtonToggle", function () {
      _this.setState(function (prevState) {
        return {
          isMenuOpen: !prevState.isMenuOpen
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeMenu", function () {
      _this.menuContainer.classList.add('unf_menu--close');

      setTimeout(function () {
        _this.setState({
          isMenuOpen: false
        });

        if (_this.props.onClose) {
          _this.onClose();
        }
      }, 500, _assertThisInitialized(_this));
    });

    _defineProperty(_assertThisInitialized(_this), "getMenuContainer", function (node) {
      _this.menuContainer = node;
    });

    _defineProperty(_assertThisInitialized(_this), "getMenuElement", function (menuList) {
      return menuList.map(function (menu, index) {
        var onClickProps = menu.onClick;
        return React.createElement("a", {
          href: menu.link,
          key: index.toString(),
          onClick: onClickProps ? onClickProps : null
        }, React.createElement(MenuItem, null, menu.text));
      });
    });

    return _this;
  }

  _createClass(MicroHeader, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          title = _this$props.title,
          menuList = _this$props.menuList,
          topPosition = _this$props.topPosition;
      var isMenuOpen = this.state.isMenuOpen;
      var menuButtonToggle = this.menuButtonToggle,
          getTopPosition = this.getTopPosition,
          container = this.container,
          closeMenu = this.closeMenu,
          getContainer = this.getContainer,
          getMenuContainer = this.getMenuContainer,
          getMenuElement = this.getMenuElement;
      return React.createElement(Container, {
        top: topPosition,
        "data-unify": "MicroHeader"
      }, React.createElement(Title, null, React.createElement("a", {
        href: title.link
      }, title.text)), menuList && React.createElement(MenuButton, {
        onClick: menuButtonToggle
      }, "Menu"), React.createElement(PortalWrapper, null, React.createElement(Delayed, {
        mounted: isMenuOpen
      }, React.createElement(Overlay, {
        onClick: closeMenu,
        display: isMenuOpen,
        style: {
          top: "".concat(topPosition, "px")
        }
      }), React.createElement(MenuContainer, {
        top: topPosition,
        innerRef: getMenuContainer
      }, React.createElement(CloseButton, {
        onClick: closeMenu
      }, "\u2715"), menuList && React.createElement(MenuList, null, getMenuElement(menuList))))));
    }
  }]);

  return MicroHeader;
}(React.PureComponent);

MicroHeader.defaultProps = {
  menuList: null,
  onClick: function onClick() {},
  onOpen: function onOpen() {},
  topPosition: 56
};
export default MicroHeader;