import styled, { css } from 'react-emotion';
import { NN200, GN500, NN950, NN0, NN600 } from 'unify-token/colors';
import { fontSizeLv4, fontSizeLv2, lineHeightLv4, lineHeightLv2, fontWeightBold, fontWeightRegular } from 'unify-token/build/v2/typographies';
import ic_burger from "../../build/Providers/assets/ic_burger.svg";
import ic_burger_white from "../../build/Providers/assets/ic_burger_white.svg";
import ic_arrow_down from "../../build/Providers/assets/ic_system_arrow_down.svg";
import { focusStyle, colorWhiteAlways } from "../../build/Providers/common/style";
var height = 52;
var _ref2 = "width:100%;top:0;right:0;left:0;";

var handleWrapper = function handleWrapper(_ref) {
  var transparent = _ref.transparent,
      fixed = _ref.fixed;
  return transparent || fixed ? css(_ref2) : '';
};

var handleWrapperPosition = function handleWrapperPosition(_ref3) {
  var transparent = _ref3.transparent,
      fixed = _ref3.fixed;

  switch (true) {
    case transparent || fixed:
      return 'fixed';

    default:
      return 'relative';
  }
};

var handleSpacerHeight = function handleSpacerHeight(_ref4) {
  var transparent = _ref4.transparent,
      fixed = _ref4.fixed;

  switch (true) {
    case transparent:
      return '0';

    case fixed:
      return '52px';

    default:
      return '0';
  }
};

var handleBoxShadow = function handleBoxShadow(_ref5) {
  var transparent = _ref5.transparent,
      shadow = _ref5.shadow,
      noShadow = _ref5.noShadow;
  return transparent || noShadow || !shadow ? 'initial' : '0 1px 3px 0 rgba(0, 0, 0, 0.15)';
};

var _ref6 = "font-size:";
var _ref7 = ";line-height:";
var _ref8 = ";white-space:nowrap;overflow:hidden;text-overflow:ellipsis;";

var mixinTitle = function mixinTitle(size, lineHeight) {
  return css(_ref6, size, _ref7, lineHeight, _ref8);
};

export var Container = styled("nav", {
  target: "eylmlox0"
})("label:unf-navbar-container;height:", function (_ref9) {
  var transparent = _ref9.transparent;
  return !transparent ? '52px' : '';
}, ";position:", function (_ref10) {
  var transparent = _ref10.transparent;
  return !transparent ? 'relative' : '';
}, ";.unf-navbar__back{display:flex;justify-content:center;align-items:center;width:52px;height:52px;background-color:transparent;-webkit-appearance:none;border:none;&:focus{outline:1px dashed ", NN200, ";}}");
export var Wrapper = styled('div', {
  target: "eylmlox1"
})(handleWrapper, ";position:", handleWrapperPosition, ";z-index:40;");
export var ContentWrapper = styled("div", {
  target: "eylmlox2"
})("width:100%;height:", height, "px;color:", function (_ref11) {
  var transparent = _ref11.transparent;
  return transparent ? colorWhiteAlways : NN950;
}, ";transition:background-color 0.24s ease;background-color:", function (_ref12) {
  var transparent = _ref12.transparent;
  return transparent ? 'transparent' : NN0;
}, ";display:flex;align-items:center;position:relative;z-index:1;box-shadow:", handleBoxShadow, ";", function (_ref13) {
  var transparent = _ref13.transparent,
      main = _ref13.main;
  return transparent && !main && 'background-image: -o-linear-gradient(bottom, transparent, rgba(0, 0, 0, 0.2), rgba(0, 0, 0, 0.35))';
}, ";", function (_ref14) {
  var transparent = _ref14.transparent,
      main = _ref14.main;
  return transparent && !main && 'background-image: -webkit-linear-gradient(bottom, transparent, rgba(0, 0, 0, 0.2), rgba(0, 0, 0, 0.35))';
}, ";", function (_ref15) {
  var transparent = _ref15.transparent,
      main = _ref15.main;
  return transparent && !main && 'background-image: -webkit-gradient(linear, left bottom, left top, from(transparent), color-stop(rgba(0, 0, 0, 0.2)), to(rgba(0, 0, 0, 0.35)))';
}, ";", function (_ref16) {
  var transparent = _ref16.transparent,
      main = _ref16.main;
  return transparent && !main && 'background-image: linear-gradient(0deg, transparent, rgba(0, 0, 0, 0.2), rgba(0, 0, 0, 0.35))';
}, ";", function (_ref17) {
  var transparent = _ref17.transparent,
      main = _ref17.main;
  return transparent && main && 'background-color: transparent';
}, ";");
export var Content = styled("div", {
  target: "eylmlox3"
})("min-width:0;flex:1;padding-right:", function (_ref18) {
  var title = _ref18.title;
  return title ? '8px' : '0px';
}, ";", focusStyle, ";&:last-child{padding-right:16px;}");
export var Heading = styled("div", {
  target: "eylmlox4"
})(".unf-navbar__title--selectable{display:initial;padding-right:16px;outline:none;border:0;background:url('", ic_arrow_down, "') no-repeat;background-position:right center;", function (_ref19) {
  var transparent = _ref19.transparent;
  return transparent && 'filter: brightness(0) invert(1);';
}, " ", function (_ref20) {
  var transparent = _ref20.transparent;
  return transparent && "color: ".concat(colorWhiteAlways);
}, "}.unf-navbar__title--heading{", mixinTitle(fontSizeLv4, lineHeightLv4), ";font-weight:", fontWeightBold, ";margin:0;padding-left:", function (_ref21) {
  var withPadding = _ref21.withPadding;
  return withPadding ? 16 : 0;
}, "px;color:", function (_ref22) {
  var transparent = _ref22.transparent;
  return transparent ? colorWhiteAlways : NN950;
}, ";}");
export var Subtitle = styled("span", {
  target: "eylmlox5"
})(mixinTitle(fontSizeLv2, lineHeightLv2), ";font-weight:", fontWeightRegular, ";color:", function (_ref23) {
  var transparent = _ref23.transparent;
  return transparent ? colorWhiteAlways : NN600;
}, ";display:block;padding-left:", function (_ref24) {
  var withPadding = _ref24.withPadding;
  return withPadding ? 16 : 0;
}, "px;");
export var Action = styled("div", {
  target: "eylmlox6"
})("max-height:100%;color:", function (_ref25) {
  var transparent = _ref25.transparent;
  return transparent ? colorWhiteAlways : NN950;
}, ";display:flex;align-items:center;justify-content:center;overflow:hidden;padding:4px 8px;");
export var Burger = styled("button", {
  target: "eylmlox7"
})("position:relative;width:48px;height:100%;border:0;outline:none;background-color:transparent;&::before{content:'';background-color:transparent;background-repeat:no-repeat;background-position:center center;background-size:24px;background-image:url('", function (_ref26) {
  var transparent = _ref26.transparent;
  return transparent ? ic_burger_white : ic_burger;
}, "');position:absolute;top:0;right:0;bottom:0;left:0;margin:auto;}");
export var Stepper = styled("div", {
  target: "eylmlox8"
})("width:100%;height:3px;background-color:transparent;position:absolute;bottom:0;z-index:30;&::before{content:'';display:block;height:inherit;background-color:", GN500, ";transition:transform 0.28s ease;transform-origin:left;transform:scaleX(", function (_ref27) {
  var _ref27$numberOfStep = _ref27.numberOfStep,
      numberOfStep = _ref27$numberOfStep === void 0 ? 0 : _ref27$numberOfStep,
      _ref27$step = _ref27.step,
      step = _ref27$step === void 0 ? 0 : _ref27$step;
  return Number(step) / numberOfStep;
}, ");}");
export var Spacer = styled('div', {
  target: "eylmlox9"
})("height:", handleSpacerHeight, ";");
export var TitleWrapper = css("display:flex;flex:1;cursor:pointer;user-select:none;");