import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "lang", "new", "promo"];
import React, { Fragment } from 'react';
import Container from "./style";

var Notification = function Notification(_ref) {
  var children = _ref.children,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'id' : _ref$lang,
      newVariant = _ref["new"],
      promo = _ref.promo,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var content = children;
  var type = 'dot';

  if (promo) {
    content = 'PROMO';
  } else if (newVariant) {
    content = lang === 'id' ? 'BARU' : 'NEW';
  }

  if (content) {
    if (Number(content)) {
      type = 'counter';
      content = Number(content) > 99 ? '99+' : content;
    } else {
      type = 'text';
    }
  }

  return React.createElement(Fragment, null, React.createElement(Container, _extends({
    type: type,
    lang: lang,
    over: !!content,
    "data-unify": "Notification"
  }, otherProps), content));
};

export default Notification;