import styled, { keyframes } from 'react-emotion';
import { GN500, RN600 } from 'unify-token/colors';
import { fontSizeLv1 } from 'unify-token/build/v2/typographies';
import { durationT3, easeOvershoot } from 'unify-token/build/v2/motions';
import { colorWhiteAlways } from "../../build/Providers/common/style";

var handleStyle = function handleStyle(_ref) {
  var type = _ref.type;

  switch (type) {
    case 'dot':
      return "border-radius: 50%; height: 8px; width: 8px;";

    case 'counter':
      return "border-radius: 6px; height: 16px; line-height: 16px; font-size: ".concat(fontSizeLv1, "; padding: 0 4px;");

    default:
      return "border-radius: 3px; height: 10px; line-height: 10px; font-size: 7px; padding: 0 4px;";
  }
};

var scaleAnimation = keyframes("0%{opacity:0;transform:scale(0);}60%{opacity:0;transform:scale(0);}100%{opacity:1;transform:scale(1);}");
export default styled("div", {
  target: "e791j4q0"
})("label:unf-notification;display:inline-block;font-weight:bold;text-transform:uppercase;text-align:center;color:", colorWhiteAlways, ";background:", function (_ref2) {
  var secondary = _ref2.secondary;
  return secondary ? GN500 : RN600;
}, ";animation:", scaleAnimation, " ", durationT3, " ", easeOvershoot, ";", handleStyle, ";");