import React from 'react';
export interface SingleInputProps {
    darkMode?: boolean;
    disabled?: boolean;
    error?: boolean;
    focus?: boolean;
    numberOnly?: boolean;
    pinMode?: boolean;
    placeholder?: string;
    type?: string;
    value?: string;
    onBlur?: (e: React.FocusEvent<HTMLInputElement>) => void;
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onFocus?: (e: React.FocusEvent<HTMLInputElement>) => void;
    onInput?: (e: React.FormEvent<HTMLInputElement>) => void;
    onKeyDown?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onPaste?: (e: React.ClipboardEvent<HTMLInputElement>) => void;
}
export interface OTPFieldProps {
    /**
     * To apply Dark Theme
     */
    darkMode?: boolean;
    /**
     * To disable Pin input
     */
    disabled?: boolean;
    /**
     * To apply error state
     */
    error?: boolean;
    /**
     * To specify input length
     */
    length?: number;
    /**
     * To allow Number input only
     */
    numberOnly?: boolean;
    /**
     * To apply input type password
     */
    pinMode?: boolean;
    /**
     * Autofocus input on initial render
     */
    shouldAutoFocus?: boolean;
    /**
     * The value that pass into the Pin component
     */
    value?: string;
    /**
     * Action when value changed
     */
    onChange?: (val: string, e: React.ChangeEvent<HTMLDivElement>) => void;
}
declare const OTPField: {
    (props: OTPFieldProps): JSX.Element;
    propTypes: {
        darkMode: import("prop-types").Requireable<boolean>;
        disabled: import("prop-types").Requireable<boolean>;
        error: import("prop-types").Requireable<boolean>;
        length: import("prop-types").Requireable<number>;
        numberOnly: import("prop-types").Requireable<boolean>;
        pinMode: import("prop-types").Requireable<boolean>;
        shouldAutoFocus: import("prop-types").Requireable<boolean>;
        value: import("prop-types").Requireable<string>;
        onChange: import("prop-types").Requireable<(...args: any[]) => any>;
        onClear: import("prop-types").Requireable<(...args: any[]) => any>;
    };
    defaultProps: {
        value: string;
    };
};
export default OTPField;
