import React from 'react';
export interface OverlayProps {
    /**
     * To toggle visibility on Overlay
     */
    display?: boolean;
    /**
     * To set custom ref on overlay
     */
    setRef?: React.MutableRefObject<HTMLDivElement> | React.Ref<any>;
    /**
     * To inform this component the type of wrapped children to override default css transition value
     */
    childrenType?: string;
    /**
     * To pass callback when overlay is clicked
     */
    onClick?: (e: React.MouseEvent<HTMLDivElement>) => void;
}
declare const Overlay: {
    (props: OverlayProps): JSX.Element;
    propTypes: {
        display: import("prop-types").Requireable<boolean>;
        setRef: import("prop-types").Requireable<(...args: any[]) => any>;
        transition: import("prop-types").Requireable<string>;
        onClick: import("prop-types").Requireable<(...args: any[]) => any>;
    };
    defaultProps: {
        display: boolean;
        onClick: () => void;
    };
};
export default Overlay;
