import _extends from "@babel/runtime/helpers/extends";
import _typeof from "@babel/runtime/helpers/typeof";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["display", "setRef", "childrenType", "onClick"];
import React, { useEffect } from 'react';
import { cx } from 'emotion';
import { NN1000L } from 'unify-token/colors';
import Container from "./style";

var Overlay = function Overlay(props) {
  var display = props.display,
      setRef = props.setRef,
      childrenType = props.childrenType,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded);

  var overlayClass = cx('unf-overlay', {
    'unf-overlay--show': display
  });
  useEffect(function () {
    if ((typeof document === "undefined" ? "undefined" : _typeof(document)) === 'object') {
      var hasDarkColor = getComputedStyle(document.documentElement).getPropertyValue('--NN0') !== '';

      if (hasDarkColor) {
        document.documentElement.style.setProperty('--color-overlay-dark', NN1000L);
      }
    }
  }, []);
  return React.createElement(Container, _extends({
    innerRef: setRef,
    "data-unify": "Overlay",
    className: overlayClass,
    mod: {
      display: display,
      childrenType: childrenType
    },
    onClick: onClick
  }, otherProps));
};

Overlay.defaultProps = {
  display: false,
  onClick: function onClick() {}
};
export default Overlay;