import styled from 'react-emotion';
import { NN0, NN900 } from 'unify-token/colors';
import { durationDefault, durationT1, easeLinear, durationT3, durationT2, easeOut, easeInOut } from 'unify-token/build/v2/motions';

var handleTransition = function handleTransition(_ref) {
  var mod = _ref.mod;
  var childrenType = mod.childrenType,
      display = mod.display;

  switch (true) {
    case childrenType === 'dialog':
      return display ? "opacity ".concat(durationT2, " ").concat(easeInOut, ", z-index ").concat(durationT2, " ").concat(easeInOut) : "opacity ".concat(durationT3, " ").concat(easeOut, ", z-index ").concat(durationT3, " ").concat(easeOut);

    default:
      return "opacity ".concat(durationDefault, " ").concat(easeLinear, ", z-index ").concat(durationT1, " ").concat(easeLinear, ", visibility ").concat(durationDefault, " ").concat(easeLinear);
  }
};

export var Container = styled("div", {
  target: "e19bgjed0"
})("label:unf-overlay;position:fixed;top:0;left:0;height:100%;width:100%;background-color:", function (_ref2) {
  var inverted = _ref2.inverted;
  return inverted ? NN900 : NN0;
}, ";overflow:hidden;z-index:50;opacity:", function (_ref3) {
  var display = _ref3.mod.display;
  return display ? 0.7 : 0;
}, ";transition:", handleTransition, ";&[data-unf='custom-overlay']{z-index:25;}");
export default Container;