import React, { useCallback } from 'react';
import { _wrapperScroll } from "./style";
var ITEM_LENGTH = 10;

var WrapperScroll = function WrapperScroll(props) {
  var children = props.children,
      active = props.active,
      length = props.length;
  var scrollCallback = useCallback(function (el) {
    if (el && length && length > 5) {
      var x = 0;

      if (active && active > 2) {
        x = ITEM_LENGTH * (active - 2);
      }

      if (active && active >= length - 3) {
        x = ITEM_LENGTH * (length - 5);
      }

      el.style.transform = "translateX(".concat(-x, "px)");
    }
  }, [active, length]);
  return React.createElement("div", {
    ref: scrollCallback,
    className: _wrapperScroll
  }, children);
};

export default WrapperScroll;