import styled, { css, keyframes } from 'react-emotion';
import { GN500, NN0, NN200, NN500, RN500, NN900L, NN0L, YN300L, BN400L, NN200L } from 'unify-token/colors';
import hexToRgba from "../../build/Providers/common/functions/hexToRgba";
var MARGIN = 4;
export var activeColors = {
  black: "var(--NN100, ".concat(NN900L, ")"),
  yellow: "var(--YN500, ".concat(YN300L, ")"),
  red: RN500,
  blue: "var(--BN500, ".concat(BN400L, ")"),
  green: GN500,
  white: NN0L
};
export var baseColors = {
  black: hexToRgba(NN500, 0.7),
  yellow: "var(--NN500, ".concat(NN200L, ")"),
  red: "var(--NN500, ".concat(NN200L, ")"),
  blue: "var(--NN500, ".concat(NN200L, ")"),
  green: NN200,
  white: hexToRgba(NN0L, 0.44)
};
var _ref = "display:inline-block;width:6px;height:6px;transform:scale(";
var _ref2 = ");";

var calcDotStyle = function calcDotStyle(index, current, length) {
  var val = 1;

  if (length > 5 && index !== current) {
    if (current - 1 === index && current > 2 && current <= length - 3 || current + 1 === index && current >= 2 && current < length - 3 || current < 3 && index === 3 || current >= length - 3 && index === length - 4) {
      val = 2 / 3;
    }

    if (current - 2 === index && current > 2 && current <= length - 3 || current + 2 === index && current >= 2 && current < length - 3 || current < 3 && index === 4 || current >= length - 3 && index === length - 5) {
      val = 1 / 3;
    }

    if (current - 3 === index && current > 2 && current <= length - 3 || current + 3 === index && current >= 2 && current < length - 3) {
      val = 0;
    }
  }

  return css(_ref, val, _ref2);
};

var _itemTimed = css("flex:1;height:2px;");

var progress = keyframes("0%{transform:scaleX(0);}100%{transform:scaleX(1);}");
export var _wrapperScroll = css("display:flex;flex:0 0 auto;white-space:nowrap;overflow:hidden;transition:transform ease 0.3s;");
export var Container = styled('div', {
  target: "etys21l0"
})("label:unf-page-control;", function (_ref3) {
  var timed = _ref3.timed;
  return !timed ? "overflow: hidden;" : "align-items: center; justify-content: center;";
}, " ", function (_ref4) {
  var numberOfPage = _ref4.numberOfPage;
  return numberOfPage && numberOfPage > 5 ? "width: 50px;" : '';
}, " display:flex;position:relative;");

var activeTimedItemStyle = function activeTimedItemStyle(_ref5) {
  var activeColor = _ref5.activeColor,
      inverted = _ref5.inverted;

  if (activeColor) {
    return activeColor;
  } else if (inverted) {
    return NN0;
  } else {
    return GN500;
  }
};

var _ref7 = "&:after,&:before{content:'';position:absolute;left:0;top:0;border-radius:6px;background-color:";
var _ref8 = ";width:100%;height:2px;transform-origin:left;}&:after{";
var _ref9 = ";opacity:";
var _ref10 = ";}&:before{opacity:";
var _ref11 = ";}";

var timedItemStyle = function timedItemStyle(_ref6) {
  var active = _ref6.active,
      activeColor = _ref6.activeColor,
      activeSecond = _ref6.activeSecond,
      inverted = _ref6.inverted;
  return css(_ref7, activeTimedItemStyle({
    activeColor: activeColor,
    inverted: inverted
  }), _ref8, active && "animation: ".concat(progress, " 1s ease"), _ref9, active ? 1 : 0, _ref10, activeSecond ? 1 : 0, _ref11);
};

var calcItemBackgroundColor = function calcItemBackgroundColor(_ref12) {
  var timed = _ref12.timed,
      active = _ref12.active,
      baseColor = _ref12.baseColor,
      activeColor = _ref12.activeColor;

  if (timed || !active) {
    return baseColor || NN200;
  } else {
    return activeColor || GN500;
  }
};

export var Item = styled("span", {
  target: "etys21l1"
})(function (_ref13) {
  var timed = _ref13.timed,
      index = _ref13.index,
      currentPage = _ref13.currentPage,
      length = _ref13.length;
  return timed ? _itemTimed : calcDotStyle(index, currentPage, length);
}, " ", function (PageControlProps) {
  return PageControlProps.timed && timedItemStyle(PageControlProps);
}, " background-color:", calcItemBackgroundColor, ";border-radius:", function (_ref14) {
  var timed = _ref14.timed;
  return timed ? 12 / 2 : 6 / 2;
}, "px;border:transparent;margin-right:", function (_ref15) {
  var last = _ref15.last;
  return last ? 0 : "".concat(MARGIN, "px");
}, ";overflow:hidden;padding:0;position:relative;position:relative;transition:transform ease 0.3s;text-indent:100%;white-space:nowrap;&.no-animation:after{animation:none;}");