import React from 'react';
declare type PageControlBaseProps = React.ComponentPropsWithoutRef<'div'>;
interface UnifyPageControlProps {
    /**
     * To specify active indicator background-color
     */
    activeColor?: string;
    /**
     * To specify indicators background-color
     */
    baseColor?: string;
    /**
     * To indicate currently active page
     */
    currentPage: number;
    /**
     * Specify data-testid in each indicators
     */
    dataTest?: string;
    /**
     * To specify inverted style
     */
    inverted?: boolean;
    /**
     * Determine format language
     */
    lang?: string;
    /**
     * To specify total items of pagecontrol, array of number for timed type of pagecontrol
     */
    numberOfPage: number | number[];
    /**
     * To apply timed pagecontrol design
     */
    timed?: boolean;
    /**
     * To choose specified color scheme
     */
    variant?: 'green' | 'yellow' | 'red' | 'blue' | 'white' | 'black';
    /**
     * To pass callback when pageControl's component is clicked | params: `indicator`: clicked indicator index
     */
    onIndicatorClick?: (index: number) => void;
}
export declare type PageControlProps = UnifyPageControlProps & Omit<PageControlBaseProps, keyof UnifyPageControlProps | 'css'>;
export interface ItemProps extends Pick<PageControlProps, 'activeColor' | 'baseColor' | 'inverted' | 'timed'> {
    index: number;
    length: number;
    active: boolean;
    activeSecond: boolean;
    last: boolean;
    currentPage: number;
}
declare type WrapperScrollBaseProps = React.ComponentProps<'div'>;
interface UnifyWrapperScrollProps {
    active?: number;
    length?: number;
}
export declare type WrapperScrollProps = UnifyWrapperScrollProps & Omit<WrapperScrollBaseProps, keyof UnifyWrapperScrollProps>;
export {};
