/**
 * Create boundary from given minimum and maximum number
 * @param {number} number target number
 * @param {number} min minimum number as boundary
 * @param {number} max maximum number as boundary
 */
export declare function clamp(number: number, min?: number, max?: number): number;
/**
 * Get a slice of page range from given array, intentionally to get neighbouring page
 * @param {array} itemArray array of items
 * @param {number} from start index to slice
 * @param {number} to end index to slice
 */
export declare function getPageRange(itemArray: number[], from: number, to: number): number[];
/**
 * Omit query parameter from a URL string
 * @param {string} url URL string that needs param to be omitted
 * @param {string} paramName Query parameter that will be omitted
 */
export declare function omitURLParam(url: string, paramName: string): string;
/**
 * Get base array from items props, create new array from number.
 * Or use the array itself
 */
export declare function getBaseItems(items: number | number[]): number[];
/**
 * Get array of items that will be mappable for render.
 */
export declare function getMappableItems(baseItems: number[], currentIndex: number): number[];
