import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useEffect, useRef, useState } from 'react';
import { isStyledComponent } from "../functions";
import UnifyPlacement from "../utilities/UnifyPlacement";
import UnifyPortal from "../utilities/UnifyPortal";
import UnifyCSSTransition from "../utilities/UnifyCSSTransition";

var Popup = function Popup(props) {
  var _children$props$inner2, _children$ref2;

  var _props$autoAdjust = props.autoAdjust,
      autoAdjust = _props$autoAdjust === void 0 ? true : _props$autoAdjust,
      children = props.children,
      container = props.container,
      _props$in = props["in"],
      _in = _props$in === void 0 ? false : _props$in,
      _props$mountOnEnter = props.mountOnEnter,
      mountOnEnter = _props$mountOnEnter === void 0 ? true : _props$mountOnEnter,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      _props$spacing = props.spacing,
      spacing = _props$spacing === void 0 ? 8 : _props$spacing,
      target = props.target,
      _props$timeout = props.timeout,
      timeout = _props$timeout === void 0 ? 300 : _props$timeout,
      _props$transition = props.transition,
      transition = _props$transition === void 0 ? true : _props$transition,
      _props$transitionClas = props.transitionClass,
      transitionClass = _props$transitionClas === void 0 ? '' : _props$transitionClas,
      _props$unmountOnExit = props.unmountOnExit,
      unmountOnExit = _props$unmountOnExit === void 0 ? true : _props$unmountOnExit,
      onClickOutside = props.onClickOutside,
      onEnter = props.onEnter,
      onEntering = props.onEntering,
      onEntered = props.onEntered,
      onExit = props.onExit,
      onExiting = props.onExiting,
      onExited = props.onExited;

  var _useState = useState(_in),
      _useState2 = _slicedToArray(_useState, 2),
      popupState = _useState2[0],
      setPopupState = _useState2[1];

  var childRef = useRef(null);
  useEffect(function () {
    return setPopupState(_in);
  }, [_in]);
  useEffect(function () {
    var handleClickOutside = function handleClickOutside(e) {
      if (e.target !== childRef.current && !e.target.closest("[data-placement]")) {
        onClickOutside && onClickOutside(e);
      }
    };

    if (popupState) {
      onClickOutside && document.addEventListener('click', handleClickOutside);
    } else {
      onClickOutside && document.removeEventListener('click', handleClickOutside);
    }

    return function () {
      onClickOutside && document.removeEventListener('click', handleClickOutside);
    };
  }, [popupState]);
  var placementProps = {
    autoAdjust: autoAdjust,
    container: container,
    placement: placement,
    spacing: spacing,
    target: target
  };

  if (!transition) {
    var _children$props$inner, _children$ref;

    return popupState ? React.createElement(UnifyPortal, null, React.createElement(UnifyPlacement, placementProps, isStyledComponent(children) ? React.cloneElement(children, {
      innerRef: (_children$props$inner = children.props.innerRef) !== null && _children$props$inner !== void 0 && _children$props$inner.current ? children.props.innerRef : childRef
    }) : React.cloneElement(children, {
      ref: (_children$ref = children.ref) !== null && _children$ref !== void 0 && _children$ref.current ? children.ref : childRef
    }))) : null;
  }

  var transitionProps = {
    classNames: transitionClass,
    "in": popupState,
    mountOnEnter: mountOnEnter,
    timeout: timeout,
    unmountOnExit: unmountOnExit,
    onEnter: onEnter,
    onEntering: onEntering,
    onEntered: onEntered,
    onExit: onExit,
    onExiting: onExiting,
    onExited: onExited
  };
  return React.createElement(UnifyPortal, null, React.createElement(UnifyCSSTransition, transitionProps, React.createElement(UnifyPlacement, placementProps, isStyledComponent(children) ? React.cloneElement(children, {
    innerRef: (_children$props$inner2 = children.props.innerRef) !== null && _children$props$inner2 !== void 0 && _children$props$inner2.current ? children.props.innerRef : childRef
  }) : React.cloneElement(children, {
    ref: (_children$ref2 = children.ref) !== null && _children$ref2 !== void 0 && _children$ref2.current ? children.ref : childRef
  }))));
};

export default Popup;