import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { canUseDOM } from "../../../../build/Providers/common/functions";
import Overlay from "../../../../build/Overlay";
import { scrollLock, scrollLock_iOS } from "../../../../build/BottomSheetV2/style";
import Delayed from "../components/Delayed";
import PortalWrapper from "../components/PortalWrapper";

var wrapperComponent = function wrapperComponent(WrappedComponent) {
  var _class, _temp;

  return _temp = _class = function (_PureComponent) {
    _inherits(BottomSheetWrapper, _PureComponent);

    var _super = _createSuper(BottomSheetWrapper);

    function BottomSheetWrapper(props) {
      var _this;

      _classCallCheck(this, BottomSheetWrapper);

      _this = _super.call(this, props);

      _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (_ref) {
        var wasOpen = _ref.display;
        var _this$props = _this.props,
            isOpen = _this$props.display,
            full = _this$props.full,
            withOverlay = _this$props.withOverlay;
        var isMaximized = _this.state.isMaximized;
        var getAnimationTime = isOpen ? 240 : 40;

        _this.getOverlayCount();

        _this.getScrollPosition();

        if (isOpen !== wasOpen) {
          if (canUseDOM) {
            _this.timeout = setTimeout(function () {
              _this.setState(function (_ref2) {
                var isDisplay = _ref2.isDisplay;
                return {
                  isDisplay: !isDisplay
                };
              });

              _this.getSheetCount();
            }, getAnimationTime);

            if (isOpen) {
              if (withOverlay || full || isMaximized) {
                _this.preventBodyScroll();
              }
            } else if (_this.activeOverlayCount < 2) {
              _this.allowBodyScroll();
            }
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), "getOverlayCount", function () {
        if (canUseDOM) {
          _this.activeOverlayCount = document.querySelectorAll('.unf-sheet-overlay--active').length || 0;
        }
      });

      _defineProperty(_assertThisInitialized(_this), "getSheetCount", function () {
        if (canUseDOM) {
          _this.sheetCount = document.querySelectorAll('[data-unf="unf-bottomsheet"]').length || 1;
        }
      });

      _defineProperty(_assertThisInitialized(_this), "getScrollPosition", function () {
        if (canUseDOM) {
          _this.pageScrolled = window.scrollY;
        }
      });

      _defineProperty(_assertThisInitialized(_this), "preventBodyScroll", function () {
        if (canUseDOM) {
          var hasLockClass = document.body.classList.contains(scrollLock);

          if (!hasLockClass) {
            document.body.style.overflow = '';
            document.body.classList.add(scrollLock);

            if (_this.isAn_iPhone) {
              document.body.style.top = "-".concat(_this.pageScrolled, "px");
              document.body.classList.add(scrollLock_iOS);
            }
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), "allowBodyScroll", function () {
        if (canUseDOM) {
          document.body.classList.remove(scrollLock);

          if (_this.isAn_iPhone) {
            document.body.style.top = '';
            document.body.classList.remove(scrollLock_iOS);
            window.scrollTo(0, _this.pageScrolled);
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleMinimize", function () {
        var _this$props2 = _this.props,
            withKnob = _this$props2.withKnob,
            withOverlay = _this$props2.withOverlay,
            onMinimize = _this$props2.onMinimize;

        _this.setState({
          isMaximized: false
        });

        if (withKnob && !withOverlay) {
          _this.getOverlayCount();

          if (_this.activeOverlayCount <= 1) {
            _this.allowBodyScroll();
          }
        }

        if (onMinimize) {
          onMinimize();
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleMaximize", function () {
        var _this$props3 = _this.props,
            withOverlay = _this$props3.withOverlay,
            withKnob = _this$props3.withKnob,
            onMaximize = _this$props3.onMaximize;

        _this.setState({
          isMaximized: true
        });

        if (withKnob && !withOverlay) {
          _this.preventBodyScroll();
        }

        if (onMaximize) {
          onMaximize();
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleClose", function (event) {
        var onClose = _this.props.onClose;

        if (onClose) {
          onClose(event);
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleDragging", function (event) {
        var onDrag = _this.props.onDrag;

        _this.preventBodyScroll();

        if (onDrag) {
          onDrag(event);
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleDraggingEnd", function (event) {
        var onDragEnd = _this.props.onDragEnd;

        if (onDragEnd) {
          onDragEnd(event);
        }
      });

      _defineProperty(_assertThisInitialized(_this), "handleDraggingStart", function (event) {
        var onDragStart = _this.props.onDragStart;

        _this.getScrollPosition();

        if (onDragStart) {
          onDragStart(event);
        }
      });

      _this.activeOverlayCount = 0;
      _this.isAn_iPhone = false;
      _this.pageScrolled = 0;
      _this.sheetCount = 1;
      _this.timeout = null;
      _this.unmountAnimationDelay = 400;
      _this.state = {
        isDisplay: _this.props.display,
        isMaximized: _this.props.full
      };
      return _this;
    }

    _createClass(BottomSheetWrapper, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this$props4 = this.props,
            display = _this$props4.display,
            full = _this$props4.full,
            withOverlay = _this$props4.withOverlay;
        var isMaximized = this.state.isMaximized;
        this.isAn_iPhone = canUseDOM && navigator.userAgent.search('iPhone') !== -1;

        if (display) {
          if (withOverlay || full || isMaximized) {
            this.preventBodyScroll();
          }
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.getScrollPosition();
        this.getOverlayCount();

        if (this.activeOverlayCount <= 1) {
          this.allowBodyScroll();
        }

        clearTimeout(this.timeout);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props5 = this.props,
            display = _this$props5.display,
            style = _this$props5.style,
            withOverlay = _this$props5.withOverlay,
            onClose = _this$props5.onClose;
        var _this$state = this.state,
            isDisplay = _this$state.isDisplay,
            isMaximized = _this$state.isMaximized;
        var zIndex = 50 + this.sheetCount * 10 || 50;

        var sheetStyle = _objectSpread({
          zIndex: zIndex
        }, style);

        var overlayStyle = _objectSpread({
          pointerEvents: withOverlay ? 'all' : 'none',
          zIndex: zIndex
        }, style);

        var getOverlayClassName = function getOverlayClassName() {
          if (withOverlay || isMaximized) {
            return 'unf-overlay unf-sheet-overlay unf-sheet-overlay--active';
          }

          return 'unf-overlay unf-sheet-overlay';
        };

        return React.createElement(PortalWrapper, null, React.createElement(Delayed, {
          mounted: display,
          unmountAfter: this.unmountAnimationDelay
        }, React.createElement(Overlay, {
          className: getOverlayClassName(),
          "data-unf": "unf-overlay",
          display: withOverlay || isMaximized ? isDisplay : false,
          inverted: true,
          style: overlayStyle,
          onClick: this.handleClose
        }), React.createElement(WrappedComponent, _extends({}, this.props, {
          display: isDisplay,
          style: sheetStyle,
          onClose: onClose ? this.handleClose : null,
          onMinimize: this.handleMinimize,
          onMaximize: this.handleMaximize,
          onDrag: this.handleDragging,
          onDragEnd: this.handleDraggingEnd,
          onDragStart: this.handleDraggingStart
        }))));
      }
    }]);

    return BottomSheetWrapper;
  }(PureComponent), _defineProperty(_class, "defaultProps", {
    display: false,
    withOverlay: true,
    onDrag: function onDrag() {},
    onDragEnd: function onDragEnd() {},
    onDragStart: function onDragStart() {},
    onMaximize: function onMaximize() {},
    onMinimize: function onMinimize() {}
  }), _temp;
};

export default wrapperComponent;