import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component } from 'react';
import { cx } from 'emotion';
import { canUseDOM } from "../../../../build/Providers/common/functions";
import Portal from "../components/Portal/LegacyPortal";
import Delayed from "../components/Delayed";
import Overlay from "../../../../build/Overlay";

var wrapperComponent = function wrapperComponent(WrappedComponent, elementName) {
  var _class, _temp;

  var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
    inverted: false,
    stacked: false
  };
  return _temp = _class = function (_Component) {
    _inherits(C, _Component);

    var _super = _createSuper(C);

    function C(props) {
      var _this;

      _classCallCheck(this, C);

      _this = _super.call(this, props);

      _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
        var display = _this.props.display;
        var getAnimationTime = display ? 240 : 40;

        if (prevProps.display !== display) {
          _this.timeout = setTimeout(function () {
            _this.setState(function (_ref) {
              var isDisplay = _ref.isDisplay;
              return {
                isDisplay: !isDisplay
              };
            });
          }, getAnimationTime);

          if (canUseDOM && display) {
            document.body.style.overflow = 'hidden';

            if (args.stacked) {
              _this.overlayCount = document.body.querySelectorAll('[data-unf="unf-overlay"]').length || 0;
            }
          } else {
            document.body.style.overflow = '';
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), "unmountAnimationDelay", 400);

      _this._isMounted = false;
      _this.state = {
        isDisplay: _this.props.display
      };
      _this.timeout;
      return _this;
    }

    _createClass(C, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var display = this.props.display;
        this._isMounted = true;

        if (display) {
          document.body.style.overflow = 'hidden';
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this._isMounted = false;
        clearTimeout(this.timeout);
        document.body.style.overflow = '';
      }
    }, {
      key: "componentClassName",
      get: function get() {
        var className = this.props.className;
        var show = this.state.isDisplay && this._isMounted ? "unf-".concat(elementName, "--show") : '';
        var componentClass = cx("unf-".concat(elementName), show, className);
        return componentClass;
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            display = _this$props.display,
            inverted = _this$props.inverted,
            style = _this$props.style,
            onClose = _this$props.onClose;
        return React.createElement(Portal, null, React.createElement(Delayed, {
          mounted: display,
          unmountAfter: this.unmountAnimationDelay
        }, React.createElement(Overlay, {
          "data-unf": "unf-overlay",
          onClick: onClose,
          display: this.state.isDisplay,
          inverted: inverted,
          childrenType: args.childrenType,
          style: args.stacked && this.overlayCount ? _objectSpread({
            zIndex: 50 + this.overlayCount * 10
          }, style) : style
        }), React.createElement(WrappedComponent, _extends({}, this.props, {
          display: this.state.isDisplay,
          className: this.componentClassName,
          style: args.stacked && this.overlayCount ? _objectSpread({
            zIndex: 60 + this.overlayCount * 10
          }, style) : style
        }))));
      }
    }]);

    return C;
  }(Component), _defineProperty(_class, "defaultProps", {
    display: false,
    inverted: args.inverted,
    stacked: args.stacked
  }), _temp;
};

export default wrapperComponent;