import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component } from 'react';
import { canUseDOM } from "../../../../build/Providers/common/functions";
import Delayed from "../components/Delayed";
import Portal from "../components/Portal/LegacyPortal";
import Overlay from "../../../../build/Overlay";

var wrapperComponent = function wrapperComponent(WrappedComponent) {
  var _class, _temp;

  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    show: true
  };
  return _temp = _class = function (_Component) {
    _inherits(C, _Component);

    var _super = _createSuper(C);

    function C() {
      var _this;

      _classCallCheck(this, C);

      for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
        _args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(_args));

      _defineProperty(_assertThisInitialized(_this), "state", {
        isDisplay: _this.props.display,
        show: args.show
      });

      _defineProperty(_assertThisInitialized(_this), "unmountAnimationDelay", 400);

      _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
        var _this$props = _this.props,
            display = _this$props.display,
            onClose = _this$props.onClose;
        var getAnimationTime = display ? 240 : 40;

        if (prevProps.display !== display) {
          setTimeout(function () {
            _this.setState(function (_ref) {
              var isDisplay = _ref.isDisplay;
              return {
                isDisplay: !isDisplay
              };
            });
          }, getAnimationTime);

          if (display && canUseDOM && onClose) {
            document.body.style.overflow = 'hidden';
          } else if (!display && canUseDOM) {
            document.body.style.overflow = '';
          }
        }
      });

      _defineProperty(_assertThisInitialized(_this), "unmountComponent", function (e) {
        var onClose = _this.props.onClose;

        if (e.keyCode === 27 && onClose && Boolean(_this.state.isDisplay)) {
          e.stopPropagation();
          onClose(e);
        }
      });

      return _this;
    }

    _createClass(C, [{
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        document.body.style.overflow = '';
      }
    }, {
      key: "throttled",
      value: function throttled(delay, fn) {
        var lastCall = 0;
        return function () {
          var now = new Date().getTime();

          if (now - lastCall < delay) {
            return;
          }

          lastCall = now;
          return fn.apply(void 0, arguments);
        };
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props2 = this.props,
            display = _this$props2.display,
            onClose = _this$props2.onClose,
            zIndex = _this$props2.zIndex;
        return React.createElement(Portal, null, React.createElement(Delayed, {
          mounted: display,
          unmountAfter: this.unmountAnimationDelay
        }, this.state.show && React.createElement(Overlay, {
          onClick: onClose ? onClose : undefined,
          display: this.state.isDisplay,
          zIndex: zIndex
        }), React.createElement(WrappedComponent, _extends({}, this.props, {
          display: this.state.isDisplay
        }))));
      }
    }]);

    return C;
  }(Component), _defineProperty(_class, "defaultProps", {
    display: false
  }), _temp;
};

export default wrapperComponent;