import React from 'react';
import { cx } from 'emotion';
import { unf_loading_circle } from "./style";

var LoadingCircle = function LoadingCircle(props) {
  var classes = cx(unf_loading_circle, {
    'unf-loading-circle--show': props.display
  });
  return React.createElement(React.Fragment, null, props.display && React.createElement("div", {
    className: classes
  }, React.createElement("svg", {
    className: "unf-loading-circle__loader",
    viewBox: "25 25 50 50",
    height: "24",
    width: "24"
  }, React.createElement("circle", {
    className: "unf-loading-circle__path",
    cx: "50",
    cy: "50",
    r: "20",
    fill: "none",
    stroke: props.color,
    strokeWidth: "4"
  }))));
};

LoadingCircle.defaultProps = {
  display: false,
  color: '#FFFFFF'
};
export default LoadingCircle;