import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
var _excluded = ["ref", "position", "show"];
import React, { useRef, useEffect, useState } from 'react';
import styled from 'react-emotion';
import { durationT3 } from 'unify-token/build/v2/motions';
import Popup from "./Popup";
var Box = styled('div', {
  target: "etu0dmb0"
})("position:absolute;top:0;left:0;z-index:", function (_ref) {
  var zIndex = _ref.zIndex;
  return zIndex;
}, ";transform:", function (_ref2) {
  var position = _ref2.position;
  return "translate(".concat(position.left, "px, ").concat(position.top, "px)");
}, ";opacity:", function (_ref3) {
  var show = _ref3.show;
  return show ? 1 : 0;
}, ";transition:opacity ", durationT3, " ease;");

var PopupTrigger = function PopupTrigger(props) {
  var children = props.children,
      targetRef = props.targetRef,
      placement = props.placement,
      trigger = props.trigger,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      onClick = props.onClick,
      delay = props.delay,
      spacing = props.spacing,
      zIndex = props.zIndex;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      display = _useState2[0],
      setDisplay = _useState2[1];

  var timeout = useRef(null);

  var handleEventListener = function handleEventListener() {
    if (targetRef && targetRef.current) {
      if (trigger === 'hover') {
        targetRef.current && targetRef.current.addEventListener('mouseenter', handleMouseEnter, true);
        targetRef.current && targetRef.current.addEventListener('mouseleave', handleMouseLeave, true);

        if (targetRef.current.matches(':hover')) {
          setDisplay(true);
        }

        return function cleanup() {
          targetRef.current && targetRef.current.removeEventListener('mouseenter', handleMouseEnter, true);
          targetRef.current && targetRef.current.removeEventListener('mouseleave', handleMouseLeave, true);
        };
      } else if (trigger === 'click') {
        targetRef.current && targetRef.current.addEventListener('click', handleMouseClick, true);
        return function cleanup() {
          targetRef.current && targetRef.current.removeEventListener('click', handleMouseClick, true);
        };
      }
    }
  };

  useEffect(handleEventListener, [targetRef, trigger]);

  var handleClickOutside = function handleClickOutside() {
    if (trigger !== 'click') {
      return null;
    }

    setDisplay(false);
  };

  var handleMouseClick = function handleMouseClick(e) {
    setDisplay(function (prev) {
      return !prev;
    });

    if (onClick) {
      onClick(e);
    }
  };

  var handleMouseEnter = function handleMouseEnter(e) {
    if (trigger !== 'hover') {
      return null;
    }

    clearTimeout(timeout.current);
    setDisplay(true);

    if (onMouseEnter) {
      onMouseEnter(e);
    }
  };

  var handleMouseLeave = function handleMouseLeave(e) {
    var event = _objectSpread({}, e);

    if (trigger !== 'hover') {
      return null;
    }

    timeout.current = setTimeout(function () {
      setDisplay(false);

      if (onMouseLeave) {
        onMouseLeave(event);
      }
    }, 250);
  };

  return React.createElement(Popup, {
    show: display,
    targetRef: targetRef,
    onClickOutside: handleClickOutside,
    placement: placement,
    delay: delay,
    spacing: spacing
  }, function (_ref4) {
    var ref = _ref4.ref,
        position = _ref4.position,
        show = _ref4.show,
        otherProps = _objectWithoutProperties(_ref4, _excluded);

    return React.createElement(Box, {
      innerRef: ref,
      onMouseEnter: handleMouseEnter,
      onMouseLeave: handleMouseLeave,
      position: position,
      show: show,
      zIndex: zIndex
    }, children(otherProps));
  });
};

PopupTrigger.defaultProps = {
  show: false,
  placement: 'bottom',
  children: function children() {
    return {};
  },
  targetRef: undefined,
  trigger: 'hover',
  zIndex: 60
};
export default PopupTrigger;