import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import ReactDOM from 'react-dom';
import { canUseDOM } from "../../../../../build/Providers/common/functions";
import SkipServer from "../SkipServer";

var PortalWrapper = function (_PureComponent) {
  _inherits(PortalWrapper, _PureComponent);

  var _super = _createSuper(PortalWrapper);

  function PortalWrapper(props) {
    var _this;

    _classCallCheck(this, PortalWrapper);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "element", void 0);

    _defineProperty(_assertThisInitialized(_this), "root", void 0);

    _this.element = canUseDOM && document.createElement('div');
    _this.root = canUseDOM && (props.root || document.body);

    if (canUseDOM && _this.element && props.portalClassName) {
      _this.element.className = props.portalClassName;
    }

    return _this;
  }

  _createClass(PortalWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.root instanceof Node) {
        this.root.appendChild(this.element);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.root instanceof Node) {
        this.root.removeChild(this.element);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var Portal = this.element ? ReactDOM.createPortal(this.props.children, this.element) : null;
      return React.createElement(SkipServer, null, Portal);
    }
  }]);

  return PortalWrapper;
}(PureComponent);

_defineProperty(PortalWrapper, "defaultProps", {
  root: null
});

export default PortalWrapper;