import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import ReactDOM from 'react-dom';
import { canUseDOM } from "../../../../../build/Providers/common/functions";
import SkipServer from "../SkipServer";

var Portal = function (_PureComponent) {
  _inherits(Portal, _PureComponent);

  var _super = _createSuper(Portal);

  function Portal(props) {
    var _this;

    _classCallCheck(this, Portal);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "element", void 0);

    _defineProperty(_assertThisInitialized(_this), "deferred", void 0);

    _defineProperty(_assertThisInitialized(_this), "handlePortal", function (type) {
      var mounted = type === 'mount';

      var timeout = _this.props["".concat(type, "After")];

      var deferred;
      _this.deferred && clearTimeout(_this.deferred);
      deferred = setTimeout(function () {
        _this.setState({
          mounted: mounted
        });
      }, timeout);
      _this.deferred = deferred;
    });

    _this.deferred = null;
    _this.element = null;
    _this.state = {
      mounted: false
    };
    return _this;
  }

  _createClass(Portal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.mounted && this.handlePortal('mount');
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var mounted = this.props.mounted;

      if (mounted !== prevProps.mounted) {
        !prevProps.mounted && mounted && this.handlePortal('mount');
        prevProps.mounted && !mounted && this.handlePortal('unmount');
      }
    }
  }, {
    key: "render",
    value: function render() {
      var mounted = this.state.mounted;
      var _this$props = this.props,
          children = _this$props.children,
          root = _this$props.root;
      var portalNode;

      if (!canUseDOM) {
        return null;
      }

      if (mounted) {
        if (!root && !this.element) {
          this.element = document.createElement('div');
          document.body.appendChild(this.element);
        }

        portalNode = ReactDOM.createPortal(children, root || this.element);
      } else {
        this.element && document.body.removeChild(this.element);
        this.element = null;
      }

      return mounted ? React.createElement(SkipServer, null, portalNode) : null;
    }
  }]);

  return Portal;
}(PureComponent);

_defineProperty(Portal, "defaultProps", {
  mounted: false,
  mountDelay: 0,
  unmountDelay: 0,
  root: null
});

export default Portal;