import getElementStyle from "./getElementStyle";

var hasPosition = function hasPosition(el) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'fixed';

  if (!el || !(el instanceof HTMLElement)) {
    return false;
  }

  var nodeName = el.nodeName;

  if (nodeName === 'BODY' || nodeName === 'HTML') {
    return false;
  }

  if (getElementStyle(el).position === type) {
    return true;
  }

  return hasPosition(el.parentNode, type);
};

export default hasPosition;