import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
export default (function (hex) {
  var alpha = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  try {
    var findColor = /(.*)(#([a-f\d]{1,2})([a-f\d]{1,2})([a-f\d]{1,2}))(.*)/i;

    var _findColor$exec = findColor.exec(hex),
        _findColor$exec2 = _slicedToArray(_findColor$exec, 7),
        prefix = _findColor$exec2[1],
        hexColor = _findColor$exec2[2],
        r = _findColor$exec2[3],
        g = _findColor$exec2[4],
        b = _findColor$exec2[5],
        postfix = _findColor$exec2[6];

    var isShortHand = (hexColor === null || hexColor === void 0 ? void 0 : hexColor.length) === 4;

    if (isShortHand) {
      r = r + r;
      g = g + g;
      b = b + b;
    }

    var red = parseInt(r, 16);
    var green = parseInt(g, 16);
    var blue = parseInt(b, 16);
    var rgbaColor = "rgba(".concat(red, ", ").concat(green, ", ").concat(blue, ", ").concat(alpha, ")");
    return "".concat(prefix + rgbaColor + postfix);
  } catch (err) {
    throw new Error('Wrong color format argument given. Please use appropriate hex color format.');
  }
});