import { useEffect, useRef } from 'react';
import { canUseDOM } from "../../../../build/Providers/common/functions";
export function usePrev(value) {
  var ref = useRef();
  useEffect(function () {
    ref.current = value;
  }, [value]);
  return ref.current;
}
export var isFirstRender = function isFirstRender() {
  var ref = useRef(true);
  useEffect(function () {
    ref.current = false;
  }, []);
  return ref.current;
};
export var useKeyboardControl = function useKeyboardControl(keyMapConfig) {
  var isListening = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var eventName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'keydown';
  useEffect(function () {
    if (!canUseDOM) {
      return function () {};
    }

    var handleKeyboardEvent = function handleKeyboardEvent(e) {
      if (keyMapConfig[e.key] !== undefined && typeof keyMapConfig[e.key] === 'function') {
        var callback = keyMapConfig[e.key];
        callback && callback(e);
      }
    };

    if (isListening) {
      document.addEventListener(eventName, handleKeyboardEvent);
    } else {
      document.removeEventListener(eventName, handleKeyboardEvent);
    }

    return function () {
      document.removeEventListener(eventName, handleKeyboardEvent);
    };
  }, [keyMapConfig, isListening]);
};