import _typeof from "@babel/runtime/helpers/typeof";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { createRef, PureComponent } from 'react';
import { addClass, hasClass, isStyledComponent, removeClass } from "../functions";
var PHASE_ENTER = 'enter';
var PHASE_ENTERING = 'entering';
var PHASE_ENTERED = 'entered';
var PHASE_EXIT = 'exit';
var PHASE_EXITING = 'exiting';
var PHASE_EXITED = 'exited';
export var UnifyCSSTransition = function (_PureComponent) {
  _inherits(UnifyCSSTransition, _PureComponent);

  var _super = _createSuper(UnifyCSSTransition);

  function UnifyCSSTransition(props) {
    var _this;

    _classCallCheck(this, UnifyCSSTransition);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "childRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "transitionTimeout", void 0);

    _this.transitionTimeout = null;
    _this.childRef = createRef();
    _this.state = {
      mount: props["in"],
      state: '',
      appear: null
    };
    return _this;
  }

  _createClass(UnifyCSSTransition, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          classNames = _this$props.classNames,
          _in = _this$props["in"],
          mountOnEnter = _this$props.mountOnEnter,
          timeout = _this$props.timeout,
          unmountOnExit = _this$props.unmountOnExit,
          onEnter = _this$props.onEnter,
          onEntering = _this$props.onEntering,
          onEntered = _this$props.onEntered,
          onExit = _this$props.onExit,
          onExiting = _this$props.onExiting,
          onExited = _this$props.onExited;
      var _this$state = this.state,
          appear = _this$state.appear,
          state = _this$state.state;
      var enterTimeout = _typeof(timeout) === 'object' ? timeout.enter ? timeout.enter : 0 : timeout;
      var exitTimeout = _typeof(timeout) === 'object' ? timeout.exit ? timeout.exit : 0 : timeout;
      var childDOM;

      if (isStyledComponent(children)) {
        childDOM = children.props.innerRef ? children.props.innerRef : this.childRef;
      } else {
        childDOM = children.ref ? children.ref : this.childRef;
      }

      childDOM = childDOM.current;

      if (prevProps["in"] !== _in) {
        clearTimeout(this.transitionTimeout);

        var initTransition = function initTransition(phase, callback) {
          var removedPhase = phase === 'enter' ? 'exit' : 'enter';

          if (childDOM) {
            appear && removeClass("".concat(classNames, "-").concat(removedPhase, " ").concat(classNames, "-").concat(removedPhase, "ing"), childDOM);
            addClass("".concat(classNames, "-").concat(phase), childDOM);
            callback && callback(childDOM);
          }
        };

        if (_in) {
          initTransition(PHASE_ENTER, onEnter);
          this.setState(function () {
            return mountOnEnter || unmountOnExit ? {
              mount: true,
              state: PHASE_ENTERING,
              appear: true
            } : {
              state: PHASE_ENTERING,
              appear: true
            };
          });
        } else {
          initTransition(PHASE_EXIT, onExit);
          this.setState({
            state: PHASE_EXITING,
            appear: true
          });
        }
      }

      if (prevState.state !== state) {
        if (state === PHASE_ENTERING || state === PHASE_EXITING) {
          clearTimeout(this.transitionTimeout);
        }

        var removeTransitionClass = function removeTransitionClass(state, DOM) {
          DOM.classList.forEach(function (domClass) {
            domClass.startsWith("".concat(classNames, "-").concat(state)) && removeClass(domClass, DOM);
          });
        };

        var startTransition = function startTransition(phase, callback, transitioning) {
          if (childDOM) {
            appear && removeTransitionClass("".concat(phase === PHASE_ENTER ? PHASE_EXIT : PHASE_ENTER), childDOM);
            transitioning && void childDOM.offsetWidth;
            !hasClass("".concat(classNames, "-").concat(phase, "ed"), childDOM) && addClass("".concat(classNames, "-").concat(phase).concat(transitioning ? 'ing' : ''), childDOM);
            callback && callback(childDOM);
          }
        };

        var endTransition = function endTransition(phase, callback) {
          if (childDOM) {
            !appear && removeClass("".concat(classNames, "-").concat(phase, " ").concat(classNames, "-").concat(phase, "ing"), childDOM);
            addClass("".concat(classNames, "-").concat(phase, "ed"), childDOM);
            callback && callback(childDOM);
          }
        };

        switch (state) {
          case PHASE_ENTERING:
            startTransition(PHASE_ENTER, onEntering, true);
            this.transitionTimeout = setTimeout(function () {
              _this2.setState({
                state: PHASE_ENTERED,
                appear: false
              });
            }, enterTimeout);
            break;

          case PHASE_ENTERED:
            endTransition(PHASE_ENTER, onEntered);
            break;

          case PHASE_EXITING:
            startTransition(PHASE_EXIT, onExiting, true);
            this.transitionTimeout = setTimeout(function () {
              _this2.setState({
                state: PHASE_EXITED,
                appear: false
              }, function () {
                if (unmountOnExit) {
                  _this2.setState({
                    mount: false,
                    state: ''
                  });
                }
              });
            }, exitTimeout);
            break;

          case PHASE_EXITED:
            endTransition(PHASE_EXIT, onExited);
            break;
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.transitionTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _children$props$inner2, _children$ref2;

      var _this$props2 = this.props,
          children = _this$props2.children,
          _in = _this$props2["in"],
          mountOnEnter = _this$props2.mountOnEnter,
          unmountOnExit = _this$props2.unmountOnExit;
      var mount = this.state.mount;

      if (mountOnEnter || unmountOnExit) {
        if (!_in && !mount) {
          return null;
        }

        if (mount) {
          var _children$props$inner, _children$ref;

          return isStyledComponent(children) ? React.cloneElement(children, {
            innerRef: (_children$props$inner = children.props.innerRef) !== null && _children$props$inner !== void 0 && _children$props$inner.current ? children.props.innerRef : this.childRef
          }) : React.cloneElement(children, {
            ref: (_children$ref = children.ref) !== null && _children$ref !== void 0 && _children$ref.current ? children.ref : this.childRef
          });
        }
      }

      return isStyledComponent(children) ? React.cloneElement(children, {
        innerRef: (_children$props$inner2 = children.props.innerRef) !== null && _children$props$inner2 !== void 0 && _children$props$inner2.current ? children.props.innerRef : this.childRef
      }) : React.cloneElement(children, {
        ref: (_children$ref2 = children.ref) !== null && _children$ref2 !== void 0 && _children$ref2.current ? children.ref : this.childRef
      });
    }
  }]);

  return UnifyCSSTransition;
}(PureComponent);

_defineProperty(UnifyCSSTransition, "defaultProps", {
  "in": false,
  mountOnEnter: false,
  timeout: 0,
  unmountOnExit: false,
  onEnter: function onEnter() {},
  onEntered: function onEntered() {},
  onEntering: function onEntering() {},
  onExit: function onExit() {},
  onExited: function onExited() {},
  onExiting: function onExiting() {}
});

export default UnifyCSSTransition;