import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["className", "display", "label", "onClick", "placeholder", "title"];
import React, { Component } from 'react';
import { cx } from 'emotion';
import { canUseDOM } from "../../../../build/Providers/common/functions";
import sanitizeHtml from 'sanitize-html';
import RichTextEditorButton from "./_RichTextEditorButton";
import RichTextEditorHeadline from "./_RichTextEditorHeadline";
import { unf_editor, unf_bottomsheet_editor } from "./_FormStyle";
import BottomSheet from "../../../../build/BottomSheet";
import TextField from "../../../../build/TextField";

var RichTextEditor = function (_Component) {
  _inherits(RichTextEditor, _Component);

  var _super = _createSuper(RichTextEditor);

  function RichTextEditor() {
    var _this;

    _classCallCheck(this, RichTextEditor);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      config: ['bold', 'underline', 'insertOrderedList', 'insertUnorderedList', 'p', 'h'],
      headlines: ['h1', 'h2', 'h3'],
      showHeadlines: false,
      sampleText: ''
    });

    _defineProperty(_assertThisInitialized(_this), "UNSAFE_componentWillReceiveProps", function (nextProps) {
      if (nextProps.display !== _this.props.display && !nextProps.display) {
        _this.element && _this.element.classList.remove('unf-menu--show');
      }
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      var editor = _this.editor;

      if (prevProps.display !== _this.props.display) {
        editor.focus();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setEditorRef", function (node) {
      _this.editor = node;
    });

    _defineProperty(_assertThisInitialized(_this), "setToolbarRef", function (node) {
      _this.toolbar = node;
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onChange = _this$props.onChange;
      onChange(_this.editor.innerHTML);
      onClose();
    });

    _defineProperty(_assertThisInitialized(_this), "handleToggleToolbar", function () {
      var toolbar = _this.toolbar;

      if (_this.props && _this.props.display && toolbar && !toolbar.classList.contains('unf-editor__toolbar--show') && canUseDOM) {
        setTimeout(function () {
          toolbar && toolbar.classList.add('unf-editor__toolbar--show');
        }, 40);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelectedText", function () {
      var text = '';

      if (window.getSelection) {
        text = window.getSelection().toString();
      } else if (document.selection && document.selection.type !== 'Control') {
        text = document.selection.createRange().text;
      }

      _this.setState({
        sampleText: text
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleExecCom", function (command) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var editor = _this.editor;
      editor.focus();
      var el = event && event.target;

      if (command === 'insertUnorderedList') {
        document.getElementsByClassName('insertOrderedList')[0].classList.remove('active');
      } else if (command === 'insertOrderedList') {
        document.getElementsByClassName('insertUnorderedList')[0].classList.remove('active');
      }

      if (el && el.classList.contains('active')) {
        el.classList.remove('active');
      } else if (el && !el.classList.contains('active')) {
        el.classList.add('active');
      }

      if (command === 'p' || command === 'h1' || command === 'h2' || command === 'h3') {
        document.execCommand('formatBlock', false, command);
      } else {
        document.execCommand(command, false, null);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "toggleHeadlines", function () {
      var editor = _this.editor;
      editor.focus();

      _this.setState({
        showHeadlines: !_this.state.showHeadlines
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderToolbar", function () {
      var _this$state = _this.state,
          config = _this$state.config,
          showHeadlines = _this$state.showHeadlines;
      var toolbar = [];
      config.map(function (item, index) {
        toolbar.push(React.createElement(RichTextEditorButton, {
          showHeadlines: showHeadlines,
          onClick: _this.handleExecCom,
          toggleHeadlines: _this.toggleHeadlines,
          command: item,
          key: "".concat(item, "-").concat(index)
        }));
      });
      return toolbar;
    });

    _defineProperty(_assertThisInitialized(_this), "renderTextEditor", function () {
      var value = _this.props.value;
      var cleanValue = sanitizeHtml(value);
      return React.createElement("div", {
        ref: _this.setEditorRef,
        className: "unf-editor--text",
        contentEditable: true,
        suppressContentEditableWarning: true,
        onFocus: _this.handleToggleToolbar,
        onKeyUp: _this.handleSelectedText,
        dangerouslySetInnerHTML: {
          __html: cleanValue
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderHeadlines", function () {
      var _this$state2 = _this.state,
          headlines = _this$state2.headlines,
          sampleText = _this$state2.sampleText;
      var headlinesList = [];
      headlines.map(function (item, index) {
        headlinesList.push(React.createElement(RichTextEditorHeadline, {
          onClick: _this.handleExecCom,
          command: item,
          key: "".concat(item, "-").concat(index)
        }, sampleText));
      });
      return headlinesList;
    });

    _defineProperty(_assertThisInitialized(_this), "renderComponent", function () {
      var _this$props2 = _this.props,
          className = _this$props2.className,
          display = _this$props2.display,
          label = _this$props2.label,
          onClick = _this$props2.onClick,
          placeholder = _this$props2.placeholder,
          title = _this$props2.title,
          rteProps = _objectWithoutProperties(_this$props2, _excluded);

      var textFieldProps = {
        label: label,
        placeholder: placeholder,
        onClick: onClick,
        value: _this.editor ? _this.editor.innerText : ''
      };
      var textEditorClass = cx(unf_editor, className);
      return React.createElement(React.Fragment, null, React.createElement(TextField, textFieldProps), React.createElement(BottomSheet, {
        className: unf_bottomsheet_editor,
        display: display,
        full: true,
        padding: "0",
        onClose: _this.handleClose,
        title: title
      }, React.createElement("div", _extends({
        className: textEditorClass
      }, rteProps), _this.renderTextEditor(), React.createElement("div", {
        className: "unf-editor__toolbar",
        ref: _this.setToolbarRef
      }, _this.state.showHeadlines && React.createElement("div", {
        className: "unf-editor__toolbar-headlines"
      }, _this.renderHeadlines()), React.createElement("div", {
        className: "unf-editor__toolbar-container"
      }, _this.renderToolbar())))));
    });

    return _this;
  }

  _createClass(RichTextEditor, [{
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, this.renderComponent());
    }
  }]);

  return RichTextEditor;
}(Component);

RichTextEditor.defaultProps = {
  display: false,
  title: 'Text Editor'
};
export default RichTextEditor;