import React from 'react';
import { cx } from 'emotion';
import Chip from "../../../../build/Chip";

var RichTextEditorButton = function RichTextEditorButton(props) {
  var command = props.command,
      onClick = props.onClick,
      toggleHeadlines = props.toggleHeadlines,
      showHeadlines = props.showHeadlines;

  var handleClick = function handleClick(event) {
    onClick(command, event);
  };

  var classes = cx('icon', command);
  return command === 'p' ? React.createElement("button", {
    className: "paragraph",
    onClick: handleClick
  }, "Paragraph") : command === 'h' ? React.createElement(Chip, {
    active: showHeadlines,
    onClick: toggleHeadlines
  }, "Headlines") : React.createElement("button", {
    className: classes,
    onClick: handleClick
  });
};

export default RichTextEditorButton;