import styled, { css } from 'react-emotion';
import { N700, G400, R500, colorTextDisabled, colorTextHigh, colorTextPlaceholder, colorTextLow, colorBorder, colorChipDisabled as colorBorderDisabled } from 'unify-token/build/v2/colors';
import { spacingRAWLv3 } from 'unify-token/build/v2/spacings';
import { fontSizeLv2, fontSizeLv4, fontWeightRegular } from 'unify-token/build/v2/typographies';
import icon_close from "../../../../build/Providers/assets/ic_close.svg";
var UNF_SPACING = spacingRAWLv3;
var INPUT_HEIGHT = 20;
var INPUT_SPACING = 3;
export var TRANSITION_DURATION = 280;
export var LABEL_LINE_HEIGHT = 18;
export var Container = styled('div', {
  target: "e16qnar70"
})("label:unf-input;margin-bottom:", UNF_SPACING * 2, "px;");
export var Group = styled('div', {
  target: "e16qnar71"
})("color:", N700, ";border-bottom-width:1px;border-bottom-color:", function (props) {
  return props.disabled ? colorBorderDisabled : colorBorder;
}, ";border-bottom-style:solid;display:flex;align-items:center;position:relative;padding-top:", function (_ref) {
  var label = _ref.label;
  return label ? "".concat(LABEL_LINE_HEIGHT, "px") : undefined;
}, ";transition:border-bottom-style ", TRANSITION_DURATION, "ms ease;&::before{content:'';width:0;height:1px;background-color:", G400, ";position:absolute;bottom:-1px;left:0;z-index:2;transition:width ", TRANSITION_DURATION, "ms ease;", Container, ".isfocused &,", Container, ".isSuccess &,", Container, ".isError &{width:100%;}", Container, ".issuccess &{background-color:", G400, ";opacity:", function (_ref2) {
  var disabled = _ref2.disabled;
  return disabled ? 0.32 : 1;
}, ";}", Container, ".iserror &{background-color:", R500, ";opacity:", function (_ref3) {
  var disabled = _ref3.disabled;
  return disabled ? 0.32 : 1;
}, ";}}.unf-input-wrapper{display:flex;flex:1;position:relative;}.unf-form-control{width:100%;height:", INPUT_HEIGHT + INPUT_SPACING * 2, "px;color:", function (props) {
  return props.disabled ? colorTextDisabled : colorTextHigh;
}, ";font-family:inherit;font-size:", fontSizeLv4, ";font-weight:", fontWeightRegular, ";line-height:", INPUT_HEIGHT, "px;background-color:transparent;border:none;border-radius:0;position:relative;outline:none;padding:", INPUT_SPACING, "px 0;margin:0;transition:color ", TRANSITION_DURATION, "ms ease;&:last-child{padding-right:16px;}&::placeholder{color:", function (props) {
  return props.disabled ? colorTextDisabled : colorTextPlaceholder;
}, ";}& + .unf-input-group__addon:not(:last-child){margin-right:0;margin-left:8px;}}textarea.unf-form-control{height:", INPUT_HEIGHT, "px;max-height:60px;resize:none;overflow:hidden;box-sizing:content-box;padding:0;margin:", INPUT_SPACING, "px 0;&:focus{transition:none;}}select.unf-form-control{z-index:2;padding-right:30px;appearance:none;&::-ms-expand{display:none;}option{padding-right:0;padding-left:0;}}i.unf-input-clear{display:block;border:none;position:absolute;right:0;top:0;bottom:0;padding:16px;font-weight:600;line-height:16px;background-image:url('", icon_close, "');background-position:right center;background-size:16px;background-repeat:no-repeat;}");
export var Info = styled('div', {
  target: "e16qnar72"
})("color:", function (props) {
  return props.disabled ? colorTextDisabled : colorTextLow;
}, ";font-size:", fontSizeLv2, ";line-height:1.5;span{opacity:1;font-size:", fontSizeLv2, ";display:inline-block;position:relative;top:0;transition:all ", TRANSITION_DURATION, "ms ease;&.animated{opacity:0;top:-4px;}}", Container, ".issuccess &{color:", G400, ";opacity:", function (_ref4) {
  var disabled = _ref4.disabled;
  return disabled ? 0.32 : 1;
}, ";}", Container, ".iserror &{color:", R500, ";opacity:", function (_ref5) {
  var disabled = _ref5.disabled;
  return disabled ? 0.32 : 1;
}, ";}");
export var InfoContainer = styled('div', {
  target: "e16qnar73"
})("width:100%;height:22px;min-height:22px;display:table;padding-top:", UNF_SPACING / 2, "px;> div{display:table-cell;vertical-align:top;}");
export var Label = styled('label', {
  target: "e16qnar74"
})("width:100%;font-size:", fontSizeLv4, ";line-height:", LABEL_LINE_HEIGHT, "px;font-weight:normal;white-space:nowrap;text-overflow:ellipsis;pointer-events:none;overflow:hidden;position:absolute;top:4px;will-change:transform,font-size;color:", function (_ref6) {
  var disabled = _ref6.disabled;
  return disabled ? colorTextDisabled : colorTextLow;
}, ";transition:", function (_ref7) {
  var hasPrepend = _ref7.hasPrepend;
  return hasPrepend ? "color ".concat(TRANSITION_DURATION, "ms ease, font-size ").concat(TRANSITION_DURATION, "ms ease, top ").concat(TRANSITION_DURATION, "ms ease, transform ").concat(TRANSITION_DURATION, "ms ease") : "color ".concat(TRANSITION_DURATION, "ms ease, font-size ").concat(TRANSITION_DURATION, "ms ease, top ").concat(TRANSITION_DURATION, "ms ease");
}, ";", Container, ".isfocused &,&.hasValue{font-size:", fontSizeLv2, ";color:", function (_ref8) {
  var disabled = _ref8.disabled;
  return disabled ? colorTextDisabled : colorTextLow;
}, ";top:", function (_ref9) {
  var hasPrepend = _ref9.hasPrepend;
  return !hasPrepend && "-".concat(LABEL_LINE_HEIGHT, "px");
}, ";}");
var _ref10 = "height:16px;width:16px;background-position:center;background-repeat:no-repeat;background-size:16px;opacity:";
var _ref11 = ";&:not(:first-child){margin-right:0;}";

var handleAddonPassword = function handleAddonPassword(props) {
  return props.password && css(_ref10, props.disabled ? '0.12' : '0.38', _ref11);
};

export var Addon = styled('div', {
  target: "e16qnar75"
})("font-size:", fontSizeLv4, ";line-height:", INPUT_HEIGHT, "px;margin-right:8px;opacity:", function (_ref12) {
  var disabled = _ref12.disabled;
  return disabled ? 0.32 : 1;
}, ";transition:color ", TRANSITION_DURATION, "ms ease;&:last-child{margin-right:0;margin-left:8px;}", Group, " .unf-input-control + &:not(:last-child){margin-right:0;margin-left:8px;}", handleAddonPassword, ";");
export var Counter = styled('div', {
  target: "e16qnar76"
})("width:55px;color:", function (props) {
  return props.disabled ? colorTextDisabled : colorTextLow;
}, ";font-size:", fontSizeLv2, ";line-height:1.5;text-align:right;> span{font-size:inherit;}");