import styled, { css, keyframes } from 'react-emotion';
import { colorPageBackground, colorShadow } from 'unify-token/build/v2/colors';
import { NN100, NN200 } from 'unify-token/colors';
export var KeyframeShimmer = keyframes("0%{background-position:-300px;}100%{background-position:300px;}");
export var KeyframeShimmerOpacity = keyframes("0%{opacity:0.3;}50%{opacity:0.7;}100%{opacity:0.3;}");
var KeyframeUpperDot = keyframes("0%{transform:translateY(-50%);}50%{transform:translateY(50%);}100%{transform:translateY(-50%);}");
var KeyframeLowerDot = keyframes("0%{transform:translateY(50%);}50%{transform:translateY(-50%);}100%{transform:translateY(50%);}");
export var ShimmerRules = css("background-color:", NN100, ";animation:", KeyframeShimmerOpacity, " 1200ms linear 1ms infinite;");
export var Line = styled("div", {
  target: "e2kcd2d0"
})("label:unf-loader-line;background-color:", NN100, ";display:block;width:", function (_ref) {
  var width = _ref.width;
  return width && width;
}, ";height:", function (_ref2) {
  var height = _ref2.height;
  return height && height;
}, ";border-radius:", function (_ref3) {
  var borderRadius = _ref3.borderRadius;
  return borderRadius && borderRadius;
}, ";margin-bottom:", function (_ref4) {
  var marginBottom = _ref4.marginBottom;
  return marginBottom && marginBottom;
}, ";", function (_ref5) {
  var shimmer = _ref5.shimmer;
  return shimmer && ShimmerRules;
}, ";");
export var Circle = styled("div", {
  target: "e2kcd2d1"
})("label:unf-loader-circle;background-color:", NN100, ";border-radius:50%;margin:auto;width:", function (_ref6) {
  var width = _ref6.width;
  return width && width;
}, ";height:", function (_ref7) {
  var height = _ref7.height;
  return height && height;
}, ";margin-bottom:", function (_ref8) {
  var marginBottom = _ref8.marginBottom;
  return marginBottom && marginBottom;
}, ";", function (_ref9) {
  var shimmer = _ref9.shimmer;
  return shimmer && ShimmerRules;
}, ";");
export var Square = styled("div", {
  target: "e2kcd2d2"
})("label:unf-loader-square;background-color:", NN100, ";border-radius:8px;width:", function (_ref10) {
  var width = _ref10.width;
  return width && width;
}, ";padding-bottom:", function (_ref11) {
  var paddingBottom = _ref11.paddingBottom;
  return paddingBottom && paddingBottom;
}, ";margin-bottom:", function (_ref12) {
  var marginBottom = _ref12.marginBottom;
  return marginBottom && marginBottom;
}, ";", function (_ref13) {
  var shimmer = _ref13.shimmer;
  return shimmer && ShimmerRules;
}, ";");
export var Card = css("label:unf-loader-card;height:123px;border-radius:4px;box-shadow:0 2px 6px 0.5px ", colorShadow, ";padding:16px;margin:16px;");
export var Container = css("label:unf-loader-container;height:123px;box-shadow:0 2px 6px 0.5px ", colorShadow, ";margin:16px 0;padding:16px;");
export var Form = css("label:unf-loader-form;margin:0 16px;");
export var FormItem = css("label:unf-loader-form-item;border-bottom:1px solid ", NN100, ";padding:32px 0;");
export var Grid = css("label:unf-loader-grid;margin:16px 0;");
export var GridItem = css("label:unf-loader-grid-item;width:50%;display:inline-block;padding:16px;");
export var Home = css("label:unf-loader-home;margin:24px 0 32px 0;& div{width:80%;border-radius:4px;display:inline-block;padding-top:30%;box-sizing:border-box;", ShimmerRules, " &:first-child{width:6%;border-radius:0 4px 4px 0;margin-right:4%;}&:last-child{width:6%;border-radius:4px 0 0 4px;margin-left:4%;}}");
export var HomeItem = css("label:unf-loader-home-item;width:25%;display:inline-block;padding:8px 0;", Line, ",& span{margin-right:auto;margin-left:auto;}");
export var Jumper = css("label:unf-loader-jumper;width:100%;height:100%;background-color:", colorPageBackground, ";opacity:1;position:absolute;left:0;top:0;z-index:9999;transition:opacity 1000ms ease;&.unf-js-jumper-unmount,&.unmount{opacity:0;}");
export var JumperAnimation = css("width:56px;height:56px;position:absolute;top:calc(50% - 28px);left:calc(50% - 28px);margin:auto;&::before,&::after{content:'';width:32px;height:32px;border-radius:50%;position:absolute;top:calc(50% - 16px);left:calc(50% - 16px);}&::before{background-image:linear-gradient(to bottom,#ffce3a,#42b549);opacity:0.8;animation:", KeyframeUpperDot, " 1500ms linear infinite;}&::after{background-image:linear-gradient(to top,#72dfe7,#42b549);opacity:0.8;animation:", KeyframeLowerDot, " 1500ms linear infinite;}");
export var List = css("label:unf-loader-list;margin-left:16px;");
export var ListItem = css("label:unf-loader-list-item;border-bottom:1px solid ", NN200, ";display:flex;align-items:center;padding:24px 0;");
export var PDPHeader = css("label:unf-loader-pdp-header;width:100%;padding-bottom:100%;margin-bottom:24px;", ShimmerRules);
export var PDPItem = css("label:unf-loader-pdp-item;width:33.33%;display:inline-block;padding:16px 0;", Line, ",& span{margin-left:auto;margin-right:auto;}");
export var PDPFooter = css("label:unf-loader-pdp-footer;margin:16px;");
export var ShopHeader = css("label:unf-loader-shop-header;width:100%;box-shadow:0 2px 6px 0.5px ", colorShadow, ";padding-top:25%;margin-bottom:16px;", ShimmerRules);
export var ShopDescription = css("label:unf-loader-shop-description;padding:16px 16px 0;");