import styled, { css } from 'react-emotion';
import { durationT1, easeOut, durationT2, easeInOut } from 'unify-token/build/v2/motions';
import { NN200, NN300, NN400, NN950, GN500, NN100 } from 'unify-token/colors';
import { fontSizeLv2 } from 'unify-token/build/v2/typographies';
import { cssRipple } from "../../build/Providers/common/style";
export var quantityButtonStyle = css("background-color:transparent;padding:0;border:none;-webkit-appearance:none;> .unf-icon{display:block !important;}");

var handleWidth = function handleWidth(_ref) {
  var width = _ref.width,
      maxValueDigit = _ref.maxValueDigit;

  switch (true) {
    case Boolean(width):
      return width;

    case maxValueDigit <= 3:
      return '90px';

    default:
      return "".concat(90 + (maxValueDigit - 3) * 10, "px");
  }
};

var handleBorderColor = function handleBorderColor(isFocus, disabled) {
  if (disabled) {
    return NN200;
  } else if (isFocus) {
    return GN500;
  } else {
    return NN300;
  }
};

export var Container = styled("div", {
  target: "e174zyp0"
})("label:unf-quantity-editor;display:inline-flex;height:32px;box-sizing:border-box;align-items:center;border:solid 1px ", function (_ref2) {
  var disabled = _ref2.disabled,
      isFocus = _ref2.isFocus;
  return handleBorderColor(isFocus, disabled);
}, ";border-radius:8px;padding:5px;transition:border ", durationT1, " ", easeOut, ";overflow:hidden;width:", handleWidth, ";button{display:flex;align-items:center;justify-content:center;flex-shrink:0;height:22px;width:22px;border-radius:4px;", cssRipple(NN100), " svg{position:relative;transition:transform ", easeInOut, " ", durationT2, ";}&:active{svg{transform:scale(0.75);}}}");
export var Input = styled('input', {
  target: "e174zyp1"
})("label:unf-quantity-editor__input;outline:none;border:none;background-color:transparent;color:", NN950, ";font-family:inherit;font-size:", fontSizeLv2, ";line-height:16px;text-align:center;padding:0;flex-shrink:2;flex-grow:2;width:100%;:disabled{color:", NN400, ";}");