import React from 'react';
interface DataTest {
    minusButton?: string;
    plusButton?: string;
}
declare type QuantityEditorAttributes = React.ComponentPropsWithoutRef<'input'>;
export interface QuantityEditorBaseProps {
    /**
     * To give customized style
     */
    className?: string;
    /**
     * To provide data-testid
     */
    dataTest?: DataTest;
    /**
     * To apply disabled QuantityEditor design
     */
    disabled?: boolean;
    /**
     * Set accessible button label language
     */
    lang?: 'en' | 'id';
    /**
     * To set the max value that can be inputted in QuantityEditor
     */
    max?: number;
    /**
     * To set the min value that can be inputted in QuantityEditor
     */
    min?: number;
    /**
     * To prevent users from directly editing value of the input. Users may still change value by clicking on min and plus icon
     */
    readonly?: boolean;
    /**
     * To set the value increased/decreased when +/- button is clicked
     */
    spinner?: number;
    /**
     * To specify the input value of QuantityEditor
     */
    value?: number | string;
    /**
     * To set the width of QuantityEditor
     */
    width?: string;
    /**
     * To pass callback when value is changed
     */
    onChange?: (val: string, e?: React.ChangeEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when minus icon is clicked
     */
    onClickMin?: (e?: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when plus icon is clicked
     */
    onClickPlus?: (e?: React.MouseEvent<HTMLButtonElement>) => void;
}
export declare type QuantityEditorProps = QuantityEditorBaseProps & Omit<QuantityEditorAttributes, keyof QuantityEditorBaseProps | 'css'>;
export {};
