import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["id", "className", "name", "value", "useLabel", "checked", "disabled", "onChange", "onClick", "inputProps"];
import React from 'react';
import { cx } from 'emotion';
import { Radio as ContainerLabel, RadioDiv as ContainerDiv } from "./style";

var Radio = function Radio(_ref) {
  var _ref$id = _ref.id,
      id = _ref$id === void 0 ? '' : _ref$id,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '' : _ref$name,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value,
      _ref$useLabel = _ref.useLabel,
      useLabel = _ref$useLabel === void 0 ? true : _ref$useLabel,
      _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? function () {} : _ref$onClick,
      _ref$inputProps = _ref.inputProps,
      otherInputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var containerClass = cx('unf_radio', {
    isDisabled: disabled
  }, className);

  var inputProps = _objectSpread({
    id: id,
    name: name,
    value: value,
    checked: checked,
    disabled: disabled,
    onClick: onClick,
    onChange: onChange
  }, otherInputProps);

  var Container = useLabel ? ContainerLabel : ContainerDiv;
  return React.createElement(Container, _extends({
    disabled: disabled,
    className: containerClass
  }, otherProps), React.createElement("input", _extends({
    "data-unify": "Radio",
    type: "radio"
  }, inputProps)), React.createElement("span", {
    className: "unf-radio__area radio-area"
  }));
};

export default Radio;