import React from 'react';
declare type RadioAttributes = React.ComponentPropsWithRef<'label' | 'div'>;
export interface RadioProps extends Omit<RadioAttributes, 'onChange' | 'onClick' | 'css'> {
    /**
     * this is not used anywhere, it might be deprecated
     */
    appendText?: string;
    /**
     * To apply checked Radio design
     */
    checked?: boolean;
    /**
     * To pass custom className to create custom style
     */
    className?: string;
    /**
     * To apply disabled Radio design
     */
    disabled?: boolean;
    /**
     * Radio input id
     */
    id?: string;
    /**
     * Insert custom property into input
     */
    inputProps?: Record<string, any>;
    /**
     * Radio input name
     */
    name?: string;
    /**
     * this is not used anywhere, it might be deprecated
     */
    prependText?: string;
    /**
     * Wrapper as label
     */
    useLabel?: boolean;
    /**
     * Radio input value
     */
    value?: string;
    /**
     * Action when Radio value is changed. `(event) => void;`
     */
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    /**
     * Action when Radio is clicked. `(event) => void;`
     */
    onClick?: (e: React.MouseEvent<HTMLInputElement>) => void;
}
export {};
