import { Component } from 'react';
export interface RangeSliderProps {
    /**
     * To apply disabled Rangeslider design
     */
    disabled?: boolean;
    /**
     * To set max value can be inputted in QuantityEditor
     */
    max?: number;
    /**
     * To set min value can be inputted in QuantityEditor
     */
    min?: number;
    /**
     * To set interval between value indicators
     */
    separator?: number;
    /**
     * To set step when sliding
     */
    step?: number;
    /**
     * To set value on RangeSlider
     */
    values?: number[];
    /**
     * To pass callback when onChange event is triggered
     */
    onChange?: () => void;
    /**
     * To pass callback whenever the user is actively changing the values on the slider
     */
    onValuesUpdated?: () => void;
}
declare class RangeSlider extends Component<RangeSliderProps> {
    state: {
        handlePos: any[];
        handleDimensions: number;
        slidingIndex: any;
        values: number[];
        snapPoints: any[];
    };
    componentDidMount: () => void;
    componentDidUpdate: (prevProps: any) => void;
    componentWillUnmount(): void;
    setHandleNode: (node: any) => void;
    setHandleContainerNode: (node: any) => void;
    getSnapPoints: () => any[];
    getPublicState: () => {
        max: number;
        min: number;
        values: number[];
    };
    getMinValue: (idx: any) => number;
    getMaxValue: (idx: any) => number;
    getSliderBoundingBox: () => {
        height: any;
        left: any;
        right: any;
        top: any;
        width: any;
    };
    getHandleDimensions: () => any;
    getNextState: (idx: any, proposedPosition: any) => {
        handlePos: any[];
        values: any[];
    };
    getClosestSnapPoint: (value: any) => any;
    getSnapPosition: (positionPercent: any) => any;
    getProgressStyle: (idx: any) => {
        left: number;
        width: string;
    } | {
        left: string;
        width: string;
    };
    positionPercent: (x: any, sliderBox: any) => number;
    validatePosition: (idx: any, proposedPosition: any) => number;
    updateNewValues: (props: any) => boolean;
    validateValues: (proposedValues: any, props: any) => any;
    handleMouseSlide: (e: any) => boolean;
    handleTouchSlide: (e: any) => boolean;
    handleSlide: (x: any) => void;
    endSlide: () => void;
    fireChangeEvent: () => void;
    slideTo: (idx: any, proposedPosition: any, onAfterSet: any) => void;
    setStartSlide: (e: any) => void;
    startMouseSlide: (e: any) => void;
    startTouchSlide: (e: any) => void;
    renderSeparator: (separator: any) => any[];
    renderProgressBar: () => JSX.Element[];
    render(): JSX.Element;
}
export default RangeSlider;
