import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component } from 'react';
import { getHandleFor, getPosition, getValue, killEvent } from "../../build/Providers/common/utilities/Archive/Algorithm/linear";
import { canUseDOM } from "../../build/Providers/common/functions";
import { Container, Background, HandleContainer, Handle, ProgressBar } from "./style";

var RangeSlider = function (_Component) {
  _inherits(RangeSlider, _Component);

  var _super = _createSuper(RangeSlider);

  function RangeSlider() {
    var _this;

    _classCallCheck(this, RangeSlider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      handlePos: [],
      handleDimensions: 0,
      slidingIndex: null,
      values: _this.props.values,
      snapPoints: []
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      var _this$props = _this.props,
          min = _this$props.min,
          max = _this$props.max,
          values = _this$props.values;

      var newArray = _this.getSnapPoints();

      var newHandlePos = values.map(function (value) {
        return getPosition(value, min, max);
      });

      _this.setState({
        handlePos: newHandlePos,
        snapPoints: newArray
      });

      _this.handleDimensionsTimeout = setTimeout(function () {
        _this.handleDimensionsTimeout = null;

        _this.setState({
          handleDimensions: _this.getHandleDimensions()
        });
      }, 0);
      console.warn('This component is going to be deprecated. Please update to SliderV2 if you see this error message (http://design.tokopedia.net/mobile/?path=/story/components-sliders--default-sliderv2). Please contact unify-dev if you have any concerns.');
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          min = _this$props2.min,
          max = _this$props2.max,
          values = _this$props2.values;
      var slidingIndex = _this.state.slidingIndex;
      var minMaxChanged = prevProps.min !== min || prevProps.max !== max;
      var valuesChanged = values.length !== prevProps.values.length || values.some(function (value, idx) {
        return prevProps.values[idx] !== value;
      });
      var willBeDisabled = prevProps.disabled && !disabled;

      if (minMaxChanged || valuesChanged) {
        setTimeout(function () {
          _this.updateNewValues(_this.props);
        }, 1);
      }

      if (willBeDisabled && slidingIndex !== null) {
        _this.endSlide();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setHandleNode", function (node) {
      _this.handleNode = node;
    });

    _defineProperty(_assertThisInitialized(_this), "setHandleContainerNode", function (node) {
      _this.handleContainerNode = node;
    });

    _defineProperty(_assertThisInitialized(_this), "getSnapPoints", function () {
      var _this$props3 = _this.props,
          min = _this$props3.min,
          max = _this$props3.max,
          step = _this$props3.step;
      var newArray = [];

      for (var x = min; x <= max; x++) {
        if (x % step === 0) {
          newArray.push(x);
        }
      }

      return newArray;
    });

    _defineProperty(_assertThisInitialized(_this), "getPublicState", function () {
      var values = _this.state.values;
      var _this$props4 = _this.props,
          min = _this$props4.min,
          max = _this$props4.max;
      return {
        max: max,
        min: min,
        values: values
      };
    });

    _defineProperty(_assertThisInitialized(_this), "getMinValue", function (idx) {
      var min = _this.props.min;
      var values = _this.state.values;
      return values[idx - 1] ? Math.max(min, values[idx - 1]) : min;
    });

    _defineProperty(_assertThisInitialized(_this), "getMaxValue", function (idx) {
      var max = _this.props.max;
      var values = _this.state.values;
      return values[idx + 1] ? Math.min(max, values[idx + 1]) : max;
    });

    _defineProperty(_assertThisInitialized(_this), "getSliderBoundingBox", function () {
      var rect = _this.handleContainerNode.getBoundingClientRect();

      return {
        height: rect.height || _this.handleContainerNode.clientHeight,
        left: rect.left,
        right: rect.right,
        top: rect.top,
        width: rect.width || _this.handleContainerNode.clientWidth
      };
    });

    _defineProperty(_assertThisInitialized(_this), "getHandleDimensions", function () {
      if (!_this.handleNode) {
        return 0;
      }

      return _this.handleNode.clientWidth;
    });

    _defineProperty(_assertThisInitialized(_this), "getNextState", function (idx, proposedPosition) {
      var handlePos = _this.state.handlePos;
      var _this$props5 = _this.props,
          max = _this$props5.max,
          min = _this$props5.min;

      var actualPosition = _this.validatePosition(idx, proposedPosition);

      var nextHandlePos = handlePos.map(function (pos, index) {
        return index === idx ? actualPosition : pos;
      });
      return {
        handlePos: nextHandlePos,
        values: nextHandlePos.map(function (pos) {
          return getValue(pos, min, max);
        })
      };
    });

    _defineProperty(_assertThisInitialized(_this), "getClosestSnapPoint", function (value) {
      var snapPoints = _this.state.snapPoints;

      if (!snapPoints.length) {
        return value;
      }

      return snapPoints.reduce(function (snapTo, step) {
        return Math.abs(snapTo - value) < Math.abs(step - value) ? snapTo : step;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getSnapPosition", function (positionPercent) {
      var _this$props6 = _this.props,
          max = _this$props6.max,
          min = _this$props6.min,
          step = _this$props6.step;

      if (!step) {
        return positionPercent;
      }

      var value = getValue(positionPercent, min, max);

      var snapValue = _this.getClosestSnapPoint(value);

      return getPosition(snapValue, min, max);
    });

    _defineProperty(_assertThisInitialized(_this), "getProgressStyle", function (idx) {
      var handlePos = _this.state.handlePos;
      var value = handlePos[idx];

      if (!idx) {
        return {
          left: 0,
          width: "".concat(value, "%")
        };
      }

      var prevValue = handlePos[idx - 1];
      var diffValue = value - prevValue;
      return {
        left: "".concat(prevValue, "%"),
        width: "".concat(diffValue, "%")
      };
    });

    _defineProperty(_assertThisInitialized(_this), "positionPercent", function (x, sliderBox) {
      return (x - sliderBox.left) / sliderBox.width * 100;
    });

    _defineProperty(_assertThisInitialized(_this), "validatePosition", function (idx, proposedPosition) {
      var handlePos = _this.state.handlePos;
      var step = _this.props.step;
      var nextPosition = proposedPosition;
      var handlePercentage = step;
      return Math.max(Math.min(nextPosition, handlePos[idx + 1] ? handlePos[idx + 1] - handlePercentage : 100), handlePos[idx - 1] !== undefined ? handlePos[idx - 1] + handlePercentage : 0);
    });

    _defineProperty(_assertThisInitialized(_this), "updateNewValues", function (props) {
      var slidingIndex = _this.state.slidingIndex;

      if (slidingIndex) {
        return false;
      }

      var max = props.max,
          min = props.min,
          values = props.values;

      var nextValues = _this.validateValues(values, props);

      _this.setState({
        handlePos: nextValues.map(function (value) {
          return getPosition(value, min, max);
        }),
        values: nextValues
      });
    });

    _defineProperty(_assertThisInitialized(_this), "validateValues", function (proposedValues, props) {
      var _ref = props || _this.props,
          max = _ref.max,
          min = _ref.min;

      return proposedValues.map(function (value, idx, values) {
        var realValue = Math.max(Math.min(value, max), min);

        if (values.length && realValue < values[idx - 1]) {
          return values[idx - 1];
        }

        return realValue;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleMouseSlide", function (e) {
      var slidingIndex = _this.state.slidingIndex;

      if (slidingIndex === null) {
        return false;
      }

      _this.handleSlide(e.clientX);

      killEvent(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchSlide", function (e) {
      var slidingIndex = _this.state.slidingIndex;

      if (slidingIndex === null) {
        return false;
      }

      if (e.changedTouches.length > 1) {
        _this.endSlide();

        return;
      }

      var touch = e.changedTouches[0];

      _this.handleSlide(touch.clientX);

      killEvent(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleSlide", function (x) {
      var idx = _this.state.slidingIndex;

      var sliderBox = _this.getSliderBoundingBox();

      var positionPercent = _this.positionPercent(x, sliderBox);

      _this.slideTo(idx, positionPercent);
    });

    _defineProperty(_assertThisInitialized(_this), "endSlide", function () {
      var step = _this.props.step;
      var _this$state = _this.state,
          slidingIndex = _this$state.slidingIndex,
          handlePos = _this$state.handlePos;

      _this.setState({
        slidingIndex: null
      });

      if (canUseDOM && typeof document.removeEventListener === 'function') {
        document.removeEventListener('mouseup', _this.endSlide, false);
        document.removeEventListener('touchend', _this.endSlide, false);
        document.removeEventListener('touchmove', _this.handleTouchSlide, false);
        document.removeEventListener('mousemove', _this.handleMouseSlide, false);
      } else if (canUseDOM) {
        document.detachEvent('onmousemove', _this.handleMouseSlide);
        document.detachEvent('onmouseup', _this.endSlide);
      }

      if (step) {
        var positionPercent = _this.getSnapPosition(handlePos[slidingIndex]);

        _this.slideTo(slidingIndex, positionPercent, function () {
          return _this.fireChangeEvent();
        });
      } else {
        _this.fireChangeEvent();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "fireChangeEvent", function () {
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(_this.getPublicState());
      }
    });

    _defineProperty(_assertThisInitialized(_this), "slideTo", function (idx, proposedPosition, onAfterSet) {
      var onValuesUpdated = _this.props.onValuesUpdated;

      var nextState = _this.getNextState(idx, proposedPosition);

      _this.setState(nextState, function () {
        if (onValuesUpdated) {
          onValuesUpdated(_this.getPublicState());
        }

        if (onAfterSet) {
          onAfterSet();
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "setStartSlide", function (e) {
      var sliderBox = _this.getSliderBoundingBox();

      _this.setState({
        handleDimensions: _this.getHandleDimensions(e, sliderBox),
        slidingIndex: getHandleFor(e)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "startMouseSlide", function (e) {
      _this.setStartSlide(e, e.clientX, e.clientY);

      if (canUseDOM && typeof document.addEventListener === 'function') {
        document.addEventListener('mousemove', _this.handleMouseSlide, false);
        document.addEventListener('mouseup', _this.endSlide, false);
      } else if (canUseDOM) {
        document.attachEvent('onmousemove', _this.handleMouseSlide);
        document.attachEvent('onmouseup', _this.endSlide);
      }

      killEvent(e);
    });

    _defineProperty(_assertThisInitialized(_this), "startTouchSlide", function (e) {
      if (e.changedTouches.length > 1) {
        return;
      }

      var touch = e.changedTouches[0];

      _this.setStartSlide(e, touch.clientX, touch.clientY);

      if (canUseDOM) {
        document.addEventListener('touchmove', _this.handleTouchSlide, false);
        document.addEventListener('touchend', _this.endSlide, false);
      }

      killEvent(e);
    });

    _defineProperty(_assertThisInitialized(_this), "renderSeparator", function (separator) {
      var _this$props7 = _this.props,
          max = _this$props7.max,
          min = _this$props7.min;

      if (separator > 20) {
        return;
      }

      var separatorHtml = [];
      separatorHtml.push(React.createElement("div", {
        key: -1,
        className: "unf-slider__separator-item",
        style: {
          width: "".concat(100 / (separator + 1), "%")
        }
      }, React.createElement("div", {
        className: "unf-slider__separator-item-line"
      })));
      var separatorValueRange;

      if (min === 1) {
        separatorValueRange = max / (separator + 1);
      } else {
        separatorValueRange = (max - min) / (separator + 1);
      }

      for (var i = 0; i < separator; i++) {
        var separatorValue = void 0;

        if (min === 1) {
          separatorValue = separatorValueRange * (i + 1);
        } else {
          separatorValue = min + separatorValueRange * (i + 1);
        }

        separatorHtml.push(React.createElement("div", {
          key: i,
          className: "unf-slider__separator-item",
          style: {
            width: "".concat(100 / (separator + 1), "%")
          }
        }, React.createElement("div", {
          className: "unf-slider__separator-item-line"
        }), i === separator - 1 && React.createElement("div", {
          className: "unf-slider__separator-item-line unf-slider__separator-item-line--last"
        })));
      }

      return separatorHtml;
    });

    _defineProperty(_assertThisInitialized(_this), "renderProgressBar", function () {
      var handlePos = _this.state.handlePos;
      var disabled = _this.props.disabled;
      return handlePos.map(function (node, idx, arr) {
        if (idx === 0 && arr.length > 1) {
          return null;
        }

        return React.createElement(ProgressBar, {
          key: idx,
          style: _this.getProgressStyle(idx),
          disabled: disabled
        });
      });
    });

    return _this;
  }

  _createClass(RangeSlider, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.handleDimensionsTimeout) {
        clearTimeout(this.handleDimensionsTimeout);
        this.handleDimensionsTimeout = null;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props8 = this.props,
          disabled = _this$props8.disabled,
          separator = _this$props8.separator;
      var _this$state2 = this.state,
          handlePos = _this$state2.handlePos,
          values = _this$state2.values;
      return React.createElement(Container, {
        separator: separator,
        values: values,
        "data-unify": "RangeSlider"
      }, separator && React.createElement("div", {
        className: "unf-slider__separator"
      }, this.renderSeparator(separator)), React.createElement(Background, null), React.createElement(HandleContainer, {
        innerRef: this.setHandleContainerNode
      }, handlePos.map(function (pos, idx) {
        var handleStyle = {
          marginLeft: "".concat(idx === 1 && '0'),
          left: "".concat(pos, "%"),
          position: 'absolute'
        };
        return React.createElement(Handle, {
          "aria-valuemax": _this2.getMaxValue(idx),
          "aria-valuemin": _this2.getMinValue(idx),
          "aria-valuenow": values[idx],
          "aria-disabled": disabled,
          "data-handle-key": idx,
          key: idx,
          disabled: disabled,
          onClick: _this2.killEvent,
          onMouseDown: disabled ? undefined : _this2.startMouseSlide,
          onTouchStart: disabled ? undefined : _this2.startTouchSlide,
          innerRef: _this2.setHandleNode,
          role: "slider",
          style: handleStyle,
          tabIndex: 0
        });
      })), this.renderProgressBar());
    }
  }]);

  return RangeSlider;
}(Component);

RangeSlider.defaultProps = {
  disabled: false,
  max: 100,
  min: 0,
  step: 1,
  onChange: null,
  onValuesUpdated: null,
  values: [0]
};
export default RangeSlider;