import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["camera", "className", "dataTest", "setRef", "value", "onClear", "onCameraClick"];
import React from 'react';
import { cx } from 'emotion';
import { Clear, Search, Camera } from 'unify-icons/system';
import { NN500 } from 'unify-token/colors';
import { searchWrapper, actionButton, searchInput, searchIconWrapper } from "./style";

var SearchBar = function SearchBar(_ref) {
  var camera = _ref.camera,
      className = _ref.className,
      dataTest = _ref.dataTest,
      setRef = _ref.setRef,
      value = _ref.value,
      onClear = _ref.onClear,
      onCameraClick = _ref.onCameraClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var hasValue = typeof value === 'string' && value.length > 0;
  return React.createElement("div", {
    className: cx(searchWrapper(otherProps), className)
  }, React.createElement("div", {
    className: searchIconWrapper
  }, React.createElement(Search, {
    size: 16,
    color: NN500
  })), React.createElement("input", _extends({
    ref: setRef,
    "data-testid": dataTest === null || dataTest === void 0 ? void 0 : dataTest.txtInput,
    "data-unify": "SearchBar",
    className: cx('unf-searchbar__input', searchInput),
    type: "search",
    value: value
  }, otherProps)), hasValue && React.createElement("button", {
    className: actionButton,
    "data-testid": dataTest === null || dataTest === void 0 ? void 0 : dataTest.clearButton,
    type: "button",
    onClick: onClear
  }, React.createElement(Clear, {
    size: 16,
    color: NN500
  })), !hasValue && camera && React.createElement("button", {
    className: actionButton,
    type: "button",
    "data-testid": dataTest === null || dataTest === void 0 ? void 0 : dataTest.iconCamera,
    onClick: onCameraClick
  }, React.createElement(Camera, {
    size: 16,
    color: NN500
  })));
};

export default SearchBar;