import React from 'react';
export interface SearchBarProps extends React.ComponentProps<'input'> {
    /**
     * To set autoCapitalize attribute
     */
    autoCapitalize?: string;
    /**
     * To set autoComplete attribute
     */
    autoComplete?: string;
    /**
     * To apply block design
     *
     * @deprecated This is default design. No margin applied by default.
     */
    block?: boolean;
    /**
     * To use borderless design
     */
    borderless?: boolean;
    /**
     * To apply camera icon on SearchBar
     */
    camera?: boolean;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To pass data-testid
     */
    dataTest?: DataTest;
    /**
     * To pass custom margin on SearchBar
     */
    margin?: string;
    /**
     * To specify placeholder text
     */
    placeholder?: string;
    /**
     * To set custom ref on SearchBar
     */
    setRef?: React.MutableRefObject<HTMLInputElement> | React.Ref<HTMLInputElement>;
    /**
     * To set value on SearchBar
     */
    value?: string;
    /**
     * To pass action when SearchBar is lost focus
     */
    onBlur?: (e: React.FocusEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when camera icon is clicked
     */
    onCameraClick?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when value is changed
     */
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when clear icon is clicked
     */
    onClear?: (e: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * To pass callback when SearchBar is clicked
     */
    onClick?: (e: React.MouseEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when SearchBar is focused
     */
    onFocus?: (e: React.FocusEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when SearchBar is clicked
     */
    onInput?: (e: React.MouseEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when keydown event is triggered
     */
    onKeyDown?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when keydown event is triggered
     */
    onKeyPress?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    /**
     * To pass callback when keyup event is triggered
     */
    onKeyUp?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
}
interface DataTest {
    txtInput?: string;
    iconCamera?: string;
    clearButton?: string;
}
export declare type ActionClearProps = {
    show?: boolean;
};
export declare type ActionCameraProps = {
    show?: boolean;
};
export {};
