import React, { PureComponent } from 'react';
export interface SelectWithSearchProps {
    children?: object[] | React.ReactNode;
    className?: string;
    disabled?: boolean;
    error?: boolean;
    id?: string;
    info?: string;
    label?: string;
    listDescription?: string;
    listTitle?: string;
    message?: string;
    name?: string;
    searchbarValue?: string;
    searchPlaceholder?: string;
    selectedOption?: string;
    selectPlaceholder?: string;
    success?: boolean;
    onBlur?: (e: React.FocusEvent<HTMLInputElement>) => void;
    onSearchChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
interface SelectWithSearchState {
    openList: boolean;
}
declare class SelectWithSearch extends PureComponent<SelectWithSearchProps, SelectWithSearchState> {
    state: {
        openList: boolean;
    };
    get bottomSheetProps(): {
        full: boolean;
        noPadding: boolean;
        title: string;
        display: boolean;
        onClose: () => void;
    };
    get searchBarProps(): {
        margin: string;
        placeholder: string;
        value: string;
        onChange: (e: any) => void;
        onClear: any;
    };
    get listProps(): {
        noMargin: boolean;
        items: any;
    };
    handleToggleList: () => void;
    get selectInputProps(): {
        appendObject: JSX.Element[];
        id: string;
        name: string;
        label: string;
        readonly: boolean;
        error: boolean;
        info: string;
        inlineLabel: boolean;
        message: string;
        placeholder: string;
        value: string;
        success: boolean;
        disabled: boolean;
    };
    renderDescription: () => JSX.Element;
    handleSelectBlur: (e: any) => void;
    render(): JSX.Element;
}
export default SelectWithSearch;
