import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { ChevronDown } from 'unify-icons/system';
import BottomSheet from "../../build/BottomSheet";
import List from "../../build/List";
import SearchBar from "../../build/SearchBar";
import TextField from "../../build/TextField";
import { unf_list_description, unf_select } from "./style";

var SelectWithSearch = function (_PureComponent) {
  _inherits(SelectWithSearch, _PureComponent);

  var _super = _createSuper(SelectWithSearch);

  function SelectWithSearch() {
    var _this;

    _classCallCheck(this, SelectWithSearch);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      openList: false
    });

    _defineProperty(_assertThisInitialized(_this), "handleToggleList", function () {
      if (!_this.props.disabled) {
        _this.setState(function (_ref) {
          var openList = _ref.openList;
          return {
            openList: !openList
          };
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderDescription", function () {
      var listDescription = _this.props.listDescription;
      return listDescription && React.createElement("div", {
        className: unf_list_description
      }, listDescription);
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelectBlur", function (e) {
      var onBlur = _this.props.onBlur;
      e.stopPropagation();
      onBlur && onBlur(e);
    });

    return _this;
  }

  _createClass(SelectWithSearch, [{
    key: "bottomSheetProps",
    get: function get() {
      return {
        full: true,
        noPadding: true,
        title: this.props.listTitle,
        display: this.state.openList,
        onClose: this.handleToggleList
      };
    }
  }, {
    key: "searchBarProps",
    get: function get() {
      var _this$props = this.props,
          searchPlaceholder = _this$props.searchPlaceholder,
          searchbarValue = _this$props.searchbarValue,
          onSearchChange = _this$props.onSearchChange,
          onClear = _this$props.onClear;
      return {
        margin: '8px 16px',
        placeholder: searchPlaceholder,
        value: searchbarValue,
        onChange: onSearchChange,
        onClear: onClear
      };
    }
  }, {
    key: "listProps",
    get: function get() {
      var _this2 = this;

      var children = this.props.children;
      return {
        noMargin: true,
        items: React.Children.map(children, function (child) {
          var _child$props;

          return {
            text: child === null || child === void 0 ? void 0 : (_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.children,
            onClick: function onClick() {
              if (child.props.onClick) {
                child.props.onClick();
              }

              _this2.setState({
                openList: false
              });
            }
          };
        })
      };
    }
  }, {
    key: "selectInputProps",
    get: function get() {
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          error = _this$props2.error,
          id = _this$props2.id,
          info = _this$props2.info,
          label = _this$props2.label,
          name = _this$props2.name,
          message = _this$props2.message,
          selectedOption = _this$props2.selectedOption,
          selectPlaceholder = _this$props2.selectPlaceholder,
          success = _this$props2.success;
      return {
        appendObject: [React.createElement("i", {
          key: "unf-select-icon-chevron",
          className: "unf-select__icon"
        })],
        id: id,
        name: name,
        label: label,
        readonly: true,
        error: error,
        info: info,
        inlineLabel: false,
        message: message,
        placeholder: selectPlaceholder,
        value: selectedOption,
        success: success,
        disabled: disabled
      };
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, React.createElement("div", {
        className: unf_select
      }, React.createElement(TextField, _extends({}, this.selectInputProps, {
        appendObject: React.createElement(ChevronDown, {
          onClick: this.handleToggleList
        }),
        onBlur: this.handleSelectBlur,
        onClick: this.handleToggleList
      }))), React.createElement(BottomSheet, this.bottomSheetProps, React.createElement(SearchBar, this.searchBarProps), this.renderDescription(), React.createElement(List, this.listProps)));
    }
  }]);

  return SelectWithSearch;
}(PureComponent);

SelectWithSearch.defaultProps = {
  disabled: false,
  error: false,
  listDescription: '',
  success: false
};
export default SelectWithSearch;