import React, { Component } from 'react';
export interface SelectProps {
    /**
     * Set the Select options.
     */
    children?: React.ReactNode;
    /**
     * Set the Select container className (not the select element).
     */
    className?: string;
    /**
     * Set the Select into disabled state.
     */
    disabled?: boolean;
    /**
     * Set the Select into error state.
     */
    error?: boolean;
    /**
     * Set the Select field id.
     */
    id?: string;
    /**
     * Set the Select info.
     */
    info?: string;
    /**
     * Set the Select label.
     */
    label?: string;
    /**
     * Description for the list when you enabled `withSearch`.
     */
    listDescription?: string;
    /**
     * Title for the list when you enabled `withSearch`.
     */
    listTitle?: string;
    /**
     * Show the Select message on validation (onChange, etc), if `info` is present, message will be hidden until info is cleared.
     */
    message?: string;
    /**
     * Set the Select field name.
     */
    name?: string;
    /**
     * Set searchbar value when you enabled `withSearch`.
     */
    searchbarValue?: string;
    /**
     * Set searchbar placeholder when you enabled `withSearch`.
     */
    searchPlaceholder?: string;
    /**
     * Set the Select default selected option.
     */
    selectedOption?: string;
    /**
     * Set Select placeholder.
     */
    selectPlaceholder: string;
    /**
     * Set the Select into success state.
     */
    success?: boolean;
    /**
     * Add search feature to Select
     */
    withSearch?: boolean;
    /**
     * Callback for onblur.
     */
    onBlur?: (e: React.FocusEvent<HTMLSelectElement>) => void;
    /**
     * Callback for onchange.
     */
    onChange?: (e: React.ChangeEvent<HTMLSelectElement>) => void;
    /**
     * Callback for onfocus.
     */
    onFocus?: (e: React.FocusEvent<HTMLSelectElement>) => void;
    /**
     * Callback for onchange on search bar when you enabled `withSearch`.
     */
    onSearchChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
declare class Select extends Component<SelectProps> {
    componentDidUpdate(prevProps: any): void;
    handleMessage: (text: any) => void;
    handleFunction: (props: any) => void;
    handleFocus: () => void;
    handleBlur: () => void;
    handleChange: (e: any) => void;
    render(): JSX.Element;
}
export default Select;
