import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["children", "className", "disabled", "error", "id", "info", "label", "message", "name", "selectedOption", "success", "withSearch"];
import React, { Component } from 'react';
import { cx } from 'emotion';
import { ChevronDown } from 'unify-icons/system';
import { Container, Group, Info, InfoContainer, Label } from "../../build/Providers/styles/Form/_SharedStyle";
import { addClass, canUseDOM, removeClass } from "../../build/Providers/common/functions";
import SelectWithSearch from "./_SelectWithSearch";
import { caretStyle } from "./style";

var Select = function (_Component) {
  _inherits(Select, _Component);

  var _super = _createSuper(Select);

  function Select() {
    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleMessage", function (text) {
      _this.info && addClass('animated', _this.info);
      setTimeout(function () {
        if (_this.info) {
          _this.info.innerHTML = text;
          removeClass('animated', _this.info);
        }
      }, 280);
    });

    _defineProperty(_assertThisInitialized(_this), "handleFunction", function (props) {
      props && props(_this.select);
    });

    _defineProperty(_assertThisInitialized(_this), "handleFocus", function () {
      var _this$props = _this.props,
          withSearch = _this$props.withSearch,
          onFocus = _this$props.onFocus;
      withSearch && addClass('isFocused', _this.container);

      _this.handleFunction(onFocus);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function () {
      var _this$props2 = _this.props,
          withSearch = _this$props2.withSearch,
          onBlur = _this$props2.onBlur;
      withSearch && removeClass('isFocused', _this.container);

      _this.handleFunction(onBlur);
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (e) {
      e.stopPropagation();

      _this.handleFunction(_this.props.onChange);
    });

    return _this;
  }

  _createClass(Select, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props3 = this.props,
          info = _this$props3.info,
          message = _this$props3.message,
          withSearch = _this$props3.withSearch;

      if (!withSearch) {
        if (message && prevProps.message !== message) {
          this.handleMessage(message);
        } else if (info && prevProps.info !== info) {
          this.handleMessage(info);
        }

        if (canUseDOM && document.activeElement === this.select) {
          addClass('isFocused', this.container);
        } else {
          removeClass('isFocused', this.container);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          children = _this$props4.children,
          className = _this$props4.className,
          disabled = _this$props4.disabled,
          error = _this$props4.error,
          id = _this$props4.id,
          info = _this$props4.info,
          label = _this$props4.label,
          message = _this$props4.message,
          name = _this$props4.name,
          selectedOption = _this$props4.selectedOption,
          success = _this$props4.success,
          withSearch = _this$props4.withSearch,
          selectProps = _objectWithoutProperties(_this$props4, _excluded);

      var containerClass = cx('unf-input', {
        isDisabled: disabled,
        isSuccess: success,
        isError: error
      }, className);
      var inputProps = {
        id: id,
        className: cx('unf-input-control unf-form-control', className),
        name: name,
        value: selectedOption,
        disabled: disabled && 'disabled'
      };
      var labelClass = cx('unf-input-label', {
        hasValue: !withSearch
      });

      if (this.props.withSearch) {
        return React.createElement(SelectWithSearch, this.props);
      }

      return React.createElement(Container, _extends({
        innerRef: function innerRef(node) {
          return _this2.container = node;
        },
        className: containerClass
      }, selectProps), React.createElement(Group, {
        className: "unf-input-group",
        disabled: disabled,
        label: label
      }, React.createElement("div", {
        className: "unf-input-wrapper"
      }, React.createElement("select", _extends({
        ref: function ref(node) {
          return _this2.select = node;
        },
        "aria-label": "unf-select",
        "data-unify": "Select"
      }, inputProps, {
        onBlur: this.handleBlur,
        onChange: this.handleChange,
        onFocus: this.handleFocus
      }), children), React.createElement(ChevronDown, {
        className: caretStyle,
        style: {
          opacity: disabled ? 0.32 : 1
        }
      }), label && React.createElement(Label, {
        className: labelClass,
        disabled: disabled
      }, label))), info || message ? React.createElement(InfoContainer, {
        className: "unf-input-info"
      }, React.createElement(Info, {
        className: "unf-input-info__msg",
        success: success,
        error: error,
        disabled: disabled
      }, React.createElement("span", {
        ref: function ref(node) {
          return _this2.info = node;
        }
      }, info || message))) : '');
    }
  }]);

  return Select;
}(Component);

Select.defaultProps = {
  success: false,
  error: false,
  disabled: false,
  withSearch: false
};
export default Select;