import styled, { css } from 'react-emotion';
import { NN700 } from 'unify-token/colors';
import { fontSizeLv2, fontSizeLv4, fontWeightRegular, lineHeightLv1, lineHeightLv4 } from 'unify-token/build/v2/typographies';
import { FORM_INPUT_LINE_HEIGHT, FORM_INPUT_PADDING, FORM_TRANSITION_TIMING, handleColor, FormLabel } from "../../build/Providers/styles/Form/_Common.style";
export var Label = styled("label", {
  target: "e17rieko0"
})(FormLabel, ";font-size:", function (_ref) {
  var focus = _ref.focus,
      formOption = _ref.formOption,
      formValue = _ref.formValue;
  return focus || formOption || formValue ? fontSizeLv2 : fontSizeLv4;
}, ";line-height:", function (_ref2) {
  var focus = _ref2.focus,
      formOption = _ref2.formOption,
      formValue = _ref2.formValue;
  return focus || formOption || formValue ? lineHeightLv1 : lineHeightLv4;
}, ";transition:", function (_ref3) {
  var hasPrepend = _ref3.hasPrepend;
  return hasPrepend ? "color ".concat(FORM_TRANSITION_TIMING, ", line-height ").concat(FORM_TRANSITION_TIMING, ", font-size ").concat(FORM_TRANSITION_TIMING, ", top ").concat(FORM_TRANSITION_TIMING, ", transform ").concat(FORM_TRANSITION_TIMING) : "color ".concat(FORM_TRANSITION_TIMING, ", line-height ").concat(FORM_TRANSITION_TIMING, ", font-size ").concat(FORM_TRANSITION_TIMING, ", top ").concat(FORM_TRANSITION_TIMING);
}, ";");
var _ref4 = "width:100%;color:";
var _ref5 = ";font-size:";
var _ref6 = ";font-weight:";
var _ref7 = ";line-height:";
var _ref8 = "px;background-color:transparent;border:none;border-radius:0;box-shadow:none;position:relative;z-index:2;outline:none;padding:";
var _ref9 = "px 24px ";
var _ref10 = "px 0;margin:0;transition:color ";
var _ref11 = ";";

var SelectInputStyle = function SelectInputStyle(props) {
  return css(_ref4, handleColor(props.disabled), _ref5, fontSizeLv4, _ref6, fontWeightRegular, _ref7, FORM_INPUT_LINE_HEIGHT, _ref8, FORM_INPUT_PADDING, _ref9, FORM_INPUT_PADDING, _ref10, FORM_TRANSITION_TIMING, _ref11);
};

var _ref12 = "label:select;";
var _ref13 = ";text-overflow:ellipsis;appearance:none;&::-ms-expand{display:none;}option{padding-right:0;padding-left:0;}";
export var SelectInput = function SelectInput(props) {
  return css(_ref12, SelectInputStyle(props), _ref13);
};
var _ref14 = "label:input;";
var _ref15 = ";&:last-child{padding-right:16px;}";
export var SelectText = function SelectText(props) {
  return css(_ref14, SelectInputStyle(props), _ref15);
};
export var ListDescription = css("font-size:", fontSizeLv2, ";color:", NN700, ";opacity:0.32;padding:0 16px;");