import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import Card from "../../build/Card";
import { canUseDOM } from "../../build/Providers/common/functions";
import { RedirectWrapper } from '.';
import { unf_sidebar_anim, unf_sidebar_referral } from "./style";
var INITIAL_VIEWPORT_WIDTH = 320;
var MAX_VIEWPORT_SUPPORTED = 414;

var SidebarAnim = function (_PureComponent) {
  _inherits(SidebarAnim, _PureComponent);

  var _super = _createSuper(SidebarAnim);

  function SidebarAnim() {
    var _this;

    _classCallCheck(this, SidebarAnim);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      animMultiplier: 1,
      bounceField: false,
      bgPos: 0,
      cloudPosR: 0,
      flagPos: 0,
      scaleStore: false,
      storePosL: 0,
      storePosR: 0,
      withFlag: 0
    });

    _defineProperty(_assertThisInitialized(_this), "setAnimRef", function (node) {
      _this.animCon = node;
    });

    _defineProperty(_assertThisInitialized(_this), "calcAnim", function (val) {
      var animMultiplier = _this.state.animMultiplier;

      if (animMultiplier === 1) {
        return val * animMultiplier;
      } else {
        return val * animMultiplier - val;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "imgResolver", function (name) {
      return "https://assets.tokopedia.net/img/unify/sidebar/".concat(name, ".svg");
    });

    _defineProperty(_assertThisInitialized(_this), "handleScroll", function () {
      if (canUseDOM && _this.state.withScrollableAnim) {
        window.scroll({
          behavior: 'smooth'
        });
        var scrollValue = _this.animCon ? _this.animCon.scrollTop : 0;
        requestAnimationFrame(function () {
          if (scrollValue >= 0 && scrollValue < 232) {
            _this.setState({
              withFlag: scrollValue
            });
          }

          if (scrollValue >= 0 && scrollValue < 232) {
            _this.setState({
              bgPos: scrollValue / 4
            });
          }

          if (scrollValue >= 216 && scrollValue < 306) {
            _this.setState({
              flagPos: scrollValue - 215
            });
          }

          if (scrollValue >= 256 && scrollValue < 368) {
            _this.setState({
              cloudPosR: scrollValue - 255
            });
          }

          if (scrollValue >= 256 && scrollValue < 408) {
            _this.setState({
              storePosL: scrollValue - 255,
              storePosR: scrollValue - 255
            });
          }

          if (scrollValue >= _this.animCon.scrollHeight - _this.animCon.offsetHeight) {
            _this.setState({
              scaleStore: true
            });
          } else {
            _this.setState({
              scaleStore: false
            });
          }
        });
      }
    });

    return _this;
  }

  _createClass(SidebarAnim, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        _this2.setState({
          animMultiplier: _this2.state.animMultiplier + (window.screen.width - INITIAL_VIEWPORT_WIDTH) / INITIAL_VIEWPORT_WIDTH,
          withScrollableAnim: window.screen.width <= MAX_VIEWPORT_SUPPORTED
        });

        window.addEventListener('scroll', _this2.handleScroll, true);
      }, 400);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.handleScroll);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          bgPos = _this$state.bgPos,
          bounceField = _this$state.bounceField,
          flagPos = _this$state.flagPos,
          scaleStore = _this$state.scaleStore,
          cloudPosR = _this$state.cloudPosR,
          storePosL = _this$state.storePosL,
          storePosR = _this$state.storePosR,
          withFlag = _this$state.withFlag,
          withScrollableAnim = _this$state.withScrollableAnim;
      var cardUrl = this.props.cardUrl;
      return React.createElement("div", {
        style: {
          position: 'relative',
          height: 296,
          overflow: 'hidden'
        }
      }, React.createElement("div", {
        ref: this.setAnimRef,
        style: {
          background: "linear-gradient(to top, #BFE5EC, #BFE5EC ".concat(62 + bgPos, "%, transparent ").concat(62 + bgPos, "%, transparent 100%)"),
          position: 'absolute'
        },
        className: unf_sidebar_anim
      }, React.createElement("img", {
        alt: "illustration toped",
        crossOrigin: "anonymous",
        className: "unf-sidebar-toped ".concat(scaleStore && 'show'),
        src: this.imgResolver('illustration-toped'),
        style: scaleStore ? {
          transform: "rotate(10deg) translate(".concat(this.calcAnim(44), "px, 104px")
        } : {}
      }), React.createElement("img", {
        alt: "illustration flag",
        crossOrigin: "anonymous",
        style: {
          transform: "translateY(".concat(withFlag, "px)"),
          opacity: flagPos > 16 ? 0 : 1
        },
        className: "unf-sidebar-flag",
        src: this.imgResolver('illustration-flag')
      }), React.createElement("div", {
        style: {
          zIndex: 2,
          transform: "translateX(".concat(flagPos, "px)"),
          position: "relative",
          top: '230px'
        }
      }, React.createElement("img", {
        alt: "illustration side flag",
        crossOrigin: "anonymous",
        style: {
          opacity: flagPos > 16 ? 1 : 0
        },
        className: "unf-sidebar-flag",
        src: this.imgResolver('illustration-flag')
      }), React.createElement("img", {
        alt: "illustration cloud left",
        crossOrigin: "anonymous",
        className: "unf-sidebar-cloud-left",
        src: this.imgResolver('illustration-cloud-left')
      })), React.createElement("div", {
        style: {
          zIndex: 1,
          position: "relative",
          top: '290px'
        }
      }, React.createElement("img", {
        alt: "illustration cloud right",
        crossOrigin: "anonymous",
        style: {
          transform: "translateX(-".concat(cloudPosR, "px)")
        },
        className: "unf-sidebar-cloud-right",
        src: this.imgResolver('illustration-cloud-right')
      }), React.createElement("img", {
        alt: "illustration store left",
        crossOrigin: "anonymous",
        style: {
          transform: "translateX(".concat(storePosL, "px)")
        },
        className: "unf-sidebar-store-left",
        src: this.imgResolver('illustration-store-left')
      }), React.createElement("img", {
        alt: "illustration store right",
        crossOrigin: "anonymous",
        style: {
          transform: "translateX(-".concat(storePosR, "px)")
        },
        className: "unf-sidebar-store-right",
        src: this.imgResolver('illustration-store-right')
      }), React.createElement("img", {
        alt: "illustration store center",
        crossOrigin: "anonymous",
        className: "unf-sidebar-store-center ".concat(scaleStore && 'show'),
        src: this.imgResolver('illustration-store-center')
      })), React.createElement("img", {
        alt: "illustration seat",
        crossOrigin: "anonymous",
        className: "unf-sidebar-seat",
        src: this.imgResolver('illustration-seat')
      }), React.createElement("img", {
        alt: "illustration field",
        crossOrigin: "anonymous",
        className: "unf-sidebar-field ".concat(bounceField && 'bounce'),
        src: this.imgResolver('illustration-field')
      }), cardUrl && React.createElement(Card, {
        margin: "32px 16px 40px",
        className: unf_sidebar_referral
      }, React.createElement(RedirectWrapper, {
        redirectUrl: cardUrl
      }, React.createElement("div", null, React.createElement("h3", null, "Dapatkan TokoCash"), React.createElement("p", null, "Bagikan aplikasi ini ke teman anda"))))));
    }
  }]);

  return SidebarAnim;
}(PureComponent);

SidebarAnim.defaultProps = {
  cardUrl: ''
};
export default SidebarAnim;