import React, { PureComponent } from 'react';
export interface SideBarProps {
    children?: React.ReactNode;
    className?: string;
    display?: boolean;
    listItems?: Array<React.ReactNode>;
    loading?: boolean;
    noAnim?: boolean;
    promoBanner?: Array<React.ReactNode>;
    props?: object;
    url?: {
        fbLogin?: string | (() => void);
        googleLogin?: string | (() => void);
        help?: string | (() => void);
        home?: string | (() => void);
        logout?: string | (() => void);
        otherLogin?: string | (() => void);
        phoneLogin?: string | (() => void);
        profile?: string | (() => void);
        promo?: string | (() => void);
        referral?: string | (() => void);
        register?: string | (() => void);
        tokopoints?: string | (() => void);
        wallet?: string | (() => void) | object;
    };
    userData?: {
        username?: string;
        wallet?: string;
        points?: string;
        membershipIcon?: string;
        membershipName?: string;
    };
    onClose?: () => void;
}
declare class SideBar extends PureComponent<SideBarProps> {
    state: {
        isDisplay: boolean;
    };
    componentDidUpdate: (prevProps: any) => void;
    renderHeaderAction: () => JSX.Element;
    renderUsername: () => JSX.Element;
    renderSocialBtn: () => JSX.Element;
    renderBalanceCard: () => JSX.Element;
    renderList: () => JSX.Element;
    renderOpsBtn: () => JSX.Element;
    handleTouchStart: (e: any) => void;
    handlePromoBannerTouchStart: (e: any) => void;
    handleTouchMove: (e: any) => boolean;
    render(): JSX.Element;
}
export default SideBar;
