import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { cx } from 'emotion';
import Card from "../../build/Card";
import Delayed from "../../build/Providers/common/components/Delayed";
import List from "../../build/List";
import PortalWrapper from "../../build/Providers/common/components/PortalWrapper";
import LoaderForm from "../../build/LoaderForm";
import LoaderLine from "../../build/LoaderLine";
import LoaderSquare from "../../build/LoaderSquare";
import Link from "../../build/Link";
import ImgFb from "../../build/Providers/assets/NavBar/icon-facebook.svg";
import ImgGoogle from "../../build/Providers/assets/NavBar/icon-google.svg";
import ImgHome from "../../build/Providers/assets/NavBar/icon-home.svg";
import ImgLogout from "../../build/Providers/assets/NavBar/icon-logout.svg";
import ImgPhone from "../../build/Providers/assets/NavBar/icon-phone.svg";
import ImgSmile from "../../build/Providers/assets/NavBar/icon-smile.svg";
import ImgTokopediaCare from "../../build/Providers/assets/NavBar/icon-tokopedia-care.svg";
import ImgWallet from "../../build/Providers/assets/NavBar/icon-wallet.svg";
import { BalanceCard, SidebarHeader, SidebarHeaderBtn, SocialBtn, unf_promo_balance_box, unf_sidebar_list, unf_sidebar_ops_container, unf_sidebar } from "./style";

var SideBar = function (_PureComponent) {
  _inherits(SideBar, _PureComponent);

  var _super = _createSuper(SideBar);

  function SideBar() {
    var _this;

    _classCallCheck(this, SideBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isDisplay: _this.props.display
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      var display = _this.props.display;
      var getAnimationTime = display ? 160 : 40;

      if (prevProps.display !== display) {
        setTimeout(function () {
          _this.setState(function (_ref) {
            var isDisplay = _ref.isDisplay;
            return {
              isDisplay: !isDisplay
            };
          });
        }, getAnimationTime);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderHeaderAction", function () {
      var _this$props = _this.props,
          props = _this$props.props,
          _this$props$url = _this$props.url,
          home = _this$props$url.home,
          profile = _this$props$url.profile,
          register = _this$props$url.register,
          userData = _this$props.userData;
      return userData.username.length ? React.createElement("div", {
        className: "unf-sidebar__account"
      }, React.createElement(Link, {
        onClick: profile
      }, React.createElement(SidebarHeaderBtn, _extends({
        img: ImgSmile
      }, props.profile))), React.createElement(Link, {
        onClick: home
      }, React.createElement(SidebarHeaderBtn, _extends({
        img: ImgHome
      }, props.home)))) : React.createElement("span", null, React.createElement(Link, _extends({
        onClick: register
      }, props.register), "Daftar"));
    });

    _defineProperty(_assertThisInitialized(_this), "renderUsername", function () {
      var _this$props2 = _this.props,
          loading = _this$props2.loading,
          props = _this$props2.props,
          username = _this$props2.userData.username;
      return React.createElement("h2", _extends({
        className: "unf-sidebar__username"
      }, props.username), loading ? React.createElement(LoaderLine, {
        width: "100%",
        height: "8px",
        marginBottom: "56px"
      }) : username.length ? username : 'Masuk dengan');
    });

    _defineProperty(_assertThisInitialized(_this), "renderSocialBtn", function () {
      var _this$props3 = _this.props,
          children = _this$props3.children,
          props = _this$props3.props,
          _this$props3$url = _this$props3.url,
          googleLogin = _this$props3$url.googleLogin,
          fbLogin = _this$props3$url.fbLogin,
          phoneLogin = _this$props3$url.phoneLogin,
          otherLogin = _this$props3$url.otherLogin,
          userData = _this$props3.userData;
      return !userData.username.length && React.createElement("div", {
        className: "unf-sidebar__login-container"
      }, React.createElement("div", {
        className: "unf-sidebar__btn-container"
      }, children ? children : React.createElement(React.Fragment, null, React.createElement(Link, _extends({
        onClick: googleLogin
      }, props.googleLogin), React.createElement(SocialBtn, {
        img: ImgGoogle
      })), React.createElement(Link, _extends({
        onClick: fbLogin
      }, props.fbLogin), React.createElement(SocialBtn, {
        img: ImgFb
      })), React.createElement(Link, _extends({
        onClick: phoneLogin
      }, props.phoneLogin), React.createElement(SocialBtn, {
        img: ImgPhone
      })))), React.createElement(Link, {
        id: "unf-other-login",
        onClick: otherLogin
      }, React.createElement("label", {
        htmlFor: "unf-other-login"
      }, "Pilihan Lainnya")));
    });

    _defineProperty(_assertThisInitialized(_this), "renderBalanceCard", function () {
      var _this$props4 = _this.props,
          loading = _this$props4.loading,
          promoBanner = _this$props4.promoBanner,
          props = _this$props4.props,
          _this$props4$url = _this$props4.url,
          wallet = _this$props4$url.wallet,
          tokopoints = _this$props4$url.tokopoints,
          promo = _this$props4$url.promo,
          userData = _this$props4.userData;
      return Boolean(userData.username.length) && React.createElement("div", {
        className: unf_promo_balance_box(_this.props)
      }, React.createElement(Card, {
        className: "unf_sidebar__balance-box"
      }, React.createElement("div", {
        className: "unf_sidebar__balance-box--flex-wrapper"
      }, React.createElement(BalanceItem, _extends({
        img: wallet.img || ImgWallet,
        url: wallet.url || wallet,
        loading: loading,
        text: userData.wallet,
        description: wallet.title || 'TokoCash'
      }, props.wallet)), React.createElement(BalanceItem, _extends({
        img: userData.membershipIcon,
        url: tokopoints,
        loading: loading,
        text: userData.membershipName,
        description: "Rewards"
      }, props.tokopoints)))), Boolean(promoBanner.length) && React.createElement("div", {
        className: "unf-sidebar__promo-wrapper",
        onTouchMove: _this.handlePromoBannerTouchStart
      }, React.createElement(Link, {
        onClick: promo
      }, React.createElement("div", {
        className: "unf-sidebar__all-promo"
      }, "Lihat Semua Promo")), React.createElement("div", {
        className: "unf-sidebar__promo-slider",
        style: {
          borderRadius: loading ? 8 : 4
        }
      }, loading ? React.createElement(LoaderSquare, {
        width: "264px",
        paddingBottom: "88px",
        marginBottom: "0"
      }) : promoBanner.map(function (item, index) {
        return React.createElement(Link, {
          key: "".concat(item, "-").concat(index),
          onClick: item.url
        }, React.createElement("img", _extends({}, item.props, {
          alt: "promo banner ".concat(index),
          crossOrigin: "anonymous",
          src: item.image,
          onClick: item.handleClick,
          onKeyDown: item.handleClick,
          className: "unf-sidebar__img-promo"
        })));
      }))));
    });

    _defineProperty(_assertThisInitialized(_this), "renderList", function () {
      var _this$props5 = _this.props,
          listItems = _this$props5.listItems,
          loading = _this$props5.loading;
      return loading ? React.createElement(LoaderForm, null) : React.createElement(List, {
        noMargin: true,
        className: unf_sidebar_list,
        subheader: "Telusuri Kategori",
        items: listItems
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderOpsBtn", function () {
      var _this$props6 = _this.props,
          props = _this$props6.props,
          _this$props6$url = _this$props6.url,
          help = _this$props6$url.help,
          logout = _this$props6$url.logout,
          username = _this$props6.userData.username;
      return React.createElement("div", {
        className: unf_sidebar_ops_container
      }, React.createElement(Link, _extends({
        onClick: help
      }, props.help), React.createElement("div", null, React.createElement("img", {
        id: "unf-tokopedia-care",
        alt: "Tokopedia Care",
        crossOrigin: "anonymous",
        src: ImgTokopediaCare
      }), React.createElement("label", {
        htmlFor: "unf-tokopedia-care"
      }, "Tokopedia Care"))), Boolean(username.length) && React.createElement(Link, _extends({
        onClick: logout
      }, props.logout), React.createElement("div", null, React.createElement("img", {
        id: "unf-logout",
        alt: "logout",
        crossOrigin: "anonymous",
        src: ImgLogout
      }), React.createElement("label", {
        htmlFor: "unf-logout"
      }, "Keluar"))));
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchStart", function (e) {
      _this.xDown = e.touches[0].clientX;
      _this.yDown = e.touches[0].clientY;
    });

    _defineProperty(_assertThisInitialized(_this), "handlePromoBannerTouchStart", function (e) {
      e.stopPropagation();
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchMove", function (e) {
      if (!_this.xDown || !_this.yDown) {
        return false;
      }

      var xUp = e.touches[0].clientX;
      var yUp = e.touches[0].clientY;
      var xDiff = _this.xDown - xUp;
      var yDiff = _this.yDown - yUp;

      if (Math.abs(xDiff) > Math.abs(yDiff)) {
        if (xDiff > 0) {
          _this.props.onClose();
        }
      }

      _this.xDown = null;
      _this.yDown = null;
    });

    return _this;
  }

  _createClass(SideBar, [{
    key: "render",
    value: function render() {
      var isDisplay = this.state.isDisplay;
      var _this$props7 = this.props,
          className = _this$props7.className,
          display = _this$props7.display,
          onClose = _this$props7.onClose,
          props = _this$props7.props,
          username = _this$props7.userData.username;
      var classes = cx('unf-sidebar', unf_sidebar, className, {
        'unf-sidebar--show': isDisplay
      });
      return React.createElement(PortalWrapper, null, React.createElement(Delayed, {
        mounted: display,
        unmountAfter: 400
      }, React.createElement("div", {
        className: classes,
        "data-unify": "SideBar",
        onScroll: this.handleWrapperScroll,
        onTouchStart: this.handleTouchStart,
        onTouchMove: this.handleTouchMove
      }, React.createElement("div", {
        className: "unf-sidebar__wrapper"
      }, React.createElement(SidebarHeader, {
        isLoggedIn: username.length
      }, React.createElement("div", {
        className: "unf-sidebar__top"
      }, React.createElement("div", _extends({
        className: "unf-sidebar__close",
        role: "button",
        tabIndex: "0",
        onClick: onClose,
        onKeyDown: onClose
      }, props.close)), this.renderHeaderAction()), this.renderUsername(), this.renderSocialBtn()), this.renderBalanceCard(), this.renderList(), this.renderOpsBtn()))));
    }
  }]);

  return SideBar;
}(PureComponent);

SideBar.defaultProps = {
  props: {
    close: {},
    help: {},
    home: {},
    logout: {},
    googleLogin: {},
    fbLogin: {},
    phoneLogin: {},
    otherLogin: {},
    profile: {},
    register: {},
    tokopoints: {},
    username: {},
    wallet: {}
  },
  display: false,
  loading: false,
  noAnim: false,
  promoBanner: [],
  url: {}
};

var BalanceItem = function BalanceItem(_ref2) {
  var img = _ref2.img,
      url = _ref2.url,
      loading = _ref2.loading,
      text = _ref2.text,
      description = _ref2.description;
  return React.createElement(BalanceCard, {
    img: img
  }, React.createElement(Link, {
    onClick: url
  }, loading ? React.createElement(LoaderLine, {
    width: "100%",
    height: "8px",
    marginBottom: "8px"
  }) : React.createElement("h3", {
    className: "unf-sidebar__balance--price"
  }, text), React.createElement("label", {
    className: "unf-sidebar__balance--label"
  }, description)));
};

export default SideBar;