import styled, { css } from 'react-emotion';
import { fontSizeLv1, fontSizeLv2, fontSizeLv3, fontSizeLv6, fontSizeLv7, fontWeightBold, fontWeightRegular, lineHeightLv5, lineHeightLv4, lineHeightLv2 } from 'unify-token/build/v2/typographies';
import { colorPageBackground, colorShadow, colorTextDisabled, colorTextHigh, G500, N0 } from 'unify-token/build/v2/colors';
import { durationDefault, easeDefault } from 'unify-token/build/v2/motions';
import Link from "../../build/Link/style";
import icon_right from "../../build/Providers/assets/List/icon-arrow-right.svg";
import icon_close_gray from "../../build/Providers/assets/NavBar/icon_close_gray.svg";
import icon_close_white from "../../build/Providers/assets/NavBar/icon_close_white.svg";
import icon_promo from "../../build/Providers/assets/NavBar/icon-promo.svg";
import icon_wallet from "../../build/Providers/assets/NavBar/icon-wallet.svg";
var unf_sidebar = css("label:unf-sidebar;position:fixed;top:0;left:0;width:100%;height:100%;background-color:", colorPageBackground, ";box-shadow:0 -1px 6px 0 ", colorShadow, ";overflow:hidden;z-index:50;-webkit-overflow-scrolling:touch;backface-visibility:hidden;transition:transform ", durationDefault, " ", easeDefault, ";transform-origin:bottom;transform:translateX(-102%);transform-box:view-box;&.unf-sidebar--show{opacity:1;transform-origin:bottom;transform:translateX(0%);}& .unf-sidebar__wrapper{width:100vw;height:100%;overflow:scroll;}& .unf-sidebar__top{position:relative;padding:24px 16px;display:flex;align-items:center;color:white;font-size:", fontSizeLv3, ";font-weight:", fontWeightBold, ";justify-content:flex-end;", Link, "{cursor:pointer;color:white;}}");
export var SidebarHeaderBtn = styled('button', {
  target: "eh84x920"
})("cursor:pointer;outline:none;width:24px;height:24px;padding:0;border:0;background-color:transparent;&::before{content:'';background-image:url('", function (props) {
  return props.img;
}, "');display:inline-block;width:100%;height:100%;background-size:cover;background-position:center;background-repeat:no-repeat;}");
export var SocialBtn = styled('button', {
  target: "eh84x921"
})("width:72px;height:72px;outline:none;border-style:none;border-radius:50%;background-color:", colorPageBackground, ";margin-right:24px;box-shadow:0 2px 8px ", colorShadow, ";cursor:pointer;object-fit:none;margin-bottom:0;&::before{content:'';background-image:url('", function (props) {
  return props.img;
}, "');display:inline-block;width:40px;height:40px;background-position:center;background-size:contain;background-repeat:no-repeat;}&:last-child{margin-right:0 !important;}");
var unf_sidebar_list = css("& .unf-list__item-text{font-weight:", fontWeightBold, ";margin-bottom:8px;}");
var SidebarHeader = styled('div', {
  target: "eh84x922"
})("label:unf-sidebar__header;background:", function (props) {
  return props.isLoggedIn ? colorPageBackground : 'linear-gradient(to bottom right, #87D58B, #8FE6EC 88%)';
}, ";height:auto;transition:height 0.3s ease;& .unf-sidebar__close{height:52px;width:50px;position:absolute;left:0;top:8px;background-color:transparent;background-repeat:no-repeat;background-position:center center;background-size:15px 15px;background-image:url('", function (props) {
  return props.isLoggedIn ? icon_close_gray : icon_close_white;
}, "');}& .unf-sidebar__username{padding:0 16px;color:", function (props) {
  return props.isLoggedIn ? colorTextHigh : N0;
}, ";font-size:", function (props) {
  return props.isLoggedIn ? fontSizeLv6 : fontSizeLv7;
}, ";line-height:", lineHeightLv5, ";font-weight:", fontWeightBold, ";margin-top:0;margin-bottom:", function (props) {
  return props.isLoggedIn ? '40' : '0';
}, "px;}& .unf-sidebar__login-container{padding:24px;margin-bottom:32px;text-align:center;& label{font-size:", fontSizeLv2, ";color:", N0, ";font-weight:", fontWeightBold, ";cursor:pointer;}}& .unf-sidebar__account{", Link, "{margin-right:24px;&:last-child{margin-right:0;}}}& .unf-sidebar__btn-container{display:flex;justify-content:center;margin-bottom:24px;", Link, "{margin-right:16px;&:last-child{margin-right:0;}}}& .unf-sidebar__btn-container button{width:72px;height:72px;outline:none;border-style:none;border-radius:50%;background-color:", N0, ";margin-right:24px;box-shadow:0 2px 8px ", colorShadow, ";cursor:pointer;object-fit:none;margin-bottom:0;}");
var _ref2 = "label:unf-balance-container;display:flex;background:linear-gradient(to bottom right,#87d58b,#8fe6ec 88%);height:";
var _ref3 = "px;position:relative;margin-bottom:";
var _ref4 = "px;align-items:flex-end;.unf_sidebar__balance-box{position:absolute;top:-24px;margin:0 16px;width:calc(100% - 32px);&--flex-wrapper{display:flex;}}.unf-sidebar__promo-wrapper{display:flex;width:100vw;overflow-x:auto;overflow-y:hidden;position:absolute;bottom:-24px;&::-webkit-scrollbar{height:0;width:0;}}.unf-sidebar__promo-slider{display:flex;border-radius:4px;}.unf-sidebar__all-promo{&::before{content:'';background-image:url('";
var _ref5 = "');display:block;width:20px;height:20px;background-size:contain;background-position:center;background-repeat:no-repeat;margin-bottom:8px;}font-size:";
var _ref6 = ";font-weight:";
var _ref7 = ";color:";
var _ref8 = ";width:88px;margin:0 24px 0 16px;cursor:pointer;flex-grow:0;flex-shrink:0;}.unf-sidebar__img-promo{object-fit:cover;width:264px;height:88px;background-color:";
var _ref9 = ";cursor:pointer;flex-grow:0;flex-shrink:0;transition:all 0.24s ease;border-radius:4px;margin:0 16px 8px 8px;box-shadow:0 2px 6px 0 rgba(0,0,0,0.16);}";

var unf_promo_balance_box = function unf_promo_balance_box(_ref) {
  var promoBanner = _ref.promoBanner;
  return css(_ref2, promoBanner.length ? '176' : '96', _ref3, promoBanner.length ? '32' : '24', _ref4, icon_promo, _ref5, fontSizeLv3, _ref6, fontWeightBold, _ref7, N0, _ref8, colorPageBackground, _ref9);
};

var BalanceCard = styled('div', {
  target: "eh84x923"
})("label:unf-balance-card;flex:1;border-right:1px solid #f1f1f1;text-align:center;padding-right:16px;margin-right:16px;&::before{content:'';background-image:url('", function (props) {
  return props.img;
}, "');display:inline-block;width:20px;height:20px;background-size:contain;background-position:center;background-repeat:no-repeat;margin-bottom:8px;}&:last-child{padding-right:0;margin-right:0;border-right:0;}& .unf-sidebar__balance--price{color:", G500, ";font-size:", fontSizeLv3, ";font-weight:", fontWeightBold, ";margin:0;}& .unf-sidebar__balance--label{color:", colorTextDisabled, ";font-size:", fontSizeLv1, ";font-weight:", fontWeightRegular, ";}");
export var unf_sidebar_ops_container = css("margin-top:8px;& div{display:flex;padding:16px;& img{object-fit:contain;width:24px;margin-right:16px;}& label{align-self:center;font-size:", fontSizeLv3, ";font-weight:600;line-height:", lineHeightLv5, ";color:", colorTextHigh, ";width:100%;}}");
var unf_sidebar_referral = css("display:flex;opacity:0;&::before{content:'';background-image:url('", icon_wallet, "');width:24px;height:24px;display:inline-block;background-repeat:no-repeat;background-size:contain;background-position:center;margin-right:16px;align-self:center;}&::after{content:'';background-image:url('", icon_right, "');display:inline-block;width:8px;height:13px;align-self:center;}& div{flex-direction:column;}& h3{color:", colorTextHigh, ";line-height:", lineHeightLv4, ";font-size:", fontSizeLv3, ";margin:0;}& p{color:", colorTextDisabled, ";line-height:", lineHeightLv2, ";font-size:", fontSizeLv2, ";margin:0;}");
var unf_link_wrapper = css("flex:1;text-decoration:none;cursor:pointer;");
var unf_sidebar_anim = css("label:unf-sidebar__anim;position:relative;height:368px;overflow-x:hidden;overflow-y:scroll;transform:translate3d(0,0,0);.unf-sidebar-field{width:100vw;height:590px;margin-top:-32px;transform:translateY(0);transition:all 0.16s ease-in;&.bounce{transform:translateY(-24px);}}.unf-sidebar-toped{position:sticky;float:right;margin-right:56px;top:16px;z-index:2;transition:all 0.3s ease;}.unf-sidebar-flag{position:absolute;top:16px;right:0;transition:all 0s ease-in;z-index:2;}.unf-sidebar-cloud-left{position:absolute;top:64px;left:-104px;}.unf-sidebar-cloud-right{position:absolute;top:64px;right:-128px;}.unf-sidebar-store-left{position:absolute;top:64px;left:-200px;}.unf-sidebar-store-right{position:absolute;top:152px;right:-152px;}.unf-sidebar-store-center{position:absolute;top:172px;left:50%;transition:all 0.3s ease;transform:translateX(-50%) scale(0);&.show{transform:translateX(-50%) scale(1);}}.unf-sidebar-seat{position:absolute;right:56px;top:125px;z-index:1;}");
export { BalanceCard, SidebarHeader, unf_sidebar, unf_link_wrapper, unf_promo_balance_box, unf_sidebar_list, unf_sidebar_referral, unf_sidebar_anim };