import { PureComponent } from 'react';
export interface SliderProps {
    /**
     * To set display to inline-block
     */
    block?: boolean;
    /**
     * To pass custom class
     */
    className?: string;
    /**
     * To make use of the second handler
     */
    double?: boolean;
    /**
     * To set value of second handler for double mode
     */
    doubleValue?: number;
    /**
     * To set max value
     */
    max?: number;
    /**
     * To set min value
     */
    min?: number;
    /**
     * To turn on noZero mode
     */
    noZero?: boolean;
    /**
     * To set indicator interval
     */
    separator?: number;
    /**
     * To set the distance covered by handler every single movement unit
     */
    step?: number;
    /**
     * To set value of first handler
     */
    value?: number;
    /**
     * To pass callback when the value of first handler is changed.
     */
    onChange?: () => void;
    /**
     * To pass callback when the value of second handler is changed.
     */
    onChangeDouble?: () => void;
}
declare class Slider extends PureComponent<SliderProps> {
    handleSeparatorClick: (separatorValue: any) => void;
    renderSeparator: (separator: any) => any[];
    handleChange: (event: any) => void;
    handleDoubleChange: (event: any) => void;
    isEmpty: (num: any) => boolean;
    render(): JSX.Element;
}
export default Slider;
