import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["className", "min", "max", "value", "doubleValue", "block", "separator", "step", "noZero", "onChange", "onChangeDouble", "double"];
import React, { PureComponent } from 'react';
import { cx } from 'emotion';
import { canUseDOM } from "../../build/Providers/common/functions";
import { unf_slider, unf_slider_container } from "./style";

var Slider = function (_PureComponent) {
  _inherits(Slider, _PureComponent);

  var _super = _createSuper(Slider);

  function Slider() {
    var _this;

    _classCallCheck(this, Slider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "handleSeparatorClick", function (separatorValue) {
      var step = _this.props.step;

      if (step && step !== 'any' && separatorValue % step !== 0) {
        console.log("Invalid props setting for slider. Separator can't be divided by step.");
        return;
      }

      var event = {};
      event.target = {};
      event.target.value = separatorValue;

      _this.handleChange(event);
    });

    _defineProperty(_assertThisInitialized(_this), "renderSeparator", function (separator) {
      var _this$props = _this.props,
          max = _this$props.max,
          min = _this$props.min;

      if (separator > 20) {
        console.log('Maximum separator is 20.');
        return;
      }

      var separatorHtml = [];
      separatorHtml.push(React.createElement("div", {
        key: -1,
        className: "unf-slider__separator-item",
        style: {
          width: "".concat(100 / (separator + 1), "%")
        }
      }, React.createElement("div", {
        className: "unf-slider__separator-item-line",
        onClick: function onClick() {
          return _this.handleSeparatorClick(min);
        }
      })));
      var separatorValueRange;

      if (min === 1 && noZero) {
        separatorValueRange = max / (separator + 1);
      } else {
        separatorValueRange = (max - min) / (separator + 1);
      }

      var _loop = function _loop(i) {
        var separatorValue = void 0;

        if (min === 1 && noZero) {
          separatorValue = separatorValueRange * (i + 1);
        } else {
          separatorValue = min + separatorValueRange * (i + 1);
        }

        separatorHtml.push(React.createElement("div", {
          key: i,
          className: "unf-slider__separator-item",
          style: {
            width: "".concat(100 / (separator + 1), "%")
          }
        }, React.createElement("div", {
          className: "unf-slider__separator-item-line",
          onClick: function onClick() {
            return _this.handleSeparatorClick(separatorValue);
          }
        }), i === separator - 1 && React.createElement("div", {
          className: "unf-slider__separator-item-line unf-slider__separator-item-line--last",
          onClick: function onClick() {
            return _this.handleSeparatorClick(max);
          }
        })));
      };

      for (var i = 0; i < separator; i++) {
        _loop(i);
      }

      return separatorHtml;
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (event) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          _double = _this$props2["double"],
          doubleValue = _this$props2.doubleValue;
      var point = parseInt(event.target.value);

      if (_double) {
        if (point > doubleValue) {
          onChange(doubleValue);
        } else if (point <= doubleValue) {
          onChange(point);
        }
      } else {
        onChange(point);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleDoubleChange", function (event) {
      var _this$props3 = _this.props,
          onChangeDouble = _this$props3.onChangeDouble,
          value = _this$props3.value;
      var point = parseInt(event.target.value);

      if (point < value) {
        onChangeDouble(value);
      } else if (point >= value) {
        onChangeDouble(point);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "isEmpty", function (num) {
      if (num === null || num === undefined || num === '' || isNaN(num)) {
        return true;
      } else {
        return false;
      }
    });

    return _this;
  }

  _createClass(Slider, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          className = _this$props4.className,
          min = _this$props4.min,
          max = _this$props4.max,
          value = _this$props4.value,
          doubleValue = _this$props4.doubleValue,
          block = _this$props4.block,
          separator = _this$props4.separator,
          step = _this$props4.step,
          noZero = _this$props4.noZero,
          onChange = _this$props4.onChange,
          onChangeDouble = _this$props4.onChangeDouble,
          _double2 = _this$props4["double"],
          sliderProps = _objectWithoutProperties(_this$props4, _excluded);

      var classes = cx(unf_slider, 'unf-slider', {
        'unf-slider--block': block,
        'unf-slider--double': _double2
      }, className);
      var minNumber = this.isEmpty(min) ? 0 : parseInt(min);
      var maxNumber = this.isEmpty(max) ? 100 : parseInt(max);
      var valueNumber = this.isEmpty(value) ? 0 : parseInt(value);
      var doubleValueNumber = this.isEmpty(doubleValue) ? 0 : parseInt(doubleValue);

      if (_double2 && (maxNumber <= minNumber || doubleValueNumber < valueNumber)) {
        minNumber = 0;
        maxNumber = 100;
        valueNumber = 0;
        doubleValueNumber = 100;
      } else {
        if (this.isEmpty(value) || parseInt(valueNumber) < parseInt(minNumber) || parseInt(valueNumber) > parseInt(maxNumber)) {
          valueNumber = minNumber;
        } else {
          valueNumber = value;
        }

        if (this.isEmpty(doubleValue) || parseInt(doubleValueNumber) > parseInt(maxNumber) || parseInt(doubleValue) < parseInt(minNumber)) {
          doubleValueNumber = maxNumber;
        } else {
          doubleValueNumber = doubleValue;
        }
      }

      console.warn('This component is going to be deprecated. Please update to SliderV2 if you see this error message (http://design.tokopedia.net/mobile/?path=/story/components-sliders--default-sliderv2). Please contact unify-dev if you have any concerns.');
      return React.createElement("div", _extends({
        className: unf_slider_container
      }, sliderProps), React.createElement("div", {
        className: classes
      }, separator && React.createElement("div", {
        className: "unf-slider__separator"
      }, this.renderSeparator(separator)), !_double2 ? React.createElement("div", null, React.createElement("input", {
        "aria-valuemax": valueNumber,
        "data-unify": "Slider",
        className: "unf-slider__input",
        type: "range",
        min: minNumber,
        max: maxNumber,
        value: valueNumber,
        step: step ? step : 'any',
        onChange: this.handleChange
      }), React.createElement("div", {
        className: "unf-slider__range",
        style: {
          width: "".concat((valueNumber - minNumber) / (maxNumber - minNumber) * 100, "%")
        }
      }), React.createElement("div", {
        className: "unf-slider__track-overlay"
      })) : React.createElement("div", null, React.createElement("input", {
        "aria-valuemax": valueNumber,
        "data-unify": "Slider",
        className: "unf-slider__input first-slider",
        type: "range",
        min: minNumber,
        max: maxNumber,
        value: valueNumber,
        step: step ? step : 'any',
        onChange: this.handleChange
      }), React.createElement("input", {
        "aria-valuemax": doubleValueNumber,
        "data-unify": "Slider",
        className: "unf-slider__input second-slider",
        type: "range",
        min: minNumber,
        max: maxNumber,
        value: doubleValueNumber,
        step: step ? step : 'any',
        onChange: this.handleDoubleChange
      }), canUseDOM && React.createElement("div", {
        className: "unf-slider__range",
        style: {
          width: window.innerWidth <= 425 ? "".concat((doubleValueNumber - valueNumber) / (maxNumber - minNumber) * 100 + 6, "%") : "".concat((doubleValueNumber - valueNumber) / (maxNumber - minNumber) * 100 + 3, "%"),
          left: window.innerWidth <= 425 ? "".concat((valueNumber - minNumber) / (maxNumber - minNumber) * 100 - 3, "%") : "".concat((valueNumber - minNumber) / (maxNumber - minNumber) * 100 - 1.5, "%")
        }
      }), React.createElement("div", {
        className: "unf-slider__track-overlay"
      }))));
    }
  }]);

  return Slider;
}(PureComponent);

Slider.defaultProps = {
  min: 0,
  max: 100,
  value: 0,
  doubleValue: 10,
  block: false,
  noZero: false,
  "double": false
};
export default Slider;