import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["disabled", "indicatorMode", "indicatorModifier", "indicatorUnit", "maxValue", "minValue", "oneHandlerMode", "singleHandlerMode", "snapPointMode", "snapPointUnit", "value1", "value2", "onValueChange"];
import React, { useState, useEffect, useCallback, useMemo, useRef, Fragment } from 'react';
import { useKeyboardControl } from "../../build/Providers/common/hooks";
import { noop } from "../../build/Providers/common/functions/noop";
import { FilterLine, Handler, IndicatorContainer, IndicatorPoint, SliderLine } from "./style";

var SliderV2 = function SliderV2(_ref) {
  var _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$indicatorMode = _ref.indicatorMode,
      indicatorMode = _ref$indicatorMode === void 0 ? 'none' : _ref$indicatorMode,
      _ref$indicatorModifie = _ref.indicatorModifier,
      indicatorModifier = _ref$indicatorModifie === void 0 ? function (val) {
    return val;
  } : _ref$indicatorModifie,
      _ref$indicatorUnit = _ref.indicatorUnit,
      indicatorUnit = _ref$indicatorUnit === void 0 ? 5 : _ref$indicatorUnit,
      maxValue = _ref.maxValue,
      minValue = _ref.minValue,
      _ref$oneHandlerMode = _ref.oneHandlerMode,
      oneHandlerMode = _ref$oneHandlerMode === void 0 ? false : _ref$oneHandlerMode,
      _ref$singleHandlerMod = _ref.singleHandlerMode,
      singleHandlerMode = _ref$singleHandlerMod === void 0 ? false : _ref$singleHandlerMod,
      _ref$snapPointMode = _ref.snapPointMode,
      snapPointMode = _ref$snapPointMode === void 0 ? 'none' : _ref$snapPointMode,
      _ref$snapPointUnit = _ref.snapPointUnit,
      snapPointUnit = _ref$snapPointUnit === void 0 ? 5 : _ref$snapPointUnit,
      _ref$value = _ref.value1,
      value1 = _ref$value === void 0 ? 0 : _ref$value,
      _ref$value2 = _ref.value2,
      value2 = _ref$value2 === void 0 ? 0 : _ref$value2,
      _ref$onValueChange = _ref.onValueChange,
      onValueChange = _ref$onValueChange === void 0 ? noop : _ref$onValueChange,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(value1),
      _useState2 = _slicedToArray(_useState, 2),
      _value1 = _useState2[0],
      setValue1 = _useState2[1];

  var _useState3 = useState(value2),
      _useState4 = _slicedToArray(_useState3, 2),
      _value2 = _useState4[0],
      setValue2 = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isFocused = _useState6[0],
      setIsFocused = _useState6[1];

  var calcSnapPointCount = useCallback(function () {
    if (snapPointMode === 'count') {
      return snapPointUnit;
    }

    if (snapPointMode === 'interval') {
      return (maxValue - minValue) / snapPointUnit + 1;
    }

    return maxValue - minValue + 1;
  }, [maxValue, minValue, snapPointMode, snapPointUnit]);

  var _useState7 = useState(calcSnapPointCount()),
      _useState8 = _slicedToArray(_useState7, 2),
      snapPointCount = _useState8[0],
      setSnapPointCount = _useState8[1];

  var edgeSnapPointWidth = 1 / (2 + (snapPointCount - 2) * 2) * 100;
  var snapPointWidth = edgeSnapPointWidth * 2;
  var calcIndicatorCount = useCallback(function () {
    if (indicatorMode === 'count') {
      return indicatorUnit;
    }

    if (indicatorMode === 'interval') {
      return (maxValue - minValue) / indicatorUnit + 1;
    }

    if (indicatorMode === 'single') {
      return 1;
    }

    return 0;
  }, [indicatorMode, indicatorUnit, maxValue, minValue]);

  var _useState9 = useState(calcIndicatorCount()),
      _useState10 = _slicedToArray(_useState9, 2),
      indicatorCount = _useState10[0],
      setIndicatorCount = _useState10[1];

  var edgeIndicatorWidth = 1 / (2 + (indicatorCount - 2) * 2) * 100;
  var indicatorWidth = edgeIndicatorWidth * 2;

  var diffTolerated = function diffTolerated(x, x1) {
    return x === x1 || Math.abs((x - x1) / x) * 100 < 1;
  };

  var roundX = useCallback(function (x) {
    var tempX = x;

    if (tempX > 100) {
      tempX = 100;
    } else if (tempX < 0) {
      tempX = 0;
    }

    var newX = Math.round(tempX / snapPointWidth) * snapPointWidth;

    if (newX > 100) {
      newX = (newX / snapPointWidth - 1) * snapPointWidth;
    }

    return newX;
  }, [snapPointWidth]);
  var convertValueToXTranslate = useCallback(function (val) {
    var xTranslate = (val - minValue) / (maxValue - minValue) * 100;

    if (xTranslate < 0) {
      return 0;
    }

    if (xTranslate > 100) {
      return 100;
    }

    return xTranslate;
  }, [maxValue, minValue]);
  var convertXTranslateToValue = useCallback(function (xTranslate1) {
    return xTranslate1 / 100 * (maxValue - minValue) + minValue;
  }, [maxValue, minValue]);
  var containerRef = useRef(null);
  var activeHandlerRef = useRef(0);
  var eventRef = useRef();

  var _useState11 = useState(convertValueToXTranslate(value1)),
      _useState12 = _slicedToArray(_useState11, 2),
      xTranslate1 = _useState12[0],
      setXTranslate = _useState12[1];

  var _useState13 = useState(convertValueToXTranslate(value2)),
      _useState14 = _slicedToArray(_useState13, 2),
      xTranslate2 = _useState14[0],
      setXTranslate2 = _useState14[1];

  var xTranslateArr = useMemo(function () {
    return [xTranslate1, xTranslate2];
  }, [xTranslate1, xTranslate2]);
  var setXTranslateArr = useMemo(function () {
    return [setXTranslate, setXTranslate2];
  }, [setXTranslate, setXTranslate2]);

  var _useState15 = useState(false),
      _useState16 = _slicedToArray(_useState15, 2),
      isDragging = _useState16[0],
      setIsDragging = _useState16[1];

  var handler1Ref = useRef(null);
  var handler2Ref = useRef(null);
  useEffect(function () {
    setSnapPointCount(calcSnapPointCount());
  }, [calcSnapPointCount, maxValue, minValue, snapPointMode]);
  useEffect(function () {
    setIndicatorCount(calcIndicatorCount());
  }, [calcIndicatorCount, maxValue, minValue]);
  useEffect(function () {
    setXTranslate(convertValueToXTranslate(value1));
  }, [convertValueToXTranslate, value1]);
  useEffect(function () {
    setXTranslate2(convertValueToXTranslate(value2));
  }, [convertValueToXTranslate, value2]);
  useEffect(function () {
    var convertXTranslate1 = snapPointMode !== 'none' ? roundX(xTranslate1) : xTranslate1;
    var convertXTranslate2 = snapPointMode !== 'none' ? roundX(xTranslate2) : xTranslate2;

    if (oneHandlerMode || singleHandlerMode) {
      var convertValue = convertXTranslateToValue(convertXTranslate1);
      onValueChange(convertValue);
      setValue1(convertValue);
    } else {
      var convertValue1 = convertXTranslateToValue(convertXTranslate1);
      var convertValue2 = convertXTranslateToValue(convertXTranslate2);
      var leftValue = convertValue1 <= convertValue2 ? convertValue1 : convertValue2;
      var rightValue = convertValue1 > convertValue2 ? convertValue1 : convertValue2;
      onValueChange(leftValue, rightValue, convertValue1, convertValue2);
      setValue1(convertValue1);
      setValue2(convertValue2);
    }
  }, [convertXTranslateToValue, onValueChange, oneHandlerMode, singleHandlerMode, roundX, snapPointMode, xTranslate1, xTranslate2]);
  var moveHandler = useCallback(function (x) {
    setXTranslateArr[activeHandlerRef.current](function () {
      if (x < 0) {
        return 0;
      }

      if (x > 100) {
        return 100;
      }

      return x;
    });
  }, [setXTranslateArr]);

  var handleTouchStart = function handleTouchStart(e) {
    e.preventDefault();
    eventRef.current = 'touchstart';
    var x = 'touches' in e ? e.touches[0].clientX : e.clientX;
    var minValueX = containerRef !== null && containerRef !== void 0 && containerRef.current ? containerRef.current.getBoundingClientRect().x : 0;
    var width = containerRef !== null && containerRef !== void 0 && containerRef.current ? containerRef.current.getBoundingClientRect().width : 0;
    var xPercent = (x - minValueX) / width * 100;
    var distToHandler = Math.abs(xPercent - xTranslate1);
    var distToHandler1 = Math.abs(xPercent - xTranslate2);

    if (oneHandlerMode || singleHandlerMode || distToHandler < distToHandler1) {
      activeHandlerRef.current = 0;
      setIsFocused(true);
    } else {
      activeHandlerRef.current = 1;
      setIsFocused(true);
    }

    setIsDragging(true);
    moveHandler(xPercent);
  };

  var handleTouchMove = useCallback(function (e) {
    e.preventDefault();

    if (isDragging) {
      eventRef.current = 'touchmove';
      var x = e.touches ? e.touches[0].clientX : e.clientX;
      var minValueX = containerRef !== null && containerRef !== void 0 && containerRef.current ? containerRef.current.getBoundingClientRect().x : 0;
      var width = containerRef !== null && containerRef !== void 0 && containerRef.current ? containerRef.current.getBoundingClientRect().width : 0;
      var xPercent = (x - minValueX) / width * 100;
      moveHandler(xPercent);
    }
  }, [isDragging, moveHandler]);
  var handleTouchEnd = useCallback(function (e) {
    e.preventDefault();
    setIsDragging(false);
    eventRef.current = 'touchend';

    if (snapPointMode !== 'none') {
      var snapHandler = function snapHandler(x) {
        setXTranslateArr[Number(activeHandlerRef.current)](roundX(x));
      };

      snapHandler(xTranslateArr[activeHandlerRef.current]);
    }
  }, [roundX, setXTranslateArr, snapPointMode, xTranslateArr]);
  useEffect(function () {
    document.addEventListener('mousemove', handleTouchMove);
    document.addEventListener('mouseup', handleTouchEnd);
    return function () {
      document.removeEventListener('mousemove', handleTouchMove);
      document.removeEventListener('mouseup', handleTouchEnd);
    };
  }, [handleTouchEnd, handleTouchMove]);

  var handleIncrementOnKeyDown = function handleIncrementOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(xTranslateArr[activeHandlerRef.current] + snapPointWidth));
  };

  var handleDecrementOnKeyDown = function handleDecrementOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(xTranslateArr[activeHandlerRef.current] - snapPointWidth));
  };

  var handleBigIncrementOnKeyDown = function handleBigIncrementOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(xTranslateArr[activeHandlerRef.current] + 5 * snapPointWidth));
  };

  var handleBigDecrementOnKeyDown = function handleBigDecrementOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(xTranslateArr[activeHandlerRef.current] - 5 * snapPointWidth));
  };

  var handleJumpToMaxOnKeyDown = function handleJumpToMaxOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(100));
  };

  var handleJumpToMinOnKeyDown = function handleJumpToMinOnKeyDown(e) {
    e.preventDefault();
    moveHandler(roundX(0));
  };

  useKeyboardControl({
    ArrowUp: handleIncrementOnKeyDown,
    ArrowRight: handleIncrementOnKeyDown,
    ArrowDown: handleDecrementOnKeyDown,
    ArrowLeft: handleDecrementOnKeyDown,
    PageUp: handleBigIncrementOnKeyDown,
    PageDown: handleBigDecrementOnKeyDown,
    End: handleJumpToMaxOnKeyDown,
    Home: handleJumpToMinOnKeyDown
  }, isFocused);
  var onTouchProps = {};

  if (!disabled) {
    onTouchProps.onTouchStart = handleTouchStart;
    onTouchProps.onTouchMove = handleTouchMove;
    onTouchProps.onTouchEnd = handleTouchEnd;
    onTouchProps.onMouseDown = handleTouchStart;
  }

  var handleBlur = function handleBlur() {
    setIsFocused(false);
  };

  var renderIndicatorPoints = function renderIndicatorPoints() {
    var nodeArray = [];
    var convertXTranslate1 = snapPointMode !== 'none' ? roundX(xTranslate1) : xTranslate1;
    var convertXTranslate2 = snapPointMode !== 'none' ? roundX(xTranslate2) : xTranslate2;
    var smallerXTranslate = convertXTranslate1 <= convertXTranslate2 ? convertXTranslate1 : convertXTranslate2;
    var largerXTranslate = convertXTranslate1 > convertXTranslate2 ? convertXTranslate1 : convertXTranslate2;

    if (indicatorMode === 'single') {
      for (var i = 0; i < xTranslateArr.length; ++i) {
        var xTrans = xTranslateArr[Number(i)];
        var val = snapPointMode !== 'none' ? convertXTranslateToValue(roundX(xTrans)) : convertXTranslateToValue(xTrans);
        nodeArray.push(React.createElement(IndicatorPoint, {
          active: true,
          style: {
            marginLeft: "".concat(xTrans, "%")
          },
          disabled: disabled,
          key: i
        }, React.createElement("span", null, indicatorModifier(val))));

        if (oneHandlerMode || singleHandlerMode) {
          break;
        }
      }
    } else if (indicatorMode === 'count') {
      var _i = 0;

      while (_i < indicatorCount) {
        var x = minValue + (maxValue - minValue) / (indicatorCount - 1) * _i;
        var style = {
          marginLeft: "".concat(_i * indicatorWidth, "%")
        };
        var isActive = false;

        if (oneHandlerMode) {
          if (diffTolerated(_i * indicatorWidth, convertXTranslate1)) {
            isActive = true;
          }
        } else if (singleHandlerMode) {
          if (_i * indicatorWidth <= convertXTranslate1) {
            isActive = true;
          }
        } else if (_i * indicatorWidth >= smallerXTranslate && _i * indicatorWidth <= largerXTranslate) {
          isActive = true;
        }

        nodeArray.push(React.createElement(IndicatorPoint, {
          active: isActive,
          style: style,
          disabled: disabled,
          key: _i
        }, React.createElement("span", null, indicatorModifier(x))));
        _i += 1;
      }
    } else if (indicatorMode === 'interval') {
      var _i2 = minValue;

      while (_i2 <= maxValue) {
        var pointXTranslate = convertValueToXTranslate(_i2);
        var _style = {
          marginLeft: "".concat(pointXTranslate, "%")
        };
        var _isActive = false;

        if (oneHandlerMode) {
          if (diffTolerated(pointXTranslate, convertXTranslate1)) {
            _isActive = true;
          }
        } else if (singleHandlerMode) {
          if (diffTolerated(pointXTranslate, convertXTranslate1) || pointXTranslate <= convertXTranslate1) {
            _isActive = true;
          }
        } else if (diffTolerated(pointXTranslate, smallerXTranslate) || diffTolerated(pointXTranslate, largerXTranslate) || pointXTranslate >= smallerXTranslate && pointXTranslate <= largerXTranslate) {
          _isActive = true;
        }

        nodeArray.push(React.createElement(IndicatorPoint, {
          active: _isActive,
          style: _style,
          disabled: disabled,
          key: _i2
        }, React.createElement("span", null, indicatorModifier(_i2))));
        _i2 += indicatorUnit;
      }
    }

    return React.createElement(IndicatorContainer, null, nodeArray);
  };

  return React.createElement("div", _extends({
    ref: containerRef,
    "data-unify": "SliderV2"
  }, otherProps), indicatorMode !== 'none' && renderIndicatorPoints(), React.createElement("div", _extends({
    style: {
      height: "30px",
      touchAction: 'none'
    }
  }, onTouchProps), React.createElement(SliderLine, null, React.createElement(Handler, {
    style: {
      marginLeft: "calc(".concat(xTranslate1, "%)")
    },
    isDragging: isDragging,
    active: activeHandlerRef.current === 0,
    disabled: disabled,
    role: "slider",
    tabIndex: 0,
    "aria-valuenow": _value1,
    "aria-valuemin": minValue,
    "aria-valuemax": maxValue,
    innerRef: handler1Ref,
    onBlur: handleBlur
  }, React.createElement("div", {
    className: 'unify-sliderV2__handler-shadow'
  }), React.createElement("div", {
    className: 'unify-sliderV2__handler-handler'
  })), singleHandlerMode && React.createElement(FilterLine, {
    style: {
      width: "".concat(xTranslate1, "%")
    },
    disabled: disabled
  }), !oneHandlerMode && !singleHandlerMode && React.createElement(Fragment, null, React.createElement(Handler, {
    style: {
      marginLeft: "calc(".concat(xTranslate2, "%)")
    },
    isDragging: isDragging,
    active: activeHandlerRef.current === 1,
    disabled: disabled,
    role: "slider",
    tabIndex: 0,
    "aria-valuenow": _value2,
    "aria-valuemin": minValue,
    "aria-valuemax": maxValue,
    innerRef: handler2Ref,
    onBlur: handleBlur
  }, React.createElement("div", {
    className: 'unify-sliderV2__handler-shadow'
  }), React.createElement("div", {
    className: 'unify-sliderV2__handler-handler'
  })), React.createElement(FilterLine, {
    style: {
      marginLeft: "".concat(xTranslate1 < xTranslate2 ? xTranslate1 : xTranslate2, "%"),
      width: "".concat(Math.abs(xTranslate2 - xTranslate1), "%")
    },
    disabled: disabled
  })))));
};

export default SliderV2;