import styled, { css } from 'react-emotion';
import { GN400, GN500, NN100, NN300, NN950 } from 'unify-token/colors';
import { durationT3, easeOvershoot } from 'unify-token/build/v2/motions';
import { focusStyle } from "../../build/Providers/common/style";
export var SliderLine = styled('div', {
  target: "e1cri0c70"
})("width:100%;height:6px;background-color:", NN100, ";position:relative;top:13px;border-radius:5px;");
export var FilterLine = styled("div", {
  target: "e1cri0c71"
})("background-color:", function (_ref) {
  var disabled = _ref.disabled;
  return disabled ? NN300 : GN400;
}, ";height:100%;top:0px;left:0px;position:absolute;");
var _ref2 = "width:";
var _ref3 = ";height:";
var _ref4 = ";top:";
var _ref5 = ";left:";
var _ref6 = ";transition:height 0.2s ease-in,width 0.2s ease-in,top 0.2s ease-in,left 0.2s ease-in;z-index:";
var _ref7 = ";";

var activeHandler = function activeHandler(active, isDragging) {
  return css(_ref2, isDragging && active ? "26px" : "20px", _ref3, isDragging && active ? "26px" : "20px", _ref4, isDragging && active ? "-11px" : "-8px", _ref5, isDragging && active ? "-13px" : "-10px", _ref6, active ? 10 : 1, _ref7);
};

export var Handler = styled("div", {
  target: "e1cri0c72"
})(function (_ref8) {
  var active = _ref8.active,
      isDragging = _ref8.isDragging;
  return activeHandler(active, isDragging);
}, " border-radius:50%;position:absolute;.unify-sliderV2__handler-shadow{width:", function (_ref9) {
  var isDragging = _ref9.isDragging,
      active = _ref9.active;
  return isDragging && active ? '48px' : '24px';
}, ";height:", function (_ref10) {
  var isDragging = _ref10.isDragging,
      active = _ref10.active;
  return isDragging && active ? '48px' : '24px';
}, ";background-color:", function (_ref11) {
  var disabled = _ref11.disabled;
  return disabled ? NN300 : GN500;
}, ";border-radius:50%;opacity:0.2;position:absolute;top:50%;left:50%;margin-left:", function (_ref12) {
  var isDragging = _ref12.isDragging,
      active = _ref12.active;
  return isDragging && active ? '-24px' : '-12px';
}, ";margin-top:", function (_ref13) {
  var isDragging = _ref13.isDragging,
      active = _ref13.active;
  return isDragging && active ? '-24px' : '-12px';
}, ";transition-property:width,height,margin;transition-duration:", durationT3, ";transition-timing-function:", easeOvershoot, ";}.unify-sliderV2__handler-handler{width:24px;height:24px;border-radius:50%;box-sizing:border-box;background-color:", function (_ref14) {
  var disabled = _ref14.disabled;
  return disabled ? NN300 : GN500;
}, ";position:absolute;top:50%;left:50%;margin-left:-12px;margin-top:-12px;}", focusStyle);
export var IndicatorContainer = styled('div', {
  target: "e1cri0c73"
})("white-space:nowrap;position:relative;font-size:12px;height:20px;");
export var IndicatorPoint = styled("div", {
  target: "e1cri0c74"
})("position:absolute;color:", function (_ref15) {
  var disabled = _ref15.disabled,
      active = _ref15.active;
  return !disabled && active ? GN500 : NN950;
}, ";text-align:center;span{position:relative;left:-50%;}");