import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["display", "menuList", "title", "onClick", "onClose"];
import React, { Fragment, PureComponent } from 'react';
import Delayed from "../../build/Providers/common/components/Delayed";
import PortalWrapper from "../../build/Providers/common/components/PortalWrapper";
import Overlay from "../../build/Overlay";
import List from "../../build/List";
import Link from "../../build/Link";
import { canUseDOM } from "../../build/Providers/common/functions";
import { Container, Handle, Icon, LinkText, ListWrapper, Menu, Wrapper } from "./style";

var SubNavBar = function (_PureComponent) {
  _inherits(SubNavBar, _PureComponent);

  var _super = _createSuper(SubNavBar);

  function SubNavBar() {
    var _this;

    _classCallCheck(this, SubNavBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isDisplay: _this.props.display,
      yPoint: -100
    });

    _defineProperty(_assertThisInitialized(_this), "componentDidUpdate", function (prevProps) {
      var display = _this.props.display;
      var getAnimationTime = display ? 160 : 40;

      if (prevProps.display !== display) {
        var yPoint = display === true ? 0 : -100;
        setTimeout(function () {
          _this.setState(function (_ref) {
            var isDisplay = _ref.isDisplay;
            return {
              isDisplay: !isDisplay,
              yPoint: yPoint
            };
          });
        }, getAnimationTime);
      }

      if (canUseDOM && _this.state.isDisplay === false) {
        document.body.style.overflow = 'initial';
      } else if (canUseDOM && _this.state.isDisplay === true) {
        document.body.style.overflow = 'hidden';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setMenuRef", function (node) {
      _this.menu = node;
    });

    _defineProperty(_assertThisInitialized(_this), "setTranslate", function (yPos) {
      _this.setState({
        yPoint: yPos
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchStart", function (e) {
      _this.initialY = e.touches[0].clientY;
      _this.menuTop = _this.menu.offsetTop;
      _this.menuHeight = _this.menu.clientHeight;
      _this.dragoffsetY = _this.initialY - _this.menuTop + 100;
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchMove", function (e) {
      _this.middleY = e.touches[0].clientY;
      _this.diff = (_this.middleY - _this.dragoffsetY) / _this.menuHeight * 100;

      if (_this.middleY - _this.dragoffsetY > 0) {
        _this.setTranslate(0);
      } else {
        _this.setTranslate(_this.diff);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleTouchEnd", function (e) {
      var onClose = _this.props.onClose;

      if (_this.diff < -10) {
        _this.yPoints = -100;
        onClose(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function (e) {
      var onClose = _this.props.onClose;

      _this.setTranslate(-100);

      onClose(e);
    });

    _defineProperty(_assertThisInitialized(_this), "unmountAnimationDelay", 400);

    return _this;
  }

  _createClass(SubNavBar, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          display = _this$props.display,
          menuList = _this$props.menuList,
          title = _this$props.title,
          onClick = _this$props.onClick,
          onClose = _this$props.onClose,
          subNavBarProps = _objectWithoutProperties(_this$props, _excluded);

      var isDisplay = this.state.isDisplay;

      var GlobalText = function GlobalText(_ref2) {
        var onClick = _ref2.onClick,
            text = _ref2.text;
        return React.createElement(Link, {
          block: true,
          onClick: onClick
        }, React.createElement(LinkText, null, text));
      };

      return React.createElement(Fragment, null, React.createElement(PortalWrapper, null, React.createElement(Delayed, {
        mounted: display,
        unmountAfter: this.unmountAnimationDelay
      }, React.createElement(Overlay, {
        display: display,
        onClick: this.handleClose,
        "data-unf": "custom-overlay"
      }))), React.createElement(Container, _extends({
        display: isDisplay,
        "data-unify": "SubNavBar"
      }, subNavBarProps), React.createElement(Wrapper, null, React.createElement(Link, {
        onClick: title.link
      }, title.text), React.createElement(Icon, {
        onClick: isDisplay ? this.handleClose : onClick,
        display: isDisplay
      })), React.createElement(Menu, {
        yPoint: this.state.yPoint,
        display: isDisplay,
        innerRef: this.setMenuRef
      }, React.createElement(ListWrapper, null, React.createElement(List, {
        items: menuList,
        template: GlobalText
      })), React.createElement(Handle, {
        onTouchStart: this.handleTouchStart,
        onTouchMove: this.handleTouchMove,
        onTouchEnd: this.handleTouchEnd
      }))));
    }
  }]);

  return SubNavBar;
}(PureComponent);

SubNavBar.defaultProps = {
  display: false,
  menuList: [],
  title: {
    text: 'Title Panjang',
    link: 'https://www.tokopedia.com'
  }
};
export default SubNavBar;