import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
var _excluded = ["active", "count", "dataTest", "icon", "iconSize", "index", "lang", "last", "newNotification", "notification", "text", "onClick"];
import React, { useRef } from 'react';
import { cx } from 'emotion';
import { NN100 } from 'unify-token/colors';
import Typography from "../../build/Typography";
import Notification from "../../build/Notification";
import Ripple from "../../build/Providers/common/components/Ripple";
import { Icon, Item, TabItemText } from "./style";

var TabItem = function TabItem(props) {
  var rippleRef = useRef(null);
  var tabItemClass = cx('unf-tab__item', props.className, {
    'unf-tab__item--active': props.active
  });

  var handleClick = function handleClick(e) {
    typeof onClick === 'function' && onClick(e, _objectSpread(_objectSpread({}, props), {}, {
      key: index
    }), index);
  };

  var handleMouseDown = function handleMouseDown(e) {
    if (rippleRef.current) {
      rippleRef.current.trigger(e);
    }
  };

  var active = props.active,
      count = props.count,
      dataTest = props.dataTest,
      icon = props.icon,
      _props$iconSize = props.iconSize,
      iconSize = _props$iconSize === void 0 ? 24 : _props$iconSize,
      index = props.index,
      _props$lang = props.lang,
      lang = _props$lang === void 0 ? 'id' : _props$lang,
      last = props.last,
      newNotification = props.newNotification,
      notification = props.notification,
      text = props.text,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded);

  return React.createElement(Item, _extends({
    "data-testid": dataTest,
    key: index,
    className: tabItemClass,
    onClick: handleClick,
    onMouseDown: handleMouseDown,
    active: active,
    last: last
  }, otherProps), React.createElement(Ripple, {
    ref: rippleRef,
    color: NN100
  }), icon && React.createElement(Icon, {
    icon: icon,
    iconSize: iconSize
  }), React.createElement(Typography, {
    tag: 5,
    className: TabItemText({
      active: active,
      icon: icon,
      count: count,
      notification: notification,
      newNotification: newNotification
    }),
    alternate: !active
  }, text), count && React.createElement("span", {
    className: "unf-tab__item-count"
  }, "(", count, ")"), notification ? React.createElement(Notification, {
    "data-unf": "unf-tab-notif",
    secondary: true
  }) : newNotification ? React.createElement(Notification, {
    "data-unf": "unf-tab-notif",
    "new": true,
    lang: lang
  }) : '');
};

export default TabItem;