import styled, { css } from 'react-emotion';
import { colorPageBackground, colorShadow } from 'unify-token/build/v2/colors';
import { fontWeightRegular, lineHeightLv1 } from 'unify-token/build/v2/typographies';
import { durationT3, easeInOut, durationT1, easeOut } from 'unify-token/build/v2/motions';
import { NN600, GN500, NN50 } from 'unify-token/colors';
import ic_chevron from "../../build/Providers/assets/ic_system_navigation_chevron_up_primary.svg";
import { focusStyle } from "../../build/Providers/common/style";
var HEIGHT_OF_CONTAINER = '48px';
export var Icon = styled('i', {
  target: "ekz1mzt0"
})("display:inline-block;width:", function (_ref) {
  var iconSize = _ref.iconSize;
  return iconSize;
}, "px;height:", function (_ref2) {
  var iconSize = _ref2.iconSize;
  return iconSize;
}, "px;font-weight:600;line-height:", lineHeightLv1, ";margin-right:4px;background-image:url('", function (_ref3) {
  var icon = _ref3.icon;
  return icon;
}, "');background-position:right center;background-size:", function (_ref4) {
  var iconSize = _ref4.iconSize;
  return iconSize;
}, "px;border-radius:4px;background-repeat:no-repeat;vertical-align:middle;position:relative;");
export var TabItemText = function TabItemText(_ref5) {
  var active = _ref5.active,
      icon = _ref5.icon,
      count = _ref5.count,
      notification = _ref5.notification,
      newNotification = _ref5.newNotification;
  return css({
    margin: 0,
    display: 'inline-block',
    verticalAlign: 'middle',
    color: active && GN500,
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
    width: icon || count || notification || newNotification ? 'auto' : '100%'
  });
};
export var Content = styled('div', {
  target: "ekz1mzt1"
})("label:unf-tab-content;display:", function (_ref6) {
  var active = _ref6.active;
  return active ? 'block' : 'none';
}, ";padding:", function (_ref7) {
  var padding = _ref7.padding;
  return padding ? padding : '16px';
}, ";");
export var Item = styled('button', {
  target: "ekz1mzt2"
})("display:inline-block;box-sizing:border-box;height:100%;padding:16px;margin-right:0;line-height:normal;font-weight:", fontWeightRegular, ";color:", function (_ref8) {
  var active = _ref8.active;
  return active ? GN500 : NN600;
}, ";text-transform:capitalize;", function (_ref9) {
  var last = _ref9.last;
  return last ? "margin-right: 0" : '';
}, ";flex:1 1 0;text-align:center;max-width:60%;background-color:transparent;border:none;position:relative;overflow:hidden;transition:background-color ", durationT1, " ", easeOut, ",color ", durationT3, " ", easeInOut, ";", focusStyle, ";&:focus-visible{outline-offset:-2px;}span{margin-left:4px;font-weight:", fontWeightRegular, ";position:relative;}[data-unf='unf-tab-notif']{margin-left:8px;position:relative;}");
var flatContainerStyle = css("display:flex;flex-wrap:nowrap;flex:1;justify-content:space-evenly;");
export var Container = styled("div", {
  target: "ekz1mzt3"
})("label:unf-tab;position:relative;min-height:", HEIGHT_OF_CONTAINER, ";white-space:nowrap;background-color:", colorPageBackground, ";overflow-x:", function (_ref10) {
  var flat = _ref10.flat;
  return flat ? 'hidden' : 'auto';
}, ";box-shadow:", function (_ref11) {
  var noShadow = _ref11.noShadow;
  return noShadow ? 'none' : "0 2px 6px 0 ".concat(colorShadow);
}, ";", function (_ref12) {
  var noShadow = _ref12.noShadow;
  return noShadow && "border-bottom: 1px solid ".concat(NN50, ";");
}, " ", function (_ref13) {
  var flat = _ref13.flat;
  return flat && flatContainerStyle;
}, ";", function (_ref14) {
  var withToggle = _ref14.withToggle,
      flat = _ref14.flat;
  return withToggle && !flat && "\n    &::after {\n      content: '';\n      min-width: 43px;\n      display: inline-block;\n    }\n  ";
});
export var TabItemInk = styled('div', {
  target: "ekz1mzt4"
})("width:", function (_ref15) {
  var width = _ref15.width;
  return width;
}, "px;border-bottom:2px solid ", function (_ref16) {
  var active = _ref16.active;
  return active ? GN500 : 'transparent';
}, ";position:absolute;bottom:0;left:", function (_ref17) {
  var left = _ref17.left;
  return left;
}, "px;transition-property:width,left,right;transition-duration:", durationT3, ";transition-timing-function:", easeInOut, ";");
export var WrapperTrigger = styled('div', {
  target: "ekz1mzt5"
})("label:unf-tab-wrapper-trigger;position:relative;width:100%;transform:translateY(-1px);");
export var TriggerSection = styled('div', {
  target: "ekz1mzt6"
})("label:unf-tab-wrapper-trigger__trigger-section;width:43px;min-height:", function (_ref18) {
  var tabHeight = _ref18.tabHeight;
  return tabHeight ? "calc(".concat(tabHeight, "px - 1px)") : HEIGHT_OF_CONTAINER;
}, ";z-index:1;position:absolute;right:0px;background-color:", colorPageBackground, ";box-shadow:4px -1px 6px -3px ", colorShadow, ";transform:translateY(-100%) rotate(180deg);background-image:url('", ic_chevron, "');background-repeat:no-repeat;background-position:center;");