import React from 'react';
declare type TabAttributes = React.ComponentPropsWithoutRef<'div'>;
export interface TabBaseProps {
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To apply evenly divided tab
     */
    flat?: boolean;
    /**
     * To indicate active tab
     */
    indexActive?: number;
    /**
     * To specify tab contents
     */
    items?: ItemsProps[];
    /**
     * To remove shadow below Tab
     */
    noShadow?: boolean;
    /**
     * To pass callback when toggle section is clicked
     */
    onClickToggle?: (e: React.MouseEvent<HTMLDivElement>) => void;
    /**
     * To pass callback when tab is clicked
     */
    onItemClick?: (e: React.MouseEvent<HTMLButtonElement>, props: TabItemProps, index: number) => void;
}
interface ItemsProps {
    count?: number;
    dataTest?: {
        tabItem: string;
    };
    icon?: string;
    iconSize?: 16 | 24 | 32;
    key?: string | number;
    lang?: string;
    newNotification?: boolean;
    notification?: boolean;
    props?: Omit<TabItemAttributes, 'css'>;
    value?: string | number;
    text?: string;
}
export declare type TabProps = TabBaseProps & Omit<TabAttributes, keyof TabBaseProps | 'css'>;
declare type TabItemAttributes = React.ComponentPropsWithoutRef<'button'>;
declare type PickedItemsProps = Pick<ItemsProps, 'icon' | 'iconSize' | 'key' | 'lang' | 'newNotification' | 'notification' | 'text'>;
export interface TabItemProps extends PickedItemsProps {
    active?: boolean;
    className?: string;
    count?: boolean | number | string;
    dataTest?: string;
    index: number;
    last?: boolean;
    onClick?: (e: React.MouseEvent<HTMLButtonElement>, props: TabItemProps, index: number) => void;
}
export {};
