import React from 'react';
export interface TabContentProps {
    /**
     * To set content inside TabContent
     */
    children?: React.ReactNode;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To indicate tab order
     */
    index?: number;
    /**
     * To indicate currently active item
     */
    indexActive?: number;
    /**
     * To apply custom padding on TabContent
     */
    padding?: string;
}
declare const TabContent: {
    (props: TabContentProps): JSX.Element;
    propTypes: {
        children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        className: import("prop-types").Requireable<string>;
        index: import("prop-types").Requireable<number>;
        indexActive: import("prop-types").Requireable<number>;
        padding: import("prop-types").Requireable<string>;
    };
    defaultProps: {
        indexActive: number;
    };
};
export default TabContent;
