import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "children", "index", "indexActive"];
import React from 'react';
import { cx } from 'emotion';
import { Content } from "./style";

var TabContent = function TabContent(props) {
  var className = props.className,
      children = props.children,
      index = props.index,
      indexActive = props.indexActive,
      otherProps = _objectWithoutProperties(props, _excluded);

  var tabContentClass = cx('unf-tab__content', {
    'unf-tab__content--active': indexActive === index
  }, className);
  return React.createElement(Content, _extends({
    className: tabContentClass,
    active: indexActive === index
  }, otherProps), children);
};

TabContent.defaultProps = {
  indexActive: 0
};
export default TabContent;