import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["id", "className", "full", "name", "value", "withInfo", "maxLength", "counter", "label", "info", "message", "success", "error", "disabled", "placeholder", "readonly", "onBlur", "onChange", "onClick", "onClear", "onFocus", "onInput", "onKeyDown"];
import React, { PureComponent } from 'react';
import { cx } from 'emotion';
import { Container, Label, Group, InfoContainer, Info, Counter } from "../../build/Providers/styles/Form/_SharedStyle";
import { addClass, canUseDOM, removeClass } from "../../build/Providers/common/functions";
import { unf_textarea_full } from "./style";

var TextArea = function (_PureComponent) {
  _inherits(TextArea, _PureComponent);

  var _super = _createSuper(TextArea);

  function TextArea() {
    var _this;

    _classCallCheck(this, TextArea);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {
      if (!_this.props.full) {
        var textarea = _this.area;
        textarea.scrollHeight <= 80 ? textarea.scrollHeight === 0 ? textarea.style.height = '20px' : textarea.style.height = "".concat(textarea.scrollHeight, "px") : textarea.style.height = '80px';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMessage", function (text) {
      _this.info && addClass('animated', _this.info);
      setTimeout(function () {
        if (_this.info) {
          _this.info.innerHTML = text;
          removeClass('animated', _this.info);
        }
      }, 280);
    });

    _defineProperty(_assertThisInitialized(_this), "handleNoAnimation", function (text) {
      _this.info.innerHTML = text;
    });

    _defineProperty(_assertThisInitialized(_this), "handleTextInput", function () {
      var textarea = _this.area;

      if (textarea.scrollHeight >= 40 && textarea.scrollHeight < 60) {
        textarea.style.height = '40px';
      } else if (textarea.scrollHeight >= 60 && textarea.scrollHeight < 80) {
        textarea.style.height = '60px';
      } else if (textarea.scrollHeight >= 80) {
        textarea.style.height = '80px';
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleTextEnter", function (event) {
      var textarea = _this.area;

      if (event.keyCode === 13 || event.keyCode === 8 && canUseDOM) {
        window.setTimeout(function () {
          if (textarea.scrollHeight <= 80) {
            textarea.style.height = '20px';
            textarea.style.height = "".concat(textarea.scrollHeight, "px");
          }
        }, 0);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleFocus", function (e) {
      var onFocus = _this.props.onFocus;
      _this.area.scrollTop = _this.area.scrollHeight;
      addClass('isFocused', _this.container);
      onFocus && onFocus(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (e) {
      var onBlur = _this.props.onBlur;
      removeClass('isFocused', _this.container);
      onBlur && onBlur(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onInput = _this$props.onInput;

      _this.handleTextInput(e);

      if (onInput) {
        onInput(e);
      } else {
        onChange(e);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClear", function (e) {
      e.preventDefault();
      e.stopPropagation();
      var onClear = _this.props.onClear;
      window.setTimeout(function () {
        if (_this.area.scrollHeight <= 80) {
          _this.area.style.height = '20px';
          _this.area.style.height = "".concat(_this.area.scrollHeight, "px");
        }
      }, 0);
      onClear && onClear(e);

      _this.area.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "handleKeyDown", function (e) {
      _this.handleTextEnter(e);

      _this.props.onKeyDown(e);
    });

    return _this;
  }

  _createClass(TextArea, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props2 = this.props,
          full = _this$props2.full,
          info = _this$props2.info,
          message = _this$props2.message;

      if (message && prevProps.message !== message && !full) {
        var withoutAnimation = this.props.withoutAnimation;

        if (withoutAnimation) {
          this.handleNoAnimation(message);
        } else {
          this.handleMessage(message);
        }
      } else if (info && prevProps.info !== info) {
        var _withoutAnimation = this.props.withoutAnimation;

        if (_withoutAnimation) {
          this.handleNoAnimation(info);
        } else {
          this.handleMessage(info);
        }
      }

      if (!full) {
        if (canUseDOM && document.activeElement === this.area) {
          addClass('isFocused', this.container);
        } else {
          removeClass('isFocused', this.container);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          id = _this$props3.id,
          className = _this$props3.className,
          full = _this$props3.full,
          name = _this$props3.name,
          value = _this$props3.value,
          withInfo = _this$props3.withInfo,
          maxLength = _this$props3.maxLength,
          counter = _this$props3.counter,
          label = _this$props3.label,
          info = _this$props3.info,
          message = _this$props3.message,
          success = _this$props3.success,
          error = _this$props3.error,
          disabled = _this$props3.disabled,
          placeholder = _this$props3.placeholder,
          readonly = _this$props3.readonly,
          onBlur = _this$props3.onBlur,
          onChange = _this$props3.onChange,
          onClick = _this$props3.onClick,
          onClear = _this$props3.onClear,
          onFocus = _this$props3.onFocus,
          onInput = _this$props3.onInput,
          onKeyDown = _this$props3.onKeyDown,
          textareaProps = _objectWithoutProperties(_this$props3, _excluded);

      var containerClass = cx('unf-input', {
        isDisabled: disabled,
        isSuccess: success,
        isError: error
      }, className);
      var inputProps = {
        id: id,
        className: cx('unf-input-control unf-form-control', className),
        name: name,
        value: value,
        maxLength: counter || maxLength,
        disabled: disabled && 'disabled',
        readOnly: readonly
      };
      var labelClass = cx('unf-input-label', {
        hasValue: value !== '' || placeholder
      });

      if (full) {
        return React.createElement(React.Fragment, null, React.createElement("textarea", _extends({
          className: unf_textarea_full,
          value: value,
          onChange: onChange
        }, this.props)));
      }

      return React.createElement(Container, _extends({
        innerRef: function innerRef(node) {
          return _this2.container = node;
        },
        className: containerClass
      }, textareaProps), React.createElement(Group, {
        className: "unf-input-group",
        success: success,
        error: error,
        disabled: disabled,
        label: label
      }, React.createElement("div", {
        ref: function ref(node) {
          return _this2.wrapper = node;
        },
        className: "unf-input-wrapper"
      }, React.createElement("textarea", _extends({
        ref: function ref(node) {
          return _this2.area = node;
        },
        "aria-label": "unf-textarea",
        "data-unify": "TextArea",
        style: {
          paddingRight: onClear ? '32px' : 0
        },
        onBlur: this.handleBlur,
        onChange: this.handleChange,
        onClick: onClick,
        onFocus: this.handleFocus,
        onKeyDown: this.handleKeyDown,
        placeholder: placeholder
      }, inputProps)), !disabled && onClear && value.length > 3 && React.createElement("i", {
        onClick: this.handleClear,
        className: "unf-input-clear"
      }), label && React.createElement(Label, {
        innerRef: function innerRef(node) {
          return _this2.label = node;
        },
        className: labelClass,
        disabled: disabled
      }, label))), info || message || counter ? React.createElement(InfoContainer, {
        className: "unf-input-info"
      }, info || message ? React.createElement(Info, {
        className: "unf-input-info__msg",
        success: success,
        error: error,
        disabled: disabled
      }, React.createElement("span", {
        ref: function ref(node) {
          return _this2.info = node;
        }
      }, info || message)) : '', counter && React.createElement(Counter, {
        className: "unf-input-info__ctr",
        disabled: this.props.disabled
      }, React.createElement("span", null, value.length), "/", counter)) : '');
    }
  }]);

  return TextArea;
}(PureComponent);

TextArea.defaultProps = {
  error: false,
  full: false,
  disabled: false,
  readonly: false,
  success: false,
  value: '',
  withInfo: true,
  withoutAnimation: false,
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onClick: function onClick() {},
  onFocus: function onFocus() {},
  onKeyDown: function onKeyDown() {}
};
export default TextArea;