import styled from 'react-emotion';
import { NN400, NN600, NN950 } from 'unify-token/colors';
import { fontSizeLv2, fontSizeLv3, fontWeightRegular, lineHeightLv1, lineHeightLv4 } from 'unify-token/build/v2/typographies';
import { FormLabel, FORM_INPUT_LINE_HEIGHT, FORM_INPUT_PADDING, FORM_TRANSITION_TIMING, handleColor } from "../../build/Providers/styles/Form/_Common.style";
export var Label = styled("label", {
  target: "e1c0gfao0"
})(FormLabel, ";color:", function (_ref) {
  var disabled = _ref.disabled,
      focus = _ref.focus,
      formValue = _ref.formValue;
  return (focus || formValue) && !disabled ? NN600 : NN400;
}, ";font-size:", function (_ref2) {
  var focus = _ref2.focus,
      formValue = _ref2.formValue;
  return focus || formValue ? fontSizeLv2 : fontSizeLv3;
}, ";line-height:", function (_ref3) {
  var focus = _ref3.focus,
      formValue = _ref3.formValue;
  return focus || formValue ? lineHeightLv1 : lineHeightLv4;
}, ";top:", FORM_INPUT_PADDING - 1, "px;transition:color ", FORM_TRANSITION_TIMING, ",font-size ", FORM_TRANSITION_TIMING, ",line-height ", FORM_TRANSITION_TIMING, ",top ", FORM_TRANSITION_TIMING, ";");
export var Area = styled("textarea", {
  target: "e1c0gfao1"
})("label:txtarea;font-family:inherit;box-sizing:content-box;width:100%;height:", FORM_INPUT_LINE_HEIGHT, "px;font-size:", fontSizeLv3, ";font-weight:", fontWeightRegular, ";line-height:", FORM_INPUT_LINE_HEIGHT, "px;background-color:transparent;border:none;border-radius:0;box-shadow:none;position:relative;outline:none;resize:none;overflow:hidden;padding:0;transition:color ", FORM_TRANSITION_TIMING, ";max-height:", function (_ref4) {
  var maxRows = _ref4.maxRows;
  return maxRows ? "".concat(FORM_INPUT_LINE_HEIGHT * maxRows, "px") : undefined;
}, ";color:", function (_ref5) {
  var disabled = _ref5.disabled;
  return handleColor(disabled);
}, ";margin:", FORM_INPUT_PADDING, "px 0;&::placeholder{color:", function (_ref6) {
  var disabled = _ref6.disabled;
  return disabled ? NN400 : NN600;
}, ";line-height:", FORM_INPUT_LINE_HEIGHT, "px;opacity:1;}");
export var LegacyAreaFull = styled("textarea", {
  target: "e1c0gfao2"
})("width:100%;height:calc(100% - 92px);font-family:inherit;color:", function (_ref7) {
  var disabled = _ref7.disabled;
  return disabled ? NN600 : NN950;
}, ";font-size:", fontSizeLv3, ";font-weight:", fontWeightRegular, ";line-height:", FORM_INPUT_LINE_HEIGHT, "px;background-color:transparent;border:0;outline:none;resize:none;padding:0;margin-bottom:16px;&::placeholder{color:", function (_ref8) {
  var disabled = _ref8.disabled;
  return disabled ? NN400 : NN600;
}, ";}");