import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["appendObject", "appendText", "autoCapitalize", "autoComplete", "autoCorrect", "spellCheck", "className", "counter", "disabled", "error", "id", "info", "inlineLabel", "label", "maxLength", "message", "name", "placeholder", "prependObject", "prependText", "readonly", "success", "type", "value", "onChange", "onClick", "onInput", "onKeyDown", "onKeyPress", "onKeyUp", "suggestions", "displaySuggestions", "withInfo"];
import React, { PureComponent } from 'react';
import { cx } from 'emotion';
import icon_password_hidden from "../../build/Providers/assets/ic_system_eye_invisible.svg";
import icon_password_visible from "../../build/Providers/assets/ic_system_eye.svg";
import { Addon, Container, Counter, Group, Info, InfoContainer, Label } from "../../build/Providers/styles/Form/_SharedStyle";
import Toolbar from "../../build/Toolbar";
import { addClass, canUseDOM, removeClass } from "../../build/Providers/common/functions";

var TextField = function (_PureComponent) {
  _inherits(TextField, _PureComponent);

  var _super = _createSuper(TextField);

  function TextField(_props) {
    var _this;

    _classCallCheck(this, TextField);

    _this = _super.call(this, _props);

    _defineProperty(_assertThisInitialized(_this), "handleMessage", function (text) {
      _this.info && addClass('animated', _this.info);
      setTimeout(function () {
        if (_this.info) {
          _this.info.innerHTML = text;

          _this.info.classList.remove('animated');

          removeClass('animated', _this.info);
        }
      }, 280);
    });

    _defineProperty(_assertThisInitialized(_this), "handleNoAnimation", function (text) {
      _this.info.innerHTML = text;
    });

    _defineProperty(_assertThisInitialized(_this), "handleFocus", function (e) {
      var _this$props = _this.props,
          displaySuggestions = _this$props.displaySuggestions,
          onFocus = _this$props.onFocus;

      _this.setState({
        focus: true
      });

      addClass('isFocused', _this.container);
      displaySuggestions && _this.handleToolbar(true);
      onFocus && onFocus(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleBlur", function (e) {
      var _this$props2 = _this.props,
          displaySuggestions = _this$props2.displaySuggestions,
          onBlur = _this$props2.onBlur;

      _this.setState({
        focus: false
      });

      removeClass('isFocused', _this.container);
      displaySuggestions && _this.handleToolbar(false);
      onBlur && onBlur(e);
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelect", function (event, suggestion) {
      suggestion.onSelect && suggestion.onSelect(event, suggestion);
      addClass('unf-toolbar--show', _this.toolbar);

      _this.input.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "handlePasswordVisibility", function () {
      _this.setState(function (_ref) {
        var isPasswordVisible = _ref.isPasswordVisible;
        return {
          isPasswordVisible: !isPasswordVisible
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleLabelPosition", function (adjust) {
      var inputWrapper = _this.wrapper;
      var inputLabel = _this.label;

      _this.setState({
        isLabelAdjusted: adjust
      }, function () {
        inputLabel.style.top = adjust ? "-18px" : '';
        inputLabel.style.transform = adjust ? "translate(-".concat(inputWrapper.offsetLeft, "px, 0)") : '';
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddon", function (props) {
      return props && React.createElement(Addon, {
        className: "unf-input-group__addon",
        disabled: _this.props.disabled
      }, props);
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddonPassword", function () {
      return React.createElement(Addon, {
        className: "unf-input-group__addon unf-input-group__addon--password",
        password: true,
        disabled: _this.props.disabled,
        style: {
          backgroundImage: "url(\"".concat(_this.state.isPasswordVisible ? icon_password_visible : icon_password_hidden, "\")")
        },
        onClick: !_this.props.disabled && _this.handlePasswordVisibility
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleToolbar", function (bool) {
      setTimeout(function () {
        _this.toolbar && bool ? addClass('unf-toolbar--show', _this.toolbar) : removeClass('unf-toolbar--show', _this.toolbar);
      }, 1);
    });

    _this.state = {
      focus: false,
      isLabelAdjusted: false,
      isPasswordVisible: false
    };
    return _this;
  }

  _createClass(TextField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props3 = this.props,
          label = _this$props3.label,
          value = _this$props3.value;

      if (label) {
        value && this.handleLabelPosition(true);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props4 = this.props,
          info = _this$props4.info,
          label = _this$props4.label,
          message = _this$props4.message,
          prependObject = _this$props4.prependObject,
          prependText = _this$props4.prependText,
          value = _this$props4.value;
      var _this$state = this.state,
          focus = _this$state.focus,
          isLabelAdjusted = _this$state.isLabelAdjusted;

      if (message && prevProps.message !== message) {
        var withoutAnimation = this.props.withoutAnimation;

        if (withoutAnimation) {
          this.handleNoAnimation(message);
        } else {
          this.handleMessage(message);
        }
      } else if (info && prevProps.info !== info) {
        var _withoutAnimation = this.props.withoutAnimation;

        if (_withoutAnimation) {
          this.handleNoAnimation(info);
        } else {
          this.handleMessage(info);
        }
      }

      if (canUseDOM && document.activeElement === this.input) {
        addClass('isFocused', this.container);
        this.label && addClass('isFocused', this.label);
      } else {
        removeClass('isFocused', this.container);
        this.label && removeClass('isFocused', this.label);
      }

      if (label) {
        if (prevState.focus !== focus) {
          if (focus) {
            !isLabelAdjusted && this.handleLabelPosition(true);
          } else {
            !value && this.handleLabelPosition(false);
          }
        }

        if (prevProps.value !== value) {
          if (value !== '') {
            !isLabelAdjusted && this.handleLabelPosition(true);
          } else {
            !focus && this.handleLabelPosition(false);
          }
        }

        if (prevProps.prependObject !== prependObject || prevProps.prependText !== prependText) {
          value !== '' && this.handleLabelPosition(true);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          appendObject = _this$props5.appendObject,
          appendText = _this$props5.appendText,
          autoCapitalize = _this$props5.autoCapitalize,
          autoComplete = _this$props5.autoComplete,
          autoCorrect = _this$props5.autoCorrect,
          spellCheck = _this$props5.spellCheck,
          className = _this$props5.className,
          counter = _this$props5.counter,
          disabled = _this$props5.disabled,
          error = _this$props5.error,
          id = _this$props5.id,
          info = _this$props5.info,
          inlineLabel = _this$props5.inlineLabel,
          label = _this$props5.label,
          maxLength = _this$props5.maxLength,
          message = _this$props5.message,
          name = _this$props5.name,
          placeholder = _this$props5.placeholder,
          prependObject = _this$props5.prependObject,
          prependText = _this$props5.prependText,
          readonly = _this$props5.readonly,
          success = _this$props5.success,
          type = _this$props5.type,
          value = _this$props5.value,
          onChange = _this$props5.onChange,
          onClick = _this$props5.onClick,
          onInput = _this$props5.onInput,
          onKeyDown = _this$props5.onKeyDown,
          onKeyPress = _this$props5.onKeyPress,
          onKeyUp = _this$props5.onKeyUp,
          suggestions = _this$props5.suggestions,
          displaySuggestions = _this$props5.displaySuggestions,
          withInfo = _this$props5.withInfo,
          textfieldProps = _objectWithoutProperties(_this$props5, _excluded);

      var toolbarProps = {
        suggestions: suggestions,
        onSelect: this.handleSelect
      };
      var containerClass = cx('unf_input', {
        isDisabled: disabled,
        isSuccess: success,
        isError: error
      }, className);
      var labelClass = cx('unf-input-label', {
        hasValue: value !== '' || !inlineLabel || placeholder
      });
      var inputProps = {
        type: type === 'password' && this.state.isPasswordVisible ? 'text' : type,
        id: id,
        className: cx('unf-input-control unf-form-control unf-text-input', className),
        name: name,
        value: value,
        maxLength: counter || maxLength,
        disabled: disabled && 'disabled',
        readOnly: readonly
      };
      return React.createElement(Container, _extends({
        innerRef: function innerRef(node) {
          return _this2.container = node;
        },
        className: containerClass
      }, textfieldProps), React.createElement(Group, {
        className: "unf-input-group",
        error: error,
        disabled: disabled,
        success: success,
        label: label
      }, this.renderAddon(prependText), this.renderAddon(prependObject), React.createElement("div", {
        ref: function ref(node) {
          return _this2.wrapper = node;
        },
        className: "unf-input-wrapper"
      }, React.createElement("input", _extends({
        ref: function ref(node) {
          return _this2.input = node;
        },
        "aria-label": "unf-input",
        "data-unify": "TextField"
      }, inputProps, {
        autoCapitalize: autoCapitalize,
        autoComplete: autoComplete,
        autoCorrect: autoCorrect,
        placeholder: placeholder,
        spellCheck: spellCheck,
        onBlur: this.handleBlur,
        onChange: onChange,
        onClick: onClick,
        onFocus: this.handleFocus,
        onInput: onInput,
        onKeyDown: onKeyDown,
        onKeyPress: onKeyPress,
        onKeyUp: onKeyUp
      })), label && React.createElement(Label, {
        innerRef: function innerRef(node) {
          return _this2.label = node;
        },
        className: labelClass,
        disabled: disabled,
        hasPrepend: prependText || prependObject
      }, label)), type === 'password' ? this.renderAddonPassword() : this.renderAddon(appendObject), this.renderAddon(appendText)), withInfo && (info || message || counter ? React.createElement(InfoContainer, {
        className: "unf-input-info"
      }, info || message ? React.createElement(Info, {
        className: "unf-input-info__msg",
        success: success,
        error: error,
        disabled: disabled
      }, React.createElement("span", {
        ref: function ref(node) {
          return _this2.info = node;
        }
      }, info || message)) : '', counter && React.createElement(Counter, {
        className: "unf-input-info__ctr",
        disabled: this.props.disabled
      }, React.createElement("span", null, value.length), "/", counter)) : ''), displaySuggestions && React.createElement(Toolbar, _extends({
        toolbarRef: function toolbarRef(node) {
          return _this2.toolbar = node;
        }
      }, toolbarProps)));
    }
  }]);

  return TextField;
}(PureComponent);

TextField.defaultProps = {
  value: '',
  disabled: false,
  displaySuggestions: false,
  error: false,
  inlineLabel: true,
  readonly: false,
  success: false,
  suggestions: [],
  type: 'text',
  withInfo: true,
  withoutAnimation: false,
  onBlur: function onBlur() {},
  onChange: function onChange() {},
  onClick: function onClick() {},
  onFocus: function onFocus() {},
  onInput: function onInput() {},
  onKeyDown: function onKeyDown() {},
  onKeyPress: function onKeyPress() {},
  onKeyUp: function onKeyUp() {},
  onSelect: function onSelect() {}
};
export default TextField;