import styled, { css } from 'react-emotion';
import { BN50, BN400, YN50, YN300, RN50, RN500, NN50, NN300, NN900, NN950, GN500, RN200, BN200, YN200 } from 'unify-token/colors';
import { durationT3, easeInOut } from 'unify-token/build/v2/motions';
import { fontSizeLv2, fontWeightBold, lineHeightLv2 } from 'unify-token/build/v2/typographies';
import icon_system_close from "../../build/Providers/assets/ic_system_close.svg";

var handleBackgroundColor = function handleBackgroundColor(_ref) {
  var warning = _ref.warning,
      error = _ref.error,
      info = _ref.info,
      additional = _ref.additional;

  switch (true) {
    case warning:
      return YN50;

    case error:
      return RN50;

    case additional && additional.length > 0 || info:
      return NN50;

    default:
      return BN50;
  }
};

var handleBorderColor = function handleBorderColor(_ref2) {
  var warning = _ref2.warning,
      error = _ref2.error,
      info = _ref2.info,
      additional = _ref2.additional;

  switch (true) {
    case warning:
      return YN200;

    case error:
      return RN200;

    case additional && additional.length > 0 || info:
      return NN300;

    default:
      return BN200;
  }
};

export var handlePageControlColor = function handlePageControlColor(_ref3) {
  var warning = _ref3.warning,
      error = _ref3.error,
      info = _ref3.info;

  switch (true) {
    case warning:
      return YN300;

    case error:
      return RN500;

    case info:
      return NN900;

    default:
      return BN400;
  }
};
export var Container = styled("div", {
  target: "e19id70u0"
})("label:unf-ticker;position:relative;margin:", function (_ref4) {
  var full = _ref4.full;
  return full ? 0 : 16;
}, "px;color:", NN950, ";overflow:hidden;opacity:", function (_ref5) {
  var show = _ref5.show;
  return show ? 1 : 0;
}, ";transition:opacity ", durationT3, " ", easeInOut, ";& > i{background-image:url(", icon_system_close, ");position:absolute;right:8px;top:8px;height:12px;width:12px;background-repeat:no-repeat;background-size:12px;background-position:center;z-index:10;}[data-unf='unf-ticker-link']{margin-left:4px;display:inline-block;color:", GN500, ";}p{display:inline;margin:0px;}& [data-unf='unf__ticker-control']{position:absolute;bottom:8px;left:50%;transform:translateX(-50%);}");
export var List = styled('ol', {
  target: "e19id70u1"
})("list-style:none;counter-reset:unf-counter;margin:0;padding:0;margin-top:4px;li{display:flex;counter-increment:unf-counter;&:before{content:counter(unf-counter) '. ';color:inherit;font-weight:", fontWeightBold, ";font-size:", fontSizeLv2, ";margin-right:8px;}}");
export var Slider = styled("div", {
  target: "e19id70u2"
})("display:flex;transition:transform ", durationT3, " ", easeInOut, ";", function (_ref6) {
  var indexActive = _ref6.indexActive;
  return indexActive ? "transform: translateX(-".concat(indexActive * 100, "%)") : '';
}, ";");
export var Item = styled("div", {
  target: "e19id70u3"
})("flex:1 0 100%;padding:8px ", function (_ref7) {
  var onClose = _ref7.onClose;
  return onClose ? 32 : 12;
}, "px ", function (_ref8) {
  var itemNum = _ref8.itemNum;
  return itemNum > 1 ? 22 : 8;
}, "px 12px;background-color:", handleBackgroundColor, ";position:relative;overflow:hidden;display:flex;align-items:center;flex-direction:row;border-radius:", function (_ref9) {
  var full = _ref9.full;
  return full ? 0 : 8;
}, "px;", function (_ref10) {
  var full = _ref10.full;
  return full ? 'border-bottom' : 'border';
}, ":1px solid ", handleBorderColor, ";.unf-ticker__decorator{position:absolute;top:-5px;left:-5px;}");
export var unf_ticker_child_wrap = css("position:inherit;font-size:", fontSizeLv2, ";line-height:", lineHeightLv2, ";");
export var tickerIconContainer = css("margin-right:8px;width:22px;");