import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["actionText", "children", "className", "description", "list", "margin", "title"];
import React from 'react';
import Lightbulb from 'unify-icons/system/Lightbulb';
import { NN300, NN950 } from 'unify-token/colors';
import Typography from "../../build/Typography";
import { Container, IconContainer, OrderedList, UnorderedList } from "./style";

var Tips = function Tips(_ref) {
  var _ref$actionText = _ref.actionText,
      actionText = _ref$actionText === void 0 ? {} : _ref$actionText,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? [] : _ref$children,
      className = _ref.className,
      _ref$description = _ref.description,
      description = _ref$description === void 0 ? '' : _ref$description,
      _ref$list = _ref.list,
      list = _ref$list === void 0 ? {} : _ref$list,
      margin = _ref.margin,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      tipsProps = _objectWithoutProperties(_ref, _excluded);

  var renderList = function renderList() {
    if (list.items && list.items.length <= 0 || !list.items) {
      return;
    }

    var listHTML = list.items.map(function (item, i) {
      return React.createElement("li", {
        key: i
      }, React.createElement(Typography, {
        body: "paragraph-3",
        margin: '0 0 4px 0',
        color: NN950
      }, item));
    });
    return list.listStyleType === 'unordered' ? React.createElement(UnorderedList, null, listHTML) : React.createElement(OrderedList, null, listHTML);
  };

  var renderAction = function renderAction() {
    return React.createElement(Typography, {
      body: "paragraph-3",
      bold: true,
      margin: '0 0 0 4px',
      link: actionText.href ? actionText.href : '',
      onClick: actionText.onClick
    }, actionText.text);
  };

  return React.createElement(Container, _extends({
    className: className,
    margin: margin
  }, tipsProps), React.createElement(IconContainer, null, React.createElement(Lightbulb, {
    size: 22,
    color: NN300
  })), title.length > 0 && React.createElement(Typography, {
    body: "paragraph-3",
    bold: true,
    margin: '0 0 4px 0',
    color: NN950,
    style: {
      paddingRight: '24px'
    }
  }, title), description && React.createElement(Typography, {
    body: "paragraph-3",
    margin: '0 0 4px 0',
    color: NN950,
    style: {
      overflow: 'hidden',
      maxHeight: '36px'
    }
  }, description, actionText.text && renderAction()), renderList(), children);
};

export default Tips;