import { ReactNode, ComponentPropsWithoutRef } from 'react';
export declare type TipsListStyle = 'ordered' | 'unordered';
declare type TipsAttributes = ComponentPropsWithoutRef<'div'>;
export interface TipsProps extends Omit<TipsAttributes, 'css'> {
    /**
     * To set action text at the end of the text
     */
    actionText?: TipsActionText;
    /**
     * To pass custom className to create custom style
     */
    className?: string;
    /**
     * To set the description content of this Tips
     */
    description?: ReactNode;
    /**
     * To add additional info in list format
     */
    list?: TipsList;
    /**
     * To specify custom margin on Tips
     */
    margin?: string;
    /**
     * To specify title
     */
    title?: string;
}
export interface TipsActionText {
    href?: string;
    onClick?: () => void;
    text?: string;
}
export interface TipsList {
    items?: ReactNode[];
    listStyleType?: TipsListStyle;
}
export {};
