import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["appendText", "checked", "className", "disabled", "id", "inputProps", "name", "prependText", "useLabel", "value", "onChange", "onClick"];
import React from 'react';
import { cx } from 'emotion';
import { noop } from "../../build/Providers/common/functions/noop";
import { Toggle as Container, ToggleDiv as ContainerDiv } from "./style";

var Toggle = function Toggle(_ref) {
  var appendText = _ref.appendText,
      _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      className = _ref.className,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$id = _ref.id,
      id = _ref$id === void 0 ? '' : _ref$id,
      _ref$inputProps = _ref.inputProps,
      otherInputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
      _ref$name = _ref.name,
      name = _ref$name === void 0 ? '' : _ref$name,
      _ref$prependText = _ref.prependText,
      prependText = _ref$prependText === void 0 ? '' : _ref$prependText,
      _ref$useLabel = _ref.useLabel,
      useLabel = _ref$useLabel === void 0 ? true : _ref$useLabel,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? noop : _ref$onChange,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      toggleProps = _objectWithoutProperties(_ref, _excluded);

  var containerClass = cx('unf_toggle', {
    isDisabled: disabled
  }, className);

  var inputProps = _objectSpread({
    checked: checked,
    disabled: disabled && 'disabled',
    id: id,
    name: name,
    value: value,
    onChange: onChange,
    onClick: onClick
  }, otherInputProps);

  var Tag = useLabel ? Container : ContainerDiv;
  return React.createElement(Tag, _extends({
    disabled: disabled,
    className: containerClass
  }, toggleProps), prependText && React.createElement("span", {
    className: "unf-toggle__text toggle-text"
  }, prependText), React.createElement("input", _extends({
    autoComplete: "off",
    "data-unify": "Toggle",
    role: "switch",
    type: "checkbox"
  }, inputProps)), React.createElement("span", {
    className: "unf-toggle__lever toggle-lever"
  }), appendText && React.createElement("span", {
    className: "unf-toggle__text toggle-text"
  }, appendText));
};

export default Toggle;