import React, { ComponentPropsWithoutRef } from 'react';
declare type ToggleAttributes = ComponentPropsWithoutRef<'div'>;
export interface ToggleProps extends Omit<ToggleAttributes, 'css'> {
    /**
     * Add suffix on the Toggle
     */
    appendText?: string;
    /**
     * To apply checked Radio design
     */
    checked?: boolean;
    /**
     * Toggle container className
     */
    className?: string;
    /**
     * Set Toggle into disabled
     */
    disabled?: boolean;
    /**
     * Toggle input id
     */
    id?: string;
    /**
     * Insert custom property into input
     */
    inputProps?: Record<string, any>;
    /**
     * Toggle input name
     */
    name?: string;
    /**
     * Add prefix on the Toggle
     */
    prependText?: string;
    /**
     * Wrapper as label
     */
    useLabel?: boolean;
    /**
     * Toggle input value
     */
    value?: string;
    /**
     * Action when Toggle value is changed. `(event) => void;`
     */
    onChange?: (e: React.ChangeEvent<HTMLInputElement>) => void;
    /**
     * Toggle input value. `(event) => void;`
     */
    onClick?: (e: React.MouseEvent<HTMLInputElement>) => void;
}
export {};
