import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["suggestions", "toolbarRef", "onSelect"];
import React from 'react';
import Chip from "../../build/Chip";
import { ToolbarContainer } from "./style";

var Toolbar = function Toolbar(props) {
  var suggestions = props.suggestions,
      toolbarRef = props.toolbarRef,
      onSelect = props.onSelect,
      toolbarProps = _objectWithoutProperties(props, _excluded);

  var renderSelection = function renderSelection() {
    return suggestions.map(function (suggestion, index) {
      return React.createElement(Chip, {
        key: "ToolbarSuggestion-".concat(index),
        primary: true,
        small: true,
        onClick: function onClick(e) {
          return onSelect(e, suggestion);
        },
        active: suggestion.active
      }, suggestion.text);
    });
  };

  return React.createElement(ToolbarContainer, _extends({
    innerRef: toolbarRef,
    "data-unify": "Toolbar"
  }, toolbarProps), suggestions && suggestions.length > 0 && renderSelection());
};

Toolbar.defaultProps = {
  suggestions: []
};
export default Toolbar;