import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["actionText", "children", "display", "image", "onActionClick", "title", "className"];
import React from 'react';
import Button from "../../build/Button";
import wrapper from "../../build/Providers/common/HOC/withMobileOverlay";
import { Container, Content, Text } from "./style";

var Tooltip = function Tooltip(props) {
  var actionText = props.actionText,
      children = props.children,
      display = props.display,
      image = props.image,
      onActionClick = props.onActionClick,
      title = props.title,
      className = props.className,
      tooltipProps = _objectWithoutProperties(props, _excluded);

  var styleBackgroundImage = {
    backgroundImage: "url(\"".concat(image, "\")")
  };
  return React.createElement(Container, _extends({
    mod: {
      display: display
    }
  }, tooltipProps, {
    "data-unify": "Tooltip",
    className: className
  }), React.createElement(Content, {
    image: image,
    style: image ? styleBackgroundImage : null,
    className: "unf-tooltip__content"
  }, React.createElement(Text, {
    className: "unf-tooltip__title",
    title: title
  }, title), React.createElement(Text, {
    className: "unf-tooltip__description"
  }, children)), React.createElement(Button, {
    primary: true,
    large: true,
    block: true,
    onClick: onActionClick
  }, actionText));
};

Tooltip.defaultProps = {
  actionText: '',
  className: '',
  display: false,
  image: '',
  title: '',
  onActionClick: function onActionClick() {}
};
var wrapperElement = wrapper(Tooltip, 'tooltip');
export default wrapperElement;