import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "disabled", "lang", "suffix", "withChevron", "onClick"];
import React from 'react';
import { NN900, NN400, NN950 } from 'unify-token/colors';
import ChevronUp from 'unify-icons/system/ChevronUp';
import Typography from "../../../build/Typography";
import { AmountWrapper, _amountStyle, _suffixStyle } from "../style";

var Amount = function Amount(props) {
  var children = props.children,
      disabled = props.disabled,
      lang = props.lang,
      suffix = props.suffix,
      withChevron = props.withChevron,
      onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded);

  var rawAmount = typeof children === 'string' ? String(children).replace(/(Rp)?\.?/g, '') : children;
  var ariaLabel = {
    button: {
      en: "Total price: ".concat(rawAmount, " rupiahs"),
      id: "Total harga: ".concat(rawAmount, " rupiah")
    },
    chevron: {
      en: ', see shopping summary',
      id: ', lihat ringkasan belanja'
    }
  };
  return React.createElement(AmountWrapper, _extends({
    onClick: !disabled && onClick
  }, otherProps), React.createElement(Typography, {
    "aria-label": ariaLabel.button[String(lang)],
    body: 2,
    bold: true,
    main: !disabled,
    disabled: disabled,
    className: _amountStyle,
    color: NN950
  }, children), suffix && React.createElement(Typography, {
    disabled: disabled,
    className: _suffixStyle,
    color: NN950
  }, suffix), withChevron && React.createElement(ChevronUp, {
    "aria-label": ariaLabel.chevron[String(lang)],
    color: disabled ? NN400 : NN900,
    style: {
      verticalAlign: 'middle',
      flexShrink: 0
    }
  }));
};

Amount.defaultProps = {
  lang: 'id',
  withChevron: true,
  onClick: function onClick() {}
};
export default Amount;