import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "disabled", "fixed", "bottom"];
import React, { useState, useEffect, useRef, useCallback } from 'react';
import { canUseDOM } from "../../../build/Providers/common/functions";
import { CollapsibleInfoStyle } from "../style";

var CollapsibleInfo = function CollapsibleInfo(props) {
  var children = props.children,
      disabled = props.disabled,
      fixed = props.fixed,
      bottom = props.bottom,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      containerHeight = _useState2[0],
      setContainerHeight = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      scrolling = _useState4[0],
      setScrolling = _useState4[1];

  var timeout = useRef(null);
  var containerCallback = useCallback(function (el) {
    if (canUseDOM) {
      var _containerHeight = el === null || el === void 0 ? void 0 : el.getBoundingClientRect().height;

      setContainerHeight(_containerHeight);
    }
  }, [children]);
  var handleScroll = useCallback(function () {
    clearTimeout(timeout.current);

    if (fixed) {
      setScrolling(true);
      timeout.current = setTimeout(function () {
        setScrolling(false);
      }, 1000);
    }
  }, [fixed]);
  useEffect(function () {
    document.addEventListener('scroll', handleScroll);
    return function () {
      return document.removeEventListener('scroll', handleScroll);
    };
  }, [handleScroll]);
  return React.createElement(CollapsibleInfoStyle, _extends({
    innerRef: containerCallback,
    bottom: bottom,
    translateY: scrolling ? containerHeight : 0,
    disabled: disabled,
    fixed: fixed
  }, otherProps), children);
};

export default CollapsibleInfo;