import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["disabled", "loading", "fixed", "buttonProps", "description", "children", "collapsibleInfo", "bottom", "zIndex"];
import React, { useState, useCallback } from 'react';
import Button from "../../../build/Button";
import Divider from "../../../build/Divider";
import CollapsibleInfo from "./CollapsibleInfo";
import Description from "./Description";
import TotalAmountShimmer from "./TotalAmountShimmer";
import { Wrapper, Content, Spacer, _noellipsis, _ellipsis } from "../style";

var Container = function Container(props) {
  var disabled = props.disabled,
      loading = props.loading,
      fixed = props.fixed,
      buttonProps = props.buttonProps,
      description = props.description,
      children = props.children,
      collapsibleInfo = props.collapsibleInfo,
      bottom = props.bottom,
      zIndex = props.zIndex,
      otherProps = _objectWithoutProperties(props, _excluded);

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      wrapperHeight = _useState2[0],
      setWrapperHeight = _useState2[1];

  var wrapperCallback = useCallback(function (wrapper) {
    if (wrapper && fixed) {
      var _wrapper$getBoundingC = wrapper.getBoundingClientRect(),
          height = _wrapper$getBoundingC.height;

      setWrapperHeight(height);
    }
  }, [fixed]);

  var renderContent = function renderContent() {
    if (loading) {
      return React.createElement(TotalAmountShimmer, null);
    } else {
      var childs = {};
      var childsArr = React.Children.toArray(children);
      childs = childsArr.map(function (child) {
        return child && React.cloneElement(child, _objectSpread({
          disabled: disabled
        }, child.props));
      });
      return React.createElement(React.Fragment, null, description && React.createElement(Description, _extends({
        disabled: disabled
      }, description)), React.createElement(Content, {
        withDescription: Boolean(description)
      }, React.createElement("div", {
        className: _ellipsis
      }, childs), React.createElement(Button, _extends({
        className: _noellipsis,
        disabled: disabled
      }, buttonProps))));
    }
  };

  return React.createElement(React.Fragment, null, fixed && React.createElement(Spacer, {
    height: wrapperHeight
  }), !fixed && React.createElement(Divider, null), collapsibleInfo && !loading && React.createElement(CollapsibleInfo, {
    bottom: wrapperHeight + bottom,
    disabled: disabled,
    fixed: fixed,
    zIndex: zIndex
  }, collapsibleInfo), React.createElement(Wrapper, _extends({
    innerRef: wrapperCallback,
    hasCollapsibleInfo: Boolean(collapsibleInfo),
    fixed: fixed,
    loading: loading,
    bottom: bottom,
    zIndex: collapsibleInfo ? zIndex + 1 : zIndex
  }, otherProps), renderContent()));
};

Container.defaultProps = {
  fixed: true,
  buttonProps: {
    filled: true,
    main: true
  },
  zIndex: 40,
  bottom: 0
};
export default Container;