import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "suffix", "disabled", "linkText", "linkUrl"];
import React from 'react';
import { GN500, NN600, NN950 } from 'unify-token/colors';
import Typography from "../../../build/Typography";
import { _titleStyle, _titleLinkStyle, _suffixStyle, _ellipsis } from "../style";

var Title = function Title(props) {
  var children = props.children,
      suffix = props.suffix,
      disabled = props.disabled,
      linkText = props.linkText,
      linkUrl = props.linkUrl,
      otherProps = _objectWithoutProperties(props, _excluded);

  return React.createElement("div", _extends({
    className: _ellipsis
  }, otherProps), React.createElement(Typography, {
    main: !disabled,
    body: 3,
    disabled: disabled,
    className: _titleStyle,
    color: NN950
  }, children), linkText && React.createElement(Typography, {
    link: linkUrl,
    body: 4,
    className: _titleLinkStyle(disabled, Boolean(children)),
    color: GN500
  }, linkText), suffix && React.createElement(Typography, {
    disabled: disabled,
    className: _suffixStyle,
    color: NN600
  }, suffix));
};

export default Title;