import React from 'react';
export interface TotalAmountProps {
    /**
     * To specify amount value
     */
    amount?: string;
    /**
     * To specify amountSuffix value
     */
    amountSuffix?: string;
    /**
     * To show chevron icon
     */
    amountWithChevron?: boolean;
    /**
     * To specify bottom value
     */
    bottom?: number;
    /**
     * To specify button props
     */
    buttonProps?: object;
    /**
     *
     */
    children?: React.ReactNode;
    /**
     * To add collapsible component
     */
    collapsibleInfo?: React.ReactNode;
    /**
     * To add description
     */
    description?: object;
    /**
     * To Apply disabled state design
     */
    disabled?: boolean;
    /**
     * To Apply fixed design
     */
    fixed?: boolean;
    /**
     * To re-order TotalAmount Labels (Title, SubTitle, Amount & Text)
     */
    labelOrder?: string[];
    /**
     * To Apply loading state design
     */
    loading?: boolean;
    /**
     * To specify subTitle value
     */
    subTitle?: string;
    /**
     * To specify title value
     */
    title?: string;
    /**
     * To specify Title link text
     */
    titleLinkText?: string;
    /**
     * To specify Title link url
     */
    titleLinkUrl?: string;
    /**
     * To specify titleSuffix value
     */
    titleSuffix?: string;
    /**
     * To Apply zIndex value
     */
    zIndex?: number;
    /**
     * To pass callback Amount component is clicked
     */
    onClickAmount?: (e: React.MouseEvent<HTMLDivElement>) => void;
}
declare const TotalAmount: {
    (props: TotalAmountProps): JSX.Element;
    defaultProps: {
        bottom: number;
        buttonProps: {
            filled: boolean;
            main: boolean;
        };
        fixed: boolean;
        labelOrder: string[];
        zIndex: number;
    };
    propTypes: {
        amount: import("prop-types").Requireable<string>;
        amountSuffix: import("prop-types").Requireable<string>;
        amountWithChevron: import("prop-types").Requireable<boolean>;
        bottom: import("prop-types").Requireable<number>;
        buttonProps: import("prop-types").Requireable<object>;
        children: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        collapsibleInfo: import("prop-types").Requireable<import("prop-types").ReactNodeLike>;
        description: import("prop-types").Requireable<object>;
        disabled: import("prop-types").Requireable<boolean>;
        fixed: import("prop-types").Requireable<boolean>;
        labelOrder: import("prop-types").Requireable<string[]>;
        loading: import("prop-types").Requireable<boolean>;
        subTitle: import("prop-types").Requireable<string>;
        title: import("prop-types").Requireable<string>;
        titleLinkText: import("prop-types").Requireable<string>;
        titleLinkUrl: import("prop-types").Requireable<string>;
        titleSuffix: import("prop-types").Requireable<string>;
        zIndex: import("prop-types").Requireable<number>;
        onClickAmount: import("prop-types").Requireable<(...args: any[]) => any>;
    };
    Container: any;
    Title: any;
    SubTitle: any;
    Amount: any;
    Description: any;
};
export default TotalAmount;
