import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["amount", "amountSuffix", "onClickAmount", "amountWithChevron", "labelOrder", "subTitle", "title", "titleLinkText", "titleLinkUrl", "titleSuffix"];
import React from 'react';
import Container from "./components/Container";
import Title from "./components/Title";
import SubTitle from "./components/SubTitle";
import Amount from "./components/Amount";
import Description from "./components/Description";

var TotalAmount = function TotalAmount(props) {
  var amount = props.amount,
      amountSuffix = props.amountSuffix,
      onClickAmount = props.onClickAmount,
      amountWithChevron = props.amountWithChevron,
      labelOrder = props.labelOrder,
      subTitle = props.subTitle,
      title = props.title,
      titleLinkText = props.titleLinkText,
      titleLinkUrl = props.titleLinkUrl,
      titleSuffix = props.titleSuffix,
      otherProps = _objectWithoutProperties(props, _excluded);

  var renderLabel = function renderLabel(type) {
    switch (type) {
      case 'title':
        return (title || titleLinkText) && React.createElement(Title, {
          key: type,
          linkText: titleLinkText,
          linkUrl: titleLinkUrl,
          suffix: titleSuffix
        }, title);

      case 'subtitle':
        return subTitle && React.createElement(SubTitle, {
          key: type
        }, subTitle);

      case 'amount':
        return amount && React.createElement(Amount, {
          key: type,
          suffix: amountSuffix,
          withChevron: amountWithChevron,
          onClick: onClickAmount
        }, amount);
    }
  };

  return React.createElement(Container, _extends({
    "data-unify": "TotalAmount"
  }, otherProps), labelOrder.map(function (label) {
    return renderLabel(label);
  }));
};

TotalAmount.defaultProps = {
  bottom: 0,
  buttonProps: {
    filled: true,
    main: true
  },
  fixed: true,
  labelOrder: ['title', 'subtitle', 'amount'],
  zIndex: 40
};
TotalAmount.Container = Container;
TotalAmount.Title = Title;
TotalAmount.SubTitle = SubTitle;
TotalAmount.Amount = Amount;
TotalAmount.Description = Description;
export default TotalAmount;