import styled, { css } from 'react-emotion';
import { colorShadow } from 'unify-token/build/v2/colors';
import { NN600, NN400, NN0 } from 'unify-token/colors';
import { durationT3, easeInOut } from 'unify-token/build/v2/motions';
import { focusStyle } from "../../build/Providers/common/style";

var handleDisabledColor = function handleDisabledColor(disabled, color) {
  return disabled ? colorTextDisabled : color;
};

export var _ellipsis = css("white-space:nowrap;overflow:hidden;text-overflow:ellipsis;");
export var _noellipsis = css("white-space:nowrap;overflow:visible;");
export var _small = css("line-height:14px;font-size:10px;margin:0;", _ellipsis);
export var _shimmerStyle = css("& > span{margin:0;}");
export var _amountStyle = css("margin:0;line-height:24px;", _ellipsis, ";");
export var _titleStyle = css("margin:0;display:inline;", _ellipsis);
var _ref = "font-size:12px;line-height:18px;display:inline;";
var _ref2 = " ";
export var _titleLinkStyle = function _titleLinkStyle(disabled, hasChildren) {
  return css(_ref, disabled ? "\n        color: ".concat(NN400, ";\n        display: inline-block;  /* For IE11/ MS Edge bug */\n        pointer-events: none;\n        text-decoration: none;\n      ") : '', _ref2, hasChildren ? "margin-left: 4px;" : '');
};
export var _suffixStyle = css("display:inline;font-weight:400;font-size:10px;font-style:normal;line-height:14px;padding-left:4px;flex-shrink:10000;", _small);
var _ref4 = "display:flex;justify-content:space-between;font-weight:400;font-size:10px;font-style:normal;line-height:14px;padding:8px 16px;color:";
var _ref5 = ";margin:0;a{white-space:nowrap;font-size:inherit;line-height:inherit;";
var _ref6 = "}";
export var _descriptionStyle = function _descriptionStyle(_ref3) {
  var disabled = _ref3.disabled;
  return css(_ref4, handleDisabledColor(disabled, NN600), _ref5, disabled ? "\n        color: currentColor;\n        display: inline-block;  /* For IE11/ MS Edge bug */\n        pointer-events: none;\n        text-decoration: none;\n      " : '', _ref6);
};
export var Wrapper = styled("div", {
  target: "e50x5yh0"
})("width:100%;bottom:", function (_ref7) {
  var bottom = _ref7.bottom;
  return bottom;
}, "px;", function (_ref8) {
  var fixed = _ref8.fixed;
  return fixed ? 'position: fixed;' : '';
}, " ", function (_ref9) {
  var fixed = _ref9.fixed,
      hasCollapsibleInfo = _ref9.hasCollapsibleInfo,
      loading = _ref9.loading;
  return !fixed || hasCollapsibleInfo && !loading ? '' : "box-shadow: 0px -1px 6px ".concat(colorShadow, ";");
}, " background-color:", NN0, ";z-index:", function (_ref10) {
  var zIndex = _ref10.zIndex;
  return zIndex;
}, ";");
export var Spacer = styled('div', {
  target: "e50x5yh1"
})("width:100%;height:", function (_ref11) {
  var height = _ref11.height;
  return height;
}, "px;");
export var Content = styled('div', {
  target: "e50x5yh2"
})("display:flex;justify-content:space-between;align-items:center;padding:", function (_ref12) {
  var withDescription = _ref12.withDescription;
  return withDescription ? '8px 16px 12px 16px' : '12px 16px';
}, ";");
export var AmountWrapper = styled('button', {
  target: "e50x5yh3"
})("display:flex;align-items:center;padding:0;border:none;background-color:transparent;-webkit-appearance:none;", focusStyle, ";&:focus-visible{outline-offset:-2px;}");
export var CollapsibleInfoStyle = styled("div", {
  target: "e50x5yh4"
})("width:100%;transition:transform ", durationT3, " ", easeInOut, ";bottom:", function (_ref13) {
  var bottom = _ref13.bottom;
  return "".concat(bottom, "px");
}, ";transform:", function (_ref14) {
  var translateY = _ref14.translateY;
  return "translateY(".concat(translateY, "px)");
}, ";padding:12px 16px 0;", function (_ref15) {
  var fixed = _ref15.fixed;
  return fixed ? "position: fixed; box-shadow: 0px -1px 6px ".concat(colorShadow, ";") : '';
}, " background-color:", NN0, ";z-index:", function (_ref16) {
  var zIndex = _ref16.zIndex;
  return zIndex;
}, ";");