import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["alternate", "asSpan", "body", "caption", "children", "color", "disabled", "heading", "large", "link", "main", "margin", "micro", "setRef", "tag", "target", "uppercase", "onClick"];
import React from 'react';
import checkString from "../../build/Providers/common/functions/isString";
import { H1, H2, H3, H4, H5, H6, Link, Paragraph, Span } from "./style";

var Typography = function Typography(props) {
  var _props$alternate = props.alternate,
      alternate = _props$alternate === void 0 ? false : _props$alternate,
      _props$asSpan = props.asSpan,
      asSpan = _props$asSpan === void 0 ? false : _props$asSpan,
      body = props.body,
      _props$caption = props.caption,
      caption = _props$caption === void 0 ? false : _props$caption,
      children = props.children,
      _props$color = props.color,
      color = _props$color === void 0 ? '' : _props$color,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      heading = props.heading,
      _props$large = props.large,
      large = _props$large === void 0 ? false : _props$large,
      _props$link = props.link,
      link = _props$link === void 0 ? '' : _props$link,
      _props$main = props.main,
      main = _props$main === void 0 ? false : _props$main,
      _props$margin = props.margin,
      margin = _props$margin === void 0 ? '' : _props$margin,
      _props$micro = props.micro,
      micro = _props$micro === void 0 ? false : _props$micro,
      setRef = props.setRef,
      tag = props.tag,
      _props$target = props.target,
      target = _props$target === void 0 ? '_self' : _props$target,
      _props$uppercase = props.uppercase,
      uppercase = _props$uppercase === void 0 ? false : _props$uppercase,
      _props$onClick = props.onClick,
      onClick = _props$onClick === void 0 ? function () {} : _props$onClick,
      otherProps = _objectWithoutProperties(props, _excluded);

  var restProps = _objectSpread({
    alternate: alternate,
    caption: caption,
    color: color,
    disabled: disabled,
    large: large,
    main: main,
    margin: margin,
    micro: micro,
    uppercase: uppercase
  }, otherProps);

  var renderHeading = function renderHeading() {
    var components = {
      1: H1,
      2: H2,
      3: H3,
      4: H4,
      5: H5,
      6: H6
    };

    var getHeading = function getHeading() {
      if (!heading || heading > 6 || heading < 0) {
        return 2;
      }

      return heading;
    };

    var Tag = typeof tag === 'number' ? components[heading ? getHeading() : tag] : null;
    return React.createElement(Tag, _extends({
      innerRef: setRef,
      heading: heading,
      tag: tag,
      onClick: onClick,
      "data-unify": "Typography"
    }, restProps), children);
  };

  var renderText = function renderText() {
    var Tag = asSpan ? Span : Paragraph;
    return React.createElement(Tag, _extends({
      onClick: !restProps.disabled ? onClick : undefined,
      body: body,
      innerRef: setRef,
      asSpan: asSpan,
      "data-unify": "Typography"
    }, restProps), children);
  };

  var renderLink = function renderLink() {
    if (checkString(link)) {
      return React.createElement(Link, _extends({
        body: body,
        innerRef: setRef,
        link: link,
        href: !restProps.disabled ? typeof link === 'string' ? link : undefined : undefined,
        onClick: !restProps.disabled ? onClick : undefined,
        target: target,
        rel: "noopener noreferrer"
      }, restProps, {
        "data-unify": "Typography"
      }), children);
    }

    return React.createElement(Link, _extends({
      body: body,
      innerRef: setRef,
      link: link,
      onClick: !restProps.disabled ? typeof link === 'function' ? link : undefined : undefined,
      target: target,
      rel: "noopener noreferrer",
      "data-unify": "Typography"
    }, restProps), children);
  };

  if (link) {
    return renderLink();
  } else if (tag) {
    return renderHeading();
  } else {
    return renderText();
  }
};

export default Typography;