import styled from 'react-emotion';
import { GN500, NN950, NN400, NN600 } from 'unify-token/colors';
import { fontSizeLv1, fontSizeLv2, fontSizeLv3, fontSizeLv4, fontSizeLv5, fontSizeLv6, fontSizeLv7, lineHeightLv1, lineHeightLv2, lineHeightLv3, lineHeightLv4, lineHeightLv5, lineHeightLv6, lineHeightLv7, lineHeightLv9, fontWeightRegular, fontWeightBold, fontWeightExtraBold, fontFamilyLite, trackingTighter, trackingTight, trackingWide, trackingWidest, trackingWider } from 'unify-token/build/v2/typographies';
var lineHeightMicro = '12px';

var handleFontSize = function handleFontSize(_ref) {
  var body = _ref.body,
      tag = _ref.tag,
      large = _ref.large,
      caption = _ref.caption,
      micro = _ref.micro;

  switch (true) {
    case body === 'display-1' || body === 'paragraph-1':
      return fontSizeLv4;

    case body === 'display-2' || body === 'paragraph-2':
      return fontSizeLv3;

    case body === 'display-3' || body === 'paragraph-3':
      return fontSizeLv2;

    case body === 4 || micro:
      return fontSizeLv1;

    case body === 3 || caption:
      return fontSizeLv2;

    case body === 1 || large:
      return fontSizeLv4;

    case tag === 6:
      return fontSizeLv2;

    case tag === 5:
      return fontSizeLv3;

    case tag === 4:
      return fontSizeLv4;

    case tag === 3:
      return fontSizeLv5;

    case tag === 2:
      return fontSizeLv6;

    case tag === 1:
      return fontSizeLv7;

    default:
      return fontSizeLv3;
  }
};

var handleLineHeight = function handleLineHeight(_ref2) {
  var body = _ref2.body,
      tag = _ref2.tag,
      micro = _ref2.micro,
      caption = _ref2.caption,
      large = _ref2.large;

  switch (true) {
    case body === 'display-1':
      return lineHeightLv4;

    case body === 'display-2':
      return lineHeightLv3;

    case body === 'display-3':
      return lineHeightLv2;

    case body === 'paragraph-1':
      return lineHeightLv7;

    case body === 'paragraph-2':
      return lineHeightLv5;

    case body === 'paragraph-3':
      return lineHeightLv3;

    case body === 4:
      return lineHeightLv1;

    case body === 3 || caption:
      return lineHeightLv2;

    case body === 1 || large:
      return lineHeightLv4;

    case tag === 6:
      return lineHeightLv3;

    case tag === 5:
      return lineHeightLv4;

    case tag === 4:
      return lineHeightLv5;

    case tag === 3:
      return lineHeightLv6;

    case tag === 2:
      return lineHeightLv7;

    case tag === 1:
      return lineHeightLv9;

    case micro:
      return lineHeightMicro;

    default:
      return lineHeightLv3;
  }
};

var handleFontWeight = function handleFontWeight(_ref3) {
  var body = _ref3.body,
      bold = _ref3.bold,
      tag = _ref3.tag,
      link = _ref3.link,
      micro = _ref3.micro,
      uppercase = _ref3.uppercase;

  switch (true) {
    case body === 'display-1' && bold || body === 'paragraph-1' && bold:
      return fontWeightExtraBold;

    case body === 'display-2' && bold || body === 'paragraph-2' && bold:
      return fontWeightExtraBold;

    case body === 'display-3' && bold || body === 'paragraph-3' && bold:
      return fontWeightExtraBold;

    case body === 'display-3' && uppercase:
      return fontWeightExtraBold;

    case tag === 1 || tag === 2 || tag === 3 || tag === 4 || tag === 5 || tag === 6:
      return fontWeightExtraBold;

    case micro && bold:
      return fontWeightExtraBold;

    case Boolean(link) || bold:
      return fontWeightBold;

    default:
      return fontWeightRegular;
  }
};

var handleColor = function handleColor(_ref4) {
  var link = _ref4.link,
      tag = _ref4.tag,
      main = _ref4.main,
      alternate = _ref4.alternate,
      disabled = _ref4.disabled;

  switch (true) {
    case Boolean(link) && !tag:
      return GN500;

    case main:
      return NN950;

    case alternate:
      return NN600;

    case disabled:
      return NN400;

    default:
      return NN600;
  }
};

var handleLetterSpacing = function handleLetterSpacing(_ref5) {
  var body = _ref5.body,
      tag = _ref5.tag,
      uppercase = _ref5.uppercase;

  switch (true) {
    case tag === 1:
      return trackingTighter;

    case tag === 2 || tag === 3 || tag === 4 || tag === 5 || tag === 6:
      return trackingTight;

    case body === 'display-2' || body === 'paragraph-2':
      return trackingWider;

    case body === 'display-3' && uppercase:
      return trackingWidest;

    default:
      return trackingWide;
  }
};

export var Container = styled('span', {
  target: "e12ykf330"
})("label:unf-heading;@font-face{font-family:", fontFamilyLite, ";src:local('Open Sauce One Regular'),url('https://assets.tokopedia.net/asts/unify/fonts/OpenSauceOne-Regular.woff2') format('woff2');font-weight:400;font-style:normal;}@font-face{font-family:", fontFamilyLite, ";src:local('Open Sauce One ExtraBold'),url('https://assets.tokopedia.net/asts/unify/fonts/OpenSauceOne-ExtraBold.woff2') format('woff2');font-weight:800;font-style:normal;}display:", function (_ref6) {
  var link = _ref6.link,
      asSpan = _ref6.asSpan;
  return link || asSpan ? 'inline-block' : 'block';
}, ";position:relative;font-weight:", function (_ref7) {
  var body = _ref7.body,
      bold = _ref7.bold,
      tag = _ref7.tag,
      link = _ref7.link,
      micro = _ref7.micro,
      uppercase = _ref7.uppercase;
  return handleFontWeight({
    body: body,
    bold: bold,
    tag: tag,
    link: link,
    micro: micro,
    uppercase: uppercase
  });
}, ";font-family:", fontFamilyLite, ";font-size:", function (_ref8) {
  var body = _ref8.body,
      tag = _ref8.tag,
      large = _ref8.large,
      caption = _ref8.caption,
      micro = _ref8.micro;
  return handleFontSize({
    body: body,
    tag: tag,
    large: large,
    caption: caption,
    micro: micro
  });
}, ";line-height:", function (_ref9) {
  var body = _ref9.body,
      tag = _ref9.tag,
      micro = _ref9.micro,
      caption = _ref9.caption,
      large = _ref9.large;
  return handleLineHeight({
    body: body,
    tag: tag,
    micro: micro,
    caption: caption,
    large: large
  });
}, ";color:", function (_ref10) {
  var color = _ref10.color,
      link = _ref10.link,
      tag = _ref10.tag,
      main = _ref10.main,
      alternate = _ref10.alternate,
      disabled = _ref10.disabled;
  return color ? color : handleColor({
    link: link,
    tag: tag,
    main: main,
    alternate: alternate,
    disabled: disabled
  });
}, ";letter-spacing:", function (_ref11) {
  var body = _ref11.body,
      tag = _ref11.tag,
      uppercase = _ref11.uppercase;
  return handleLetterSpacing({
    body: body,
    tag: tag,
    uppercase: uppercase
  });
}, ";text-decoration:", function (_ref12) {
  var link = _ref12.link;
  return link ? 'none' : 'initial';
}, ";", function (_ref13) {
  var uppercase = _ref13.uppercase;
  return uppercase ? "text-transform: uppercase" : '';
}, ";", function (_ref14) {
  var margin = _ref14.margin;
  return margin ? "margin: ".concat(margin) : '';
}, ";");
export var H1 = Container.withComponent('h1', {
  target: "e12ykf331"
});
export var H2 = Container.withComponent('h2', {
  target: "e12ykf332"
});
export var H3 = Container.withComponent('h3', {
  target: "e12ykf333"
});
export var H4 = Container.withComponent('h4', {
  target: "e12ykf334"
});
export var H5 = Container.withComponent('h5', {
  target: "e12ykf335"
});
export var H6 = Container.withComponent('h6', {
  target: "e12ykf336"
});
export var Link = Container.withComponent('a', {
  target: "e12ykf337"
});
export var Paragraph = Container.withComponent('p', {
  target: "e12ykf338"
});
export var Span = Container.withComponent('span', {
  target: "e12ykf339"
});