import React from 'react';
export interface TypographyProps extends Omit<React.ComponentPropsWithoutRef<'span'>, 'css'> {
    /**
     * To apply alternate Typography design
     */
    alternate?: boolean;
    /**
     * To determine paragraphy font size
     */
    body?: number | string;
    /**
     * To apply bold on text
     */
    bold?: boolean;
    /**
     * To apply caption Typography design
     */
    caption?: boolean;
    /**
     * To specify typography content
     */
    children?: React.ReactNode;
    /**
     * To pass custom className to create custom styles
     */
    className?: string;
    /**
     * To apply custom color on text
     */
    color?: string;
    /**
     * To apply disabled on text
     */
    disabled?: boolean;
    /**
     * To change html tag different than it's size appearance
     */
    heading?: number;
    /**
     * To apply large Typography design
     */
    large?: boolean;
    /**
     * To provide link url and apply link design
     */
    link?: string | ((e: React.MouseEvent<HTMLElement>) => void);
    /**
     * To apply main Typography design
     */
    main?: boolean;
    /**
     * To apply custom margin on Typography
     */
    margin?: string;
    /**
     * To apply micro Typography design
     */
    micro?: boolean;
    /**
     * To set custom ref on Typography
     */
    setRef?: React.MutableRefObject<HTMLElement>;
    /**
     * To determine heading font size
     */
    tag?: number;
    target?: string;
    /**
     * To transforms text to uppercase
     */
    uppercase?: boolean;
    /**
     * To apply the wrapper as span
     */
    asSpan?: boolean;
    /**
     * To pass callback when Typography is clicked
     */
    onClick?: (e: React.MouseEvent<HTMLHeadingElement | HTMLParagraphElement | HTMLAnchorElement>) => void;
}
