import styled, { css } from 'react-emotion';
import { BN400L, BN700L, GN300L, GN700L, NN0L, PN400L, PN700L, RN400L, RN700L, TN400L, TN700L, YN400L, YN700L, NN0, NN200 } from 'unify-token/colors';
import { spacingLv3 } from 'unify-token/build/v2/spacings';
import { focusStyle } from "../../build/Providers/common/style";
import geGreen from "../../build/Providers/assets/ViewAllCard/ge-green.svg";
import geWhite from "../../build/Providers/assets/ViewAllCard/ge-white.svg";

var handleBackgroundColor = function handleBackgroundColor(_ref) {
  var backgroundColor = _ref.backgroundColor,
      inverted = _ref.inverted;

  switch (true) {
    case inverted:
      return 'rgba(255, 255, 255, 0.2)';

    case backgroundColor === 'blue':
      return "linear-gradient(180deg, ".concat(BN400L, " 0%, ").concat(BN700L, " 100%)");

    case backgroundColor === 'green':
      return "linear-gradient(180deg, ".concat(GN300L, " 0%, ").concat(GN700L, " 100%)");

    case backgroundColor === 'purple':
      return "linear-gradient(180deg, ".concat(PN400L, " 0%, ").concat(PN700L, " 100%)");

    case backgroundColor === 'red':
      return "linear-gradient(180deg, ".concat(RN400L, " 0%, ").concat(RN700L, " 100%)");

    case backgroundColor === 'teal':
      return "linear-gradient(180deg, ".concat(TN400L, " 0%, ").concat(TN700L, " 100%)");

    case backgroundColor === 'yellow':
      return "linear-gradient(180deg, ".concat(YN400L, " 0%, ").concat(YN700L, " 100%)");

    case Boolean(backgroundColor):
      return Array.isArray(backgroundColor) ? "linear-gradient(180deg, ".concat(backgroundColor[0], " 0%, ").concat(backgroundColor[1], " 100%)") : "linear-gradient(180deg, ".concat(backgroundColor, " 0%, ").concat(backgroundColor, " 100%)");

    default:
      return NN0;
  }
};

var handleBackgroundImage = function handleBackgroundImage(_ref2) {
  var backgroundColor = _ref2.backgroundColor,
      backgroundImage = _ref2.backgroundImage,
      inverted = _ref2.inverted,
      cardHeight = _ref2.cardHeight;

  switch (true) {
    case (Boolean(backgroundColor) || inverted) && Boolean(backgroundImage):
      return "url(".concat(backgroundImage === null || backgroundImage === void 0 ? void 0 : backgroundImage.alternate, ") no-repeat ").concat(cardHeight && cardHeight < 133 ? '0 -44px' : 'right top', ", ");

    case Boolean(backgroundImage):
      return "url(".concat(backgroundImage === null || backgroundImage === void 0 ? void 0 : backgroundImage.normal, ") no-repeat ").concat(cardHeight && cardHeight < 133 ? '0 -44px' : 'right top', ", ");

    default:
      return null;
  }
};

var handleBackground = function handleBackground(_ref3) {
  var backgroundImage = _ref3.backgroundImage,
      backgroundColor = _ref3.backgroundColor,
      inverted = _ref3.inverted,
      cardHeight = _ref3.cardHeight;

  if (backgroundImage) {
    return handleBackgroundImage({
      backgroundImage: backgroundImage,
      backgroundColor: backgroundColor,
      inverted: inverted,
      cardHeight: cardHeight
    });
  } else if (Boolean(backgroundColor) || inverted) {
    return "url(".concat(geWhite, ") no-repeat ").concat(cardHeight && cardHeight < 133 ? '0 -44px' : 'right top', ", ");
  } else {
    return "url(".concat(geGreen, ") no-repeat ").concat(cardHeight && cardHeight < 133 ? '0 -44px' : 'right top', ", ");
  }
};

export var Container = styled('section', {
  target: "e1ylbqyw0"
})("position:relative;background:", handleBackground, " ", function (props) {
  return props.inverted || props.backgroundColor ? handleBackgroundColor : NN0;
}, ";border-radius:8px;box-shadow:0px 1px 6px rgba(49,53,59,0.12);display:flex;flex-direction:column;height:100%;justify-content:space-between;margin:0;padding:12px;.unf-card__content--wrapper{display:flex;flex:1;flex-direction:column;justify-content:center;}");
export var contentLinkWrapper = css("label:unf-card__content-link--wrapper;text-decoration:none;");
export var imgBannerWrapper = css("label:unf-card__img--banner;height:100%;width:100%;div{padding:0;height:100%;width:100%;img{border-radius:8px;}}");
export var linkWrapper = css("label:unf-card__link--wrapper;display:flex;align-items:center;justify-content:space-between;position:absolute;bottom:12px;width:calc(100% - 24px);", focusStyle, ";span{flex:1;padding-right:", spacingLv3, ";overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}");
export var linkIconWrapper = css("label:unf-card__link-icon--wrapper;display:flex;align-items:center;justify-content:center;height:32px;width:32px;background-color:var(--NN50,", NN0L, ");border:1px solid ", NN200, ";border-radius:32px;position:absolute;bottom:12px;", focusStyle, ";");