import React from 'react';
declare type ViewAllCardAttributes = React.ComponentPropsWithoutRef<'section'>;
export interface ViewAllCardProps extends Omit<ViewAllCardAttributes, 'css'> {
    /**
     * To set background-color of View All Card
     */
    backgroundColor?: string | string[];
    /**
     * To set background-image of View All Card
     */
    backgroundImage?: {
        alternate?: string;
        normal?: string;
    };
    /**
     * To pass custom className to apply custom style
     */
    className?: string;
    /**
     * To specify description text of View All Card
     */
    description?: string;
    /**
     * To specify image alt
     */
    imageAlt?: string;
    /**
     * To apply image as banner  design
     */
    imageAsBanner?: boolean;
    /**
     * To specify image ratio
     */
    imageRatio?: '1:1' | '2:1' | '3:2' | '3:1';
    /**
     * To specify image size
     */
    imageSize?: string;
    /**
     * To specify image source
     */
    imageSrc?: string;
    /**
     * To apply inverted View All Card design
     */
    inverted?: boolean;
    /**
     * To specify the language of View All Card
     * @default "id"
     */
    lang?: string;
    /**
     * To specify link text of View All Card
     */
    linkText?: string;
    /**
     * To specify link url of View All Card
     */
    linkUrl?: string;
    /**
     * To specify title text of View All Card
     */
    title?: string;
    /**
     * To specify title size
     */
    titleSize?: 'large' | 'small';
    /**
     * To pass callback when the View All Card is clicked
     */
    onClick?: (e: React.MouseEvent<HTMLElement>) => void;
}
export interface ViewAllCardState extends ViewAllCardProps {
    cardHeight?: number;
}
export interface ConditionalContentWrapperProps {
    children?: React.ReactElement;
    condition?: boolean;
    wrapper: (children?: React.ReactElement) => React.ReactNode;
}
export {};
