import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["onClick"];
import React, { useState, useEffect, useRef } from 'react';
import { RN500, NN200 } from 'unify-token/colors';
import { noop } from "../../build/Providers/common/functions/noop";
import { ANIM_TIMEOUT, WishlistButton } from "./style";

var Wishlist = function Wishlist(_ref) {
  var _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      beating = _useState2[0],
      setBeat = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      active = _useState4[0],
      setActive = _useState4[1];

  var isInitialMount = useRef(true);
  useEffect(function () {
    var timerId = null;

    if (isInitialMount.current) {
      isInitialMount.current = false;
    } else {
      timerId = setTimeout(function () {
        setBeat(false);
      }, ANIM_TIMEOUT);
    }

    return function () {
      return clearTimeout(timerId);
    };
  }, [beating]);

  var handleClick = function handleClick(e) {
    setBeat(function (prevState) {
      return !prevState;
    });
    setActive(function (prevState) {
      return !prevState;
    });
    onClick && onClick(e);
  };

  return React.createElement(WishlistButton, _extends({
    active: active,
    beating: beating,
    "data-unify": "Wishlist",
    onClick: handleClick
  }, otherProps), React.createElement("svg", {
    width: "20",
    height: "17",
    xmlns: "http://www.w3.org/2000/svg"
  }, React.createElement("path", {
    d: "M10 17s10-3 10-11c0-4-3-6-5-6-5 0-5 4-5 4s0-4-5-4C3 0 0 2 0 6c0 8 10 11 10 11",
    fill: active ? RN500 : NN200,
    fillRule: "evenodd"
  })));
};

export default Wishlist;